PDL/Opt/NonLinear version 0.01
=============================

This module provide some optimization routines for PDL.

INSTALLATION

   perl Makefile.PL
   make
   make test
   make install

DEPENDENCIES

This module requires the following Perl modules:
  
  PDL
  PDL::LinearAlgebra
  ExtUtils::F77

and C and Fortran compilers.

COPYRIGHT AND LICENCE

Copyright (C) 2005-2007 Grégory Vanuxem

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

C%% TRUNCATED-NEWTON METHOD: BLAS
C   NOTE: ALL ROUTINES HERE ARE FROM LINPACK WITH THE EXCEPTION
C         OF DXPY (A VERSION OF DAXPY WITH A=1.0)
C   WRITTEN BY:  STEPHEN G. NASH
C                OPERATIONS RESEARCH AND APPLIED STATISTICS DEPT.
C                GEORGE MASON UNIVERSITY
C                FAIRFAX, VA 22030

C******************************************************************
C SPECIAL BLAS FOR Y = X+Y
C******************************************************************
      SUBROUTINE DXPY(N,DX,INCX,DY,INCY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     VECTOR PLUS A VECTOR.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     STEPHEN G. NASH 5/30/89.
C
      DOUBLE PRECISION DX(1),DY(1)
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DY(IY) = DY(IY) + DX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,4)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DY(I) = DY(I) + DX(I)
   30 CONTINUE
      IF( N .LT. 4 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,4
        DY(I) = DY(I) + DX(I)
        DY(I + 1) = DY(I + 1) + DX(I + 1)
        DY(I + 2) = DY(I + 2) + DX(I + 2)
        DY(I + 3) = DY(I + 3) + DX(I + 3)
   50 CONTINUE
      RETURN
      END

c
c
      subroutine cvsmod(n,x,f,g,s,stp,ftol,gtol,xtol,
     *           stpmin,stpmax,maxfev,info,nfev,wa,dginit,dgout)
      integer n,maxfev,info,nfev
      double precision f,stp,ftol,gtol,xtol,stpmin,stpmax
      double precision x(n),g(n),s(n),wa(n)
      save
c     **********
c
c     subroutine cvsmod
c
c     *** this is a modification of more's line search routine **
c                   * * * * * * 
c     the purpose of cvsmod is to find a step which satisfies
c     a sufficient decrease condition and a curvature condition.
c     the user must provide a subroutine which calculates the
c     function and the gradient.
c
c     at each stage the subroutine updates an interval of
c     uncertainty with endpoints stx and sty. the interval of
c     uncertainty is initially chosen so that it contains a
c     minimizer of the modified function
c
c          f(x+stp*s) - f(x) - ftol*stp*(gradf(x)'s).
c
c     if a step is obtained for which the modified function
c     has a nonpositive function value and nonnegative derivative,
c     then the interval of uncertainty is chosen so that it
c     contains a minimizer of f(x+stp*s).
c
c     the algorithm is designed to find a step which satisfies
c     the sufficient decrease condition
c
c           f(x+stp*s) .le. f(x) + ftol*stp*(gradf(x)'s),
c
c     and the curvature condition
c
c           abs(gradf(x+stp*s)'s)) .le. gtol*abs(gradf(x)'s).
c
c     if ftol is less than gtol and if, for example, the function
c     is bounded below, then there is always a step which satisfies
c     both conditions. if no step can be found which satisfies both
c     conditions, then the algorithm usually stops when rounding
c     errors prevent further progress. in this case stp only
c     satisfies the sufficient decrease condition.
c
c     the subroutine statement is
c
c        subroutine cvsmod(n,x,f,g,s,stp,ftol,gtol,xtol,
c                   stpmin,stpmax,maxfev,info,nfev,wa,dg,dgout)
c     where
c
c       n is a positive integer input variable set to the number
c         of variables.
c
c       x is an array of length n. on input it must contain the
c         base point for the line search. on output it contains
c         x + stp*s.
c
c       f is a variable. on input it must contain the value of f
c         at x. on output it contains the value of f at x + stp*s.
c
c       g is an array of length n. on input it must contain the
c         gradient of f at x. on output it contains the gradient
c         of f at x + stp*s.
c
c       s is an input array of length n which specifies the
c         search direction.
c
c       stp is a nonnegative variable. on input stp contains an
c         initial estimate of a satisfactory step. on output
c         stp contains the final estimate.
c
c       ftol and gtol are nonnegative input variables. termination
c         occurs when the sufficient decrease condition and the
c         directional derivative condition are satisfied.
c
c       xtol is a nonnegative input variable. termination occurs
c         when the relative width of the interval of uncertainty
c         is at most xtol.
c
c       stpmin and stpmax are nonnegative input variables which
c         specify lower and upper bounds for the step.
c
c       maxfev is a positive integer input variable. termination
c         occurs when the number of calls to fcn is at least
c         maxfev by the end of an iteration.
c
c       info is an integer output variable set as follows:
c
c         info = 0  improper input parameters.
c
c         info =-1  a return is made to compute the function and gradient.
c
c         info = 1  the sufficient decrease condition and the
c                   directional derivative condition hold.
c
c         info = 2  relative width of the interval of uncertainty
c                   is at most xtol.
c
c         info = 3  number of calls to fcn has reached maxfev.
c
c         info = 4  the step is at the lower bound stpmin.
c
c         info = 5  the step is at the upper bound stpmax.
c
c         info = 6  rounding errors prevent further progress.
c                   there may not be a step which satisfies the
c                   sufficient decrease and curvature conditions.
c                   tolerances may be too small.
c
c       nfev is an integer output variable set to the number of
c         calls to fcn.
c
c       wa is a work array of length n.
c
c       *** the following two parameters are a modification to the code
c
c       dg is the initial directional derivative (in the original code
c                 it was computed in this routine0
c
c       dgout is the value of the directional derivative when the wolfe
c             conditions hold, and an exit is made to check descent.
c
c     subprograms called
c
c       cstepm
c
c       fortran-supplied...abs,max,min
c
c     argonne national laboratory. minpack project. june 1983
c     jorge j. more', david j. thuente
c
c     **********
      integer infoc,j
      logical brackt,stage1
      double precision dg,dgm,dginit,dgtest,dgx,dgxm,dgy,dgym,
     *       finit,ftest1,fm,fx,fxm,fy,fym,p5,p66,stx,sty,
     *       stmin,stmax,width,width1,xtrapf,zero,dgout
      data p5,p66,xtrapf,zero /0.5d0,0.66d0,4.0d0,0.0d0/
      if(info.eq.-1) go to 45
      if(info.eq.1) go to 321
      infoc = 1
c
c     check the input parameters for errors.
c
      if (n .le. 0 .or. stp .le. zero .or. ftol .lt. zero .or.
     *    gtol .lt. zero .or. xtol .lt. zero .or. stpmin .lt. zero
     *    .or. stpmax .lt. stpmin .or. maxfev .le. 0) return
c
c     compute the initial gradient in the search direction
c     and check that s is a descent direction.
c
      if (dginit .ge. zero) return
c
c     initialize local variables.
c
      brackt = .false.
      stage1 = .true.
      nfev = 0
      finit = f
      dgtest = ftol*dginit
      width = stpmax - stpmin
      width1 = width/p5
      do 20 j = 1, n
         wa(j) = x(j)
   20    continue
c
c     the variables stx, fx, dgx contain the values of the step,
c     function, and directional derivative at the best step.
c     the variables sty, fy, dgy contain the value of the step,
c     function, and derivative at the other endpoint of
c     the interval of uncertainty.
c     the variables stp, f, dg contain the values of the step,
c     function, and derivative at the current step.
c
      stx = zero
      fx = finit
      dgx = dginit
      sty = zero
      fy = finit
      dgy = dginit
c
c     start of iteration.
c
   30 continue
c
c        set the minimum and maximum steps to correspond
c        to the present interval of uncertainty.
c
         if (brackt) then
            stmin = min(stx,sty)
            stmax = max(stx,sty)
         else
            stmin = stx
            stmax = stp + xtrapf*(stp - stx)
            end if
c
c        force the step to be within the bounds stpmax and stpmin.
c
         stp = max(stp,stpmin)
         stp = min(stp,stpmax)
c
c        if an unusual termination is to occur then let
c        stp be the lowest point obtained so far.
c
         if ((brackt .and. (stp .le. stmin .or. stp .ge. stmax))
     *      .or. nfev .ge. maxfev-1 .or. infoc .eq. 0
     *      .or. (brackt .and. stmax-stmin .le. xtol*stmax)) stp = stx
c
c        evaluate the function and gradient at stp
c        and compute the directional derivative.
c
         do 40 j = 1, n
            x(j) = wa(j) + stp*s(j)
   40       continue
c        return to compute function value
         info=-1
         return
c
   45    info=0
         nfev = nfev + 1
         dg = zero
         do 50 j = 1, n
            dg = dg + g(j)*s(j)
   50       continue
         ftest1 = finit + stp*dgtest
c
c        test for convergence.
c
         if ((brackt .and. (stp .le. stmin .or. stp .ge. stmax))
     *      .or. infoc .eq. 0) info = 6
         if (stp .eq. stpmax .and.
     *       f .le. ftest1 .and. dg .le. dgtest) info = 5
         if (stp .eq. stpmin .and.
     *       (f .gt. ftest1 .or. dg .ge. dgtest)) info = 4
         if (nfev .ge. maxfev) info = 3
         if (brackt .and. stmax-stmin .le. xtol*stmax) info = 2
c        more's code has been modified so that at least one new
c        function value is computed during the line search (enforcing
c        at least one interpolation is not easy, since the code may
c        override an interpolation)
         if (f .le. ftest1 .and. abs(dg) .le. gtol*(-dginit).
     *       and.nfev.gt.1) info = 1
c
c        check for termination.
c
         if (info .ne. 0)then
            dgout=dg
            return
         endif
 321     continue
c
c        in the first stage we seek a step for which the modified
c        function has a nonpositive value and nonnegative derivative.
c
         if (stage1 .and. f .le. ftest1 .and.
     *       dg .ge. min(ftol,gtol)*dginit) stage1 = .false.
c
c        a modified function is used to predict the step only if
c        we have not obtained a step for which the modified
c        function has a nonpositive function value and nonnegative
c        derivative, and if a lower function value has been
c        obtained but the decrease is not sufficient.
c
         if (stage1 .and. f .le. fx .and. f .gt. ftest1) then
c
c           define the modified function and derivative values.
c
            fm = f - stp*dgtest
            fxm = fx - stx*dgtest
            fym = fy - sty*dgtest
            dgm = dg - dgtest
            dgxm = dgx - dgtest
            dgym = dgy - dgtest
c
c           call cstepm to update the interval of uncertainty
c           and to compute the new step.
c
            call cstepm(stx,fxm,dgxm,sty,fym,dgym,stp,fm,dgm,
     *                 brackt,stmin,stmax,infoc)
c
c           reset the function and gradient values for f.
c
            fx = fxm + stx*dgtest
            fy = fym + sty*dgtest
            dgx = dgxm + dgtest
            dgy = dgym + dgtest
         else
c
c           call cstepm to update the interval of uncertainty
c           and to compute the new step.
c
            call cstepm(stx,fx,dgx,sty,fy,dgy,stp,f,dg,
     *                 brackt,stmin,stmax,infoc)
            end if
c
c        force a sufficient decrease in the size of the
c        interval of uncertainty.
c
         if (brackt) then
            if (abs(sty-stx) .ge. p66*width1)
     *         stp = stx + p5*(sty - stx)
            width1 = width
            width = abs(sty-stx)
            end if
c
c        end of iteration.
c
         go to 30
c
c     last card of subroutine cvsmod.
c
      end
      subroutine cstepm(stx,fx,dx,sty,fy,dy,stp,fp,dp,brackt,
     *                 stpmin,stpmax,info)
      integer info
      double precision stx,fx,dx,sty,fy,dy,stp,fp,dp,stpmin,stpmax
      logical brackt,bound
c     **********
c
c     subroutine cstepm
c
c     the purpose of cstepm is to compute a safeguarded step for
c     a linesearch and to update an interval of uncertainty for
c     a minimizer of the function.
c
c     the parameter stx contains the step with the least function
c     value. the parameter stp contains the current step. it is
c     assumed that the derivative at stx is negative in the
c     direction of the step. if brackt is set true then a
c     minimizer has been bracketed in an interval of uncertainty
c     with endpoints stx and sty.
c
c     the subroutine statement is
c
c       subroutine cstepm(stx,fx,dx,sty,fy,dy,stp,fp,dp,brackt,
c                        stpmin,stpmax,info)
c
c     where
c
c       stx, fx, and dx are variables which specify the step,
c         the function, and the derivative at the best step obtained
c         so far. the derivative must be negative in the direction
c         of the step, that is, dx and stp-stx must have opposite
c         signs. on output these parameters are updated appropriately.
c
c       sty, fy, and dy are variables which specify the step,
c         the function, and the derivative at the other endpoint of
c         the interval of uncertainty. on output these parameters are
c         updated appropriately.
c
c       stp, fp, and dp are variables which specify the step,
c         the function, and the derivative at the current step.
c         if brackt is set true then on input stp must be
c         between stx and sty. on output stp is set to the new step.
c
c       brackt is a logical variable which specifies if a minimizer
c         has been bracketed. if the minimizer has not been bracketed
c         then on input brackt must be set false. if the minimizer
c         is bracketed then on output brackt is set true.
c
c       stpmin and stpmax are input variables which specify lower
c         and upper bounds for the step.
c
c       info is an integer output variable set as follows:
c         if info = 1,2,3,4,5, then the step has been computed
c         according to one of the five cases below. otherwise
c         info = 0, and this indicates improper input parameters.
c
c     subprograms called
c
c       fortran-supplied ... abs,max,min,sqrt
c
c     argonne national laboratory. minpack project. june 1983
c     jorge j. more', david j. thuente
c
c     **********
      double precision gamma,p,q,r,s,sgnd,stpc,stpf,stpq,theta
      info = 0
c
c     check the input parameters for errors.
c
      if ((brackt .and. (stp .le. min(stx,sty) .or.
     *    stp .ge. max(stx,sty))) .or.
     *    dx*(stp-stx) .ge. 0.0 .or. stpmax .lt. stpmin) return
c
c     determine if the derivatives have opposite sign.
c
      sgnd = dp*(dx/abs(dx))
c
c     first case. a higher function value.
c     the minimum is bracketed. if the cubic step is closer
c     to stx than the quadratic step, the cubic step is taken,
c     else the average of the cubic and quadratic steps is taken.
c
      if (fp .gt. fx) then
         info = 1
         bound = .true.
         theta = 3*(fx - fp)/(stp - stx) + dx + dp
         s = max(abs(theta),abs(dx),abs(dp))
         gamma = s*sqrt((theta/s)**2 - (dx/s)*(dp/s))
         if (stp .lt. stx) gamma = -gamma
         p = (gamma - dx) + theta
         q = ((gamma - dx) + gamma) + dp
         r = p/q
         stpc = stx + r*(stp - stx)
         stpq = stx + ((dx/((fx-fp)/(stp-stx)+dx))/2)*(stp - stx)
         if (abs(stpc-stx) .lt. abs(stpq-stx)) then
            stpf = stpc
         else
           stpf = stpc + (stpq - stpc)/2
           end if
         brackt = .true.
c
c     second case. a lower function value and derivatives of
c     opposite sign. the minimum is bracketed. if the cubic
c     step is closer to stx than the quadratic (secant) step,
c     the cubic step is taken, else the quadratic step is taken.
c
      else if (sgnd .lt. 0.0) then
         info = 2
         bound = .false.
         theta = 3*(fx - fp)/(stp - stx) + dx + dp
         s = max(abs(theta),abs(dx),abs(dp))
         gamma = s*sqrt((theta/s)**2 - (dx/s)*(dp/s))
         if (stp .gt. stx) gamma = -gamma
         p = (gamma - dp) + theta
         q = ((gamma - dp) + gamma) + dx
         r = p/q
         stpc = stp + r*(stx - stp)
         stpq = stp + (dp/(dp-dx))*(stx - stp)
         if (abs(stpc-stp) .gt. abs(stpq-stp)) then
            stpf = stpc
         else
            stpf = stpq
            end if
         brackt = .true.
c
c     third case. a lower function value, derivatives of the
c     same sign, and the magnitude of the derivative decreases.
c     the cubic step is only used if the cubic tends to infinity
c     in the direction of the step or if the minimum of the cubic
c     is beyond stp. otherwise the cubic step is defined to be
c     either stpmin or stpmax. the quadratic (secant) step is also
c     computed and if the minimum is bracketed then the the step
c     closest to stx is taken, else the step farthest away is taken.
c
      else if (abs(dp) .lt. abs(dx)) then
         info = 3
         bound = .true.
         theta = 3*(fx - fp)/(stp - stx) + dx + dp
         s = max(abs(theta),abs(dx),abs(dp))
c
c        the case gamma = 0 only arises if the cubic does not tend
c        to infinity in the direction of the step.
c
         gamma = s*sqrt(max(0.0d0,(theta/s)**2 - (dx/s)*(dp/s)))
         if (stp .gt. stx) gamma = -gamma
         p = (gamma - dp) + theta
         q = (gamma + (dx - dp)) + gamma
         r = p/q
         if (r .lt. 0.0 .and. gamma .ne. 0.0) then
            stpc = stp + r*(stx - stp)
         else if (stp .gt. stx) then
            stpc = stpmax
         else
            stpc = stpmin
            end if
         stpq = stp + (dp/(dp-dx))*(stx - stp)
         if (brackt) then
            if (abs(stp-stpc) .lt. abs(stp-stpq)) then
               stpf = stpc
            else
               stpf = stpq
               end if
         else
            if (abs(stp-stpc) .gt. abs(stp-stpq)) then
               stpf = stpc
            else
               stpf = stpq
               end if
            end if
c
c     fourth case. a lower function value, derivatives of the
c     same sign, and the magnitude of the derivative does
c     not decrease. if the minimum is not bracketed, the step
c     is either stpmin or stpmax, else the cubic step is taken.
c
      else
         info = 4
         bound = .false.
         if (brackt) then
            theta = 3*(fp - fy)/(sty - stp) + dy + dp
            s = max(abs(theta),abs(dy),abs(dp))
            gamma = s*sqrt((theta/s)**2 - (dy/s)*(dp/s))
            if (stp .gt. sty) gamma = -gamma
            p = (gamma - dp) + theta
            q = ((gamma - dp) + gamma) + dy
            r = p/q
            stpc = stp + r*(sty - stp)
            stpf = stpc
         else if (stp .gt. stx) then
            stpf = stpmax
         else
            stpf = stpmin
            end if
         end if
c
c     update the interval of uncertainty. this update does not
c     depend on the new step or the case analysis above.
c
      if (fp .gt. fx) then
         sty = stp
         fy = fp
         dy = dp
      else
         if (sgnd .lt. 0.0) then
            sty = stx
            fy = fx
            dy = dx
            end if
         stx = stp
         fx = fp
         dx = dp
         end if
c
c     compute the new step and safeguard it.
c
      stpf = min(stpmax,stpf)
      stpf = max(stpmin,stpf)
      stp = stpf
      if (brackt .and. bound) then
         if (sty .gt. stx) then
            stp = min(stx+0.66*(sty-stx),stp)
         else
            stp = max(stx+0.66*(sty-stx),stp)
            end if
         end if
      return
c
c     last card of subroutine cstepm.
c
      end



 



 

      subroutine lmqn (ifail, n, x, f, g, w, lw, sfun,
     *            msglvl, maxit, maxfun, eta, stepmx, accrcy, xtol)
      implicit          double precision (a-h,o-z)
      integer           msglvl, n, maxfun, ifail, lw
      double precision  x(n), g(n), w(lw), eta, xtol, stepmx, f, accrcy

c
c this routine solves the optimization problem
c
c            minimize f(x)
c               x
c
c where x is a vector of n real variables.  the method used is
c a truncated-newton algorithm (see "newton-type minimization via
c the lanczos method" by s.g. nash (siam j. numer. anal. 21 (1984),
c pp. 770-778).  this algorithm finds a local minimum of f(x).  it does
c not assume that the function f is convex (and so cannot guarantee a
c global solution), but does assume that the function is bounded below.
c it can solve problems having any number of variables, but it is
c especially useful when the number of variables (n) is large.
c
c subroutine parameters:
c
c ierror - (integer) error code
c          ( 0 => normal return)
c          ( 2 => more than maxfun evaluations)
c          ( 3 => line search failed to find
c          (          lower point (may not be serious)
c          (-1 => error in input parameters)
c n      - (integer) number of variables
c x      - (real*8) vector of length at least n; on input, an initial
c          estimate of the solution; on output, the computed solution.
c g      - (real*8) vector of length at least n; on output, the final
c          value of the gradient
c f      - (real*8) on input, a rough estimate of the value of the
c          objective function at the solution; on output, the value
c          of the objective function at the solution
c w      - (real*8) work vector of length at least 14*n
c lw     - (integer) the declared dimension of w
c sfun   - a user-specified subroutine that computes the function
c          and gradient of the objective function.  it must have
c          the calling sequence
c             subroutine sfun (n, x, f, g)
c             integer           n
c             double precision  x(n), g(n), f
c
c eta    - severity of the linesearch
c maxfun - maximum allowable number of function evaluations
c xtol   - desired accuracy for the solution x*
c stepmx - maximum allowable step in the linesearch
c accrcy - accuracy of computed function values
c msglvl - determines quantity of printed output
c          0 = none, 1 = one line per major iteration.
c maxit  - maximum number of inner iterations per step

c
c this routine is a truncated-newton method.
c the truncated-newton method is preconditioned by a limited-memory
c quasi-newton method (this preconditioning strategy is developed
c in this routine) with a further diagonal scaling (see routine ndia3).
c for further details on the parameters, see routine tn.
c
      integer i, icycle, ioldg, ipk, iyk, loldg, lpk, lsr,
     *     lwtest, lyk, lyr, nftotl, niter, nm1, numf, nwhy
      double precision abstol, alpha, difnew, difold, epsmch,
     *     epsred, fkeep, fm, fnew, fold, fstop, ftest, gnorm, gsk,
     *     gtg, gtpnew, oldf, oldgtp, one, pe, peps, pnorm, reltol,
     *     rteps, rtleps, rtol, rtolsq, small, spe, tiny,
     *     tnytol, toleps, xnorm, yksk, yrsr, zero
      logical lreset, upd1
c
c the following imsl and standard functions are used
c
      double precision dabs, ddot, dsqrt, step1, dnrm2
      external sfun
      common /subscr/ lgv,lz1,lzk,lv,lsk,lyk,ldiagb,lsr,lyr,
     *     loldg,lhg,lhyk,lpk,lemat,lwtest
c
c initialize parameters and constants
c
      if (msglvl .ge. 1) write(*,800)
      call setpar(n)
      upd1 = .true.
      ireset = 0
      nfeval = 0
      nmodif = 0
      nlincg = 0
      fstop = f
      zero = 0.d0
      one = 1.d0
      nm1 = n - 1
c
c within this routine the array w(loldg) is shared by w(lhyr)
c
      lhyr = loldg
c
c check parameters and set constants
c
      call chkucp(lwtest,maxfun,nwhy,n,alpha,epsmch,
     *     eta,peps,rteps,rtol,rtolsq,stepmx,ftest,
     *     xtol,xnorm,x,lw,small,tiny,accrcy)
      if (nwhy .lt. 0) go to 120
      call setucr(small,nftotl,niter,n,f,fnew,
     *     fm,gtg,oldf,sfun,g,x)
      fold = fnew
      if (msglvl .ge. 1) write(*,810) niter,nftotl,nlincg,fnew,gtg
c
c check for small gradient at the starting point.
c
      ftest = one + dabs(fnew)
      if (gtg .lt. 1.d-4*epsmch*ftest*ftest) go to 90
c
c set initial values to other parameters
c
      icycle = nm1
      toleps = rtol + rteps
      rtleps = rtolsq + epsmch
      gnorm  = dsqrt(gtg)
      difnew = zero
      epsred = 5.0d-2
      fkeep  = fnew
c
c set the diagonal of the approximate hessian to unity.
c
      idiagb = ldiagb
      do 10 i = 1,n
         w(idiagb) = one
         idiagb = idiagb + 1
10    continue
c
c ..................start of main iterative loop..........
c
c compute the new search direction
c
      modet = msglvl - 3
      call modlnp(modet,w(lpk),w(lgv),w(lz1),w(lv),
     *     w(ldiagb),w(lemat),x,g,w(lzk),
     *     n,w,lw,niter,maxit,nfeval,nmodif,
     *     nlincg,upd1,yksk,gsk,yrsr,lreset,sfun,.false.,ipivot,
     *     accrcy,gtpnew,gnorm,xnorm)
20    continue
      call dcopy(n,g,1,w(loldg),1)
      pnorm = dnrm2(n,w(lpk),1)
      oldf = fnew
      oldgtp = gtpnew
c
c prepare to compute the step length
c
      pe = pnorm + epsmch
c
c compute the absolute and relative tolerances for the linear search
c
      reltol = rteps*(xnorm + one)/pe
      abstol = - epsmch*ftest/(oldgtp - epsmch)
c
c compute the smallest allowable spacing between points in
c the linear search
c
      tnytol = epsmch*(xnorm + one)/pe
      spe = stepmx/pe
c
c set the initial step length.
c
      alpha = step1(fnew,fm,oldgtp,spe)
c
c perform the linear search
c
      call linder(n,sfun,small,epsmch,reltol,abstol,tnytol,
     *     eta,zero,spe,w(lpk),oldgtp,x,fnew,alpha,g,numf,
     *     nwhy,w,lw)
c
      fold = fnew
      niter = niter + 1
      nftotl = nftotl + numf
      gtg = ddot(n,g,1,g,1)
      if (msglvl .ge. 1) write(*,810) niter,nftotl,nlincg,fnew,gtg
      if (nwhy .lt. 0) go to 120
      if (nwhy .eq. 0 .or. nwhy .eq. 2) go to 30
c
c the linear search has failed to find a lower point
c
      nwhy = 3
      go to 100
30    if (nwhy .le. 1) go to 40
      call sfun(n,x,fnew,g)
      nftotl = nftotl + 1
c
c terminate if more than maxfun evalutations have been made
c
40    nwhy = 2
      if (nftotl .gt. maxfun) go to 110
      nwhy = 0
c
c set up parameters used in convergence and resetting tests
c
      difold = difnew
      difnew = oldf - fnew
c
c if this is the first iteration of a new cycle, compute the
c percentage reduction factor for the resetting test.
c
      if (icycle .ne. 1) go to 50
      if (difnew .gt. 2.0d0 *difold) epsred = epsred + epsred
      if (difnew .lt. 5.0d-1*difold) epsred = 5.0d-1*epsred
50    continue
      gnorm = dsqrt(gtg)
      ftest = one + dabs(fnew)
      xnorm = dnrm2(n,x,1)
c
c test for convergence
c
      if ((alpha*pnorm .lt. toleps*(one + xnorm)
     *     .and. dabs(difnew) .lt. rtleps*ftest
     *     .and. gtg .lt. peps*ftest*ftest)
     *     .or. gtg .lt. 1.d-4*accrcy*ftest*ftest) go to 90
c
c compute the change in the iterates and the corresponding change
c in the gradients
c
      isk = lsk
      ipk = lpk
      iyk = lyk
      ioldg = loldg
      do 60 i = 1,n
         w(iyk) = g(i) - w(ioldg)
         w(isk) = alpha*w(ipk)
         ipk = ipk + 1
         isk = isk + 1
         iyk = iyk + 1
         ioldg = ioldg + 1
60    continue
c
c set up parameters used in updating the direction of search.
c
      yksk = ddot(n,w(lyk),1,w(lsk),1)
      lreset = .false.
      if (icycle .eq. nm1 .or. difnew .lt.
     *     epsred*(fkeep-fnew)) lreset = .true.
      if (lreset) go to 70
      yrsr = ddot(n,w(lyr),1,w(lsr),1)
      if (yrsr .le. zero) lreset = .true.
70    continue
      upd1 = .false.
c
c      compute the new search direction
c
      modet = msglvl - 3
      call modlnp(modet,w(lpk),w(lgv),w(lz1),w(lv),
     *     w(ldiagb),w(lemat),x,g,w(lzk),
     *     n,w,lw,niter,maxit,nfeval,nmodif,
     *     nlincg,upd1,yksk,gsk,yrsr,lreset,sfun,.false.,ipivot,
     *     accrcy,gtpnew,gnorm,xnorm)
      if (lreset) go to 80
c
c      store the accumulated change in the point and gradient as an
c      "average" direction for preconditioning.
c
      call dxpy(n,w(lsk),1,w(lsr),1)
      call dxpy(n,w(lyk),1,w(lyr),1)
      icycle = icycle + 1
      goto 20
c
c reset
c
80    ireset = ireset + 1
c
c initialize the sum of all the changes in x.
c
      call dcopy(n,w(lsk),1,w(lsr),1)
      call dcopy(n,w(lyk),1,w(lyr),1)
      fkeep = fnew
      icycle = 1
      go to 20
c
c ...............end of main iteration.......................
c
90    ifail = 0
      f = fnew
      go to 130
100   oldf = fnew
c
c local search here could be installed here
c
110    f = oldf
c
c set ifail
c
120   ifail = nwhy

130   if (msglvl .ge. 1 .and. ifail .lt. 0) then
	      if (ifail .ne. 0) write(*,820) ifail
	      return
      endif
      
      if (msglvl .ge. 1) then
	      if (ifail .ne. 0) write(*,820) ifail
	      write(*,830) f
	      write(*,840)
	      nmax = 10
	      if (n .lt. nmax) nmax = n
	      write(*,850) (i,x(i),i=1,nmax)
      endif
      return

800   format(//' nit   nf   cg', 9x, 'f', 21x, 'gtg',//)
810   format(' ',i3,1x,i4,1x,i4,1x,1pd22.15,2x,1pd15.8)
820   format(//,' error code =', i3)
830   format(//,' optimal function value = ', 1pd22.15)
840   format(10x, 'current solution is (at most 10 components)', /,
     *       14x, 'i', 11x, 'x(i)')
850   format(10x, i5, 2x, 1pd22.15)

      end
c
c
      subroutine lmqnbc (ifail, n, x, f, g, w, lw, sfun, low, up,
     *   ipivot, msglvl, maxit, maxfun, eta, stepmx, accrcy, xtol)
      implicit         double precision (a-h,o-z)
      integer          msglvl,n,maxfun,ifail,lw
      integer          ipivot(n)
      double precision eta,xtol,stepmx,f,accrcy
      double precision x(n),g(n),w(lw),low(n),up(n)

c this routine solves the optimization problem
c
c   minimize     f(x)
c      x
c   subject to   low <= x <= up
c
c where x is a vector of n real variables.  the method used is
c a truncated-newton algorithm (see "newton-type minimization via
c the lanczos algorithm" by s.g. nash (technical report 378, math.
c the lanczos method" by s.g. nash (siam j. numer. anal. 21 (1984),
c pp. 770-778).  this algorithm finds a local minimum of f(x).  it does
c not assume that the function f is convex (and so cannot guarantee a
c global solution), but does assume that the function is bounded below.
c it can solve problems having any number of variables, but it is
c especially useful when the number of variables (n) is large.
c
c subroutine parameters:
c
c ierror  - (integer) error code
c           ( 0 => normal return
c           ( 2 => more than maxfun evaluations
c           ( 3 => line search failed to find lower
c           (          point (may not be serious)
c           (-1 => error in input parameters
c n       - (integer) number of variables
c x       - (real*8) vector of length at least n; on input, an initial
c           estimate of the solution; on output, the computed solution.
c g       - (real*8) vector of length at least n; on output, the final
c           value of the gradient
c f       - (real*8) on input, a rough estimate of the value of the
c           objective function at the solution; on output, the value
c           of the objective function at the solution
c w       - (real*8) work vector of length at least 14*n
c lw      - (integer) the declared dimension of w
c sfun    - a user-specified subroutine that computes the function
c           and gradient of the objective function.  it must have
c           the calling sequence
c             subroutine sfun (n, x, f, g)
c             integer           n
c             double precision  x(n), g(n), f
c low, up - (real*8) vectors of length at least n containing
c           the lower and upper bounds on the variables.  if
c           there are no bounds on a particular variable, set
c           the bounds to -1.d38 and 1.d38, respectively.
c ipivot  - (integer) work vector of length at least n, used
c           to record which variables are at their bounds.
c
c eta    - severity of the linesearch
c maxfun - maximum allowable number of function evaluations
c xtol   - desired accuracy for the solution x*
c stepmx - maximum allowable step in the linesearch
c accrcy - accuracy of computed function values
c msglvl - controls quantity of printed output
c          0 = none, 1 = one line per major iteration.
c maxit  - maximum number of inner iterations per step
c
c this routine is a bounds-constrained truncated-newton method.
c the truncated-newton method is preconditioned by a limited-memory
c quasi-newton method (this preconditioning strategy is developed
c in this routine) with a further diagonal scaling (see routine ndia3).
c for further details on the parameters, see routine tnbc.
c
      integer i, icycle, ioldg, ipk, iyk, loldg, lpk, lsr,
     *     lwtest, lyk, lyr, nftotl, niter, nm1, numf, nwhy
      double precision abstol, alpha, difnew, difold, epsmch, epsred,
     *     fkeep, flast, fm, fnew, fold, fstop, ftest, gnorm, gsk,
     *     gtg, gtpnew, oldf, oldgtp, one, pe, peps, pnorm, reltol,
     *     rteps, rtleps, rtol, rtolsq, small, spe, tiny,
     *     tnytol, toleps, xnorm, yksk, yrsr, zero
      logical conv, lreset, upd1, newcon
c
c the following standard functions and system functions are used
c
      double precision dabs, ddot, dnrm2, dsqrt, step1
      external sfun
      common/subscr/ lgv, lz1, lzk, lv, lsk, lyk, ldiagb, lsr, lyr,
     *     loldg, lhg, lhyk, lpk, lemat, lwtest
c
c check that initial x is feasible and that the bounds are consistent
c
      call crash(n,x,ipivot,low,up,ier)
      if (ier .ne. 0) write(*,800)
      if (ier .ne. 0) return
      if (msglvl .ge. 1) write(*,810)
c
c initialize variables
c
      call setpar(n)
      upd1 = .true.
      ireset = 0
      nfeval = 0
      nmodif = 0
      nlincg = 0
      fstop = f
      conv = .false.
      zero = 0.d0
      one = 1.d0
      nm1 = n - 1
c
c within this routine the array w(loldg) is shared by w(lhyr)
c
      lhyr = loldg
c
c check parameters and set constants
c
      call chkucp(lwtest,maxfun,nwhy,n,alpha,epsmch,
     *     eta,peps,rteps,rtol,rtolsq,stepmx,ftest,
     *     xtol,xnorm,x,lw,small,tiny,accrcy)
      if (nwhy .lt. 0) go to 160
      call setucr(small,nftotl,niter,n,f,fnew,
     *     fm,gtg,oldf,sfun,g,x)
      fold = fnew
      flast = fnew
c
c test the lagrange multipliers to see if they are non-negative.
c because the constraints are only lower bounds, the components
c of the gradient corresponding to the active constraints are the
c lagrange multipliers.  afterwords, the projected gradient is formed.
c
      do 10 i = 1,n
         if (ipivot(i) .eq. 2) go to 10
         if (-ipivot(i)*g(i) .ge. 0.d0) go to 10
         ipivot(i) = 0
10    continue
      call ztime(n,g,ipivot)
      gtg = ddot(n,g,1,g,1)
      if (msglvl .ge. 1)
     *    call monit(n,x,fnew,g,niter,nftotl,nfeval,lreset,ipivot)
c
c check if the initial point is a local minimum.
c
      ftest = one + dabs(fnew)
      if (gtg .lt. 1.d-4*epsmch*ftest*ftest) go to 130
c
c set initial values to other parameters
c
      icycle = nm1
      toleps = rtol + rteps
      rtleps = rtolsq + epsmch
      gnorm  = dsqrt(gtg)
      difnew = zero
      epsred = 5.0d-2
      fkeep  = fnew
c
c set the diagonal of the approximate hessian to unity.
c
      idiagb = ldiagb
      do 15 i = 1,n
         w(idiagb) = one
         idiagb = idiagb + 1
15    continue
c
c ..................start of main iterative loop..........
c
c compute the new search direction
c
      modet = msglvl - 3
      call modlnp(modet,w(lpk),w(lgv),w(lz1),w(lv),
     *     w(ldiagb),w(lemat),x,g,w(lzk),
     *     n,w,lw,niter,maxit,nfeval,nmodif,
     *     nlincg,upd1,yksk,gsk,yrsr,lreset,sfun,.true.,ipivot,
     *     accrcy,gtpnew,gnorm,xnorm)
20    continue
      call dcopy(n,g,1,w(loldg),1)
      pnorm = dnrm2(n,w(lpk),1)
      oldf = fnew
      oldgtp = gtpnew
c
c prepare to compute the step length
c
      pe = pnorm + epsmch
c
c compute the absolute and relative tolerances for the linear search
c
      reltol = rteps*(xnorm + one)/pe
      abstol = - epsmch*ftest/(oldgtp - epsmch)
c
c compute the smallest allowable spacing between points in
c the linear search
c
      tnytol = epsmch*(xnorm + one)/pe
      call stpmax(stepmx,pe,spe,n,x,w(lpk),ipivot,low,up)
c
c set the initial step length.
c
      alpha = step1(fnew,fm,oldgtp,spe)
c
c perform the linear search
c
      call linder(n,sfun,small,epsmch,reltol,abstol,tnytol,
     *     eta,zero,spe,w(lpk),oldgtp,x,fnew,alpha,g,numf,
     *     nwhy,w,lw)
      newcon = .false.
      if (dabs(alpha-spe) .gt. 1.d1*epsmch) go to 30
      newcon = .true.
      nwhy   = 0
      call modz(n,x,w(lpk),ipivot,epsmch,low,up,flast,fnew)
      flast = fnew
c
30    if (msglvl .ge. 2) write(*,820) alpha,pnorm
      fold = fnew
      niter = niter + 1
      nftotl = nftotl + numf
c
c if required, print the details of this iteration
c
      if (msglvl .ge. 1)
     *    call monit(n,x,fnew,g,niter,nftotl,nfeval,lreset,ipivot)
      if (nwhy .lt. 0) go to 160
      if (nwhy .eq. 0 .or. nwhy .eq. 2) go to 40
c
c the linear search has failed to find a lower point
c
      nwhy = 3
      go to 140
40    if (nwhy .le. 1) go to 50
      call sfun(n,x,fnew,g)
      nftotl = nftotl + 1
c
c terminate if more than maxfun evaluations have been made
c
50    nwhy = 2
      if (nftotl .gt. maxfun) go to 150
      nwhy = 0
c
c set up parameters used in convergence and resetting tests
c
      difold = difnew
      difnew = oldf - fnew
c
c if this is the first iteration of a new cycle, compute the
c percentage reduction factor for the resetting test.
c
      if (icycle .ne. 1) go to 60
      if (difnew .gt. 2.d0*difold) epsred = epsred + epsred
      if (difnew .lt. 5.0d-1*difold) epsred = 5.0d-1*epsred
60    call dcopy(n,g,1,w(lgv),1)
      call ztime(n,w(lgv),ipivot)
      gtg = ddot(n,w(lgv),1,w(lgv),1)
      gnorm = dsqrt(gtg)
      ftest = one + dabs(fnew)
      xnorm = dnrm2(n,x,1)
c
c test for convergence
c
      call cnvtst(conv,alpha,pnorm,toleps,xnorm,difnew,rtleps,
     *     ftest,gtg,peps,epsmch,gtpnew,fnew,flast,g,ipivot,n,accrcy)
      if (conv) go to 130
      call ztime(n,g,ipivot)
c
c compute the change in the iterates and the corresponding change
c in the gradients
c
      if (newcon) go to 90
      isk = lsk
      ipk = lpk
      iyk = lyk
      ioldg = loldg
      do 70 i = 1,n
         w(iyk) = g(i) - w(ioldg)
         w(isk) = alpha*w(ipk)
         ipk = ipk + 1
         isk = isk + 1
         iyk = iyk + 1
         ioldg = ioldg + 1
70    continue
c
c set up parameters used in updating the preconditioning strategy.
c
      yksk = ddot(n,w(lyk),1,w(lsk),1)
      lreset = .false.
      if (icycle .eq. nm1 .or. difnew .lt.
     *     epsred*(fkeep-fnew)) lreset = .true.
      if (lreset) go to 80
      yrsr = ddot(n,w(lyr),1,w(lsr),1)
      if (yrsr .le. zero) lreset = .true.
80    continue
      upd1 = .false.
c
c      compute the new search direction
c
90    if (upd1 .and. msglvl .ge. 2) write(*,830)
      if (newcon .and. msglvl .ge. 2) write(*,840)
      modet = msglvl - 3
      call modlnp(modet,w(lpk),w(lgv),w(lz1),w(lv),
     *     w(ldiagb),w(lemat),x,g,w(lzk),
     *     n,w,lw,niter,maxit,nfeval,nmodif,
     *     nlincg,upd1,yksk,gsk,yrsr,lreset,sfun,.true.,ipivot,
     *     accrcy,gtpnew,gnorm,xnorm)
      if (newcon) go to 20
      if (lreset) go to 110
c
c compute the accumulated step and its corresponding
c gradient difference.
c
      call dxpy(n,w(lsk),1,w(lsr),1)
      call dxpy(n,w(lyk),1,w(lyr),1)
      icycle = icycle + 1
      goto 20
c
c reset
c
110   ireset = ireset + 1
c
c initialize the sum of all the changes in x.
c
      call dcopy(n,w(lsk),1,w(lsr),1)
      call dcopy(n,w(lyk),1,w(lyr),1)
      fkeep = fnew
      icycle = 1
      go to 20
c
c ...............end of main iteration.......................
c
130   ifail = 0
      f = fnew
      goto 170
140   oldf = fnew
c
c local search could be installed here
c
150   f = oldf
      if (msglvl .ge. 1) call monit(n,x,
     *     f,g,niter,nftotl,nfeval,ireset,ipivot)
c
c set ifail
c
160   ifail = nwhy


170   if (msglvl .ge. 1 .and. ifail .lt. 0) then
	      if (ifail .ne. 0) write(*,850) ifail
	      return
      endif
      if (msglvl .ge. 1) then
	      if (ifail .ne. 0) write(*,850) ifail
	      write(*,860) f
	      write(*,870)
	      nmax = 10
	      if (n .lt. nmax) nmax = n
	      write(*,880) (i,x(i),i=1,nmax)
      endif
      return



800   format(' there is no feasible point; terminating algorithm')
810   format(//'  nit   nf   cg', 9x, 'f', 21x, 'gtg',//)
820   format('        linesearch results:  alpha,pnorm',2(1pd12.4))
830   format(' upd1 is true - trivial preconditioning')
840   format(' newcon is true - constraint added in linesearch')
850   format(//,' error code =', i3)
860   format(//,' optimal function value = ', 1pd22.15)
870   format(10x, 'current solution is (at most 10 components)', /,
     *       14x, 'i', 11x, 'x(i)')
880   format(10x, i5, 2x, 1pd22.15)

      end
c
c
      subroutine monit(n,x,f,g,niter,nftotl,nfeval,ireset,ipivot)
c
c print results of current iteration
c
      implicit         double precision (a-h,o-z)
      double precision x(n),f,g(n),gtg
      integer          ipivot(n)
c
      gtg = 0.d0
      do 10 i = 1,n
         if (ipivot(i) .ne. 0) go to 10
         gtg = gtg + g(i)*g(i)
10    continue
      write(*,800) niter,nftotl,nfeval,f,gtg
      return
800   format(' ',i4,1x,i4,1x,i4,1x,1pd22.15,2x,1pd15.8)
      end
c
c
      subroutine ztime(n,x,ipivot)
      implicit         double precision (a-h,o-z)
      double precision x(n)
      integer          ipivot(n)
c
c this routine multiplies the vector x by the constraint matrix z
c
      do 10 i = 1,n
         if (ipivot(i) .ne. 0) x(i) = 0.d0
10    continue
      return
      end
c
c
      subroutine stpmax(stepmx,pe,spe,n,x,p,ipivot,low,up)
      implicit         double precision (a-h,o-z)
      double precision low(n),up(n),x(n),p(n),stepmx,pe,spe,t
      integer          ipivot(n)
c
c compute the maximum allowable step length
c
      spe = stepmx / pe
c spe is the standard (unconstrained) max step
      do 10 i = 1,n
         if (ipivot(i) .ne. 0) go to 10
         if (p(i) .eq. 0.d0) go to 10
         if (p(i) .gt. 0.d0) go to 5
         t = low(i) - x(i)
         if (t .gt. spe*p(i)) spe = t / p(i)
         go to 10
5        t = up(i) - x(i)
         if (t .lt. spe*p(i)) spe = t / p(i)
10    continue
      return
      end
c
c
      subroutine modz(n,x,p,ipivot,epsmch,low,up,flast,fnew)
      implicit         double precision (a-h,o-z)
      double precision x(n), p(n), epsmch, dabs, tol, low(n), up(n),
     *                 flast, fnew
      integer          ipivot(n)
c
c update the constraint matrix if a new constraint is encountered
c
      do 10 i = 1,n
         if (ipivot(i) .ne. 0) go to 10
         if (p(i) .eq. 0.d0) go to 10
         if (p(i) .gt. 0.d0) go to 5
         tol = 1.d1 * epsmch * (dabs(low(i)) + 1.d0)
         if (x(i)-low(i) .gt. tol) go to 10
         flast = fnew
         ipivot(i) = -1
         x(i) = low(i)
         go to 10
5        tol = 1.d1 * epsmch * (dabs(up(i)) + 1.d0)
         if (up(i)-x(i) .gt. tol) go to 10
         flast = fnew
         ipivot(i) = 1
         x(i) = up(i)
10    continue
      return
      end
c
c
      subroutine cnvtst(conv,alpha,pnorm,toleps,xnorm,difnew,rtleps,
     *     ftest,gtg,peps,epsmch,gtpnew,fnew,flast,g,ipivot,n,accrcy)
      implicit double precision (a-h,o-z)
      logical conv,ltest
      integer ipivot(n)
      double precision g(n), alpha, pnorm, toleps, xnorm, difnew,
     *     rtleps, ftest, gtg, peps, epsmch, gtpnew, fnew, flast, one,
     *     cmax, t, accrcy
c
c test for convergence
c
      imax = 0
      cmax = 0.d0
      ltest = flast - fnew .le. -5.d-1*gtpnew
      do 10 i = 1,n
         if (ipivot(i) .eq. 0 .or. ipivot(i) .eq. 2) go to 10
         t = -ipivot(i)*g(i)
         if (t .ge. 0.d0) go to 10
         conv = .false.
         if (ltest) go to 10
         if (cmax .le. t) go to 10
         cmax = t
         imax = i
10    continue
      if (imax .eq. 0) go to 15
      ipivot(imax) = 0
      flast = fnew
      return
15    continue
      conv = .false.
      one = 1.d0
      if ((alpha*pnorm .ge. toleps*(one + xnorm)
     *     .or. dabs(difnew) .ge. rtleps*ftest
     *     .or. gtg .ge. peps*ftest*ftest)
     *     .and. gtg .ge. 1.d-4*accrcy*ftest*ftest) return
      conv = .true.
c
c for details, see gill, murray, and wright (1981, p. 308) and
c fletcher (1981, p. 116).  the multiplier tests (here, testing
c the sign of the components of the gradient) may still need to
c modified to incorporate tolerances for zero.
c
      return
      end
c
c
      subroutine crash(n,x,ipivot,low,up,ier)
      implicit double precision (a-h,o-z)
      double precision x(n),low(n),up(n)
      integer ipivot(n)
c
c this initializes the constraint information, and ensures that the
c initial point satisfies  low <= x <= up.
c the constraints are checked for consistency.
c
      ier = 0
      do 30 i = 1,n
         if (x(i) .lt. low(i)) x(i) = low(i)
         if (x(i) .gt. up(i)) x(i) = up(i)
         ipivot(i) = 0
         if (x(i) .eq. low(i)) ipivot(i) = -1
         if (x(i) .eq. up(i)) ipivot(i) = 1
         if (up(i) .eq. low(i)) ipivot(i) = 2
         if (low(i) .gt. up(i)) ier = -i
30    continue
      return
      end
c
c the vectors sk and yk, although not in the call,
c are used (via their position in w) by the routine msolve.
c
      subroutine modlnp(modet,zsol,gv,r,v,diagb,emat,
     *     x,g,zk,n,w,lw,niter,maxit,nfeval,nmodif,nlincg,
     *     upd1,yksk,gsk,yrsr,lreset,sfun,bounds,ipivot,accrcy,
     *     gtp,gnorm,xnorm)
      implicit double precision (a-h,o-z)
      integer modet,n,niter,ipivot(1)
      double precision zsol(n),g(n),gv(n),r(n),v(n),diagb(n),w(lw)
      double precision emat(n),zk(n),x(n),accrcy
      double precision alpha,beta,delta,gsk,gtp,pr,
     *     qold,qnew,qtest,rhsnrm,rnorm,rz,rzold,tol,vgv,yksk,yrsr
      double precision gnorm,xnorm
      double precision ddot,dnrm2
      logical first,upd1,lreset,bounds
      external sfun
c
c this routine performs a preconditioned conjugate-gradient
c iteration in order to solve the newton equations for a search
c direction for a truncated-newton algorithm.  when the value of the
c quadratic model is sufficiently reduced,
c the iteration is terminated.
c
c parameters
c
c modet       - integer which controls amount of output
c zsol        - computed search direction
c g           - current gradient
c gv,gz1,v    - scratch vectors
c r           - residual
c diagb,emat  - diagonal preconditoning matrix
c niter       - nonlinear iteration #
c feval       - value of quadratic function
c
c *************************************************************
c initialization
c *************************************************************
c
c general initialization
c
      if (modet .gt. 0) write(*,800)
      if (maxit .eq. 0) return
      first = .true.
      rhsnrm = gnorm
      tol = 1.d-12
      qold = 0.d0
c
c initialization for preconditioned conjugate-gradient algorithm
c
      call initpc(diagb,emat,n,w,lw,modet,
     *            upd1,yksk,gsk,yrsr,lreset)
      do 10 i = 1,n
         r(i) = -g(i)
         v(i) = 0.d0
         zsol(i) = 0.d0
10    continue
c
c ************************************************************
c main iteration
c ************************************************************
c
      do 30 k = 1,maxit
         nlincg = nlincg + 1
         if (modet .gt. 1) write(*,810) k
c
c cg iteration to solve system of equations
c
         if (bounds) call ztime(n,r,ipivot)
         call msolve(r,zk,n,w,lw,upd1,yksk,gsk,
     *                 yrsr,lreset,first)
         if (bounds) call ztime(n,zk,ipivot)
         rz = ddot(n,r,1,zk,1)
         if (rz/rhsnrm .lt. tol) go to 80
         if (k .eq. 1) beta = 0.d0
         if (k .gt. 1) beta = rz/rzold
         do 20 i = 1,n
            v(i) = zk(i) + beta*v(i)
20       continue
         if (bounds) call ztime(n,v,ipivot)
         call gtims(v,gv,n,x,g,w,lw,sfun,first,delta,accrcy,xnorm)
         if (bounds) call ztime(n,gv,ipivot)
         nfeval = nfeval + 1
         vgv = ddot(n,v,1,gv,1)
         if (vgv/rhsnrm .lt. tol) go to 50
         call ndia3(n,emat,v,gv,r,vgv,modet)
c
c compute linear step length
c
         alpha = rz / vgv
         if (modet .ge. 1) write(*,820) alpha
c
c compute current solution and related vectors
c
         call daxpy(n,alpha,v,1,zsol,1)
         call daxpy(n,-alpha,gv,1,r,1)
c
c test for convergence
c
         gtp = ddot(n,zsol,1,g,1)
         pr = ddot(n,r,1,zsol,1)
         qnew = 5.d-1 * (gtp + pr)
         qtest = k * (1.d0 - qold/qnew)
         if (qtest .lt. 0.d0) go to 70
         qold = qnew
         if (qtest .le. 5.d-1) go to 70
c
c perform cautionary test
c
         if (gtp .gt. 0) go to 40
         rzold = rz
30    continue
c
c terminate algorithm
c
      k = k-1
      go to 70
c
c truncate algorithm in case of an emergency
c
40    if (modet .ge. -1) write(*,830) k
      call daxpy(n,-alpha,v,1,zsol,1)
      gtp = ddot(n,zsol,1,g,1)
      go to 90
50    continue
      if (modet .gt. -2) write(*,840)
60    if (k .gt. 1) go to 70
      call msolve(g,zsol,n,w,lw,upd1,yksk,gsk,yrsr,lreset,first)
      call negvec(n,zsol)
      if (bounds) call ztime(n,zsol,ipivot)
      gtp = ddot(n,zsol,1,g,1)
70    continue
      if (modet .ge. -1) write(*,850) k,rnorm
      go to 90
80    continue
      if (modet .ge. -1) write(*,860)
      if (k .gt. 1) go to 70
      call dcopy(n,g,1,zsol,1)
      call negvec(n,zsol)
      if (bounds) call ztime(n,zsol,ipivot)
      gtp = ddot(n,zsol,1,g,1)
      go to 70
c
c store (or restore) diagonal preconditioning
c
90    continue
      call dcopy(n,emat,1,diagb,1)
      return
800   format(' ',//,' entering modlnp')
810   format(' ',//,' ### iteration ',i2,' ###')
820   format(' alpha',1pd16.8)
830   format(' g(t)z positive at iteration ',i2,
     *     ' - truncating method',/)
840   format(' ',10x,'hessian not positive-definite')
850   format(' ',/,8x,'modlan truncated after ',i3,' iterations',
     *     '  rnorm = ',1pd14.6)
860   format(' preconditioning not positive-definite')
      end
c
c
      subroutine ndia3(n,e,v,gv,r,vgv,modet)
      implicit double precision (a-h,o-z)
      double precision e(n),v(n),gv(n),r(n),vgv,vr,ddot
c
c update the preconditioing matrix based on a diagonal version
c of the bfgs quasi-newton update.
c
      vr = ddot(n,v,1,r,1)
      do 10 i = 1,n
         e(i) = e(i) - r(i)*r(i)/vr + gv(i)*gv(i)/vgv
         if (e(i) .gt. 1.d-6) go to 10
         if (modet .gt. -2) write(*,800) e(i)
         e(i) = 1.d0
10    continue
      return
800   format(' *** emat negative:  ',1pd16.8)
      end
c
c      service routines for optimization
c
      subroutine negvec(n,v)
      implicit double precision (a-h,o-z)
      integer n
      double precision v(n)
c
c negative of the vector v
c
      integer i
      do 10 i = 1,n
         v(i) = -v(i)
10    continue
      return
      end
c
c
      subroutine lsout(iloc,itest,xmin,fmin,gmin,xw,fw,gw,u,a,
     *     b,tol,eps,scxbd,xlamda)
      implicit double precision (a-h,o-z)
      double precision xmin,fmin,gmin,xw,fw,gw,u,a,b,
     *     tol,eps,scxbd,xlamda
c
c error printouts for getptc
c
      double precision ya,yb,ybnd,yw,yu
      yu = xmin + u
      ya = a + xmin
      yb = b + xmin
      yw = xw + xmin
      ybnd = scxbd + xmin
      write(*,800)
      write(*,810) tol,eps
      write(*,820) ya,yb
      write(*,830) ybnd
      write(*,840) yw,fw,gw
      write(*,850) xmin,fmin,gmin
      write(*,860) yu
      write(*,870) iloc,itest
      return
800   format(///' output from linear search')
810   format('  tol and eps'/2d25.14)
820   format('  current upper and lower bounds'/2d25.14)
830   format('  strict upper bound'/d25.14)
840   format('  xw, fw, gw'/3d25.14)
850   format('  xmin, fmin, gmin'/3d25.14)
860   format('  new estimate'/2d25.14)
870   format('  iloc and itest'/2i3)
      end
c
c
      double precision function step1(fnew,fm,gtp,smax)
      implicit double precision (a-h,o-z)
      double precision fnew,fm,gtp,smax
c
c ********************************************************
c step1 returns the length of the initial step to be taken along the
c vector p in the next linear search.
c ********************************************************
c
      double precision alpha,d,epsmch
      double precision dabs,mchpr1
      epsmch = mchpr1()
      d = dabs(fnew-fm)
      alpha = 1.d0
      if (2.d0*d .le. (-gtp) .and. d .ge. epsmch)
     *     alpha = -2.d0*d/gtp
      if (alpha .ge. smax) alpha = smax
      step1 = alpha
      return
      end
c
c
      double precision function mchpr1()
      implicit double precision (a-h,o-z)
      double precision x
c
c returns the value of epsmch, where epsmch is the smallest possible
c real number such that 1.0 + epsmch .gt. 1.0
c
c for vax
c
c     mchpr1 = 1.d-17
c
c for sun
c
c     mchpr1 = 1.0842021724855d-19
c win32
      mchpr1 = 2.2204460492503131d-16 
      return
      end
c
c
      subroutine chkucp(lwtest,maxfun,nwhy,n,alpha,epsmch,
     *     eta,peps,rteps,rtol,rtolsq,stepmx,test,
     *     xtol,xnorm,x,lw,small,tiny,accrcy)
      implicit double precision (a-h,o-z)
      integer lw,lwtest,maxfun,nwhy,n
      double precision accrcy,alpha,epsmch,eta,peps,rteps,rtol,
     *     rtolsq,stepmx,test,xtol,xnorm,small,tiny
      double precision x(n)
c
c checks parameters and sets constants which are common to both
c derivative and non-derivative algorithms
c
      double precision dabs,dsqrt,mchpr1
      epsmch = mchpr1()
      small = epsmch*epsmch
      tiny = small
      nwhy = -1
      rteps = dsqrt(epsmch)
      rtol = xtol
      if (dabs(rtol) .lt. accrcy) rtol = 1.d1*rteps
c
c check for errors in the input parameters
c
      if (lw .lt. lwtest
     *      .or. n .lt. 1 .or. rtol .lt. 0.d0 .or. eta .ge. 1.d0 .or.
     *      eta .lt. 0.d0 .or. stepmx .lt. rtol .or.
     *      maxfun .lt. 1) return
      nwhy = 0
c
c set constants for later
c
      rtolsq = rtol*rtol
      peps = accrcy**0.6666d0
      xnorm = dnrm2(n,x,1)
      alpha = 0.d0
      test = 0.d0
      return
      end
c
c
      subroutine setucr(small,nftotl,niter,n,f,fnew,
     *            fm,gtg,oldf,sfun,g,x)
      implicit         double precision (a-h,o-z)
      integer          nftotl,niter,n
      double precision f,fnew,fm,gtg,oldf,small
      double precision g(n),x(n)
      external         sfun
c
c check input parameters, compute the initial function value, set
c constants for the subsequent minimization
c
      fm = f
c
c compute the initial function value
c
      call sfun(n,x,fnew,g)
      nftotl = 1
c
c set constants for later
c
      niter = 0
      oldf = fnew
      gtg = ddot(n,g,1,g,1)
      return
      end
c
c
      subroutine gtims(v,gv,n,x,g,w,lw,sfun,first,delta,accrcy,xnorm)
      implicit double precision (a-h,o-z)
      double precision v(n),gv(n),dinv,delta,g(n)
      double precision f,x(n),w(lw),accrcy,dsqrt,xnorm
      logical first
      external sfun
      common/subscr/ lgv,lz1,lzk,lv,lsk,lyk,ldiagb,lsr,lyr,
     *     lhyr,lhg,lhyk,lpk,lemat,lwtest
c
c this routine computes the product of the matrix g times the vector
c v and stores the result in the vector gv (finite-difference version)
c
      if (.not. first) go to 20
      delta = dsqrt(accrcy)*(1.d0+xnorm)
      first = .false.
20    continue
      dinv = 1.d0/delta
      ihg = lhg
      do 30 i = 1,n
         w(ihg) = x(i) + delta*v(i)
         ihg = ihg + 1
30    continue
      call sfun(n,w(lhg),f,gv)
      do 40 i = 1,n
         gv(i) = (gv(i) - g(i))*dinv
40    continue
      return
      end
c
c
      subroutine msolve(g,y,n,w,lw,upd1,yksk,gsk,
     *     yrsr,lreset,first)
      implicit double precision (a-h,o-z)
      double precision g(n),y(n),w(lw),yksk,gsk,yrsr
      logical upd1,lreset,first
c
c this routine sets upt the arrays for mslv
c
      common/subscr/ lgv,lz1,lzk,lv,lsk,lyk,ldiagb,lsr,lyr,
     *     lhyr,lhg,lhyk,lpk,lemat,lwtest
      call mslv(g,y,n,w(lsk),w(lyk),w(ldiagb),w(lsr),w(lyr),w(lhyr),
     *     w(lhg),w(lhyk),upd1,yksk,gsk,yrsr,lreset,first)
      return
      end
      subroutine mslv(g,y,n,sk,yk,diagb,sr,yr,hyr,hg,hyk,
     *     upd1,yksk,gsk,yrsr,lreset,first)
      implicit double precision (a-h,o-z)
      double precision g(n),y(n)
c
c this routine acts as a preconditioning step for the
c linear conjugate-gradient routine.  it is also the
c method of computing the search direction from the
c gradient for the non-linear conjugate-gradient code.
c it represents a two-step self-scaled bfgs formula.
c
      double precision ddot,yksk,gsk,yrsr,rdiagb,ykhyk,ghyk,
     *     yksr,ykhyr,yrhyr,gsr,ghyr
      double precision sk(n),yk(n),diagb(n),sr(n),yr(n),hyr(n),hg(n),
     *     hyk(n),one
      logical lreset,upd1,first
      if (upd1) go to 100
      one = 1.d0
      gsk = ddot(n,g,1,sk,1)
      if (lreset) go to 60
c
c compute hg and hy where h is the inverse of the diagonals
c
      do 57 i = 1,n
         rdiagb = 1.0d0/diagb(i)
         hg(i) = g(i)*rdiagb
         if (first) hyk(i) = yk(i)*rdiagb
         if (first) hyr(i) = yr(i)*rdiagb
57    continue
      if (first) yksr = ddot(n,yk,1,sr,1)
      if (first) ykhyr = ddot(n,yk,1,hyr,1)
      gsr = ddot(n,g,1,sr,1)
      ghyr = ddot(n,g,1,hyr,1)
      if (first) yrhyr = ddot(n,yr,1,hyr,1)
      call ssbfgs(n,one,sr,yr,hg,hyr,yrsr,
     *     yrhyr,gsr,ghyr,hg)
      if (first) call ssbfgs(n,one,sr,yr,hyk,hyr,yrsr,
     *     yrhyr,yksr,ykhyr,hyk)
      ykhyk = ddot(n,hyk,1,yk,1)
      ghyk = ddot(n,hyk,1,g,1)
      call ssbfgs(n,one,sk,yk,hg,hyk,yksk,
     *     ykhyk,gsk,ghyk,y)
      return
60    continue
c
c compute gh and hy where h is the inverse of the diagonals
c
      do 65 i = 1,n
         rdiagb = 1.d0/diagb(i)
         hg(i) = g(i)*rdiagb
         if (first) hyk(i) = yk(i)*rdiagb
65    continue
      if (first) ykhyk = ddot(n,yk,1,hyk,1)
      ghyk = ddot(n,g,1,hyk,1)
      call ssbfgs(n,one,sk,yk,hg,hyk,yksk,
     *     ykhyk,gsk,ghyk,y)
      return
100   continue
      do 110 i = 1,n
110      y(i) = g(i) / diagb(i)
      return
      end
c
c
      subroutine ssbfgs(n,gamma,sj,yj,hjv,hjyj,yjsj,yjhyj,
     *     vsj,vhyj,hjp1v)
      implicit double precision (a-h,o-z)
      integer n
      double precision gamma,yjsj,yjhyj,vsj,vhyj
      double precision sj(n),yj(n),hjv(n),hjyj(n),hjp1v(n)
c
c self-scaled bfgs
c
      integer i
      double precision beta,delta
      delta = (1.d0 + gamma*yjhyj/yjsj)*vsj/yjsj
     *     - gamma*vhyj/yjsj
      beta = -gamma*vsj/yjsj
      do 10 i = 1,n
         hjp1v(i) = gamma*hjv(i) + delta*sj(i) + beta*hjyj(i)
10    continue
      return
      end
c
c routines to initialize preconditioner
c
      subroutine initpc(diagb,emat,n,w,lw,modet,
     *     upd1,yksk,gsk,yrsr,lreset)
      implicit double precision (a-h,o-z)
      double precision diagb(n),emat(n),w(lw)
      double precision yksk,gsk,yrsr
      logical lreset,upd1
      common/subscr/ lgv,lz1,lzk,lv,lsk,lyk,ldiagb,lsr,lyr,
     *     lhyr,lhg,lhyk,lpk,lemat,lwtest
      call initp3(diagb,emat,n,lreset,yksk,yrsr,w(lhyk),
     *     w(lsk),w(lyk),w(lsr),w(lyr),modet,upd1)
      return
      end
      subroutine initp3(diagb,emat,n,lreset,yksk,yrsr,bsk,
     *     sk,yk,sr,yr,modet,upd1)
      implicit double precision (a-h,o-z)
      double precision diagb(n),emat(n),yksk,yrsr,bsk(n),sk(n),
     *     yk(n),cond,sr(n),yr(n),ddot,sds,srds,yrsk,td,d1,dn
      logical lreset,upd1
      if (upd1) go to 90
      if (lreset) go to 60
      do 10 i = 1,n
         bsk(i) = diagb(i)*sr(i)
10    continue
      sds = ddot(n,sr,1,bsk,1)
      srds = ddot(n,sk,1,bsk,1)
      yrsk = ddot(n,yr,1,sk,1)
      do 20 i = 1,n
         td = diagb(i)
         bsk(i) = td*sk(i) - bsk(i)*srds/sds+yr(i)*yrsk/yrsr
         emat(i) = td-td*td*sr(i)*sr(i)/sds+yr(i)*yr(i)/yrsr
20    continue
      sds = ddot(n,sk,1,bsk,1)
      do 30 i = 1,n
         emat(i) = emat(i) - bsk(i)*bsk(i)/sds+yk(i)*yk(i)/yksk
30    continue
      go to 110
60    continue
      do 70 i = 1,n
         bsk(i) = diagb(i)*sk(i)
70    continue
      sds = ddot(n,sk,1,bsk,1)
      do 80 i = 1,n
         td = diagb(i)
         emat(i) = td - td*td*sk(i)*sk(i)/sds + yk(i)*yk(i)/yksk
80    continue
      go to 110
90    continue
      call dcopy(n,diagb,1,emat,1)
110   continue
      if (modet .lt. 1) return
      d1 = emat(1)
      dn = emat(1)
      do 120 i = 1,n
         if (emat(i) .lt. d1) d1 = emat(i)
         if (emat(i) .gt. dn) dn = emat(i)
120   continue
      cond = dn/d1
      write(*,800) d1,dn,cond
800   format(' ',//8x,'dmin =',1pd12.4,'  dmax =',1pd12.4,
     *     ' cond =',1pd12.4,/)
      return
      end
c
c
      subroutine setpar(n)
      implicit double precision (a-h,o-z)
      integer lsub(14)
      common/subscr/ lsub,lwtest
c
c set up parameters for the optimization routine
c
      do 10 i = 1,14
          lsub(i) = (i-1)*n + 1
10    continue
      lwtest = lsub(14) + n - 1
      return
      end
c
c      line search algorithms of gill and murray
c
      subroutine linder(n,sfun,small,epsmch,reltol,abstol,
     *     tnytol,eta,sftbnd,xbnd,p,gtp,x,f,alpha,g,nftotl,
     *     iflag,w,lw)
      implicit double precision (a-h,o-z)
      integer n,nftotl,iflag,lw
      double precision small,epsmch,reltol,abstol,tnytol,eta,
     *     sftbnd,xbnd,gtp,f,alpha
      double precision p(n),x(n),g(n),w(lw)
c
c
      integer i,ientry,itest,l,lg,lx,numf,itcnt
      double precision a,b,b1,big,e,factor,fmin,fpresn,fu,
     *     fw,gmin,gtest1,gtest2,gu,gw,oldf,scxbnd,step,
     *     tol,u,xmin,xw,rmu,rtsmll,ualpha
      logical braktd
c
c      the following standard functions and system functions are
c      called within linder
c
      double precision ddot,dsqrt
      external sfun
c
c      allocate the addresses for local workspace
c
      lx = 1
      lg = lx + n
      lsprnt = 0
      nprnt  = 10000
      rtsmll = dsqrt(small)
      big = 1.d0/small
      itcnt = 0
c
c      set the estimated relative precision in f(x).
c
      fpresn = 10.d0*epsmch
      numf = 0
      u = alpha
      fu = f
      fmin = f
      gu = gtp
      rmu = 1.0d-4
c
c      first entry sets up the initial interval of uncertainty.
c
      ientry = 1
10    continue
c
c test for too many iterations
c
      itcnt = itcnt + 1
      iflag = 1
      if (itcnt .gt. 20) go to 50
      iflag = 0
      call getptc(big,small,rtsmll,reltol,abstol,tnytol,
     *     fpresn,eta,rmu,xbnd,u,fu,gu,xmin,fmin,gmin,
     *     xw,fw,gw,a,b,oldf,b1,scxbnd,e,step,factor,
     *     braktd,gtest1,gtest2,tol,ientry,itest)
clsout
      if (lsprnt .ge. nprnt) call lsout(ientry,itest,xmin,fmin,gmin,
     *     xw,fw,gw,u,a,b,tol,reltol,scxbnd,xbnd)
c
c      if itest=1, the algorithm requires the function value to be
c      calculated.
c
      if (itest .ne. 1) go to 30
      ualpha = xmin + u
      l = lx
      do 20 i = 1,n
         w(l) = x(i) + ualpha*p(i)
         l = l + 1
20    continue
      call sfun(n,w(lx),fu,w(lg))
      numf = numf + 1
      gu = ddot(n,w(lg),1,p,1)
c
c      the gradient vector corresponding to the best point is
c      overwritten if fu is less than fmin and fu is sufficiently
c      lower than f at the origin.
c
      if (fu .le. fmin .and. fu .le. oldf-ualpha*gtest1)
     *     call dcopy(n,w(lg),1,g,1)
      goto 10
c
c      if itest=2 or 3 a lower point could not be found
c
30    continue
      nftotl = numf
      iflag = 1
      if (itest .ne. 0) go to 50
c
c      if itest=0 a successful search has been made
c
      iflag = 0
      f = fmin
      alpha = xmin
      do 40 i = 1,n
         x(i) = x(i) + alpha*p(i)
40    continue
50    return
      end
c
c
      subroutine getptc(big,small,rtsmll,reltol,abstol,tnytol,
     *     fpresn,eta,rmu,xbnd,u,fu,gu,xmin,fmin,gmin,
     *     xw,fw,gw,a,b,oldf,b1,scxbnd,e,step,factor,
     *     braktd,gtest1,gtest2,tol,ientry,itest)
      implicit double precision (a-h,o-z)
      logical braktd
      integer ientry,itest
      double precision big,small,rtsmll,reltol,abstol,tnytol,
     *     fpresn,eta,rmu,xbnd,u,fu,gu,xmin,fmin,gmin,
     *     xw,fw,gw,a,b,oldf,b1,scxbnd,e,step,factor,
     *     gtest1,gtest2,tol,denom
c
c ************************************************************
c getptc, an algorithm for finding a steplength, called repeatedly by
c routines which require a step length to be computed using cubic
c interpolation. the parameters contain information about the interval
c in which a lower point is to be found and from this getptc computes a
c point at which the function can be evaluated by the calling program.
c the value of the integer parameters ientry determines the path taken
c through the code.
c ************************************************************
c
      logical convrg
      double precision abgmin,abgw,absr,a1,chordm,chordu,
     *     d1,d2,p,q,r,s,scale,sumsq,twotol,xmidpt
      double precision zero, point1,half,one,three,five,eleven
c
c the following standard functions and system functions are called
c within getptc
c
      double precision dabs, dsqrt
c
      zero = 0.d0
      point1 = 1.d-1
      half = 5.d-1
      one = 1.d0
      three = 3.d0
      five = 5.d0
      eleven = 11.d0
c
c      branch to appropriate section of code depending on the
c      value of ientry.
c
      goto (10,20), ientry
c
c      ientry=1
c      check input parameters
c
10      itest = 2
      if (u .le. zero .or. xbnd .le. tnytol .or. gu .gt. zero)
     *     return
      itest = 1
      if (xbnd .lt. abstol) abstol = xbnd
      tol = abstol
      twotol = tol + tol
c
c a and b define the interval of uncertainty, x and xw are points
c with lowest and second lowest function values so far obtained.
c initialize a,smin,xw at origin and corresponding values of
c function and projection of the gradient along direction of search
c at values for latest estimate at minimum.
c
      a = zero
      xw = zero
      xmin = zero
      oldf = fu
      fmin = fu
      fw = fu
      gw = gu
      gmin = gu
      step = u
      factor = five
c
c      the minimum has not yet been bracketed.
c
      braktd = .false.
c
c set up xbnd as a bound on the step to be taken. (xbnd is not computed
c explicitly but scxbnd is its scaled value.)  set the upper bound
c on the interval of uncertainty initially to xbnd + tol(xbnd).
c
      scxbnd = xbnd
      b = scxbnd + reltol*dabs(scxbnd) + abstol
      e = b + b
      b1 = b
c
c compute the constants required for the two convergence criteria.
c
      gtest1 = -rmu*gu
      gtest2 = -eta*gu
c
c set ientry to indicate that this is the first iteration
c
      ientry = 2
      go to 210
c
c ientry = 2
c
c update a,b,xw, and xmin
c
20      if (fu .gt. fmin) go to 60
c
c if function value not increased, new point becomes next
c origin and other points are scaled accordingly.
c
      chordu = oldf - (xmin + u)*gtest1
      if (fu .le. chordu) go to 30
c
c the new function value does not satisfy the sufficient decrease
c criterion. prepare to move the upper bound to this point and
c force the interpolation scheme to either bisect the interval of
c uncertainty or take the linear interpolation step which estimates
c the root of f(alpha)=chord(alpha).
c
      chordm = oldf - xmin*gtest1
      gu = -gmin
      denom = chordm-fmin
      if (dabs(denom) .ge. 1.d-15) go to 25
          denom = 1.d-15
          if (chordm-fmin .lt. 0.d0)  denom = -denom
25    continue
      if (xmin .ne. zero) gu = gmin*(chordu-fu)/denom
      fu = half*u*(gmin+gu) + fmin
      if (fu .lt. fmin) fu = fmin
      go to 60
30      fw = fmin
      fmin = fu
      gw = gmin
      gmin = gu
      xmin = xmin + u
      a = a-u
      b = b-u
      xw = -u
      scxbnd = scxbnd - u
      if (gu .le. zero) go to 40
      b = zero
      braktd = .true.
      go to 50
40    a = zero
50    tol = dabs(xmin)*reltol + abstol
      go to 90
c
c if function value increased, origin remains unchanged
c but new point may now qualify as w.
c
60    if (u .lt. zero) go to 70
      b = u
      braktd = .true.
      go to 80
70    a = u
80    xw = u
      fw = fu
      gw = gu
90    twotol = tol + tol
      xmidpt = half*(a + b)
c
c check termination criteria
c
      convrg = dabs(xmidpt) .le. twotol - half*(b-a) .or.
     *     dabs(gmin) .le. gtest2 .and. fmin .lt. oldf .and.
     *     (dabs(xmin - xbnd) .gt. tol .or. .not. braktd)
      if (.not. convrg) go to 100
      itest = 0
      if (xmin .ne. zero) return
c
c if the function has not been reduced, check to see that the relative
c change in f(x) is consistent with the estimate of the delta-
c unimodality constant, tol.  if the change in f(x) is larger than
c expected, reduce the value of tol.
c
      itest = 3
      if (dabs(oldf-fw) .le. fpresn*(one + dabs(oldf))) return
      tol = point1*tol
      if (tol .lt. tnytol) return
      reltol = point1*reltol
      abstol = point1*abstol
      twotol = point1*twotol
c
c continue with the computation of a trial step length
c
100   r = zero
      q = zero
      s = zero
      if (dabs(e) .le. tol) go to 150
c
c fit cubic through xmin and xw
c
      r = three*(fmin-fw)/xw + gmin + gw
      absr = dabs(r)
      q = absr
      if (gw .eq. zero .or. gmin .eq. zero) go to 140
c
c compute the square root of (r*r - gmin*gw) in a way
c which avoids underflow and overflow.
c
      abgw = dabs(gw)
      abgmin = dabs(gmin)
      s = dsqrt(abgmin)*dsqrt(abgw)
      if ((gw/abgw)*gmin .gt. zero) go to 130
c
c compute the square root of r*r + s*s.
c
      sumsq = one
      p = zero
      if (absr .ge. s) go to 110
c
c there is a possibility of overflow.
c
      if (s .gt. rtsmll) p = s*rtsmll
      if (absr .ge. p) sumsq = one +(absr/s)**2
      scale = s
      go to 120
c
c there is a possibility of underflow.
c
110   if (absr .gt. rtsmll) p = absr*rtsmll
      if (s .ge. p) sumsq = one + (s/absr)**2
      scale = absr
120   sumsq = dsqrt(sumsq)
      q = big
      if (scale .lt. big/sumsq) q = scale*sumsq
      go to 140
c
c compute the square root of r*r - s*s
c
130   q = dsqrt(dabs(r+s))*dsqrt(dabs(r-s))
      if (r .ge. s .or. r .le. (-s)) go to 140
      r = zero
      q = zero
      go to 150
c
c compute the minimum of fitted cubic
c
140   if (xw .lt. zero) q = -q
      s = xw*(gmin - r - q)
      q = gw - gmin + q + q
      if (q .gt. zero) s = -s
      if (q .le. zero) q = -q
      r = e
      if (b1 .ne. step .or. braktd) e = step
c
c construct an artificial bound on the estimated steplength
c
150   a1 = a
      b1 = b
      step = xmidpt
      if (braktd) go to 160
      step = -factor*xw
      if (step .gt. scxbnd) step = scxbnd
      if (step .ne. scxbnd) factor = five*factor
      go to 170
c
c if the minimum is bracketed by 0 and xw the step must lie
c within (a,b).
c
160   if ((a .ne. zero .or. xw .ge. zero) .and. (b .ne. zero .or.
     *     xw .le. zero)) go to 180
c
c if the minimum is not bracketed by 0 and xw the step must lie
c within (a1,b1).
c
      d1 = xw
      d2 = a
      if (a .eq. zero) d2 = b
c this line might be
c     if (a .eq. zero) d2 = e
      u = - d1/d2
      step = five*d2*(point1 + one/u)/eleven
      if (u .lt. one) step = half*d2*dsqrt(u)
170   if (step .le. zero) a1 = step
      if (step .gt. zero) b1 = step
c
c reject the step obtained by interpolation if it lies outside the
c required interval or it is greater than half the step obtained
c during the last-but-one iteration.
c
180   if (dabs(s) .le. dabs(half*q*r) .or.
     *     s .le. q*a1 .or. s .ge. q*b1) go to 200
c
c a cubic interpolation step
c
      step = s/q
c
c the function must not be evalutated too close to a or b.
c
      if (step - a .ge. twotol .and. b - step .ge. twotol) go to 210
      if (xmidpt .gt. zero) go to 190
      step = -tol
      go to 210
190   step = tol
      go to 210
200   e = b-a
c
c if the step is too large, replace by the scaled bound (so as to
c compute the new point on the boundary).
c
210   if (step .lt. scxbnd) go to 220
      step = scxbnd
c
c move sxbd to the left so that sbnd + tol(xbnd) = xbnd.
c
      scxbnd = scxbnd - (reltol*dabs(xbnd)+abstol)/(one + reltol)
220   u = step
      if (dabs(step) .lt. tol .and. step .lt. zero) u = -tol
      if (dabs(step) .lt. tol .and. step .ge. zero) u = tol
      itest = 1
      return
      end

C      ALGORITHM 739, COLLECTED ALGORITHMS FROM ACM.
C      THIS WORK PUBLISHED IN TRANSACTIONS ON MATHEMATICAL SOFTWARE,
C      VOL. 20, NO. 4, DECEMBER, 1994, P.518-530.
c*** tensrd.f
C  ----------------------
C  |  T E N S O R       |
C  ----------------------
      SUBROUTINE TENSOR(NR,N,X,FCN,GRD,HSN,TYPX,FSCALE,GRADTL,STEPTL,
     Z                  ITNLIM,STEPMX,IPR,METHOD,GRDFLG,HESFLG,NDIGIT,
     Z                  MSG,XPLS,FPLS,GPLS,H,ITNNO,WRK,IWRK)
C
C AUTHORS:   TA-TUNG CHOW, ELIZABETH ESKOW AND ROBERT B. SCHNABEL
C
C DATE:      MARCH 29, 1991
C
C PURPOSE:
C   DERIVATIVE TENSOR METHOD FOR UNCONSTRAINED OPTIMIZATION 
C     THE METHOD BASES EACH ITERATION ON A SPECIALLY CONSTRUCTED
C     FOURTH ORDER MODEL OF THE OBJECTIVE FUNCTION.  THE MODEL
C     INTERPOLATES THE FUNCTION VALUE AND GRADIENT FROM THE PREVIOUS
C     ITERATE AND THE CURRENT FUNCTION VALUE, GRADIENT AND HESSIAN
C     MATRIX.
C
C BLAS SUBROUTINES: DCOPY,DDOT,DSCAL
C UNCMIN SUBROUTINES: DFAULT, OPTCHK, GRDCHK, HESCHK, LNSRCH, FSTOFD,
C                     SNDOFD, BAKSLV, FORSLV, OPTSTP
C MODCHL SUBROUTINES: MODCHL, INIT, GERCH, FIN2X2
C
C-----------------------------------------------------------------------
C
C PARAMETERS:
C
C   NR      --> ROW DIMENSION OF MATRIX
C   N       --> DIMENSION OF PROBLEM
C   X(N)    --> INITIAL GUESS (INPUT) AND CURRENT POINT
C   FCN     --> NAME OF SUBROUTINE TO EVALUATE FUNCTION VALUE
C   GRD     --> NAME OF SUBROUTINE TO EVALUATE ANALYTICAL GRADIENT
C   HSN     --> NAME OF SUBROUTINE TO EVALUATE ANALYTICAL HESSIAN
C               HSN SHOULD FILL ONLY THE LOWER TRIANGULAR PART
C               AND DIAGONAL OF H             
C   TYPX(N) --> TYPICAL SIZE OF EACH COMPONENT OF X
C   FSCALE  --> ESTIMATE OF SCALE OF OBJECTIVE FUNCTION FCN
C   GRADTL  --> GRADIENT TOLERANCE
C   STEPTL  --> STEP TOLERANCE
C   ITNLIM  --> ITERATION LIMIT
C   STEPMX  --> MAXIMUM STEP LENGTH ALLOWED
C   IPR     --> OUTPUT UNIT NUMBER
C   METHOD  --> IF VALUE IS 0 THEN USE ONLY NEWTON STEP AT
C               EACH ITERATION
C               IF VALUE IS 1 THEN TRY BOTH TENSOR AND NEWTON
C               STEPS AT EACH ITERATION
C   GRDFLG  --> = 1 OR 2 IF ANALYTICAL GRADIENT IS SUPPLIED
C   HESFLG  --> = 1 OR 2 IF ANALYTICAL HESSIAN IS SUPPLIED
C   NDIGIT  --> NUMBER OF GOOD DIGITS IN OPTIMIZATION FUNCTION FCN
C   MSG     --> OUTPUT MESSAGE CONTROL
C   XPLS(N) <--  NEW POINT AND FINAL POINT (OUTPUT)
C   FPLS    <--  NEW FUNCTION VALUE AND FINAL FUNCTION VALUE (OUTPUT)
C   GPLS(N) <--  CURRENT GRADIENT AND GRADIENT AT FINAL POINT (OUTPUT)
C   H(N,N)  --> HESSIAN
C   ITNNO   <--  NUMBER OF ITERATIONS
C   WRK(N,8)--> WORK SPACE
C   IWRK(N) --> WORK SPACE
C
      
      INTEGER NR,N,ITNLIM,IPR,METHOD,GRDFLG,HESFLG,NDIGIT,MSG
      INTEGER ITNNO,IWRK(N)
      DOUBLE PRECISION X(N),TYPX(N),FSCALE,GRADTL,STEPTL,STEPMX
      DOUBLE PRECISION XPLS(N),FPLS,GPLS(N),H(NR,N),WRK(NR,8)
      EXTERNAL FCN,GRD,HSN
C
C   EQUIVALENCE WRK(N,1) = G(N)
C               WRK(N,2) = S(N)
C               WRK(N,3) = D(N)
C               WRK(N,4) = DN(N)
C               WRK(N,6) = E(N)
C               WRK(N,7) = WK1(N)
C               WRK(N,8) = WK2(N)
C
      CALL OPT(NR,N,X,FCN,GRD,HSN,TYPX,FSCALE,GRADTL,STEPTL,
     Z         ITNLIM,STEPMX,IPR,METHOD,GRDFLG,HESFLG,NDIGIT,
     Z         MSG,XPLS,FPLS,GPLS,H,ITNNO,
     Z         WRK(1,1),WRK(1,2),WRK(1,3),WRK(1,4),
     Z         WRK(1,6),WRK(1,7),WRK(1,8),IWRK)
      RETURN
      END
C  ----------------------
C  |  T E N S R D       |
C  ----------------------
      SUBROUTINE TENSRD(NR,N,X,FCN,GRD,HSN,MSG,XPLS,FPLS,
     Z                  GPLS,H,ITNNO,WRK,IWRK)
C
C PURPOSE:
C   SHORT CALLING SEQUENCE SUBROUTINE
C
C-----------------------------------------------------------------------
C
C PARAMETERS:
C
C   NR         --> ROW DIMENSION OF MATRIX
C   N          --> DIMENSION OF PROBLEM
C   X(N)       --> INITIAL GUESS (INPUT) AND CURRENT POINT
C   FCN        --> NAME OF SUBROUTINE TO EVALUATE FUNCTION VALUE
C   MSG        --> OUTPUT MESSAGE CONTROL
C   XPLS(N)    <--  NEW POINT AND FINAL POINT (OUTPUT)
C   FPLS       <--  NEW FUNCTION VALUE AND FINAL FUNCTION VALUE (OUTPUT)
C   GPLS(N)    <--  GRADIENT AT FINAL POINT (OUTPUT)
C   H(N,N)     --> HESSIAN
C   ITNNO      <--  NUMBER OF ITERATIONS
C   WRK(N,8)   --> WORK SPACE
C   IWRK(N)    --> WORK SPACE
C vanuxemg@yahoo.fr (2/27/2005): Add name of function in parameter
      
      INTEGER NR,N,MSG,ITNNO,IWRK(N) 
      DOUBLE PRECISION X(N),XPLS(N),FPLS,GPLS(N),H(NR,N),WRK(NR,8)
      DOUBLE PRECISION FSCALE,GRADTL,STEPTL,STEPMX
      INTEGER GRDFLG,HESFLG,ITNLIM,IPR,METHOD,NDIGIT
      EXTERNAL FCN,GRD,HSN
C
C   EQUIVALENCE WRK(N,1) = G(N)
C               WRK(N,2) = S(N)
C               WRK(N,3) = D(N)
C               WRK(N,4) = DN(N)
C               WRK(N,5) = TYPX(N)
C               WRK(N,6) = E(N)
C               WRK(N,7) = WK1(N)
C               WRK(N,8) = WK2(N)
C
      CALL DFAULT(N,WRK(1,5),FSCALE,GRADTL,STEPTL,ITNLIM,STEPMX,IPR,
     Z             METHOD,GRDFLG,HESFLG,NDIGIT,MSG)
      CALL TENSOR(NR,N,X,FCN,GRD,HSN,WRK(1,5),FSCALE,GRADTL,STEPTL,
     Z            ITNLIM,STEPMX,IPR,METHOD,GRDFLG,HESFLG,NDIGIT,
     Z            MSG,XPLS,FPLS,GPLS,H,ITNNO,WRK,IWRK)
      END

C  ----------------------
C  |       O P T        |
C  ----------------------
      SUBROUTINE OPT(NR,N,X,FCN,GRD,HSN,TYPX,FSCALE,GRADTL,STEPTL,
     Z               ITNLIM,STEPMX,IPR,METHOD,GRDFLG,HESFLG,NDIGIT,
     Z               MSG,XPLS,FPLS,GPLS,H,ITNNO,G,S,D,DN,E,WK1,WK2,
     Z               PIVOT)
C
C PURPOSE:
C   DERIVATIVE TENSOR METHODS FOR UNCONSTRAINED OPTIMIZATION 
C
C-----------------------------------------------------------------------
C
C PARAMETERS:
C
C   NR      --> ROW DIMENSION OF MATRIX
C   N       --> DIMENSION OF PROBLEM
C   X(N)    --> INITIAL GUESS (INPUT) AND CURRENT POINT
C   FCN     --> NAME OF SUBROUTINE TO EVALUATE FUNCTION VALUE
C               FCN: R(N) --> R(1)
C   GRD     --> NAME OF SUBROUTINE TO EVALUATE ANALYTICAL GRADIENT
C               FCN: R(N) --> R(N)
C   HSN     --> NAME OF SUBROUTINE TO EVALUATE ANALYTICAL HESSIAN
C               FCN: R(N) --> R(N X N)
C               HSN SHOULD FILL ONLY THE LOWER TRIANGULAR PART
C               AND DIAGONAL OF H
C   TYPX(N) --> TYPICAL SIZE OF EACH COMPONENT OF X
C   FSCALE  --> ESTIMATE OF SCALE OF OBJECTIVE FUNCTION FCN
C   GRADTL  --> GRADIENT TOLERANCE
C   STEPTL  --> STEP TOLERANCE
C   ITNLIM  --> ITERATION LIMIT
C   STEPMX  --> MAXIMUM STEP LENGTH ALLOWED
C   IPR     --> OUTPUT UNIT NUMBER
C   METHOD  --> IF VALUE IS 0 THEN USE ONLY NEWTON STEP AT
C               EACH ITERATION
C   GRDFLG  --> = 1 OR 2 IF ANALYTICAL GRADIENT IS SUPPLIED
C   HESFLG  --> = 1 OR 2 IF ANALYTICAL HESSIAN IS SUPPLIED
C   NDIGIT  --> NUMBER OF GOOD DIGITS IN OPTIMIZATION FUNCTION FCN
C   MSG     --> OUTPUT MESSAGE CONTRO
C   XPLS(N) <--  NEW POINT AND FINAL POINT (OUTPUT)
C   FPLS    <--  NEW FUNCTION VALUE AND FINAL FUNCTION VALUE (OUTPUT)
C   GPLS(N) <--  CURRENT GRADIENT AND GRADIENT AT FINAL POINT (OUTPUT)
C   H(N,N)  --> HESSIAN
C   ITNNO   <--  NUMBER OF ITERATIONS
C   G(N)    --> PREVIOUS GRADIENT
C   S       --> STEP TO PREVIOUS ITERATE (FOR TENSOR MODEL)
C   D       --> CURRENT STEP (TENSOR OR NEWTON)
C   DN      --> NEWTON STEP
C   E(N)    --> DIAGONAL ADDED TO HESSIAN IN CHOLESKY DECOMPOSITION
C   WK1(N)  --> WORKSPACE
C   WK2(N)  --> WORKSPACE
C   PIVOT(N)--> PIVOT VECTOR FOR CHOLESKY DECOMPOSITION
C
      
      INTEGER NR,N,ITNLIM,IPR,METHOD,GRDFLG,HESFLG,NDIGIT,MSG
      INTEGER ITNNO,PIVOT(N),ICSCMX,I,ITRMCD,IRETCD,IMSG,NFCNT
      DOUBLE PRECISION F,FP,GPLS(N),G(N),H(NR,N),S(N)
      DOUBLE PRECISION D(N),WK1(N),TYPX(N),FSCALE,GRADTL,STEPTL
      DOUBLE PRECISION X(N),STEPMX,FINIT
      DOUBLE PRECISION WK2(N),FPLS,XPLS(N),E(N)
      DOUBLE PRECISION DN(N),EPS,RNF,ANALTL,GNORM,TWONRM
      DOUBLE PRECISION ADDMAX,TEMP,ALPHA,BETA,GD,FN,DDOT
      DOUBLE PRECISION RGX,RSX
      LOGICAL NOMIN,MXTAKE
      EXTERNAL FCN,GRD,HSN,DCOPY,DDOT
C--------------------------------   
C     INITIALIZATION           |
C--------------------------------
C
      ITNNO=0
      ICSCMX=0
      NFCNT=0

      CALL MCHEPS(EPS)
      CALL OPTCHK(NR,N,MSG,X,TYPX,FSCALE,GRADTL,STEPTL,ITNLIM,
     +     NDIGIT,EPS,METHOD,GRDFLG,HESFLG,STEPMX,IPR)
      IF (MSG.LT.0) RETURN

      
C
C     SCALE X
      DO 10 I=1,N
        X(I)=X(I)/TYPX(I)
10    CONTINUE
C
C--------------------------------
C     INITIAL ITERATION |
C--------------------------------
C
C     COMPUTE TYPICAL SIZE OF X 
      DO 15 I=1,N
        DN(I)=1D0/TYPX(I)
15    CONTINUE
      RNF=MAX(10.0D0**(-NDIGIT),EPS)
      ANALTL=MAX(1D-2,SQRT(RNF))
C     UNSCALE X AND COMPUTE F AND G
      DO 20 I=1,N
        WK1(I)=X(I)*TYPX(I)
20    CONTINUE
      CALL FCN(N,WK1,F)
      NFCNT=NFCNT+1
      IF(GRDFLG .GE. 1)THEN
        CALL GRD(N,WK1,G)
        IF(GRDFLG .EQ. 1)THEN
          FSCALE=1D0
          CALL GRDCHK(N,WK1,FCN,F,G,DN,TYPX,FSCALE,RNF,ANALTL,WK2,
     Z                    MSG,IPR,NFCNT)
        END IF
      ELSE
        CALL FSTOFD(1,1,N,WK1,FCN,F,G,TYPX,RNF,WK2,1,NFCNT)
      END IF
      IF(MSG .LT. -20) THEN
        RETURN
      END IF
C
      GNORM=TWONRM(N,G)
C
C     PRINT OUT 1ST ITERATION?
      IF(MSG .GE. 1)THEN
        WRITE(IPR,25)F
25      FORMAT(' INITIAL FUNCTION VALUE F=',E20.13)
        WRITE(IPR,30)(G(I),I=1,N)
30      FORMAT(' INITIAL GRADIENT G=',999E20.13)
      END IF
C
C     TEST WHETHER THE INITIAL GUESS SATISFIES THE STOPPING CRITERIA
      IF(GNORM .LE. GRADTL)THEN
        FPLS=F
        DO 40,I=1,N
           XPLS(I)=X(I)
           GPLS(I)=G(I)
40      CONTINUE
        CALL OPTSTP(N,XPLS,FPLS,GPLS,X,ITNNO,ICSCMX,
     Z            ITRMCD,GRADTL,STEPTL,FSCALE,ITNLIM,IRETCD,
     Z            MXTAKE,IPR,MSG,RGX,RSX)   
        GO TO 350
      END IF
      FINIT=F
C
C------------------------
C     ITERATION 1 |
C------------------------
C
      ITNNO=ITNNO+1
C
C     COMPUTE HESSIAN
      IF(HESFLG .EQ. 0)THEN
        IF (GRDFLG .EQ. 1)  THEN
           CALL FSTOFD(NR,N,N,WK1,GRD,G,H,TYPX,RNF,WK2,3,NFCNT)
        ELSE
           CALL SNDOFD(NR,N,WK1,FCN,F,H,TYPX,RNF,WK2,D,NFCNT)
        END IF
      ELSE
        IF(HESFLG .EQ. 2)THEN
          CALL HSN(NR,N,WK1,H)
        ELSE
          IF(HESFLG .EQ. 1)THEN
C           IN HESCHK GPLS,XPLS AND E ARE USED AS WORK SPACE
            CALL HESCHK(NR,N,WK1,FCN,GRD,HSN,F,G,H,DN,TYPX,RNF,
     Z                    ANALTL,GRDFLG,GPLS,XPLS,E,MSG,IPR,NFCNT)
          END IF
        END IF
      END IF
      IF(MSG .LT. -20)RETURN
      DO 50 I=2,N
         CALL DCOPY(I-1,H(I,1),NR,H(1,I),1)
50    CONTINUE
C
C     CHOLESKY DECOMPOSITION FOR H (H=LLT)
      CALL CHOLDR(NR,N,H,D,EPS,PIVOT,E,WK1,ADDMAX)
C
C     SOLVE FOR NEWTON STEP D
      DO 60 I=1,N
60       WK2(I)=-G(I)
      CALL FORSLV(NR,N,H,WK1,WK2)
      CALL BAKSLV(NR,N,H,D,WK1)
      
C
C     APPLY LINESEARCH TO THE NEWTON STEP
      CALL LNSRCH(NR,N,X,F,G,D,XPLS,FPLS,MXTAKE,IRETCD,STEPMX,
     Z                STEPTL,TYPX,FCN,WK1,NFCNT)
C
C     UPDATE G
C      CALL DCOPY(N,GPLS(1),1,GP(1),1)
C
C     UNSCALE XPLS AND COMPUTE GPLS
      DO 80 I=1,N
         WK1(I)=XPLS(I)*TYPX(I)
80    CONTINUE
      IF(GRDFLG .GE. 1)THEN
        CALL GRD(N,WK1,GPLS)
      ELSE
        CALL FSTOFD(1,1,N,WK1,FCN,FPLS,GPLS,TYPX,RNF,WK2,1,NFCNT)
      END IF
C
C     CHECK STOPPING CONDITIONS
      CALL OPTSTP(N,XPLS,FPLS,GPLS,X,ITNNO,ICSCMX,
     Z            ITRMCD,GRADTL,STEPTL,FSCALE,ITNLIM,IRETCD,
     Z            MXTAKE,IPR,MSG,RGX,RSX)   
C
C     IF ITRMCD > 0 THEN STOPPING CONDITIONS SATISFIED
      IF(ITRMCD .GT. 0)GO TO 350
C
C     UPDATE X,F AND S FOR TENSOR MODEL
      FP=F
      F=FPLS
      DO 90 I=1,N
        TEMP=XPLS(I)
        S(I)=X(I)-TEMP
        X(I)=TEMP
90    CONTINUE
      
C
C     IF MSG >= 2 THEN PRINT OUT EACH ITERATION
      IF(MSG .GE. 2)THEN
        WRITE (IPR,103)ITNNO 
103     FORMAT(' -----------    ITERATION ',I4,' ----------------')
          WRITE(IPR,104)(X(I),I=1,N)
104     FORMAT(' X=',999E20.13)
        WRITE(IPR,105)FPLS
105     FORMAT(' F(X)=',E20.13)
        WRITE(IPR,106)(GPLS(I),I=1,N)
106     FORMAT(' G(X)=',999E20.13)
      END IF
      IF (MSG .GE. 3 )THEN
		WRITE (IPR,108) NFCNT,RGX
108     FORMAT('FUNCTION EVAL COUNT:',I6,' REL. GRAD. MAX:',E20.13)
        WRITE (IPR,110) RSX
110     FORMAT('REL. STEP MAX :',E20.13)
      ENDIF

C
C------------------------
C     ITERATION > 1     |
C------------------------
C
C     UNSCALE X AND COMPUTE H
200   DO 210 I=1,N
        WK1(I)=X(I)*TYPX(I)
210   CONTINUE
      IF(HESFLG .EQ. 0)THEN
        IF (GRDFLG .EQ. 1)  THEN
           CALL FSTOFD(NR,N,N,WK1,GRD,G,H,TYPX,RNF,WK2,3,NFCNT)
        ELSE
           CALL SNDOFD(NR,N,WK1,FCN,F,H,TYPX,RNF,WK2,D,NFCNT)
        END IF
      ELSE  
        CALL HSN(NR,N,WK1,H)
      END IF
      DO 230 I=2,N
         CALL DCOPY(I-1,H(I,1),NR,H(1,I),1)
230   CONTINUE
C
C     IF METHOD = 0 THEN USE NEWTON STEP ONLY
      IF (METHOD .EQ. 0)  THEN
C
C       CHOLESKY DECOMPOSITION FOR H
        CALL CHOLDR(NR,N,H,WK2,EPS,PIVOT,E,WK1,ADDMAX)
C
C       COMPUTE NEWTON STEP
        DO 240 I=1,N
          WK1(I)=-GPLS(I)
240     CONTINUE
        CALL FORSLV(NR,N,H,WK2,WK1)
        CALL BAKSLV(NR,N,H,D,WK2)
C
C       NO TENSOR STEP
        NOMIN=.TRUE.
        GO TO 300
C
      END IF
C
C     FORM TENSOR MODEL
      CALL MKMDL(NR,N,F,FP,GPLS,G,S,H,ALPHA,BETA,WK1,D)
C
C   SOLVE TENSOR MODEL AND COMPUTE NEWTON STEP
C   ON INPUT : SH IS STORED IN WK1
C            A=(G-GPLS-SH-S*BETA/(6*STS)) IS STORED IN D
C   ON OUTPUT: NEWTON STEP IS STORED IN DN
C            TENSOR STEP IS STORED IN D
      CALL SLVMDL(NR,N,H,XPLS,WK2,E,G,S,GPLS,PIVOT,D,WK1,DN,
     Z                ALPHA,BETA,NOMIN,EPS)
C
C     IF TENSOR MODEL HAS NO MINIMIZER THEN USE NEWTON STEP
      IF(NOMIN)THEN
        CALL DCOPY(N,DN(1),1,D(1),1)
        GO TO 300
      END IF
C
C     IF TENSOR STEP IS NOT IN DESCENT DIRECTION THEN USE NEWTON STEP

      GD = DDOT(N,GPLS(1),1,D(1),1)
      IF(GD .GT. 0D0)THEN
        CALL DCOPY(N,DN(1),1,D(1),1)
        NOMIN=.TRUE.
      END IF
C
300   ITNNO=ITNNO+1
      CALL DCOPY(N,GPLS(1),1,G(1),1)
C
C     APPLY LINESEARCH TO TENSOR (OR NEWTON) STEP
      CALL LNSRCH(NR,N,X,F,G,D,XPLS,FPLS,MXTAKE,IRETCD,STEPMX,
     Z                STEPTL,TYPX,FCN,WK1,NFCNT)
C
      IF(.NOT. NOMIN)THEN
C       TENSOR STEP IS FOUND AND IN DESCENT DIRECTION, 
C       APPLY LINESEARCH TO NEWTON STEP
C       NEW NEWTON POINT IN WK2
        CALL LNSRCH(NR,N,X,F,G,DN,WK2,FN,MXTAKE,IRETCD,STEPMX,
     Z                STEPTL,TYPX,FCN,WK1,NFCNT)
C
C       COMPARE TENSOR STEP TO NEWTON STEP
C       IF NEWTON STEP IS BETTER, SET NEXT ITERATE TO NEW NEWTON POINT
        IF(FN .LT. FPLS)THEN
          FPLS=FN
          CALL DCOPY(N,DN(1),1,D(1),1)
          CALL DCOPY(N,WK2(1),1,XPLS(1),1)
        END IF
      END IF
      DO 320 I=1,N
        D(I)=XPLS(I)-X(I)
320   CONTINUE
C
C     UNSCALE XPLS, AND COMPUTE FPLS AND GPLS
      DO 330 I=1,N
         WK1(I)=XPLS(I)*TYPX(I)
330   CONTINUE
      CALL FCN(N,WK1,FPLS)
      NFCNT=NFCNT+1
      IF(GRDFLG .GE. 1)THEN
        CALL GRD(N,WK1,GPLS)
      ELSE
        CALL FSTOFD(1,1,N,WK1,FCN,FPLS,GPLS,TYPX,RNF,WK2,1,NFCNT)
      END IF
C
C     CHECK STOPPING CONDITIONS
      IMSG=MSG
      CALL OPTSTP(N,XPLS,FPLS,GPLS,X,ITNNO,ICSCMX,
     Z            ITRMCD,GRADTL,STEPTL,FSCALE,ITNLIM,IRETCD,
     Z            MXTAKE,IPR,MSG,RGX,RSX)   
C
C     IF ITRMCD = 0 THEN NOT OVER YET
      IF(ITRMCD .EQ. 0)GO TO 500
C
C     IF MSG >= 1 THEN PRINT OUT FINAL ITERATION
350   IF(IMSG .GE. 1)THEN
C
C       TRANSFORM X BACK TO ORIGINAL SPACE
        DO 360 I=1,N
          XPLS(I)=XPLS(I)*TYPX(I) 
360     CONTINUE
        WRITE(IPR,370)(XPLS(I),I=1,N)
370     FORMAT(' FINAL X=',999E20.13)
        WRITE(IPR,380)(GPLS(I),I=1,N)
380     FORMAT(' GRADIENT G=',999E20.13)
        WRITE(IPR,390)FPLS,ITNNO
390     FORMAT(' FUNCTION VALUE F(X)=',E20.13,
     Z         ' AT ITERATION ',I4) 
        IF (IMSG .GE. 3) THEN
		WRITE (IPR,400) NFCNT,RGX
400     FORMAT('FUNCTION EVAL COUNT:',I6,' REL. GRAD. MAX:',E20.13)
        WRITE (IPR,410) RSX
410     FORMAT('REL. STEP MAX :',E20.13)
      ENDIF

C       UPDATE THE HESSIAN
        IF(HESFLG .EQ. 0)THEN
           IF (GRDFLG .EQ. 1)  THEN
              CALL FSTOFD(NR,N,N,XPLS,GRD,GPLS,H,TYPX,RNF,WK2,3,NFCNT)
           ELSE
              CALL SNDOFD(NR,N,XPLS,FCN,FPLS,H,TYPX,RNF,WK2,D,NFCNT)
           END IF
        ELSE  
          CALL HSN(NR,N,XPLS,H)
        END IF
      END IF
      RETURN
C
C     UPDATE INFORMATION AT THE CURRENT POINT
500   CALL DCOPY(N,XPLS(1),1,X(1),1)
      DO 550 I=1,N
        S(I)=-D(I)
550   CONTINUE
C
C     IF TOO MANY ITERATIONS THEN RETURN
      IF(ITNNO .GT. ITNLIM)GO TO 350
C
C     IF MSG >= 2 THEN PRINT OUT EACH ITERATION
      IF(MSG .GE. 2)THEN
        WRITE (IPR,560)ITNNO
560     FORMAT(' -----------    ITERATION ',I4,' ----------------')
          WRITE(IPR,570)(X(I),I=1,N)
570     FORMAT(' X=',999E20.13)
        WRITE(IPR,580)FPLS
580     FORMAT(' F(X)=',E20.13)
        WRITE(IPR,590)(GPLS(I),I=1,N)
590     FORMAT(' G(X)=',999E20.13)
      END IF
      IF (MSG .GE. 3) THEN
		WRITE (IPR,600) NFCNT,RGX
600     FORMAT('FUNCTION EVAL COUNT:',I6,' REL. GRAD. MAX:',E20.13)
        WRITE (IPR,610) RSX
610     FORMAT('REL. STEP MAX :',E20.13)
      ENDIF

C     UPDATE F
      FP=F
      F=FPLS
C
C     PERFORM NEXT ITERATION
      GO TO 200
C
C     END OF ITERATION > 1
C
      END
C  ----------------------
C  |  D F A U L T      |
C  ----------------------
      SUBROUTINE DFAULT(N,TYPX,FSCALE,GRADTL,STEPTL,ITNLIM,
     Z                  STEPMX,IPR,METHOD,GRDFLG,HESFLG,NDIGIT,MSG)
      
      INTEGER N,ITNLIM,IPR,METHOD,NDIGIT,MSG,GRDFLG,HESFLG,I
      DOUBLE PRECISION TYPX(N),FSCALE,GRADTL,STEPTL,STEPMX,EPS,TEMP 
      CALL MCHEPS(EPS)
      METHOD=1
      FSCALE=1D0
      GRDFLG=0
      HESFLG=0
      DO 1 I=1,N
        TYPX(I)=1D0
1     CONTINUE
      TEMP=EPS**(1D0/3D0)
      GRADTL=TEMP
      STEPTL=TEMP*TEMP
      NDIGIT=-LOG10(EPS)
C     SET ACTUAL DFAULT VALUE OF STEPMX IN OPTCHK
      STEPMX=0D0
      ITNLIM=100
      IPR=6
      MSG=1
      END
C  ----------------------
C  |  O P T C H K       |
C  ----------------------
      SUBROUTINE OPTCHK(NR,N,MSG,X,TYPX,FSCALE,GRADTL,STEPTL,
     +    ITNLIM,NDIGIT,EPS,METHOD,GRDFLG,HESFLG,STEPMX,IPR)

C                                                                       
C PURPOSE                                                               
C -------                                                               
C CHECK INPUT FOR REASONABLENESS                                        
C                                                                       
C PARAMETERS                                                            
C ----------                                                            
C NR          <--> ROW DIMENSION OF H AND WRK
C N            --> DIMENSION OF PROBLEM                                 
C X(N)         --> ON ENTRY, ESTIMATE TO ROOT OF FCN
C TYPX(N)     <--> TYPICAL SIZE OF EACH COMPONENT OF X                  
C FSCALE      <--> ESTIMATE OF SCALE OF OBJECTIVE FUNCTION FCN          
C GRADTL      <--> TOLERANCE AT WHICH GRADIENT CONSIDERED CLOSE         
C                  ENOUGH TO ZERO TO TERMINATE ALGORITHM                
C STEPTL      <--> TOLERANCE AT WHICH STEP LENGTH CONSIDERED CLOSE 
C                  ENOUGH TO ZERO TO TERMINATE ALGORITHM
C ITNLIM      <--> MAXIMUM NUMBER OF ALLOWABLE ITERATIONS               
C NDIGIT      <--> NUMBER OF GOOD DIGITS IN OPTIMIZATION FUNCTION FCN   
C EPS          --> MACHINE PRECISION
C METHOD      <--> ALGORITHM INDICATOR                                  
C GRDFLG      <--> =1 IF ANALYTIC GRADIENT SUPPLIED                     
C HESFLG      <--> =1 IF ANALYTIC HESSIAN SUPPLIED                      
C STEPMX      <--> MAXIMUM STEP SIZE
C MSG         <--> MESSAGE AND ERROR CODE                               
C IPR          --> DEVICE TO WHICH TO SEND OUTPUT                       
C                                                                       
      INTEGER NR,N,ITNLIM,IPR,METHOD,NDIGIT,MSG,GRDFLG,HESFLG,I
      DOUBLE PRECISION X(N),TYPX(N),FSCALE,GRADTL,STEPTL,STEPMX,EPS
      DOUBLE PRECISION STPSIZ,TEMP
      INTRINSIC LOG10, MAX, SQRT
C                                                                       
C CHECK DIMENSION OF PROBLEM                                            
C                                                                       
      IF(N.LE.0) GO TO 805                                              
      IF(NR.LT.N) GO TO 806
C                                                                       
C CHECK THAT PARAMETERS ONLY TAKE ON ACCEPTABLE VALUES.                 
C IF NOT, SET THEM TO DEFAULT VALUES.                                   
      IF(METHOD.NE.0) METHOD=1                                          
      IF(GRDFLG.NE.2 .AND. GRDFLG.NE.1) GRDFLG=0                        
      IF(HESFLG.NE.2 .AND. HESFLG.NE.1) HESFLG=0                        
      IF(MSG.GT.3 .OR. MSG.LT.0 .)  MSG=1                                 
C                                                                       
C COMPUTE SCALE MATRIX                                                  
C                                                                       
      DO 10 I=1,N                                                       
        IF(TYPX(I).EQ.0.) TYPX(I)=1D0                                   
        IF(TYPX(I).LT.0.) TYPX(I)=-TYPX(I)                              
   10 CONTINUE                                                          
C                 
C CHECK MAXIMUM STEP SIZE
C                 
      IF (STEPMX .GT. 0D0) GO TO 20
      STPSIZ = 0D0
      DO 15 I = 1, N
         STPSIZ = STPSIZ + X(I)*X(I)/TYPX(I)*TYPX(I)
   15 CONTINUE    
      STPSIZ = SQRT(STPSIZ)
      STEPMX = MAX(1D3*STPSIZ, 1D3)
   20 CONTINUE    
C CHECK FUNCTION SCALE                                                  
      IF(FSCALE.EQ.0.) FSCALE=1D0                                       
      IF(FSCALE.LT.0.) FSCALE=-FSCALE    
                                                                        
C CHECK GRADIENT TOLERANCE                                              
      IF(GRADTL.LT.0.) GRADTL=EPS**(1D0/3D0)                            
C CHECK STEP TOLERANCE                                                  
      IF(STEPTL.LT.0.) THEN
         TEMP=EPS**(1D0/3D0)
         STEPTL=TEMP*TEMP
      END IF 
C                                                                       
C CHECK ITERATION LIMIT                                                 
      IF(ITNLIM.LE.0) ITNLIM=100                                        
C                                                                       
C CHECK NUMBER OF DIGITS OF ACCURACY IN FUNCTION FCN                    
      IF(NDIGIT.LE.0) NDIGIT=-LOG10(EPS)                                
      IF(10D0**(-NDIGIT).LE.EPS) NDIGIT=-LOG10(EPS)
      RETURN
C                                                                       
C ERROR EXITS                                                           
C                                                                       
  805 WRITE(IPR,901) N                                                  
      MSG=-20                                                            
      RETURN 
  806 WRITE(IPR,902) NR,N
      MSG=-20
      RETURN
  901 FORMAT(32H0OPTCHK    ILLEGAL DIMENSION, N=,I5)                    
  902 FORMAT('OPTCHK    ILLEGAL INPUT VALUES OF: NR=',I5,', N=',I5,
     +       ', NR MUST BE <=  N.')
      END 
C  ----------------------
C  |  G R D C H K       |
C  ----------------------
      SUBROUTINE GRDCHK(N,X,FCN,F,G,TYPSIZ,TYPX,FSCALE,RNF,
     +     ANALTL,WRK1,MSG,IPR,IFN)
C                                                                       
C PURPOSE                                                               
C -------                                                               
C CHECK ANALYTIC GRADIENT AGAINST ESTIMATED GRADIENT                    
C                                                                       
C PARAMETERS                                                            
C ----------                                                            
C N            --> DIMENSION OF PROBLEM                                 
C X(N)         --> ESTIMATE TO A ROOT OF FCN                            
C FCN          --> NAME OF SUBROUTINE TO EVALUATE OPTIMIZATION FUNCTION 
C                  MUST BE DECLARED EXTERNAL IN CALLING ROUTINE         
C                       FCN:  R(N) --> R(1)                             
C F            --> FUNCTION VALUE:  FCN(X)                              
C G(N)         --> GRADIENT:  G(X)                                      
C TYPSIZ(N)    --> TYPICAL SIZE FOR EACH COMPONENT OF X                 
C FSCALE       --> ESTIMATE OF SCALE OF OBJECTIVE FUNCTION FCN          
C RNF          --> RELATIVE NOISE IN OPTIMIZATION FUNCTION FCN          
C ANALTL       --> TOLERANCE FOR COMPARISON OF ESTIMATED AND            
C                  ANALYTICAL GRADIENTS                                 
C WRK1(N)      --> WORKSPACE                                            
C MSG         <--  MESSAGE OR ERROR CODE                                
C                    ON OUTPUT: =-21, PROBABLE CODING ERROR OF GRADIENT 
C IPR          --> DEVICE TO WHICH TO SEND OUTPUT                       
C IFN         <--> NUMBER OF FUNCTION EVALUATIONS
      INTEGER N,MSG,IPR,IFN,KER,I
      DOUBLE PRECISION F,X(N),G(N),TYPX(N),FSCALE,ANALTL,RNF
      DOUBLE PRECISION TYPSIZ(N),GS,WRK
      DOUBLE PRECISION WRK1(N)                                                 
      EXTERNAL FCN                                                      
      INTRINSIC ABS,MAX
C                                                                       
C COMPUTE FIRST ORDER FINITE DIFFERENCE GRADIENT AND COMPARE TO
C ANALYTIC GRADIENT.
C
      CALL FSTOFD(1,1,N,X,FCN,F,WRK1,TYPX,RNF,WRK,1,IFN)
      KER=0
      DO 5 I=1,N
        GS=MAX(ABS(F),FSCALE)/MAX(ABS(X(I)),TYPSIZ(I))
        IF(ABS(G(I)-WRK1(I)).GT.MAX(ABS(G(I)),GS)*ANALTL) KER=1
    5 CONTINUE
      IF(KER.EQ.0) GO TO 20
        WRITE(IPR,901)
        WRITE(IPR,902) (I,G(I),WRK1(I),I=1,N)
        MSG=-21
   20 CONTINUE                                                          
      RETURN                                                            
  901 FORMAT(47H0GRDCHK    PROBABLE ERROR IN CODING OF ANALYTIC,        
     +       19H GRADIENT FUNCTION./                                    
     +       16H GRDCHK     COMP,12X,8HANALYTIC,12X,8HESTIMATE)         
  902 FORMAT(11H GRDCHK    ,I5,3X,E20.13,3X,E20.13)
      END                                                               
C  ----------------------
C  |  H E S C H K       |
C  ----------------------
      SUBROUTINE HESCHK(NR,N,X,FCN,GRD,HSN,F,G,A,TYPSIZ,TYPX,RNF,       
     +     ANALTL,IAGFLG,UDIAG,WRK1,WRK2,MSG,IPR,IFN)
C                                                                       
C PURPOSE                                                               
C -------                                                               
C CHECK ANALYTIC HESSIAN AGAINST ESTIMATED HESSIAN                      
C  (THIS MAY BE DONE ONLY IF THE USER SUPPLIED ANALYTIC HESSIAN         
C   HSN FILLS ONLY THE LOWER TRIANGULAR PART AND DIAGONAL OF A)         
C                                                                       
C PARAMETERS                                                            
C ----------                                                            
C NR           --> ROW DIMENSION OF MATRIX                              
C N            --> DIMENSION OF PROBLEM                                 
C X(N)         --> ESTIMATE TO A ROOT OF FCN                            
C FCN          --> NAME OF SUBROUTINE TO EVALUATE OPTIMIZATION FUNCTION 
C                  MUST BE DECLARED EXTERNAL IN CALLING ROUTINE         
C                       FCN:  R(N) --> R(1)                             
C GRD          --> NAME OF SUBROUTINE TO EVALUATE GRADIENT OF FCN.      
C                  MUST BE DECLARED EXTERNAL IN CALLING ROUTINE         
C HSN          --> NAME OF SUBROUTINE TO EVALUATE HESSIAN OF FCN.       
C                  MUST BE DECLARED EXTERNAL IN CALLING ROUTINE 
C                  HSN SHOULD FILL ONLY THE LOWER TRIANGULAR PART
C                  AND DIAGONAL OF A         
C F            --> FUNCTION VALUE:  FCN(X)                              
C G(N)        <--  GRADIENT:  G(X)                                      
C A(N,N)      <--  ON EXIT:  HESSIAN IN LOWER TRIANGULAR PART AND DIAG  
C TYPSIZ(N)    --> TYPICAL SIZE FOR EACH COMPONENT OF X                 
C RNF          --> RELATIVE NOISE IN OPTIMIZATION FUNCTION FCN          
C ANALTL       --> TOLERANCE FOR COMPARISON OF ESTIMATED AND            
C                  ANALYTICAL GRADIENTS                                 
C IAGFLG       --> =1 IF ANALYTIC GRADIENT SUPPLIED                     
C UDIAG(N)     --> WORKSPACE                                            
C WRK1(N)      --> WORKSPACE                                            
C WRK2(N)      --> WORKSPACE                                            
C MSG         <--> MESSAGE OR ERROR CODE                                
C                    ON INPUT : IF =1XX DO NOT COMPARE ANAL + EST HESS  
C                    ON OUTPUT: =-22, PROBABLE CODING ERROR OF HESSIAN  
C IPR          --> DEVICE TO WHICH TO SEND OUTPUT                       
C IFN         <--> NUMBER OF FUNCTION EVALUTATIONS                                                            
      
      INTEGER NR,N,MSG,IPR,KER,I,J,IAGFLG,JP1,IM1,IFN
      DOUBLE PRECISION F,X(N),G(N),TYPX(N),ANALTL,RNF
      DOUBLE PRECISION TYPSIZ(N)                                               
      DOUBLE PRECISION WRK1(N)
      DOUBLE PRECISION A(NR,1),UDIAG(N),WRK2(N),HS
      EXTERNAL FCN,GRD,HSN                                              
      INTRINSIC ABS,MAX
C
C COMPUTE FINITE DIFFERENCE APPROXIMATION A TO THE HESSIAN.
C                                                                       
      IF(IAGFLG.EQ.1) CALL FSTOFD(NR,N,N,X,GRD,G,A,TYPX,RNF,
     Z                              WRK1,3,IFN)

      IF(IAGFLG.NE.1) CALL SNDOFD(NR,N,X,FCN,F,A,TYPX,RNF,WRK1,
     Z                          WRK2,IFN)                               
C                                                                       
      KER=0                                                             
C                                                                       
C COPY LOWER TRIANGULAR PART OF "A" TO UPPER TRIANGULAR PART            
C AND DIAGONAL OF "A" TO UDIAG                                          
C                                                                       
      DO 30 J=1,N
        UDIAG(J)=A(J,J)
        IF(J.EQ.N) GO TO 30
        JP1=J+1
        DO 25 I=JP1,N
          A(J,I)=A(I,J)
   25   CONTINUE
   30 CONTINUE
C
C COMPUTE ANALYTIC HESSIAN AND COMPARE TO FINITE DIFFERENCE
C APPROXIMATION.
C
      DO 32, I=1,N
        DO 32, J=I,N
          A(J,I)=0D0
  32  CONTINUE
C
      CALL HSN(NR,N,X,A)
      DO 40 J=1,N
        HS=MAX(ABS(G(J)),1.0D0)/MAX(ABS(X(J)),TYPSIZ(J))
        IF(ABS(A(J,J)-UDIAG(J)).GT.MAX(ABS(UDIAG(J)),HS)*ANALTL)
     +       KER=1
        IF(J.EQ.N) GO TO 40
        JP1=J+1
        DO 35 I=JP1,N
          IF(ABS(A(I,J)-A(J,I)).GT.MAX(ABS(A(I,J)),HS)*ANALTL) KER=1
   35   CONTINUE
   40 CONTINUE
C
      IF(KER.EQ.0) GO TO 90
        WRITE(IPR,901)
        DO 50 I=1,N
          IF(I.EQ.1) GO TO 45
          IM1=I-1
          DO 43 J=1,IM1
            WRITE(IPR,902) I,J,A(I,J),A(J,I)
   43     CONTINUE
   45     WRITE(IPR,902) I,I,A(I,I),UDIAG(I)
   50   CONTINUE
        MSG=-22
C     ENDIF                                                             
   90 CONTINUE                                                          
      RETURN                                                            
  901 FORMAT(47H HESCHK    PROBABLE ERROR IN CODING OF ANALYTIC,        
     +       18H HESSIAN FUNCTION./                                     
     +       21H HESCHK      ROW  COL,14X,8HANALYTIC,14X,10H(ESTIMATE)) 
  902 FORMAT(11H HESCHK    ,2I5,2X,E20.13,2X,1H(,E20.13,1H))            
      END                                                               



C  -----------------------
C  |    M C H E P S    |
C  -----------------------        
      SUBROUTINE MCHEPS(EPS)
C
C PURPOSE:
C   COMPUTE MACHINE PRECISION
C
C-------------------------------------------------------------------------
C
C PARAMETERS:
C
C   EPS <-- MACHINE PRECISION
C 
      DOUBLE PRECISION EPS,TEMP,TEMP1
        
        TEMP = 1.D0
 20     CONTINUE
            TEMP = TEMP / 2.D0
            TEMP1 = TEMP + 1.D0
            IF (TEMP1 .NE. 1.D0) GOTO 20
        EPS = TEMP * 2.D0
        RETURN
        END


C
      FUNCTION TWONRM(N,V)
C
C PURPOSE:
C   COMPUTER L-2 NORM
C
C--------------------------------------------------------------------------
C
C PARAMETER:
C
C   N       --> DIMENSION OF PROBLEM
C   V(N)    --> VECTOR WHICH L-2 NORM IS EVALUATED
C
      
      INTEGER N
      DOUBLE PRECISION V(N),TEMP,TWONRM,DDOT
      EXTERNAL DDOT
      INTRINSIC SQRT

      TEMP = DDOT(N,V(1),1,V(1),1)
      TWONRM=SQRT(TEMP)
      RETURN
      END
C  ----------------------
C  |  L N S R C H       |
C  ----------------------
      SUBROUTINE LNSRCH(NR,N,X,F,G,P,XPLS,FPLS,MXTAKE,                  
     +   IRETCD,STEPMX,STEPTL,TYPX,FCN,W2,NFCNT)                              
C     
C     THE ALPHA CONDITION ONLY LINE SEARCH
C
C PURPOSE                                                               
C -------                                                               
C FIND A NEXT NEWTON ITERATE BY LINE SEARCH.                            
C                                                                       
C PARAMETERS                                                            
C ----------                                                            
C N            --> DIMENSION OF PROBLEM                                 
C X(N)         --> OLD ITERATE:   X[K-1]                                
C F            --> FUNCTION VALUE AT OLD ITERATE, F(X)                  
C G(N)         --> GRADIENT AT OLD ITERATE, G(X), OR APPROXIMATE        
C P(N)         --> NON-ZERO NEWTON STEP                                 
C XPLS(N)     <--  NEW ITERATE X[K]                                     
C FPLS        <--  FUNCTION VALUE AT NEW ITERATE, F(XPLS)               
C FCN          --> NAME OF SUBROUTINE TO EVALUATE FUNCTION              
C IRETCD      <--  RETURN CODE                                          
C MXTAKE      <--  BOOLEAN FLAG INDICATING STEP OF MAXIMUM LENGTH USED  
C STEPMX       --> MAXIMUM ALLOWABLE STEP SIZE                          
C STEPTL       --> RELATIVE STEP SIZE AT WHICH SUCCESSIVE ITERATES      
C                  CONSIDERED CLOSE ENOUGH TO TERMINATE ALGORITHM       
C TYPX(N)            --> DIAGONAL SCALING MATRIX FOR X (NOT IN UNCMIN)
C IPR          --> DEVICE TO WHICH TO SEND OUTPUT                       
C W2         --> WORKING SPACE
C NFCNT      <--> NUMBER OF FUNCTION EVALUTIONS
C                                                                       
C INTERNAL VARIABLES                                                    
C ------------------                                                    
C SLN              NEWTON LENGTH                                        
C RLN              RELATIVE LENGTH OF NEWTON STEP                       
C                                                                       
      
      INTEGER NR,N,IRETCD,I,K,NFCNT     
      DOUBLE PRECISION STEPMX,STEPTL,TYPX(N),W2(N),X(N),G(N)
      DOUBLE PRECISION XPLS(N),F,FPLS ,P(N)
      DOUBLE PRECISION ALPHA,TMP,SLN,SCL,SLP,DDOT
      DOUBLE PRECISION RLN,TEMP,TEMP1,TEMP2,ALMBDA,T1,T2,T3
      DOUBLE PRECISION ALMBMN,TLMBDA,PLMBDA,PFPLS,DISC,A,B
      LOGICAL MXTAKE                                                    
      EXTERNAL FCN,DSCAL,DDOT
      INTRINSIC ABS,MAX,SQRT
C                                                                       
      MXTAKE=.FALSE.                                                    
      IRETCD=2                                                          
      ALPHA=1D-4
C$    WRITE(IPR,954)                                                    
C$    WRITE(IPR,955) (P(I),I=1,N)                                       
      TMP=0D0                                                           
      DO 5 I=1,N                                                        
       TMP=TMP+P(I)*P(I) 
    5 CONTINUE                                                          
      SLN=SQRT(TMP)                                                     
      IF(SLN.LE.STEPMX) GO TO 10                                        
C                                                                       
C NEWTON STEP LONGER THAN MAXIMUM ALLOWED                               
        SCL=STEPMX/SLN                                                  
        CALL DSCAL(N,SCL,P(1),1)
        SLN=STEPMX                                                      
C$     WRITE(IPR,954)                                                   
C$     WRITE(IPR,955) (P(I),I=1,N)                                      
   10 CONTINUE                                                          
      SLP=DDOT(N,G(1),1,P(1),1)
      RLN=0D0                                                           
      DO 15 I=1,N                                                       
        TEMP=1D0
        TEMP1=ABS(X(I))
        TEMP2=MAX(TEMP1,TEMP)
        TEMP1=ABS(P(I))
        RLN=MAX(RLN,TEMP1/TEMP2)
   15 CONTINUE                                                          
      ALMBMN=STEPTL/RLN                                                 
      ALMBDA=1.0D0                                                      
C$    WRITE(IPR,952) SLN,SLP,RMNLMB,STEPMX,STEPTL                       
C                                                                       
C LOOP                                                                  
C CHECK IF NEW ITERATE SATISFACTORY.  GENERATE NEW LAMBDA IF NECESSARY. 
C                                                                       
  100 CONTINUE                                                          
      IF(IRETCD.LT.2) THEN                                              
        RETURN
      END IF
      DO 105 I=1,N                                                      
        XPLS(I)=X(I) + ALMBDA*P(I)                                      
  105 CONTINUE                                                          
      DO 101 K=1,N
        W2(K)=XPLS(K)*TYPX(K)
101   CONTINUE
      CALL FCN(N,W2,FPLS)
      NFCNT=NFCNT+1
C$    WRITE(IPR,956) ALMBDA                                             
C$    WRITE(IPR,951)                                                    
C$    WRITE(IPR,955) (XPLS(I),I=1,N)                                    
C$    WRITE(IPR,953) FPLS                                               
      IF(FPLS.GT. F+SLP*ALPHA*ALMBDA) GO TO 130                         
C     IF(FPLS.LE. F+SLP*1.E-4*ALMBDA)                                   
C     THEN                                                              
C                                                                       
C SOLUTION FOUND                                                        
C                                                                       
        IRETCD=0                                                        
        IF(ALMBDA.EQ.1D0 .AND. SLN.GT. .99D0*STEPMX) MXTAKE=.TRUE.      
        GO TO 100                                                       
C                                                                       
C SOLUTION NOT (YET) FOUND                                              
C                                                                       
C     ELSE                                                              
  130   IF(ALMBDA .GE. ALMBMN) GO TO 140                                
C       IF(ALMBDA .LT. ALMBMN)                                          
C       THEN                                                            
C                                                                       
C NO SATISFACTORY XPLS FOUND SUFFICIENTLY DISTINCT FROM X               
C                                                                       
          IRETCD=1                                                      
          GO TO 100                                                     
C       ELSE                                                            
C                                                                       
C CALCULATE NEW LAMBDA                                                  
C                                                                       
  140     IF(ALMBDA.NE.1D0) GO TO 150                                   
C         IF(ALMBDA.EQ.1.0)                                             
C         THEN                                                          
C                                                                       
C FIRST BACKTRACK: QUADRATIC FIT                                        
C                                                                       
            TLMBDA=-SLP/(2D0*(FPLS-F-SLP))                              
            GO TO 170                                                   
C         ELSE                                                          
C                                                                       
C ALL SUBSEQUENT BACKTRACKS: CUBIC FIT                                  
C                                                                       
  150       T1=FPLS-F-ALMBDA*SLP                                        
            T2=PFPLS-F-PLMBDA*SLP                                       
            T3=1D0/(ALMBDA-PLMBDA)                                      
            A=T3*(T1/(ALMBDA*ALMBDA) - T2/(PLMBDA*PLMBDA))              
            B=T3*(T2*ALMBDA/(PLMBDA*PLMBDA)                             
     +           - T1*PLMBDA/(ALMBDA*ALMBDA) )                          
            DISC=B*B-3.0*A*SLP                                          
            IF(DISC.LE. B*B) GO TO 160                                  
C           IF(DISC.GT. B*B)                                            
C           THEN                                                        
C                                                                       
C ONLY ONE POSITIVE CRITICAL POINT, MUST BE MINIMUM                     
C                                                                       
              TLMBDA=(-B+SIGN(1.0D0,A)*SQRT(DISC))/(3.0*A)              
              GO TO 165                                                 
C           ELSE                                                        
C                                                                       
C BOTH CRITICAL POINTS POSITIVE, FIRST IS MINIMUM                       
C                                                                       
  160         TLMBDA=(-B-SIGN(1.0D0,A)*SQRT(DISC))/(3.0*A)              
C           ENDIF                                                       
  165       IF(TLMBDA.GT. .5D0*ALMBDA) TLMBDA=.5D0*ALMBDA               
C         ENDIF                                                         
  170     PLMBDA=ALMBDA                                                 
          PFPLS=FPLS                                                    
          IF(TLMBDA.GE. ALMBDA*.1D0) GO TO 180                          
C         IF(TLMBDA.LT.ALMBDA/10.)                                      
C         THEN                                                          
            ALMBDA=ALMBDA*.1                                            
            GO TO 190                                                   
C         ELSE                                                          
  180       ALMBDA=TLMBDA                                               
C         ENDIF                                                         
C       ENDIF                                                           
C     ENDIF                                                             
  190 GO TO 100                                                         
  956 FORMAT(18H LNSRCH    ALMBDA=,E20.13)                              
  951 FORMAT(29H LNSRCH    NEW ITERATE (XPLS))                          
  952 FORMAT(18H LNSRCH    SLN   =,E20.13/                              
     +       18H LNSRCH    SLP   =,E20.13/                              
     +       18H LNSRCH    ALMBMN=,E20.13/                              
     +       18H LNSRCH    STEPMX=,E20.13/                              
     +       18H LNSRCH    STEPTL=,E20.13)                              
  953 FORMAT(19H LNSRCH    F(XPLS)=,E20.13)                             
  954 FORMAT(26H0LNSRCH    NEWTON STEP (P))                             
  955 FORMAT(14H LNSRCH       ,5(E20.13,3X))                            
      END                                                               
C  ----------------------
C  |       Z H Z        |
C  ----------------------     
      SUBROUTINE ZHZ(NR,N,Y,H,U,T)
C
C PURPOSE:
C   COMPUTE QTHQ(N,N) AND ZTHZ(N-1,N-1) = FIRST N-1 ROWS AND 
C   FIRST N-1 COLUMNS OF QTHQ
C
C---------------------------------------------------------------------------
C
C PARAMETERS:
C   
C   NR            --> ROW DIMENSION OF MATRIX
C   N       --> DIMENSION OF PROBLEM
C   Y(N)    --> FIRST BASIS IN Q
C   H(N,N)     <--> ON INPUT : HESSIAN
C               ON OUTPUT: QTHQ (ZTHZ)
C   U(N)       <--  VECTOR TO FORM Q AND Z
C   T(N)        --> WORKSPACE
C
      
      INTEGER NR,N,I,J
      DOUBLE PRECISION T(N),Y(N),H(NR,N),U(N),S,SGN,YNORM
      DOUBLE PRECISION DDOT,D,TEMP1,TEMP2
      EXTERNAL DDOT,DCOPY
      INTRINSIC SQRT,ABS
C
C     U=Y+SGN(Y(N))||Y||E(N)
      IF( Y(N) .NE. 0D0)THEN
        SGN=Y(N)/ABS(Y(N))
      ELSE
        SGN=1D0
      END IF
      YNORM=DDOT(N,Y(1),1,Y(1),1)
      YNORM=SQRT(YNORM)
      U(N)=Y(N)+SGN*YNORM
      CALL DCOPY(N-1,Y(1),1,U(1),1)

C
C     D=UTU/2
      D=DDOT(N,U(1),1,U(1),1)
      D=D/2D0
C
C     T=2HU/UTU
      DO 40 I=1,N
        T(I)=0D0
        DO 30 J=1,N
           T(I)=H(I,J)*U(J)+T(I)
30      CONTINUE
        T(I)=T(I)/D
40    CONTINUE
C
C     S=4UHU/(UTU)**2
      S = DDOT(N,U(1),1,T(1),1)
      S=S/D
C
C     COMPUTE QTHQ (ZTHZ)
      DO 70 I=1,N
        TEMP1=U(I)
        DO 60 J=1,N
          TEMP2=U(J)
          H(I,J)=H(I,J)-U(I)*T(J)-T(I)*U(J)+U(I)*U(J)*S
60      CONTINUE
70    CONTINUE
      RETURN
      END

C  ----------------------
C  |    S O L V E W     |
C  ----------------------
      SUBROUTINE SOLVEW(NR,N,AL,U,W,B)
C
C PURPOSE:
C   SOLVE L*W=ZT*V
C
C----------------------------------------------------------------------
C
C PARAMETERS:
C   NR            --> ROW DIMENSION OF MATRIX
C   N       --> DIMENSION OF PROBLEM
C   AL(N-1,N-1)   --> LOWER TRIAGULAR MATRIX
C   U(N)    --> VECTOR TO FORM Z
C   W(N)    --> ON INPUT : VECTOR V IN SYSTEM OF LINEAR EQUATIONS
C               ON OUTPUT: SOLUTION OF SYSTEM OF LINEAR EQUATIONS
C   B(N)    --> WORKSPACE TO STORE ZT*V
      
      INTEGER NR,N,I,J
      DOUBLE PRECISION B(N),AL(NR,1),W(N),U(N),D,DDOT
      EXTERNAL DDOT
C
C     FORM ZT*V (STORED IN B)
	  D = DDOT(N,U(1),1,U(1),1)
      D=D/2D0
      DO 20 I=1,N-1
        B(I)=0D0
        DO 15 J=1,N
          B(I)=B(I)+U(J)*U(I)*W(J)/D
15      CONTINUE
        B(I)=W(I)-B(I)
20    CONTINUE
C
C     SOLVE LW=ZT*V
	  CALL FORSLV(NR,N-1,AL,W,B)
	  RETURN
      END

C  ----------------------
C  |     D S T A R      |
C  ----------------------
      SUBROUTINE DSTAR(NR,N,U,S,W1,W2,W3,SIGMA,AL,D)
C
C PURPOSE:
C   COMPUTE TENSOR STEP D=SIGMA*S+ZT*T(SIGMA)
C
C------------------------------------------------------------------------
C
C PARAMETERS:
C   NR            --> ROW DIMENSION OF MATRIX
C   N       --> DIMENSION OF PROBLEM
C   U(N)    --> VECTOR TO FORM Z
C   S(N)    --> PREVIOUS STEP
C   W1(N)   --> L**-1*ZT*A, WHERE A IS DESCRIBED IN SUBROUTINE SLVMDL
C   W2(N)   --> L**-1*ZT*SH, WHERE H IS CURRENT HESSIAN
C   W3(N)   --> L**-1*ZT*G, WHERE G IS CURRENT GRADIENT
C   SIGMA   --> SOLUTION FOR REDUCED ONE VARIABLE MODEL
C   AL(N-1,N-1) --> LOWER TRIANGULAR MATRIX L
C   D(N)    --> TENSOR STEP
C
      
      INTEGER NR,N,I
      DOUBLE PRECISION U(N),S(N),W1(N-1),W2(N-1),W3(N-1),AL(NR,1),D(N)
      DOUBLE PRECISION SIGMA,DDOT,UTU,TEMP,UTT
      EXTERNAL DDOT
      IF (N.EQ.1) THEN
        D(1)=SIGMA * S(1)
      ELSE
C
C     COMPUTE T(SIGMA)=-(ZTHZ)*ZT*(G+SIGMA*SH+SIGMA**2*A/2) (STORED IN D)
      DO 10 I=1,N-1
        W2(I)=W3(I)+SIGMA*W2(I)+0.5D0*W1(I)*SIGMA*SIGMA
10    CONTINUE
	
      CALL BAKSLV(NR,N-1,AL,D,W2)
	
      D(N)=0D0
C
C     COMPUTE TENSOR STEP D=SIGMA*S+ZT*T(SIGMA)
      UTU=DDOT(N,U(1),1,U(1),1)
      UTT=DDOT(N,U(1),1,D(1),1)
      TEMP=UTT/UTU
      DO 50 I=1,N
        D(I)=SIGMA*S(I)-(D(I)-2D0*U(I)*TEMP)
50    CONTINUE
      END IF
      RETURN
      END

C  ----------------------
C  |     M K M D L      |
C  ----------------------     
      SUBROUTINE MKMDL(NR,N,F,FP,G,GP,S,H,ALPHA,BETA,SH,A)
C
C PURPOSE:
C   FORM TENSOR MODEL
C
C-----------------------------------------------------------------------
C
C PARAMETERS:
C   NR            --> ROW DIMENSION OF MATRIX
C   N       --> DIMENSION OF PROBLEM
C   F       --> CURRENT FUNCTION VALUE
C   FP            --> PREVIOUS FUNCTION VALUE
C   G(N)    --> CURRENT GRADIENT
C   GP(N)   --> PREVIOUS GRADIENT
C   S(N)    --> STEP TO PREVIOUS POINT
C   H(N,N)  --> HESSIAN
C   ALPHA      <--  SCALAR TO FORM 3RD ORDER TERM OF TENSOR MODEL
C   BETA       <--  SCALAR TO FORM 4TH ORDER TERM OF TENSOR MODEL
C   SH(N)      <--  SH
C   A(N)       <--  A=2*(GP-G-SH-S*BETA/(6*STS))
C
      
      INTEGER NR,N,I,J
      DOUBLE PRECISION F,FP,G(N),GP(N),S(N),H(NR,N),SH(N),A(N)
      DOUBLE PRECISION ALPHA,BETA,DDOT,GS,GPS,SHS,B1,B2,STS
      EXTERNAL DDOT
C
C     COMPUTE SH
      DO 20 I=1,N
        SH(I)=0D0
        DO 10 J=1,N
          SH(I)=SH(I)+S(J)*H(J,I)
10      CONTINUE
20    CONTINUE

      GS=DDOT(N,G(1),1,S(1),1)
      GPS=DDOT(N,GP(1),1,S(1),1)
      SHS=DDOT(N,SH(1),1,S(1),1)
      B1=GPS-GS-SHS
      B2=FP-F-GS-.5D0*SHS
      ALPHA=24D0*B2-6D0*B1
      BETA=24D0*B1-72D0*B2
C
C     COMPUTE A
      STS=DDOT(N,S(1),1,S(1),1)
      DO 50 I=1,N
        A(I)=2D0*(GP(I)-G(I)-SH(I)-S(I)*BETA/(6D0*STS))
50    CONTINUE
      RETURN
      END


C  ----------------------
C  |     S I G M A      |
C  ----------------------
      SUBROUTINE SIGMA(SGSTAR,A,B,C,D)
C
C PURPOSE:
C   COMPUTE DESIRABLE ROOT OF REDUCED ONE VARIABLE EQUATION
C
C-------------------------------------------------------------------------
C
C PARAMETERS:
C   SGSTAR     --> DESIRABLE ROOT
C   A       --> COEFFICIENT OF 3RD ORDER TERM
C   B       --> COEFFICIENT OF 2ND ORDER TERM
C   C       --> COEFFICIENT OF 1ST ORDER TERM
C   D       --> COEFFICIENT OF CONSTANT TERM
C
      DOUBLE PRECISION SGSTAR,A,B,C,D
      DOUBLE PRECISION S1,S2,S3      
C
C     COMPUTE ALL THREE ROOTS
      CALL ROOTS(S1,S2,S3,A,B,C,D)
C
C     SORT ROOTS
      CALL SORTRT(S1,S2,S3)
C
C     CHOOSE DESIRABLE ROOT
      IF( A .GT. 0D0 )THEN
        SGSTAR=S3
        IF( S2 .GE. 0D0 )THEN
          SGSTAR=S1
        END IF
      ELSE
C       IF  A  <  0  THEN
        SGSTAR=S2
        IF( (S1.GT.0D0) .OR. (S3.LT.0D0) )THEN
          IF( S1 .GT. 0D0)THEN
            SGSTAR=S1
          ELSE
            SGSTAR=S3
          END IF
          A=0D0
        END IF
      END IF
      RETURN
      END

C  ----------------------
C  |     R O O T S      |
C  ----------------------     
      SUBROUTINE ROOTS(S1,S2,S3,A,B,C,D)
C
C PURPOSE:
C   COMPUTE ROOT(S) OF 3RD ORDER EQUATION
C
C---------------------------------------------------------------------------
C
C PARAMETERS:
C   S1             <--  ROOT   (IF THREE ROOTS ARE
C   S2             <--  ROOT    EQUAL, THEN S1=S2=S3)
C   S3             <--  ROOT    
C   A       --> COEFFICIENT OF 3RD ORDER TERM
C   B       --> COEFFICIENT OF 2ND ORDER TERM
C   C       --> COEFFICIENT OF 1ST ORDER TERM
C   D       --> COEFFICIENT OF CONSTANT TERM
      DOUBLE PRECISION S1,S2,S3,A,B,C,D
      DOUBLE PRECISION PI,A1,A2,A3,Q,R,V,S,T,TEMP,THETA
      
      INTRINSIC ACOS, COS, SQRT
C
C     SET VALUE OF PI
      PI=3.141592653589793D0
      A1=B/A
      A2=C/A
      A3=D/A
      Q=(.3D01*A2-A1*A1)/.9D01
      R=(.9D01*A1*A2-.27D02*A3-.2D01*A1*A1*A1)/.54D02
      V=Q*Q*Q+R*R
      IF(V .GT. 0D0)THEN
        S=R+SQRT(V)
        T=R-SQRT(V)
        IF(T .LT. 0D0)THEN
          T=-(-T)**(1D0/3D0)  
        ELSE
          T=T**(1D0/3D0)
        END IF
        IF(S .LT. 0)THEN
          S=-(-S)**(1D0/3D0)
        ELSE
          S=S**(1D0/3D0)
        END IF
        S1=S+T-A1/3D0
        S3=S1
        S2=S1
      ELSE    
        TEMP=R/SQRT(-Q**.3D01)
        THETA=ACOS(TEMP)
        THETA=THETA/.3D01
        TEMP=.2D01*SQRT(-Q)
        S1=TEMP*COS(THETA)-A1/.3D01
        S2=TEMP*COS(THETA+PI*.2D01/.3D01)-A1/.3D01
        S3=TEMP*COS(THETA+PI*.4D01/.3D01)-A1/.3D01
      END IF
      RETURN
      END

C  ----------------------
C  | S O R T R T         |
C  ----------------------
      SUBROUTINE SORTRT(S1,S2,S3)
C 
C PURPOSE:
C   SORT ROOTS INTO ASCENDING ORDER
C
C-----------------------------------------------------------------------------
C
C PARAMETERS:
C   S1             <--> ROOT
C   S2             <--> ROOT
C   S3             <--> ROOT
C
      DOUBLE PRECISION S1,S2,S3
      DOUBLE PRECISION T
      
      
      IF(S1 .GT. S2)THEN
        T=S1
        S1=S2
        S2=T
      END IF
      IF(S2 .GT. S3)THEN
        T=S2
        S2=S3
        S3=T
      END IF
      IF(S1 .GT. S2)THEN
        T=S1
        S1=S2
        S2=T
      END IF
      RETURN
      END
C  ----------------------
C  |  F S T O F D       |
C  ----------------------
      SUBROUTINE FSTOFD(NR,M,N,XPLS,FCN,FPLS,A,TYPX,RNOISE,
     Z                  FHAT,ICASE,NFCNT)
C PURPOSE                                                               
C -------                                                               
C FIND FIRST ORDER FORWARD FINITE DIFFERENCE APPROXIMATION "A" TO THE   
C FIRST DERIVATIVE OF THE FUNCTION DEFINED BY THE SUBPROGRAM "FNAME"    
C EVALUATED AT THE NEW ITERATE "XPLS".                                  
C                                                                       
C                                                                       
C FOR OPTIMIZATION USE THIS ROUTINE TO ESTIMATE:                        
C 1) THE FIRST DERIVATIVE (GRADIENT) OF THE OPTIMIZATION FUNCTION "FCN  
C    ANALYTIC USER ROUTINE HAS BEEN SUPPLIED;                           
C 2) THE SECOND DERIVATIVE (HESSIAN) OF THE OPTIMIZATION FUNCTION       
C    IF NO ANALYTIC USER ROUTINE HAS BEEN SUPPLIED FOR THE HESSIAN BUT  
C    ONE HAS BEEN SUPPLIED FOR THE GRADIENT ("FCN") AND IF THE          
C    OPTIMIZATION FUNCTION IS INEXPENSIVE TO EVALUATE                   
C                                                                       
C NOTE                                                                  
C ----                                                                  
C _M=1 (OPTIMIZATION) ALGORITHM ESTIMATES THE GRADIENT OF THE FUNCTION  
C      (FCN).   FCN(X) # F: R(N)-->R(1)                                 
C _M=N (SYSTEMS) ALGORITHM ESTIMATES THE JACOBIAN OF THE FUNCTION       
C      FCN(X) # F: R(N)-->R(N).                                         
C _M=N (OPTIMIZATION) ALGORITHM ESTIMATES THE HESSIAN OF THE OPTIMIZATIO
C      FUNCTION, WHERE THE HESSIAN IS THE FIRST DERIVATIVE OF "FCN"     
C                                                                       
C PARAMETERS                                                            
C ----------                                                            
C NR           --> ROW DIMENSION OF MATRIX                              
C M            --> NUMBER OF ROWS IN A                                  
C N            --> NUMBER OF COLUMNS IN A; DIMENSION OF PROBLEM         
C XPLS(N)      --> NEW ITERATE:  X[K]                                   
C FCN          --> NAME OF SUBROUTINE TO EVALUATE FUNCTION              
C FPLS(M)      --> _M=1 (OPTIMIZATION) FUNCTION VALUE AT NEW ITERATE:   
C                       FCN(XPLS)                                       
C                  _M=N (OPTIMIZATION) VALUE OF FIRST DERIVATIVE        
C                       (GRADIENT) GIVEN BY USER FUNCTION FCN           
C                  _M=N (SYSTEMS)  FUNCTION VALUE OF ASSOCIATED         
C                       MINIMIZATION FUNCTION                           
C A(NR,N)     <--  FINITE DIFFERENCE APPROXIMATION (SEE NOTE).  ONLY
C                  LOWER TRIANGULAR MATRIX AND DIAGONAL ARE RETURNED    
C RNOISE       --> RELATIVE NOISE IN FCN [F(X)]                         
C FHAT(M)      --> WORKSPACE                                            
C ICASE        --> =1 OPTIMIZATION (GRADIENT)                           
C                  =2 SYSTEMS                                           
C                  =3 OPTIMIZATION (HESSIAN) 
C NFCNT       <--> NUMBER OF FUNCTION EVALUTIONS                           
C                                                                       
C INTERNAL VARIABLES                                                    
C ------------------                                                    
C STEPSZ - STEPSIZE IN THE J-TH VARIABLE DIRECTION                      
C                                                                       
     
      INTEGER NR,M,N,ICASE,NFCNT 
      DOUBLE PRECISION XPLS(N),FPLS(M),FHAT(M),TYPX(N),A(NR,N)  
      DOUBLE PRECISION RNOISE
      INTEGER I,J,NM1,JP1
      DOUBLE PRECISION XTMPJ,STEPSZ                                               
      EXTERNAL FCN
      INTRINSIC ABS, MAX, SQRT
C                                                                       
C FIND J-TH COLUMN OF A                                                 
C EACH COLUMN IS DERIVATIVE OF F(FCN) WITH RESPECT TO XPLS(J)           
C                                                                       
      DO 30 J=1,N                                                       
        XTMPJ=XPLS(J)                                                   
        STEPSZ=SQRT(RNOISE)*MAX(ABS(XPLS(J)),1.D0)                        
        XPLS(J)=XTMPJ+STEPSZ                                            
        CALL FCN(N,XPLS,FHAT) 
        NFCNT = NFCNT + 1                                          
        XPLS(J)=XTMPJ                                                   
        DO 20 I=1,M                                                     
          A(I,J)=(FHAT(I)-FPLS(I))/STEPSZ                               
          A(I,J)=A(I,J)*TYPX(J)
   20   CONTINUE                                                        
   30 CONTINUE                                                          
      IF(ICASE.NE.3) RETURN                                             
C                                                                       
C IF COMPUTING HESSIAN, A MUST BE SYMMETRIC                             
C                                                                       
      IF(N.EQ.1) RETURN                                                 
      NM1=N-1                                                           
      DO 50 J=1,NM1                                                     
        JP1=J+1                                                         
        DO 40 I=JP1,M                                                   
          A(I,J)=(A(I,J)+A(J,I))/2.0                                    
   40   CONTINUE                                                        
   50 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C  ----------------------
C  |  S N D O F D       |
C  ----------------------
      SUBROUTINE SNDOFD(NR,N,XPLS,FCN,FPLS,A,TYPX,
     Z                    RNOISE,STEPSZ,ANBR,NFCNT)       
C PURPOSE                                                               
C -------                                                               
C FIND SECOND ORDER FORWARD FINITE DIFFERENCE APPROXIMATION "A"         
C TO THE SECOND DERIVATIVE (HESSIAN) OF THE FUNCTION DEFINED BY THE SUBP
C "FCN" EVALUATED AT THE NEW ITERATE "XPLS"                             
C                                                                       
C FOR OPTIMIZATION USE THIS ROUTINE TO ESTIMATE                         
C 1) THE SECOND DERIVATIVE (HESSIAN) OF THE OPTIMIZATION FUNCTION       
C    IF NO ANALYTICAL USER FUNCTION HAS BEEN SUPPLIED FOR EITHER        
C    THE GRADIENT OR THE HESSIAN AND IF THE OPTIMIZATION FUNCTION       
C    "FCN" IS INEXPENSIVE TO EVALUATE.                                  
C                                                                       
C PARAMETERS                                                            
C ----------                                                            
C NR           --> ROW DIMENSION OF MATRIX                              
C N            --> DIMENSION OF PROBLEM                                 
C XPLS(N)      --> NEW ITERATE:   X[K]                                  
C FCN          --> NAME OF SUBROUTINE TO EVALUATE FUNCTION              
C FPLS         --> FUNCTION VALUE AT NEW ITERATE, F(XPLS)               
C A(N,N)      <--  FINITE DIFFERENCE APPROXIMATION TO HESSIAN           
C                  ONLY LOWER TRIANGULAR MATRIX AND DIAGONAL            
C                  ARE RETURNED                                         
C RNOISE       --> RELATIVE NOISE IN FNAME [F(X)]                       
C STEPSZ(N)    --> WORKSPACE (STEPSIZE IN I-TH COMPONENT DIRECTION)     
C ANBR(N)      --> WORKSPACE (NEIGHBOR IN I-TH DIRECTION)
C NFCNT       <--> NUMBER OF FUNCTION EVALUATIONS              
C                                                                       
C    
      INTEGER NR,N,NFCNT
      DOUBLE PRECISION XPLS(N),TYPX(N),STEPSZ(N),ANBR(N),A(NR,N) 
      DOUBLE PRECISION FPLS,RNOISE,OV3,XTMPI,XTMPJ,FHAT
      INTEGER I,J,IP1
      EXTERNAL FCN
      INTRINSIC ABS, MAX
C                                                                       
C FIND I-TH STEPSIZE AND EVALUATE NEIGHBOR IN DIRECTION                 
C OF I-TH UNIT VECTOR.                                                  
C                                                                       
      OV3 = 1D0/3D0
      DO 10 I=1,N                                                       
        XTMPI=XPLS(I)                                                   
        STEPSZ(I)=RNOISE**OV3 * MAX(ABS(XPLS(I)),1D0)                   
        XPLS(I)=XTMPI+STEPSZ(I)                                         
        CALL FCN(N,XPLS,ANBR(I))
        NFCNT = NFCNT + 1                                      
        XPLS(I)=XTMPI                                                   
   10 CONTINUE                                                          
C                                                                       
C CALCULATE COLUMN I OF A                                               
C                                                                       
      DO 30 I=1,N                                                       
        XTMPI=XPLS(I)                                                   
        XPLS(I)=XTMPI+2.0*STEPSZ(I)                                     
        CALL FCN(N,XPLS,FHAT) 
        NFCNT = NFCNT + 1                                          
        A(I,I)=((FPLS-ANBR(I))+(FHAT-ANBR(I)))/(STEPSZ(I)*STEPSZ(I))    
        A(I,I)=A(I,I)*(TYPX(I)*TYPX(I))
C                                                                       
C CALCULATE SUB-DIAGONAL ELEMENTS OF COLUMN                             
        IF(I.EQ.N) GO TO 25                                             
        XPLS(I)=XTMPI+STEPSZ(I)                                         
        IP1=I+1                                                         
        DO 20 J=IP1,N                                                   
          XTMPJ=XPLS(J)                                                 
          XPLS(J)=XTMPJ+STEPSZ(J)                                       
          CALL FCN(N,XPLS,FHAT) 
          NFCNT = NFCNT + 1                                       
          A(J,I)=((FPLS-ANBR(I))+(FHAT-ANBR(J)))/(STEPSZ(I)*STEPSZ(J))  
          A(J,I)=A(J,I)*(TYPX(I)*TYPX(J))
          XPLS(J)=XTMPJ                                                 
   20   CONTINUE                                                        
   25   XPLS(I)=XTMPI                                                   
   30 CONTINUE                                                          
      RETURN                                                            
      END                                                               
C  ----------------------
C  |  B A K S L V       |
C  ----------------------
      SUBROUTINE BAKSLV(NR,N,A,X,B)                                     
C                                                                       
C PURPOSE                                                               
C -------                                                               
C SOLVE  AX=B  WHERE A IS UPPER TRIANGULAR MATRIX.                      
C NOTE THAT A IS INPUT AS A LOWER TRIANGULAR MATRIX AND                 
C THAT THIS ROUTINE TAKES ITS TRANSPOSE IMPLICITLY.                     
C                                                                       
C PARAMETERS                                                            
C ----------                                                            
C NR           --> ROW DIMENSION OF MATRIX                              
C N            --> DIMENSION OF PROBLEM                                 
C A(N,N)       --> LOWER TRIANGULAR MATRIX (PRESERVED)                  
C X(N)        <--  SOLUTION VECTOR                                      
C B(N)         --> RIGHT-HAND SIDE VECTOR                               
C                                                                       
C NOTE                                                                  
C ----                                                                  
C IF B IS NO LONGER REQUIRED BY CALLING ROUTINE,                        
C THEN VECTORS B AND X MAY SHARE THE SAME STORAGE.                      
C                                                                       
      INTEGER NR,N
      DOUBLE PRECISION A(NR,N),X(N),B(N)  
      INTEGER I,IP1,J
      DOUBLE PRECISION SUM                                    
C                                                                       
C SOLVE (L-TRANSPOSE)X=B. (BACK SOLVE)                                  
C                                                                       
      I=N                                                               
      X(I)=B(I)/A(I,I)                                                  
      IF(N.EQ.1) RETURN                                                 
   30 IP1=I                                                             
      I=I-1                                                             
      SUM=0.                                                            
      DO 40 J=IP1,N                                                     
        SUM=SUM+A(J,I)*X(J)                                             
   40 CONTINUE                                                          
      X(I)=(B(I)-SUM)/A(I,I)                                            
      IF(I.GT.1) GO TO 30                                               
      RETURN                                                            
      END                                                               
C  ----------------------
C  |  F O R S L V       |
C  ----------------------
       SUBROUTINE FORSLV (NR,N,A,X,B)                                   
C                                                                       
C PURPOSE                                                               
C --------                                                              
C SOLVE  AX=B  WHERE A  IS LOWER TRIANGULAR  MATRIX                     
C                                                                       
C PARAMETERS                                                            
C ---------                                                             
C                                                                       
C NR            -----> ROW DIMENSION OF MATRIX                          
C N             -----> DIMENSION OF PROBLEM                             
C A(N,N)        -----> LOWER TRIANGULAR MATRIX (PRESERVED)              
C X(N)          <----  SOLUTION VECTOR                                   
C B(N)           ----> RIGHT-HAND SIDE VECTOR                           
C                                                                       
C NOTE                                                                  
C-----                                                                  
C THEN VECTORS B AND X MAY SHARE THE SAME STORAGE                       
C                                                                       
      INTEGER NR,N
      DOUBLE PRECISION A(NR,N),X(N),B(N)
      INTEGER I,J,IM1
      DOUBLE PRECISION SUM                                       
C                                                                       
C SOLVE LX=B.  (FOREWARD  SOLVE)                                        
C                                                                       
      X(1)=B(1)/A(1,1)                                                  
      IF(N.EQ.1) RETURN                                                 
      DO 20 I=2,N                                                       
        SUM=0.0                                                         
        IM1=I-1                                                         
        DO 10 J=1,IM1                                                   
          SUM=SUM+A(I,J)*X(J)                                           
   10   CONTINUE                                                        
        X(I)=(B(I)-SUM)/A(I,I)                                          
   20 CONTINUE                                                          
      RETURN                                                            
      END
C  ----------------------
C  |  C H O L D R       |
C  ----------------------
      SUBROUTINE CHOLDR(NR,N,H,G,EPS,PIVOT,E,DIAG,ADDMAX)
C
C PURPOSE:
C   DRIVER FOR CHOLESKY DECOMPOSITION
C
C----------------------------------------------------------------------
C
C PARAMETERS:
C
C   NR            --> ROW DIMENSION
C   N       --> DIMENSION OF PROBLEM
C   H(N,N)  --> MATRIX
C   G(N)    --> WORK SPACE
C   EPS           --> MACHINE EPSILON
C   PIVOT(N)      --> PIVOTING VECTOR
C   E(N)    --> DIAGONAL MATRIX ADDED TO H FOR MAKING H P.D.
C   DIAG(N) --> DIAGONAL OF H
C   ADDMAX  --> ADDMAX * I  IS ADDED TO H

      INTEGER NR,N
      DOUBLE PRECISION H(NR,N),G(N),EPS,E(N),DIAG(N),
     Z      ADDMAX,TEMP
      INTEGER PIVOT(N),I,J,K
      LOGICAL REDO
      DOUBLE PRECISION TAU1,TAU2
      INTRINSIC SQRT

      REDO=.FALSE.
C
C     SAVE DIAGONAL OF H
      DO 10 I=1,N
        DIAG(I)=H(I,I)
10    CONTINUE
      TAU1=EPS**(1D0/3D0)
      TAU2=TAU1
      CALL MODCHL(NR,N,H,G,EPS,TAU1,TAU2,PIVOT,E)
      ADDMAX=E(N)
      DO 22 I=1,N
        IF(PIVOT(I) .NE. I)REDO=.TRUE.
22    CONTINUE
      IF((ADDMAX .GT. 0D0) .OR. REDO)THEN
C********************************
C                       *
C       H IS NOT P.D.         *
C                       *
C********************************
C
C     H=H+UI
        DO 30 I=2,N
          DO 32 J=1,I-1
            H(I,J)=H(J,I)
32        CONTINUE
30      CONTINUE
        DO 34 I=1,N
          PIVOT(I)=I
          H(I,I)=DIAG(I)+ADDMAX
34      CONTINUE
C********************************
C                       *
C        COMPUTE L            *
C                       *
C********************************
        DO 40 J=1,N
C
C     COMPUTE L(J,J)
          TEMP=0D0
          IF(J .GT. 1)THEN
            DO 41 I=1,J-1
              TEMP=TEMP+H(J,I)*H(J,I)
41          CONTINUE
          END IF
          H(J,J)=H(J,J)-TEMP
          H(J,J)=SQRT(H(J,J))
C
C     COMPUTE L(I,J)
          DO 43 I=J+1,N
            TEMP=0D0
            IF(J .GT. 1)THEN
              DO 45 K=1,J-1
                TEMP=TEMP+H(I,K)*H(J,K)
45            CONTINUE
            END IF
            H(I,J)=H(J,I)-TEMP
            H(I,J)=H(I,J)/H(J,J)
43        CONTINUE
40      CONTINUE
      END IF
      RETURN
      END
C  ----------------------
C  |  M O D C H L       |
C  ----------------------
C*********************************************************************
C       
C       SUBROUTINE NAME: MODCHL
C
C       AUTHORS :  ELIZABETH ESKOW AND ROBERT B. SCHNABEL
C
C       DATE    : DECEMBER, 1988
C
C       PURPOSE : PERFORM A MODIFIED CHOLESKY FACTORIZATION
C                 OF THE FORM (PTRANSPOSE)AP  + E = L(LTRANSPOSE), 
C       WHERE L IS STORED IN THE LOWER TRIANGLE OF THE 
C       ORIGINAL MATRIX A.
C       THE FACTORIZATION HAS 2 PHASES: 
C        PHASE 1: PIVOT ON THE MAXIMUM DIAGONAL ELEMENT.
C            CHECK THAT THE NORMAL CHOLESKY UPDATE 
C            WOULD RESULT IN A POSITIVE DIAGONAL 
C            AT THE CURRENT ITERATION, AND
C            IF SO, DO THE NORMAL CHOLESKY UPDATE,
C            OTHERWISE SWITCH TO PHASE 2.
C        PHASE 2: PIVOT ON THE MINIMUM OF THE NEGATIVES
C            OF THE LOWER GERSCHGORIN BOUND 
C            ESTIMATES.
C            COMPUTE THE AMOUNT TO ADD TO THE 
C            PIVOT ELEMENT AND ADD THIS 
C            TO THE PIVOT ELEMENT.
C            DO THE CHOLESKY UPDATE.
C            UPDATE THE ESTIMATES OF THE 
C            GERSCHGORIN BOUNDS.
C
C       INPUT   : NDIM    - LARGEST DIMENSION OF MATRIX THAT 
C                           WILL BE USED
C
C                 N       - DIMENSION OF MATRIX A
C
C                 A       - N*N SYMMETRIC MATRIX (ONLY LOWER TRIANGULAR
C            PORTION OF A, INCLUDING THE MAIN DIAGONAL, IS USED)
C
C                 G       - N*1 WORK ARRAY
C
C                 MCHEPS - MACHINE PRECISION
C
C                TAU1    - TOLERANCE USED FOR DETERMINING WHEN TO SWITCH TO 
C                          PHASE 2
C
C                TAU2    - TOLERANCE USED FOR DETERMINING THE MAXIMUM
C                          CONDITION NUMBER OF THE FINAL 2X2 SUBMATRIX.
C
C
C       OUTPUT  : L     - STORED IN THE MATRIX A (IN LOWER TRIANGULAR
C                           PORTION OF A, INCLUDING THE MAIN DIAGONAL)
C
C                 P     - A RECORD OF HOW THE ROWS AND COLUMNS
C                         OF THE MATRIX WERE PERMUTED WHILE
C                         PERFORMING THE DECOMPOSITION
C
C                 E     - N*1 ARRAY, THE ITH ELEMENT IS THE 
C                         AMOUNT ADDED TO THE DIAGONAL OF A 
C                         AT THE ITH ITERATION
C
C
C************************************************************************
      SUBROUTINE MODCHL(NDIM,N,A,G,MCHEPS,TAU1,TAU2,P,E)
   
      INTEGER N,NDIM
      DOUBLE PRECISION A(NDIM,N),G(N),MCHEPS,TAU1,TAU2
      INTEGER P(N)
      DOUBLE PRECISION E(N)
   
C
C  J        - CURRENT ITERATION NUMBER
C  IMING    - INDEX OF THE ROW WITH THE MIN. OF THE 
C           NEG. LOWER GERSCH. BOUNDS
C  IMAXD    - INDEX OF THE ROW WITH THE MAXIMUM DIAG. 
C           ELEMENT
C  I,ITEMP,JPL,K  - TEMPORARY INTEGER VARIABLES
C  DELTA    - AMOUNT TO ADD TO AJJ AT THE JTH ITERATION
C  GAMMA    - THE MAXIMUM DIAGONAL ELEMENT OF THE ORIGINAL
C           MATRIX A.
C  NORMJ    - THE 1 NORM OF A(COLJ), ROWS J+1 --> N.
C  MING     - THE MINIMUM OF THE NEG. LOWER GERSCH. BOUNDS
C  MAXD     - THE MAXIMUM DIAGONAL ELEMENT
C  TAUGAM - TAU1 * GAMMA
C  PHASE1      - LOGICAL, TRUE IF IN PHASE1, OTHERWISE FALSE
C  DELTA1,TEMP,JDMIN,TDMIN,TEMPJJ - TEMPORARY DOUBLE PRECISION VARS.
C

      INTEGER J,IMING,I,IMAXD,ITEMP,JP1,K
      DOUBLE PRECISION DELTA,GAMMA
      DOUBLE PRECISION NORMJ, MING,MAXD
      DOUBLE PRECISION DELTA1,TEMP,JDMIN,TDMIN,TAUGAM,TEMPJJ
      LOGICAL PHASE1
      INTRINSIC ABS, MAX, SQRT, MIN
   
      CALL INIT(N, NDIM, A, PHASE1, DELTA, P, G, E,
     *         MING,TAU1,GAMMA,TAUGAM)
C     CHECK FOR N=1
      IF (N.EQ.1) THEN
         DELTA = (TAU2 * ABS(A(1,1))) - A(1,1)
         IF (DELTA .GT. 0) E(1)=DELTA
         IF (A(1,1) .EQ. 0) E(1) = TAU2
         A(1,1)=SQRT(A(1,1)+E(1))
      ENDIF 
C
C  
      DO 200 J = 1, N-1
C
C        PHASE 1
C
         IF ( PHASE1 ) THEN
C         
C           FIND INDEX OF MAXIMUM DIAGONAL ELEMENT A(I,I) WHERE I>=J
C
            MAXD = A(J,J)
            IMAXD = J
            DO 20 I = J+1, N
               IF (MAXD .LT. A(I,I)) THEN
                  MAXD = A(I,I)
                  IMAXD = I
               END IF
 20         CONTINUE

C
C           PIVOT TO THE TOP THE ROW AND COLUMN WITH THE MAX DIAG
C
            IF (IMAXD .NE. J) THEN
C
C              SWAP ROW J WITH ROW OF MAX DIAG
C
               DO 30 I = 1, J-1
                  TEMP = A(J,I)
                  A(J,I) = A(IMAXD,I)
                  A(IMAXD,I) = TEMP
 30            CONTINUE
C
C              SWAP COLJ AND ROW MAXDIAG BETWEEN J AND MAXDIAG
C
               DO 35 I = J+1,IMAXD-1
                  TEMP = A(I,J)
                  A(I,J) = A(IMAXD,I)
                  A(IMAXD,I) = TEMP
 35            CONTINUE
C
C              SWAP COLUMN J WITH COLUMN OF MAX DIAG
C
               DO 40 I = IMAXD+1, N
                  TEMP = A(I,J)
                  A(I,J) = A(I,IMAXD)
                  A(I,IMAXD) = TEMP
 40            CONTINUE
C
C              SWAP DIAG ELEMENTS
C        
               TEMP = A(J,J)
               A(J,J) = A(IMAXD,IMAXD)
               A(IMAXD,IMAXD) = TEMP
C
C              SWAP ELEMENTS OF THE PERMUTATION VECTOR
C
               ITEMP = P(J)
               P(J) = P(IMAXD)
               P(IMAXD) = ITEMP

            END IF


C           CHECK TO SEE WHETHER THE NORMAL CHOLESKY UPDATE FOR THIS 
C           ITERATION WOULD RESULT IN A POSITIVE DIAGONAL, 
C           AND IF NOT THEN SWITCH TO PHASE 2.

            JP1 = J+1
            TEMPJJ=A(J,J)

            IF (TEMPJJ.GT.0) THEN

               JDMIN=A(JP1,JP1)
               DO 60 I = JP1, N
                  TEMP = A(I,J) * A(I,J) / TEMPJJ
                  TDMIN = A(I,I) - TEMP
                  JDMIN = MIN(JDMIN, TDMIN)
 60            CONTINUE  

               IF (JDMIN .LT. TAUGAM) PHASE1 = .FALSE.

            ELSE

               PHASE1 = .FALSE.

            END IF

            IF (PHASE1) THEN
C
C              DO THE NORMAL CHOLESKY UPDATE IF STILL IN PHASE 1
C
               A(J,J) = SQRT(A(J,J))
               TEMPJJ = A(J,J)
               DO 70 I = JP1, N
                  A(I,J) = A(I,J) / TEMPJJ
 70            CONTINUE
               DO 80 I=JP1,N
                  TEMP=A(I,J)
                  DO 75 K = JP1, I
                     A(I,K) = A(I,K) - (TEMP * A(K,J))
 75               CONTINUE
 80            CONTINUE

               IF (J .EQ. N-1) A(N,N)=SQRT(A(N,N))

            ELSE

C
C              CALCULATE THE NEGATIVES OF THE LOWER GERSCHGORIN BOUNDS
C
               CALL GERSCH(NDIM,N,A,J,G)

            END IF         

         END IF


C
C        PHASE 2
C
         IF (.NOT. PHASE1) THEN

            IF (J .NE. N-1) THEN
C
C              FIND THE MINIMUM NEGATIVE GERSHGORIN BOUND
C

               IMING=J
               MING = G(J)
               DO 90 I = J+1,N
                  IF (MING .GT. G(I)) THEN
                     MING = G(I)
                     IMING = I   
                  END IF
 90            CONTINUE
   
C
C               PIVOT TO THE TOP THE ROW AND COLUMN WITH THE 
C               MINIMUM NEGATIVE GERSCHGORIN BOUND
C
                IF (IMING .NE. J) THEN
C 
C                  SWAP ROW J WITH ROW OF MIN GERSCH BOUND
C 
                   DO 100 I = 1, J-1
                      TEMP = A(J,I)
                       A(J,I) = A(IMING,I)
                       A(IMING,I) = TEMP
 100               CONTINUE
C
C                  SWAP COLJ WITH ROW IMING FROM J TO IMING
C
                   DO 105 I = J+1,IMING-1
                      TEMP = A(I,J)
                      A(I,J) = A(IMING,I)
                      A(IMING,I) = TEMP
 105              CONTINUE
C 
C                 SWAP COLUMN J WITH COLUMN OF MIN GERSCH BOUND
C         
                  DO 110 I = IMING+1, N
                     TEMP = A(I,J)
                     A(I,J) = A(I,IMING)
                     A(I,IMING) = TEMP
 110              CONTINUE
C
C                 SWAP DIAGONAL ELEMENTS
C
                  TEMP = A(J,J)
                  A(J,J) = A(IMING,IMING)
                  A(IMING,IMING) = TEMP
C 
C                 SWAP ELEMENTS OF THE PERMUTATION VECTOR
C    
                  ITEMP = P(J)
                  P(J) = P(IMING)
                  P(IMING) = ITEMP
C
C                 SWAP ELEMENTS OF THE NEGATIVE GERSCHGORIN BOUNDS VECTOR
C
                  TEMP = G(J) 
                  G(J) = G(IMING)
                  G(IMING) = TEMP 
 
               END IF
C
C              CALCULATE DELTA AND ADD TO THE DIAGONAL.
C              DELTA=MAX{0,-A(J,J) + MAX{NORMJ,TAUGAM},DELTA_PREVIOUS}
C              WHERE NORMJ=SUM OF |A(I,J)|,FOR I=1,N, 
C              DELTA_PREVIOUS IS THE DELTA COMPUTED AT THE PREVIOUS ITERATION,
C              AND TAUGAM IS TAU1*GAMMA.
C

               NORMJ = 0.0
               DO 140 I = J+1, N
                  NORMJ = NORMJ + ABS(A(I,J))
 140           CONTINUE

               TEMP = MAX(NORMJ,TAUGAM)
               DELTA1 = TEMP - A(J,J)
               TEMP = 0.0
               DELTA1 = MAX(TEMP, DELTA1)
               DELTA = MAX(DELTA1,DELTA)     
               E(J) =  DELTA
               A(J,J) = A(J,J) + E(J)
C 
C              UPDATE THE GERSCHGORIN BOUND ESTIMATES
C              (NOTE: G(I) IS THE NEGATIVE OF THE 
C               GERSCHGORIN LOWER BOUND.)
C              
               IF (A(J,J) .NE. NORMJ) THEN
                  TEMP = (NORMJ/A(J,J)) - 1.0
 
                  DO 150 I = J+1, N
                     G(I) = G(I) + ABS(A(I,J)) * TEMP
 150              CONTINUE
 
               END IF
C
C              DO THE CHOLESKY UPDATE
C
               A(J,J) = SQRT(A(J,J))
               TEMPJJ = A(J,J)
               DO 160 I = J+1, N
                  A(I,J) = A(I,J) / TEMPJJ
 160           CONTINUE
               DO 180 I = J+1, N
                  TEMP = A(I,J)
                  DO 170 K = J+1, I
                     A(I,K) = A(I,K) - (TEMP * A(K,J))
 170              CONTINUE                               
 180           CONTINUE

            ELSE
   
               CALL FIN2X2(NDIM, N, A, E, J, TAU2, DELTA,GAMMA)

            END IF     

         END IF
   
 200   CONTINUE
   
      RETURN
      END
C************************************************************************
C       SUBROUTINE NAME : INIT
C
C       PURPOSE : SET UP FOR START OF CHOLESKY FACTORIZATION
C
C       INPUT : N, NDIM, A, TAU1
C
C       OUTPUT : PHASE1    - BOOLEAN VALUE SET TO TRUE IF IN PHASE ONE, 
C             OTHERWISE FALSE.
C      DELTA     - AMOUNT TO ADD TO AJJ AT ITERATION J
C      P,G,E - DESCRIBED ABOVE IN MODCHL
C      MING      - THE MINIMUM NEGATIVE GERSCHGORIN BOUND
C      GAMMA     - THE MAXIMUM DIAGONAL ELEMENT OF A
C      TAUGAM  - TAU1 * GAMMA
C
C************************************************************************
      SUBROUTINE INIT(N,NDIM,A,PHASE1,DELTA,P,G,E,MING,
     *                TAU1,GAMMA,TAUGAM)

      INTEGER N,NDIM
      DOUBLE PRECISION A(NDIM,N)
      LOGICAL PHASE1
      DOUBLE PRECISION DELTA,G(N),E(N)
      INTEGER P(N),I
      DOUBLE PRECISION MING,TAU1,GAMMA,TAUGAM
      INTRINSIC ABS, MAX


      PHASE1 = .TRUE.
      DELTA = 0.0
      MING = 0.0
      DO 10 I=1,N
         P(I)=I
         G(I)= 0.0
         E(I) = 0.0
 10   CONTINUE
   
C
C     FIND THE MAXIMUM MAGNITUDE OF THE DIAGONAL ELEMENTS.
C     IF ANY DIAGONAL ELEMENT IS NEGATIVE, THEN PHASE1 IS FALSE.
C
      GAMMA = 0.0
      DO 20 I=1,N
         GAMMA=MAX(GAMMA,ABS(A(I,I)))
         IF (A(I,I) .LT. 0.0) PHASE1 = .FALSE.
 20   CONTINUE
   
      TAUGAM = TAU1 * GAMMA

C
C     IF NOT IN PHASE1, THEN CALCULATE THE INITIAL GERSCHGORIN BOUNDS
C     NEEDED FOR THE START OF PHASE2.
C
      IF ( .NOT.PHASE1) CALL GERSCH(NDIM,N,A,1,G)
   
      RETURN 
      END
C************************************************************************
C
C       SUBROUTINE NAME : GERSCH
C
C       PURPOSE : CALCULATE THE NEGATIVE OF THE GERSCHGORIN BOUNDS
C                 CALLED ONCE AT THE START OF PHASE II.
C
C       INPUT   : NDIM, N, A, J
C
C       OUTPUT  : G - AN N VECTOR CONTAINING THE NEGATIVES OF THE
C           GERSCHGORIN BOUNDS.
C
C************************************************************************
      SUBROUTINE GERSCH(NDIM, N, A, J, G)

      INTEGER NDIM, N, J
      DOUBLE PRECISION A(NDIM,N), G(N)
 
      INTEGER I, K
      DOUBLE PRECISION OFFROW
      INTRINSIC ABS
 
      DO 30 I = J, N
         OFFROW = 0.0
         DO 10 K = J, I-1
            OFFROW = OFFROW + ABS(A(I,K))
 10      CONTINUE
         DO 20 K = I+1, N
            OFFROW = OFFROW + ABS(A(K,I))
 20      CONTINUE
            G(I) = OFFROW - A(I,I)
 30   CONTINUE

      RETURN
      END
C************************************************************************
C
C  SUBROUTINE NAME : FIN2X2
C
C  PURPOSE : HANDLES FINAL 2X2 SUBMATRIX IN PHASE II.
C            FINDS EIGENVALUES OF FINAL 2 BY 2 SUBMATRIX,
C            CALCULATES THE AMOUNT TO ADD TO THE DIAGONAL,
C            ADDS TO THE FINAL 2 DIAGONAL ELEMENTS, 
C            AND DOES THE FINAL UPDATE.
C
C  INPUT : NDIM, N, A, E, J, TAU2,
C          DELTA - AMOUNT ADDED TO THE DIAGONAL IN THE 
C                  PREVIOUS ITERATION
C
C  OUTPUT : A - MATRIX WITH COMPLETE L FACTOR IN THE LOWER TRIANGLE, 
C           E - N*1 VECTOR CONTAINING THE AMOUNT ADDED TO THE DIAGONAL 
C               AT EACH ITERATION,
C           DELTA - AMOUNT ADDED TO DIAGONAL ELEMENTS N-1 AND N.
C
C************************************************************************
      SUBROUTINE FIN2X2(NDIM, N, A, E, J, TAU2, DELTA,GAMMA) 

      INTEGER NDIM, N, J
      DOUBLE PRECISION A(NDIM,N), E(N), TAU2, DELTA,GAMMA

      DOUBLE PRECISION T1, T2, T3,LMBD1,LMBD2,LMBDHI,LMBDLO
      DOUBLE PRECISION DELTA1, TEMP,T1A,T2A
      INTRINSIC SQRT, MAX, MIN

C
C     FIND EIGENVALUES OF FINAL 2 BY 2 SUBMATRIX
C
      T1 = A(N-1,N-1) + A(N,N)
      T2 = A(N-1,N-1) - A(N,N) 
      T1A=ABS(T2)
      T2A= 2.D0 *  ABS(A(N,N-1))
      IF (T1A .GE. T2A) THEN
         IF (T1A .GT. 0) T2A = T2A / T1A
         T3 = T1A * SQRT(1.D0 + (T2A**2)) 
      ELSE
         T1A = T1A / T2A
         T3 = T2A * SQRT(1.D0 + (T1A**2))
      ENDIF
      LMBD1 = (T1 - T3)/2.
      LMBD2 = (T1 + T3)/2.
      LMBDHI = MAX(LMBD1,LMBD2)
      LMBDLO = MIN(LMBD1,LMBD2)
C
C     FIND DELTA SUCH THAT:
C     1.  THE L2 CONDITION NUMBER OF THE FINAL 
C     2X2 SUBMATRIX + DELTA*I <= TAU2 
C     2. DELTA >= PREVIOUS DELTA,
C     3. LMBDLO + DELTA >= TAU2 * GAMMA, 
C     WHERE LMBDLO IS THE SMALLEST EIGENVALUE OF THE FINAL 
C     2X2 SUBMATRIX
C

      DELTA1=(LMBDHI-LMBDLO)/(1.0-TAU2)
      DELTA1= MAX(DELTA1,GAMMA)
      DELTA1= TAU2 * DELTA1 - LMBDLO 
      TEMP = 0.0
      DELTA = MAX(DELTA, TEMP)
      DELTA = MAX(DELTA, DELTA1)

      IF (DELTA .GT. 0.0) THEN
         A(N-1,N-1) = A(N-1,N-1) + DELTA
         A(N,N) = A(N,N) + DELTA
         E(N-1) = DELTA
         E(N) = DELTA
      END IF
C
C     FINAL UPDATE
C
      A(N-1,N-1) = SQRT(A(N-1,N-1))
      A(N,N-1) = A(N,N-1)/A(N-1,N-1)
      A(N,N) = A(N,N) - (A(N,N-1)**2)
      A(N,N) = SQRT(A(N,N))

      RETURN
      END
C  ----------------------
C  |    S L V M D L     |
C  ----------------------     
      SUBROUTINE SLVMDL(NR,N,H,U,T,E,DIAG,S,G,
     Z                    PIVOT,W1,W2,W3,ALPHA,BETA,NOMIN,EPS)
      
C 
C PURPOSE:
C   COMPUTE TENSOR AND NEWTON STEPS
C
C----------------------------------------------------------------------------
C
C PARAMETERS:
C
C   NR            --> ROW DIMENSION OF MATRIX
C   N       --> DIMENSION OF PROBLEM
C   H(N,N)  --> HESSIAN
C   U(N)    --> VECTOR TO FORM Q IN QR
C   T(N)    --> WORKSPACE
C   E(N)    --> DIAGONAL ADDED TO HESSIAN IN CHOLESKY DECOMPOSITION
C   DIAG(N) --> DIAGONAL OF HESSIAN
C   S(N)    --> STEP TO PREVIOUS POINT (FOR TENSOR MODEL)
C   G(N)    --> CURRENT GRADIENT
C   PIVOT(N)      --> PIVOT VECTOR FOR CHOLESKY DECOMPOSITION
C   W1(N)      <--> ON INPUT: A=2*(GP-G-HS-S*BETA/(6*STS))
C               ON OUTPUT: TENSOR STEP
C   W2(N)   --> SH
C   W3(N)      <--  NEWTON STEP
C   ALPHA   --> SCALAR FOR 3RD ORDER TERM OF TENSOR MODEL
C   BETA    --> SCALAR FOR 4TH ORDER TERM OF TENSOR MODEL
C   NOMIN      <--  =.TRUE. IF TENSOR MODEL HAS NO MINIMIZER
C   EPS           --> MACHINE EPSILON
C
      INTEGER NR,N,PIVOT(N)
      DOUBLE PRECISION H(NR,N),U(N),T(N),E(N),DIAG(N),S(N),
     Z              G(N),W1(N),W2(N),W3(N),ALPHA,BETA,EPS
      INTEGER I,J
      DOUBLE PRECISION W11,W22,W33,SG,ADDMAX,SHS,CA,W12
      DOUBLE PRECISION W13,W23,SGSTAR,CB,CC,CD,R,R2,R1,TEMP
      DOUBLE PRECISION UU,SS
      LOGICAL NOMIN
C
C     S O L V E    M O D E L
C
      NOMIN=.FALSE.
C
C     COMPUTE QTHQ(N,N), ZTHZ(N-1,N-1) = FIRST N-1 ROWS AND N-1 
C     COLUMNS OF QTHQ

      IF (N.GT.1) THEN
      CALL ZHZ(NR,N,S,H,U,T)
	
C
C     IN CHOLESKY DECOMPOSITION WILL STORE H(1,1) ... H(N-1,N-1) 
C     IN DIAG(1) ... DIAG(N-1), STORE H(N,N) IN DIAG(N) FIRST
      DIAG(N)=H(N,N)
C
C     COLESKY DECOMPOSITION FOR FIRST N-1 ROWS AND N-1 COLUMNS OF ZTHZ
C     ZTHZ(N-1,N-1)=LLT
      CALL CHOLDR(NR,N-1,H,T,EPS,PIVOT,E,DIAG,ADDMAX)

      END IF
C
C     ON INPUT: SH IS STORED IN W2
      SHS=0D0
      DO 100 I=1,N
        SHS=SHS+W2(I)*S(I)
        W3(I)=G(I)
100   CONTINUE
C
C   COMPUTE W1,W2,W3
C   W1=L**-1*ZT*A
C   W2=L**-1*ZT*SH
C   W3=L**-1*ZT*G
C
      IF (N.GT.1) THEN

      CALL SOLVEW(NR,N,H,U,W1,T)
      CALL SOLVEW(NR,N,H,U,W2,T)
      CALL SOLVEW(NR,N,H,U,W3,T)

      END IF
C
C     COMPUTE COEFFICIENTS CA,CB,CC AND CD FOR REDUCED ONE VARIABLE
C     3RD ORDER EQUATION
      W11=0D0
      DO 110 I=1,N-1
        W11=W11+W1(I)*W1(I)
110   CONTINUE
      CA=BETA/6D0-W11/2D0
      W12=0D0
      DO 120 I=1,N-1
        W12=W12+W1(I)*W2(I)
120   CONTINUE
      CB=ALPHA/2D0-3D0*W12/2D0
      W13=0D0
      DO 130 I=1,N-1
        W13=W13+W1(I)*W3(I)
130   CONTINUE
      W22=0D0
      DO 133 I=1,N-1
        W22=W22+W2(I)*W2(I)
133   CONTINUE
      CC=SHS-W22-W13
      SG=0D0
      DO 140 I=1,N
        SG=SG+S(I)*G(I)
140   CONTINUE
      W23=0D0
      DO 145 I=1,N-1
        W23=W23+W2(I)*W3(I)
145   CONTINUE
      CD=SG-W23
      W33=0D0
      DO 147 I=1,N-1
        W33=W33+W3(I)*W3(I)
147   CONTINUE
C
C     COMPUTE DESIRABLE ROOT, SGSTAR, OF 3RD ORDER EQUATION
      IF(CA .NE. 0D0)THEN
        CALL SIGMA(SGSTAR,CA,CB,CC,CD)
        IF(CA .EQ. 0D0)THEN
          NOMIN=.TRUE.
          GO TO 200
        END IF
      ELSE
C       2ND ORDER ( CA=0 )
        IF(CB .NE. 0D0)THEN
          R=CC*CC-4D0*CB*CD
          IF(R .LT. 0D0)THEN
            NOMIN=.TRUE.
            GO TO 200
          ELSE
            R1=(-CC+SQRT(R))/(2D0*CB)
            R2=(-CC-SQRT(R))/(2D0*CB)
            IF(R2 .LT. R1)THEN
            TEMP=R1
            R1=R2
            R2=TEMP
            END IF
            IF(CB .GT. 0D0)THEN
            SGSTAR=R2
            ELSE
            SGSTAR=R1
            END IF
            IF( ( (R1 .GT. 0D0) .AND. (SGSTAR .EQ. R2) ) .OR.
     Z                ( (R2 .LT. 0D0) .AND. (SGSTAR .EQ. R1) ) )THEN
            NOMIN=.TRUE.
              GO TO 200
            END IF
          END IF
        ELSE
C         1ST ORDER (CA=0,CB=0)
          IF(CC .GT. 0D0)THEN
            SGSTAR=-CD/CC
          ELSE
            NOMIN=.TRUE.
            GO TO 200
          END IF
        END IF
      END IF
C
C     FIND TENSOR STEP, W1 (FUNCTION OF SGSTAR)
      CALL DSTAR(NR,N,U,S,W1,W2,W3,SGSTAR,H,W1)
C
C     COMPUTE DN
200   UU=0D0
      SS=0D0
      DO 202 I=1,N
        UU=UU+U(I)*U(I)
        SS=SS+S(I)*S(I)
202   CONTINUE
      UU=UU/2D0
      SS=DSQRT(SS)
      
      IF (N.EQ.1) THEN
        CALL CHOLDR(NR,N,H,T,EPS,PIVOT,E,DIAG,ADDMAX)
      ELSE
C
C COMPUTE LAST ROW OF L(N,N)
      DO 220 I=1,N-1
        TEMP=0D0
       IF(I .GT. 1)THEN
          DO 210 J=1,I-1
           TEMP=TEMP+H(N,J)*H(I,J)
210       CONTINUE
       END IF
       H(N,I)=(H(I,N)-TEMP)/H(I,I)
220   CONTINUE
      TEMP=0D0
      DO 224 I=1,N-1
        TEMP=TEMP+H(N,I)*H(N,I)
224   CONTINUE
      H(N,N)=DIAG(N)-TEMP+ADDMAX
      IF(H(N,N) .GT. 0D0)THEN
        H(N,N)=DSQRT(H(N,N))
      ELSE
C     AFTER ADDING THE LAST COLUMN AND ROW
C     QTHQ IS NOT P.D., NEED TO REDO CHOLESKY DECOMPOSITION
       DO 232 I=2,N
          DO 230 J=1,I-1
            H(I,J)=H(J,I)
230       CONTINUE
          H(I,I)=DIAG(I)
232     CONTINUE
        H(1,1)=DIAG(1)
        CALL CHOLDR(NR,N,H,T,EPS,PIVOT,E,DIAG,ADDMAX)
      END IF
      END IF
C
C   SOLVE QTHQ*QT*W3=-QT*G, WHERE W3 IS NEWTON STEP
C   W2=-QT*G
      DO 302 I=1,N
        W2(I)=0D0
        DO 300 J=1,N
          W2(I)=W2(I)+U(J)*U(I)*G(J)/UU
300     CONTINUE
        W2(I)=W2(I)-G(I)
302   CONTINUE
      CALL FORSLV(NR,N,H,W3,W2)
      CALL BAKSLV(NR,N,H,W2,W3)
C     W2=QT*W3 => W3=Q*W2 --- NEWTON STEP
      DO 312 I=1,N
        W3(I)=0D0
        DO 310 J=1,N
          W3(I)=W3(I)+U(I)*U(J)*W2(J)/UU
310     CONTINUE
        W3(I)=W2(I)-W3(I)
312   CONTINUE
      RETURN
      END
C  ----------------------
C  |  O P T S T P       |
C  ----------------------
      SUBROUTINE OPTSTP(N,XPLS,FPLS,GPLS,X,ITNCNT,ICSCMX,               
     +      ITRMCD,GRADTL,STEPTL,FSCALE,ITNLIM,IRETCD,MXTAKE,IPR,MSG,
     +      RGX,RSX)
C                                                                       
C UNCONSTRAINED MINIMIZATION STOPPING CRITERIA                          
C --------------------------------------------                          
C FIND WHETHER THE ALGORITHM SHOULD TERMINATE, DUE TO ANY               
C OF THE FOLLOWING:                                                     
C 1) PROBLEM SOLVED WITHIN USER TOLERANCE                               
C 2) CONVERGENCE WITHIN USER TOLERANCE                                  
C 3) ITERATION LIMIT REACHED                                            
C 4) DIVERGENCE OR TOO RESTRICTIVE MAXIMUM STEP (STEPMX) SUSPECTED      
C                                                                       
C                                                                       
C PARAMETERS                                                            
C ----------                                                            
C N            --> DIMENSION OF PROBLEM                                 
C XPLS(N)      --> NEW ITERATE X[K]                                     
C FPLS         --> FUNCTION VALUE AT NEW ITERATE F(XPLS)                
C GPLS(N)      --> GRADIENT AT NEW ITERATE, G(XPLS), OR APPROXIMATE     
C X(N)         --> OLD ITERATE X[K-1]                                   
C ITNCNT       --> CURRENT ITERATION K                                  
C ICSCMX      <--> NUMBER CONSECUTIVE STEPS .GE. STEPMX                 
C                  [RETAIN VALUE BETWEEN SUCCESSIVE CALLS]              
C ITRMCD      <--  TERMINATION CODE                                     
C GRADTL       --> TOLERANCE AT WHICH RELATIVE GRADIENT CONSIDERED CLOSE
C                  ENOUGH TO ZERO TO TERMINATE ALGORITHM                
C STEPTL       --> RELATIVE STEP SIZE AT WHICH SUCCESSIVE ITERATES      
C                  CONSIDERED CLOSE ENOUGH TO TERMINATE ALGORITHM       
C FSCALE       --> ESTIMATE OF SCALE OF OBJECTIVE FUNCTION              
C ITNLIM       --> MAXIMUM NUMBER OF ALLOWABLE ITERATIONS               
C IRETCD       --> RETURN CODE                                          
C MXTAKE       --> BOOLEAN FLAG INDICATING STEP OF MAXIMUM LENGTH USED  
C IPR          --> DEVICE TO WHICH TO SEND OUTPUT                       
C MSG         <--> CONTROL OUTPUT ON INPUT AND CONTAIN STOPPING
C                  CONDITION ON OUTPUT
C                                                                       
C                                                                       
      INTEGER N,ITNCNT,ICSCMX,ITRMCD,ITNLIM,IRETCD,IPR,MSG
      DOUBLE PRECISION XPLS(N),GPLS(N),X(N),FPLS,GRADTL,STEPTL,FSCALE
      INTEGER I,JTRMCD,IMSG
      DOUBLE PRECISION RGX,D,RELGRD,RELSTP,RSX
      LOGICAL MXTAKE                                                    
      INTRINSIC ABS, MAX
C                                                                       
      ITRMCD=0                                                          
      IMSG=MSG
      RGX=0.D0
      RSX=0.D0
C                                                                       
C LAST GLOBAL STEP FAILED TO LOCATE A POINT LOWER THAN X                
      IF(IRETCD.NE.1) GO TO 50                                          
C     IF(IRETCD.EQ.1)                                                   
C     THEN                                                              
        JTRMCD=3                                                        
        GO TO 600                                                       
C     ENDIF                                                             
   50 CONTINUE                                                          
C                                                                       
C FIND DIRECTION IN WHICH RELATIVE GRADIENT MAXIMUM.                    
C CHECK WHETHER WITHIN TOLERANCE                                        
C                                                                       
      D=MAX(ABS(FPLS),FSCALE)                                           
C     D=1D0
      RGX=0.0                                                           
      DO 100 I=1,N                                                      
        RELGRD=ABS(GPLS(I))*MAX(ABS(XPLS(I)),1.D0)/D                      
        RGX=MAX(RGX,RELGRD)                                             
  100 CONTINUE                                                          
      JTRMCD=1                                                          
      IF(RGX.LE.GRADTL) GO TO 600                                       
C                                                                       
      IF(ITNCNT.EQ.0) RETURN                                            
C                                                                       
C FIND DIRECTION IN WHICH RELATIVE STEPSIZE MAXIMUM                     
C CHECK WHETHER WITHIN TOLERANCE.                                       
C                                                                       
      RSX=0.0                                                           
      DO 120 I=1,N                                                      
        RELSTP=ABS(XPLS(I)-X(I))/MAX(ABS(XPLS(I)),1.D0)                   
        RSX=MAX(RSX,RELSTP)                                             
  120 CONTINUE                                                          
      JTRMCD=2                                                          
      IF(RSX.LE.STEPTL) GO TO 600                                       
C                                                                       
C CHECK ITERATION LIMIT                                                 
C                                                                       
      JTRMCD=4                                                          
      IF(ITNCNT.GE.ITNLIM) GO TO 600                                    
C                                                                       
C CHECK NUMBER OF CONSECUTIVE STEPS \ STEPMX                            
C                                                                       
      IF(MXTAKE) GO TO 140                                              
C     IF(.NOT.MXTAKE)                                                   
C     THEN                                                              
        ICSCMX=0                                                        
        RETURN                                                          
C     ELSE                                                              
  140   CONTINUE                                                        
C       IF (MOD(MSG/8,2) .EQ. 0) WRITE(IPR,900)
      IF(IMSG .GE. 1) WRITE(IPR,900)
        ICSCMX=ICSCMX+1                                                 
        IF(ICSCMX.LT.5) RETURN                                          
        JTRMCD=5                                                        
C     ENDIF                                                             
C                                                                       
C                                                                       
C PRINT TERMINATION CODE                                                
C                                                                       
  600 ITRMCD=JTRMCD                                                     
C     IF (MOD(MSG/8,2) .EQ. 0) GO TO(601,602,603,604,605), ITRMCD
      IF (IMSG .GE. 1) GO TO(601,602,603,604,605), ITRMCD
      GO TO 700
  601 WRITE(IPR,901)                                                    
      GO TO 700                                                         
  602 WRITE(IPR,902)                                                    
      GO TO 700                                                         
  603 WRITE(IPR,903)                                                    
      GO TO 700                                                         
  604 WRITE(IPR,904)                                                    
      GO TO 700                                                         
  605 WRITE(IPR,905)                                                    
C                                                                       
700   MSG=-ITRMCD
      RETURN                                                            
C                                                                       
  900 FORMAT(48H OPTSTP    STEP OF MAXIMUM LENGTH (STEPMX) TAKEN)       
  901 FORMAT(' OPTSTP    RELATIVE GRADIENT CLOSE TO ZERO.'/             
     +       ' OPTSTP    CURRENT ITERATE IS PROBABLY SOLUTION.')        
  902 FORMAT(48H OPTSTP    SUCCESSIVE ITERATES WITHIN TOLERANCE./       
     +       48H OPTSTP    CURRENT ITERATE IS PROBABLY SOLUTION.)       
  903 FORMAT(52H OPTSTP    LAST GLOBAL STEP FAILED TO LOCATE A POINT,   
     +       14H LOWER THAN X./                                         
     +       51H OPTSTP    EITHER X IS AN APPROXIMATE LOCAL MINIMUM,    
     +       17H OF THE FUNCTION,/                                      
     +       50H OPTSTP    THE FUNCTION IS TOO NON-LINEAR FOR THIS,     
     +       11H ALGORITHM,/                                            
     +       34H OPTSTP    OR STEPTL IS TOO LARGE.)                     
  904 FORMAT(36H OPTSTP    ITERATION LIMIT EXCEEDED./                   
     +       28H OPTSTP    ALGORITHM FAILED.)                           
  905 FORMAT(39H OPTSTP    MAXIMUM STEP SIZE EXCEEDED 5,                
     +       19H CONSECUTIVE TIMES./                                    
     +       50H OPTSTP    EITHER THE FUNCTION IS UNBOUNDED BELOW,/     
     +       47H OPTSTP    BECOMES ASYMPTOTIC TO A FINITE VALUE,        
     +       30H FROM ABOVE IN SOME DIRECTION,/                         
     +       33H OPTSTP    OR STEPMX IS TOO SMALL)                      
      END 
C                                                              
      SUBROUTINE  DCOPY(N,DX,INCX,DY,INCY)
C
C     COPIES A VECTOR, X, TO A VECTOR, Y.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(*),DY(*)
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DY(IY) = DX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,7)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DY(I) = DX(I)
   30 CONTINUE
      IF( N .LT. 7 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,7
        DY(I) = DX(I)
        DY(I + 1) = DX(I + 1)
        DY(I + 2) = DX(I + 2)
        DY(I + 3) = DX(I + 3)
        DY(I + 4) = DX(I + 4)
        DY(I + 5) = DX(I + 5)
        DY(I + 6) = DX(I + 6)
   50 CONTINUE
      RETURN
      END
C
      DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)
C
C     FORMS THE DOT PRODUCT OF TWO VECTORS.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(*),DY(*),DTEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      DDOT = 0.0D0
      DTEMP = 0.0D0
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DTEMP = DTEMP + DX(IX)*DY(IY)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      DDOT = DTEMP
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DTEMP = DTEMP + DX(I)*DY(I)
   30 CONTINUE
      IF( N .LT. 5 ) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DTEMP = DTEMP + DX(I)*DY(I) + DX(I + 1)*DY(I + 1) +
     *   DX(I + 2)*DY(I + 2) + DX(I + 3)*DY(I + 3) + DX(I + 4)*DY(I + 4)
   50 CONTINUE
   60 DDOT = DTEMP
      RETURN
      END
C
      SUBROUTINE  DSCAL(N,DA,DX,INCX)
C
C     SCALES A VECTOR BY A CONSTANT.
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DA,DX(*)
      INTEGER I,INCX,M,MP1,N,NINCX
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
        DX(I) = DA*DX(I)
   10 CONTINUE
      RETURN
C
C        CODE FOR INCREMENT EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DX(I) = DA*DX(I)
   30 CONTINUE
      IF( N .LT. 5 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DX(I) = DA*DX(I)
        DX(I + 1) = DA*DX(I + 1)
        DX(I + 2) = DA*DX(I + 2)
        DX(I + 3) = DA*DX(I + 3)
        DX(I + 4) = DA*DX(I + 4)
   50 CONTINUE
      RETURN
      END

c
c     --------------------------------------------------------------------
c     conjugate gradient methods for solving unconstrained nonlinear
c     optimization problems, as described in the paper:
c
c     gilbert, j.c. and nocedal, j. (1992). "global convergence properties 
c     of conjugate gradient methods", siam journal on optimization, vol. 2,
c     pp. 21-42. 
c
c     a web-based server which solves unconstrained nonlinear optimization
c     problems using this conjugate gradient code can be found at:
c
c       http://www-neos.mcs.anl.gov/neos/solvers/uco:cgplus/
c
c     --------------------------------------------------------------------
c
      subroutine cgfam(n,x,f,g,d,gold,iprint,eps,xtol,gtol,w,
     *                  iflag,irest,method,finish )
c
c subroutine parameters
c
      double precision x(n),g(n),d(n),gold(n),w(n),f,eps,gtol,xtol
      integer n,iprint(2),iflag,irest,method,im,ndes
c
c     n      =  number of variables
c     x      =  iterate
c     f      =  function value
c     g      =  gradient value
c     gold   =  previous gradient value
c     iprint =  frequency and type of printing
c               iprint(1) < 0 : no output is generated
c               iprint(1) = 0 : output only at first and last iteration
c               iprint(1) > 0 : output every iprint(1) iterations
c               iprint(2)     : specifies the type of output generated;
c                               the larger the value (between 0 and 3),
c                               the more information
c               iprint(2) = 0 : no additional information printed
c 		iprint(2) = 1 : initial x and gradient vectors printed
c		iprint(2) = 2 : x vector printed every iteration
c		iprint(2) = 3 : x vector and gradient vector printed 
c				every iteration 
c     eps    =  convergence constant
c     w      =  working array
c     iflag  =  controls termination of code, and return to main
c               program to evaluate function and gradient
c               iflag = -3 : improper input parameters
c               iflag = -2 : descent was not obtained
c               iflag = -1 : line search failure
c               iflag =  0 : initial entry or 
c                            successful termination without error   
c               iflag =  1 : indicates a re-entry with new function values
c               iflag =  2 : indicates a re-entry with a new iterate
c     irest  =  0 (no restarts); 1 (restart every n steps)
c     method =  1 : fletcher-reeves 
c               2 : polak-ribiere
c               3 : positive polak-ribiere ( beta=max{beta,0} )
c
c local variables
c
      double precision one,zero,gnorm,ddot,stp1,ftol,stpmin,
     .       stpmax,stp,beta,betafr,betapr,dg0,gg,gg0,dgold,
     .       dgout,dg,dg1
      integer mp,lp,iter,nfun,maxfev,info,i,nfev,nrst,ides
      logical new,finish,cancel
c
c     the following parameters are placed in common blocks so they
c     can be easily accessed anywhere in the code
c
c     mp = unit number which determines where to write regular output
c     lp = unit number which determines where to write error ouput
      common /cgdd/mp,lp
c
c     iter: keeps track of the number of iterations
c     nfun: keeps track of the number of function/gradient evaluations
      common /runinf/iter,nfun
      save
      data one,zero/1.0d+0,0.0d+0/

      if (method .lt. 1 .or.  method .gt. 3) method = 1
      if (finish) then
      	cancel = .true.
      else
        cancel = .false.
      endif 
c
c iflag = 1 indicates a re-entry with new function values
      if(iflag.eq.1) go to 72
c
c iflag = 2 indicates a re-entry with a new iterate
      if(iflag.eq.2) go to 80
c
c     initialize
c     ----------
c
c
c     im =   number of times betapr was negative for method 2 or
c            number of times betapr was 0 for method 3
c
c     ndes = number of line search iterations after wolfe conditions
c            were satisfied
c
      iter= 0
      if(n.le.0) go to 96
      nfun= 1
      new=.true.
      nrst= 0
      im=0
      ndes=0
c
      do 5 i=1,n
 5    d(i)= -g(i)
      gnorm= dsqrt(ddot(n,g,1,g,1))
      stp1= one/gnorm
c
c     parameters for line search routine
c     ----------------------------------
c
c     ftol and gtol are nonnegative input variables. termination
c       occurs when the sufficient decrease condition and the
c       directional derivative condition are satisfied.
c
c     xtol is a nonnegative input variable. termination occurs
c       when the relative width of the interval of uncertainty
c       is at most xtol.
c
c     stpmin and stpmax are nonnegative input variables which
c       specify lower and upper bounds for the step.
c
c     maxfev is a positive integer input variable. termination
c       occurs when the number of calls to fcn is at least
c       maxfev by the end of an iteration.

      ftol= 1.0d-4
      if(gtol.le.1.d-04) then
        if(lp.gt.0) write(lp,145)
        gtol=1.d-02
      endif
      stpmin= 1.0d-20
      stpmax= 1.0d+20
      maxfev= 40
c
      if(iprint(1).ge.0) call cgbd(iprint,iter,nfun,
     *   gnorm,n,x,f,g,stp,finish,ndes,im,betafr,betapr,beta,cancel)
c
c     main iteration loop
c    ---------------------
c
 8    iter= iter+1
c     when nrst>n and irest=1 then restart
      nrst= nrst+1
      info=0
c
c
c     call the line search routine of mor'e and thuente
c     (modified for our cg method)
c     -------------------------------------------------
c
c       jj mor'e and d thuente, "linesearch algorithms with guaranteed
c       sufficient decrease". acm transactions on mathematical
c       software 20 (1994), pp 286-307.
c
      nfev=0
      do 70 i=1,n
  70  gold(i)= g(i)
      dg= ddot(n,d,1,g,1)
      dgold=dg
      stp=one
c
c shanno-phua's formula for trial step
c
      if(.not.new) stp= dg0/dg
      if (iter.eq.1) stp=stp1
      ides=0
      new=.false.
  72  continue
c
c     write(6,*) 'step= ', stp
c
c call to the line search subroutine
c
      call cvsmod(n,x,f,g,d,stp,ftol,gtol,
     *            xtol,stpmin,stpmax,maxfev,info,nfev,w,dg,dgout)

c       info is an integer output variable set as follows:
c         info = 0  improper input parameters.
c         info =-1  a return is made to compute the function and gradient.
c         info = 1  the sufficient decrease condition and the
c                   directional derivative condition hold.
c         info = 2  relative width of the interval of uncertainty
c                   is at most xtol.
c         info = 3  number of calls to fcn has reached maxfev.
c         info = 4  the step is at the lower bound stpmin.
c         info = 5  the step is at the upper bound stpmax.
c         info = 6  rounding errors prevent further progress.
c                   there may not be a step which satisfies the
c                   sufficient decrease and curvature conditions.
c                   tolerances may be too small.

      if (info .eq. -1) then
c       return to fetch function and gradient
        iflag=1
        return
      endif
      if (info .ne. 1) go to 90
c
c     test if descent direction is obtained for methods 2 and 3
c     ---------------------------------------------------------
c
      gg= ddot(n,g,1,g,1)
      gg0= ddot(n,g,1,gold,1)
      betapr= (gg-gg0)/gnorm**2
      if (irest.eq.1.and.nrst.gt.n) then
        nrst=0
        new=.true.
        go to 75
      endif 
c
      if (method.eq.1) then
        go to 75
      else
        dg1=-gg + betapr*dgout
        if (dg1.lt. 0.0d0 ) go to 75
        if (iprint(1).ge.0) write(6,*) 'no descent'
        ides= ides + 1
        if(ides.gt.5) go to 95
        go to 72
      endif
c
c     determine correct beta value for method chosen
c     ----------------------------------------------
c
c     im =   number of times betapr was negative for method 2 or
c            number of times betapr was 0 for method 3
c
c     ndes = number of line search iterations after wolfe conditions
c            were satisfied
c
  75  nfun= nfun + nfev
      ndes= ndes + ides
      betafr= gg/gnorm**2
      if (nrst.eq.0) then
        beta= zero
      else
        if (method.eq.1) beta=betafr
        if (method.eq.2) beta=betapr
        if ((method.eq.2.or.method.eq.3).and.betapr.lt.0) im=im+1
        if (method.eq.3) beta=max(zero,betapr)
      endif
c
c     compute the new direction
c     --------------------------
c
      do 78 i=1,n
  78  d(i) = -g(i) +beta*d(i)
      dg0= dgold*stp
c
c     return to driver for termination test
c     -------------------------------------
c
      xnorm=dsqrt(ddot(n,x,1,x,1))
      gnorm=dsqrt(ddot(n,g,1,g,1))
      if (gnorm/xnorm .le. eps) then
      	finish=.true.
      else
	iflag=2
        return
      endif


  80  continue
c
c call subroutine for printing output
c
      if(iprint(1).ge.0) call cgbd(iprint,iter,nfun,
     *     gnorm,n,x,f,g,stp,finish,ndes,im,betafr,betapr,beta,cancel)
      if (finish) then
         iflag = 0
         return
      end if
      go to 8
c
c     ----------------------------------------
c     end of main iteration loop. error exits.
c     ----------------------------------------
c
  90  iflag=-1
      if(lp.gt.0) write(lp,100) info
      return
  95  iflag=-2
      if(lp.gt.0) write(lp,135) i
      return
  96  iflag= -3
      if(lp.gt.0) write(lp,140)
c
c     formats
c     -------
c
 100  format(/' iflag= -1 ',/' line search failed. see',
     .          ' documentation of routine cvsmod',/' error return',
     .          ' of line search: info= ',i2,/
     .          ' possible cause: function or gradient are incorrect')
 135  format(/' iflag= -2',/' descent was not obtained')
 140  format(/' iflag= -3',/' improper input parameters (n',
     .       ' is not positive)')
 145  format(/'  gtol is less than or equal to 1.d-04',
     .       / ' it has been reset to 1.d-02')
      return
      end
c
c     last line of routine cgfam
c     ***************************
c
c
c**************************************************************************
      subroutine cgbd(iprint,iter,nfun,
     *           gnorm,n,x,f,g,stp,finish,ndes,im,betafr,betapr,beta,
     *		 cancel)
c
c     ---------------------------------------------------------------------
c     this routine prints monitoring information. the frequency and amount
c     of output are controlled by iprint.
c     ---------------------------------------------------------------------
c
      double precision x(n),g(n),f,gnorm,stp,betafr,betapr,beta
      integer iprint(2),iter,nfun,lp,mp,n,ndes,im
      logical finish,cancel
      common /cgdd/mp,lp
c
      if (iter.eq.0)then
           print*
           write(mp,10)
           write(mp,20) n
           write(mp,30) f,gnorm
                 if (iprint(2).ge.1)then
                     write(mp,40)
                     write(mp,50) (x(i),i=1,n)
                     write(mp,60)
                     write(mp,50) (g(i),i=1,n)
                 endif
           write(mp,10)
           write(mp,70)
      else
          if ((iprint(1).eq.0).and.(iter.ne.1.and..not.finish))return
          if (iprint(1).ne.0)then
               if(mod(iter-1,iprint(1)).eq.0.or.finish)then
                     if(iprint(2).gt.1.and.iter.gt.1) write(mp,70)
                     write(mp,80)iter,nfun,f,gnorm,stp,beta
               else
                     return
               endif
          else
               if( iprint(2).gt.1.and.finish) write(mp,70)
               write(mp,80)iter,nfun,f,gnorm,stp,beta
          endif
          if (iprint(2).eq.2.or.iprint(2).eq.3)then
                  write(mp,40)
                  write(mp,50)(x(i),i=1,n)
              if (iprint(2).eq.3)then
                  write(mp,60)
                  write(mp,50)(g(i),i=1,n)
              endif
          endif
          if (finish) then
	  	if (cancel)then
		  write(mp,110)
		else
		  write(mp,100)
		endif
	  endif
      endif
c
 10   format('*************************************************')
 20   format(' n=',i5,//,'initial values:')
 30   format(' f= ',1pd10.3,'   gnorm= ',1pd10.3)
 40   format(/,' vector x= ')
 50   format(6(2x,1pd10.3/))
 60   format(' gradient vector g= ')
 70   format(/'   i  nfn',4x,'func',7x,'gnorm',6x,
     *   'steplen',4x,'beta',/,
     *   ' ----------------------------------------------------')
 80   format(i4,1x,i3,2x,2(1pd10.3,2x),1pd8.1,2x,1pd8.1)
100   format(/' successful convergence (no errors).'
     *          ,/,' iflag = 0')
110   format(/' User canceled optimization.')
c
      return
      end
c     
c     last line of cgbd
c*************************************************************************
c
c
c   ----------------------------------------------------------
c     data 
c   ----------------------------------------------------------
c
c     mp = unit number which determines where to write regular output
c     lp = unit number which determines where to write error ouput
c
      block data cgcd
      common /cgdd/mp,lp
      integer lp,mp
      data mp,lp/6,6/
      end
c
c
c   ----------------------------------------------------------
c
c     last line of cgfam
c*************************************************************************

 



 

c     Last update: March 22th, 2002

c     See report of last modifications at the end of this file.

      subroutine gencan(n,x,l,u,epsgpen,epsgpsn,epsnfp,maxitnfp,
     *maxitngp,fmin,maxit,maxfc,udelta0,ucgmaxit,cgscre,cggpnf,cgepsi,
     *cgepsf,epsnqmp,maxitnqmp,nearlyq,gtype,htvtype,trtype,iprint,
     *iprint2,f,g,gpeucn2,gpsupn,iter,fcnt,gcnt,cgcnt,spgiter,spgfcnt,
     *tniter,tnfcnt,tnstpcnt,tnintcnt,tnexgcnt,tnexbcnt,tnintfe,tnexgfe,
     *tnexbfe,flag,s,y,d,ind,w,eta,delmin,lammax,lammin,theta,gamma,
     *beta,sigma1,sigma2,nint,next,mininterp,ncomp,sterel,steabs,epsrel,
     *epsabs,infty,evalf,evalg,evalhd)

      logical nearlyq

      integer n,maxitnfp,maxitngp,maxit,maxfc,maxitnqmp,ucgmaxit,
     *cgscre,gtype,htvtype,trtype,iprint,iprint2,iter,fcnt,gcnt,cgcnt,
     *spgiter,spgfcnt,tniter,tnfcnt,tnstpcnt,tnintcnt,tnexgcnt,tnexbcnt,
     *tnintfe,tnexgfe,tnexbfe,flag,ind(n),mininterp,ncomp

      double precision x(n),l(n),u(n),epsgpen,epsgpsn,epsnfp,fmin,
     *udelta0,cggpnf,cgepsi,cgepsf,epsnqmp,f,g(n),gpeucn2,gpsupn,s(n),
     *y(n),d(n),w(5*n),eta,delmin,lammax,lammin,theta,gamma,beta,sigma1,
     *sigma2,nint,next,sterel,steabs,epsrel,epsabs,infty
     
      external evalf,evalg,evalhd
c     Solves the box-constrained minimization problem
c
c                  Minimize f(x)
c                  subject to l \leq x \leq u
c
c     using a method described in
c
c     E. G. Birgin and J. M. Martinez, "Large-scale active-set
c     box-constrained optimization method with spectral projected
c     gradients", Computational Optimization and
c     Applications 23, 101-125 (2002).
c
c     Subroutines evalf and evalg must be supplied by the user to
c     evaluate the function f and its gradient, respectively. The
c     calling sequences are
c
c                  call evalf(n, x, f, inform)
c
c                  call evalg(n, x, g, inform)
c
c     where x is the point where the function (the gradient) must be
c     evaluated, n is the number of variables and f (g) is the
c     functional value (the gradient vector). The real parameters
c     x, f, g must be double precision.
c
c     A subroutine evalhd to compute the Hessian times vector products
c     is optional. If this subroutine is not provided an incremental
c     quotients version will be used instead. The calling sequence of
c     this subroutine should be
c
c                  call evalhd(nind,ind,n,x,u,hu,inform)
c
c     where x is the point where the approx-Hessian is being considered,
c     n is the number of variables, u is the vector which should be
c     multiplied by the approx-Hessian H and hu is the vector where the
c     product should be placed. The information about the matrix H must
c     be passed to evalhd by means of common declarations. The necessary
c     computations must be done in evalg. The real parameters x, u, hu
c     must be double precision.
c
c     This subroutine must be coded by the user, taking into account
c     that n is the number of variables of the problem and that hu must
c     be the product H u. Moreover, you must assume, when you code evalhd,
c     that only nind components of u are nonnull and that ind is the set
c     of indices of those components. In other words, you must write
c     evalhd in such a way that hu is the vector whose i-th entry is
c
c               hu(i) = \Sum_{j=1}^{nind} H_{i,ind(j)} u_ind(j)
c
c     Moreover, the only components of hu that you need to compute are
c     those which corresponds to the indices ind(1),...,ind(nind).
c     However, observe that you must assume that, in u, the whole
c     vector is present, with its n components, even the zeroes. So,
c     if you decide to code evalhd without taking into account the
c     presence of ind and nind, you can do it. A final observation:
c     probably, if nind is close to n, it is not worthwhile to use ind,
c     due to the cost of accessing the correct indices. If you want,
c     you can test, within your evalhd, if (say) nind > n/2, and, in
c     this case use a straightforward scalar product for the components
c     of hu.
c
c     Example: Suppose that the matrix H is full. The main steps of
c     evalhd could be:
c
c          do i= 1, nind
c              indi= ind(i)
c              hu(indi)= 0.0d0
c              do j= 1, nind
c                  indj= ind(j)
c                  hu(indi)= hu(indi) + H(indi,indj) * u(indj)
c              end do
c          end do
c
c
c     On Entry
c
c     n    integer
c          the space dimension
c
c     x    double precision x(n)
c          initial estimate to the solution
c
c     l    double precision l(n)
c          lower bounds
c
c     u    double precision u(n)
c          upper bounds
c
c     epsgpen double precision
c          small positive number for declaring convergence when the
c          euclidian norm of the projected gradient is less than
c          or equal to epsgpen
c
c          RECOMMENDED: epsgpen = 1.0d-5
c
c     epsgpsn double precision
c          small positive number for declaring convergence when the
c          infinite norm of the projected gradient is less than
c          or equal to epsgpsn
c
c          RECOMMENDED: epsgpsn = 1.0d-5
c
c     epsnfp double precision
c          ``lack of enough progress'' measure. The algorithm stops by
c          ``lack of enough progress'' when f(x_k) - f(x_{k+1}) <=
c          epsnfp * max { f(x_j)-f(x_{j+1}, j<k} during maxitnfp
c          consecutive iterations. This stopping criterion may be
c          inhibited setting epsnfp = 0. We recommend, preliminary, to
c          set epsnfp = 0.01 and maxitnfp = 5
c
c          RECOMMENDED: epsnfp = 1.0d-2
c
c     maxitnfp integer
c          see the meaning of epsnfp, above
c
c          RECOMMENDED: maxitnfp = 5
c
c     maxitngp integer
c          If the order of the euclidian-norm of the continuous projected
c          gradient did not change during maxitngp consecutive iterations
c          the execution stops. Recommended: maxitngp= 10. In any case
c          maxitngp must be greater than or equal to 1
c
c          RECOMMENDED: maxitngp = 10
c
c     fmin double precision
c          function value for the stopping criteria f <= fmin
c
c          RECOMMENDED: fmin = -1.0d+99 (inhibited)
c
c     maxit integer
c          maximum number of iterations allowed
c
c          RECOMMENDED: maxit = 1000
c
c     maxfc integer
c          maximum number of funtion evaluations allowed
c
c          RECOMMENDED: maxfc = 5000
c
c     udelta0 double precision
c          initial trust-region radius. Default max{0.1||x||,0.1} is set
c          if you set udelta0 < 0. Otherwise, the parameters udelta0
c          will be the ones set by the user.
c
c          RECOMMENDED: udelta0 = -1
c
c     ucgmaxit integer
c          maximum number of iterations allowed for the cg subalgorithm
c
c          Default values for this parameter and the previous one are
c          0.1 and 10 * log (number of free variables). Default values
c          are taken if you set ucgeps < 0 and ucgmaxit < 0,
c          respectively. Otherwise, the parameters ucgeps and ucgmaxit
c          will be the ones set by the user
c
c          RECOMMENDED: ucgmaxit = -1
c
c     cgscre, cggpnf double precision
c          cgscre means cunjugate gradient stopping criterion relation, and
c          cggpnf means conjugate gradients projected gradient final norm.
c          Both are related to a stopping criterion of conjugate gradients.
c          This stopping criterion depends on the norm of the residual
c          of the linear system. The norm of the this residual should be
c          less or equal than a ``small''quantity which decreases as we are
c          approximating the solution of the minimization problem (near the
c          solution, better the truncated-Newton direction we aim). Then, the
c          log of the required precision requested to conjugate gradient has
c          a linear dependence on the log of the norm of the projected
c          gradient. This linear relation uses the squared euclidian-norm
c          of the projected gradient if cgscre = 1 and uses the sup-norm if
c          cgscre = 2. In adition, the precision required to CG is equal to
c          cgepsi (conjugate gradient initial epsilon) at x0 and cgepsf
c          (conjugate gradient final epsilon) when the euclidian- or sup-norm
c          of the projected gradient is equal to cggpnf (conjugate gradients
c          projected gradient final norm) which is an estimation of the value
c          of the euclidian- or sup-norm of the projected gradient at the
c          solution.
c
c          RECOMMENDED: cgscre = 1, cggpnf = epsgpen; or
c                       cgscre = 2, cggpnf = epsgpsn.
c
c     cgepsi, cgepsf double precision
c          small positive numbers for declaring convergence of the
c          conjugate gradient subalgorithm when
c          ||r||_2 < cgeps * ||rhs||_2, where r is the residual and
c          rhs is the right hand side of the linear system, i.e., cg
c          stops when the relative error of the solution is smaller
c          that cgeps.
c
c          cgeps varies from cgepsi to cgepsf in such a way that, depending
c          on cgscre (see above),
c
c          i) log10(cgeps^2) depends linearly on log10(||g_P(x)||_2^2)
c          which varies from ||g_P(x_0)||_2^2 to epsgpen^2; or
c
c          ii) log10(cgeps) depends linearly on log10(||g_P(x)||_inf)
c          which varies from ||g_P(x_0)||_inf to epsgpsn.
c
c          RECOMMENDED: cgepsi = 1.0d-1, cgepsf = 1.0d-5
c
c     epsnqmp double precision
c          see below
c
c     maxitnqmp integer
c          This and the previous one parameter are used for a stopping
c          criterion of the conjugate gradient subalgorithm. If the
c          progress in the quadratic model is less or equal than a
c          fraction of the best progress ( epsnqmp * bestprog ) during
c          maxitnqmp consecutive iterations then CG is stopped by not
c          enough progress of the quadratic model.
c
c          RECOMMENDED: epsnqmp = 1.0d-4, maxitnqmp = 5
c
c     nearlyq logical
c          if function f is (nearly) quadratic, use the option
c          nearlyq = TRUE. Otherwise, keep the default option.
c
c          if, at an iteration of CG we find a direction d such
c          that d^T H d <= 0 then we take the following decision:
c
c          (i) if nearlyq = TRUE then take direction d and try to
c          go to the boundary chosing the best point among the two
c          point at the boundary and the current point.
c
c          (ii) if nearlyq = FALSE then we stop at the current point.
c
c          RECOMMENDED: nearlyq = .FALSE.
c
c     gtype integer
c          type of gradient calculation
c          gtype = 0 means user suplied evalg subroutine,
c          gtype = 1 means central diference approximation.
c
c          RECOMMENDED: gtype = 0
c
c          (provided you have the evalg subroutine)
c
c     htvtype integer
c          type of gradient calculation
c          htvtype = 0 means user suplied evalhd subroutine,
c          htvtype = 1 means incremental quotients approximation.
c
c          RECOMMENDED: htvtype = 1
c
c          (you take some risk using this option but, unless you have
c          a good evalhd subroutine, incremental quotients is a very
c          cheap option)
c
c     trtype integer
c          type of trust-region radius
c          trtype = 0 means 2-norm trust-region
c          trtype = 1 means infinite-norm trust-region
c
c          RECOMMENDED: trtype = 0
c
c     iprint integer
c          commands printing. Nothing is printed if iprint < 0.
c          If iprint = 0, only initial and final information is printed.
c          If iprint > 0, information is printed every iprint iterations.
c          Exhaustive printing when iprint > 0 is commanded by iprint2.
c
c          RECOMMENDED: iprint = 1
c
c     iprint2 integer
c          When iprint > 0, detailed printing can be required setting
c          iprint2 = 1.
c
c          RECOMMENDED: iprint2 = 1
c
c     s,y,d,w double precision s(n),y(n),d(n),w(5*n)
c          working vectors
c
c     ind  integer ind(n)
c          working vector
c
c     eta  double precision
c          constant for deciding abandon the current face or not
c          We abandon the current face if the norm of the internal
c          gradient (here, internal components of the continuous
c          projected gradient) is smaller than (1-eta) times the
c          norm of the continuous projected gradient. Using eta=0.9
c          is a rather conservative strategy in the sense that
c          internal iterations are preferred over SPG iterations.
c
c          RECOMMENDED: eta = 0.9
c
c     delmin double precision
c          minimum ``trust region'' to compute the Truncated Newton
c          direction
c
c          RECOMMENDED: delmin = 0.1
c
c     lammin, lammax double precision
c          The spectral steplength, called lambda, is projected
c          inside the box [lammin,lammax]
c
c          RECOMMENDED: lammin = 10^{-10} and lammax = 10^{10}
c
c     theta double precision
c          constant for the angle condition, i.e., at iteration k
c          we need a direction d_k such that
c          <g_k,d_k> <= -theta ||g||_2 ||d_k||_2,
c          where g_k is \nabla f(x_k)
c
c          RECOMMENDED: theta = 10^{-6}
c
c     gamma double precision
c          constant for the Armijo crtierion
c          f(x + alpha d) <= f(x) + gamma * alpha * <\nabla f(x),d>
c
c          RECOMMENDED: gamma = 10^{-4}
c
c     beta double precision
c          constant for the beta condition
c          <d_k, g(x_k + d_k)>  .ge.  beta * <d_k,g_k>
c          if (x_k + d_k) satisfies the Armijo condition but does not
c          satisfy the beta condition then the point is accepted, but
c          if it satisfied the Armijo condition and also satisfies the
c          beta condition then we know that there is the possibility
c          for a succesful extrapolation
c
c          RECOMMENDED: beta = 0.5
c
c     sigma1, sigma2 double precision
c          constant for the safeguarded interpolation
c          if alpha_new \notin [sigma1, sigma*alpha] then we take
c          alpha_new = alpha / nint
c
c          RECOMMENDED: sigma1 = 0.1 and sigma2 = 0.9
c
c     nint double precision
c          constant for the interpolation. See the description of
c          sigma1 and sigma2 above. Sometimes we take as a new trial
c          step the previous one divided by nint
c
c          RECOMMENDED: nint = 2.0
c
c     next double precision
c          constant for the extrapolation
c          when extrapolating we try alpha_new = alpha * next
c
c          RECOMMENDED: next = 2.0
c
c     mininterp integer
c          constant for testing if, after having made at least mininterp
c          interpolations, the steplength is too small. In that case
c          failure of the line search is declared (may be the direction
c          is not a descent direction due to an error in the gradient
c          calculations)
c
c          RECOMMENDED: mininterp = 4
c
c          (use mininterp > maxfc for inhibit this stopping criterion)
c
c     ncomp integer
c          this constant is just for printing. In a detailed printing
c          option, ncomp component of the actual point will be printed
c
c          RECOMMENDED: ncomp = 5
c
c     sterel, steabs double precision
c          this constants mean a ``relative small number'' and ``an
c          absolute small number'' for the increments in finite
c          difference approximations of derivatives
c
c          RECOMMENDED: epsrel = 10^{-7}, epsabs = 10^{-10}
c
c     epsrel, epsabs, infty  double precision
c          this constants mean a ``relative small number'', ``an
c          absolute small number'', and ``infinite or a very big
c          number''. Basically, a quantity A is considered negligeble
c          with respect to another quantity B if
c          |A| < max ( epsrel * |B|, epsabs )
c
c          RECOMMENDED: epsrel = 10^{-10}, epsabs = 10^{-20} and
c          infty = 10^{+20}
c
c
c     On Return
c
c     x    double precision x(n)
c          final estimation to the solution
c
c     f    double precision
c          function value at the final estimation
c
c     g    double precision g(n)
c          gradient at the final estimation
c
c     gpeucn2 double precision
c          squared 2-norm of the continuous projected
c          gradient g_p at the final estimation (||g_p||_2^2)
c
c     gpsupn double precision
c          ||g_p||_inf at the final estimation
c
c     iter integer
c          number of iterations
c
c     fcnt integer
c          number of function evaluations
c
c     gcnt integer
c          number of gradient evaluations
c
c     cgcnt integer
c          number of conjugate gradient iterations
c
c     spgiter integer
c          number of SPG iterations
c
c     spgfcnt integer
c          number of function evaluations in SPG-directions line searches
c
c     tniter integer
c          number of Truncated Newton iterations
c
c     tnfcnt integer
c          number of function evaluations in TN-directions line searches
c
c     tnintcnt integer
c          number of times a backtracking in a TN-drection was needed
c
c     tnexgcnt integer
c          number of times an extrapolation in a TN-direction was
c          succesful in decreass the function value
c
c     tnexbcnt integer
c          number of times an extrapolation was aborted in the first
c          extrapolated point by augment of the function value
c
c     flag integer
c          This output parameter tells what happened in this
c          subroutine, according to the following conventions:
c
c          0= convergence with small euclidian-norm of the
c             projected gradient (smaller than epsgpen);
c
c          1= convergence with small infinite-norm of the
c             projected gradient (smaller than epsgpsn);
c
c          2= the algorithm stopped by ``lack of enough progress'',
c             that means that f(x_k) - f(x_{k+1}) <=
c             epsnfp * max { f(x_j)-f(x_{j+1}, j<k} during maxitnfp
c             consecutive iterations;
c
c          3= the algorithm stopped because the order of the euclidian-
c             norm of the continuous projected gradient did not change
c             during maxitngp consecutive iterations. Probably, we
c             are asking for an exagerately small norm of continuous
c             projected gradient for declaring convergence;
c
c          4= the algorithm stopped because the functional value
c             is very small (f <= fmin);
c
c          6= too small step in a line search. After having made at
c             least mininterp interpolations, the steplength becames
c             small. ``small steplength'' means that we are at point
c             x with direction d and step alpha, and
c
c             alpha * ||d||_infty < max(epsabs, epsrel * ||x||_infty).
c
c             In that case failure of the line search is declared
c             (may be the direction is not a descent direction
c             due to an error in the gradient calculations). Use
c             mininterp > maxfc for inhibit this criterion;
c
c          7= it was achieved the maximum allowed number of
c             iterations (maxit);
c
c          8= it was achieved the maximum allowed number of
c             function evaluations (maxfc);
c
c          9= error in evalf subroutine;
c
c         10= error in evalg subroutine;
c
c         11= error in evalhd subroutine.

      character*3 ittype
      logical outite,outdet,evals
      integer i,itnfp,itngp,cgflag,lsflag,nind,nprint,cgmaxit,cgiter,
     *fcntprev,tnintprev,tnexgprev,tnexbprev,rbdtype,rbdind,inform
      double precision lambda,gieucn2,gpi,fprev,sts,sty,epsgpen2,delta,
     *currprog,bestprog,gexp,gexpprev,cgeps,xnorm,ometa2,amax,amaxx,
     *acgeps,bcgeps,kappa,gpeucn20,gpsupn0

c     =======================================================
c     Initialization
c     =======================================================

c     Set some initial values:

c     counters,
      iter= 0
      fcnt= 0
      gcnt= 0
      cgcnt= 0

      spgiter= 0
      spgfcnt= 0

      tniter= 0
      tnfcnt= 0

      tnstpcnt= 0
      tnintcnt= 0
      tnexgcnt= 0
      tnexbcnt= 0

      tnintfe= 0
      tnexgfe= 0
      tnexbfe= 0

c     just for printing,
      nprint= min0(n,ncomp)

c     for testing convergence,
      epsgpen2= epsgpen**2

c     for testing wether abandon the current face or not,
c     (ometa2 means '(one minus eta) squared')
      ometa2= (1.0d0-eta)**2

c     for testing progress in f,
      fprev= infty
      bestprog= 0.0d0
      itnfp= 0

c     for testing progress in the order of the gradient norm, and
      gexpprev= infty
      itngp= 0

c     Print problem information

      if(iprint.ge.0) then
          write(*,977) n
          write(*,978) nprint,(l(i),i=1,nprint)
          write(*,979) nprint,(u(i),i=1,nprint)
          write(*,980) nprint,(x(i),i=1,nprint)

          write(10,977) n
          write(10,978) nprint,(l(i),i=1,nprint)
          write(10,979) nprint,(u(i),i=1,nprint)
          write(10,980) nprint,(x(i),i=1,nprint)
      end if

c     Project initial guess. If the initial guess is infeasible,
c     projection puts it in the box.

      do i= 1, n
          x(i)= dmax1(l(i),dmin1(x(i),u(i)))
      end do

c     Compute x euclidian-norm

      xnorm= 0.0d0
      do i= 1, n
          xnorm= xnorm + x(i)**2
      end do
      xnorm= dsqrt(xnorm)

c     Compute function and gradient at the initial point

      call evalf(n,x,f,inform)
      fcnt= fcnt + 1

      if (inform.ne.0) then
          flag = 9

          if (iprint.ge.0) then
              write(*,999)  flag
              write(10,999) flag
          end if

          go to 500
      end if

c      if (evals(n,x,f,inform)) then
c          flag = 0
c          go to 500
c      end if

      if (gtype.eq.0) then
          call evalg(n,x,g,inform)
      else if (gtype.eq.1) then
          call evalgdiff(n,x,g,sterel,steabs,evalf,inform)
      end if
      gcnt= gcnt + 1

      if (inform.ne.0) then
          flag = 10

          if (iprint.ge.0) then
              write(*,1000)  flag
              write(10,1000) flag
          end if

          go to 500
      end if

c     Compute continuous project gradient infinite- and euclidian-
c     norm, internal gradient euclidian-norm, and store in nind the
c     number of free variables and in array p their identifiers.

      nind= 0
      gpsupn= 0.0d0
      gpeucn2= 0.0d0
      gieucn2= 0.0d0
      do i= 1, n
          gpi= dmin1(u(i),dmax1(l(i),x(i)-g(i)))-x(i)
          gpsupn= dmax1(gpsupn, dabs(gpi))
          gpeucn2= gpeucn2 + gpi**2
          if (x(i).gt.l(i).and.x(i).lt.u(i)) then
              gieucn2= gieucn2 + gpi**2
              nind= nind + 1
              ind(nind)= i
          end if
      end do

c     Compute a linear relation between gpeucn2 and cgeps2, i.e.,
c     scalars a and b such that
c
c         a * log10(||g_P(x_0)||_2^2) + b = log10(cgeps_0^2) and
c
c         a * log10(||g_P(x_f)||_2^2) + b = log10(cgeps_f^2),
c
c     where cgeps_0 and cgeps_f are provided. Note that if
c     cgeps_0 is equal to cgeps_f then cgeps will be allways
c     equal to cgeps_0 and cgeps_f.

c     We introduce now a linear relation between gpsupn and cgeps also.

      if (cgscre.eq.1) then
          acgeps= 2.0d0*dlog10(cgepsf/cgepsi)/dlog10(cggpnf**2/gpeucn2)
          bcgeps= 2.0d0*dlog10(cgepsi)-acgeps*dlog10(gpeucn2)
      else ! if (cgscre.eq.2) then
          acgeps= dlog10(cgepsf/cgepsi)/dlog10(cggpnf/gpsupn)
          bcgeps= dlog10(cgepsi)-acgeps*dlog10(gpsupn)
      end if

c     And it will be used for the linear relation of cgmaxit

      gpsupn0= gpsupn
      gpeucn20= gpeucn2

c     Print initial information

      if(iprint.ge.0) then
          write(*,981) iter
          write(*,985) nprint,(x(i),i=1,nprint)
          write(*,986) nprint,(g(i),i=1,nprint)
          write(*,987) nprint,
     *    (dmin1(u(i),dmax1(l(i),x(i)-g(i)))-x(i),i=1,nprint)
          write(*,988) min0(nprint,nind),nind,
     *    (ind(i),i=1,min0(nprint,nind))
          write(*,1003) f,dsqrt(gpeucn2),dsqrt(gieucn2),gpsupn,nind,n,
     *    spgiter,tniter,fcnt,gcnt,cgcnt

          write(10,981) iter
          write(10,985) nprint,(x(i),i=1,nprint)
          write(10,986) nprint,(g(i),i=1,nprint)
          write(10,987) nprint,
     *    (dmin1(u(i),dmax1(l(i),x(i)-g(i)))-x(i),i=1,nprint)
          write(10,988) min0(nprint,nind),nind,
     *    (ind(i),i=1,min0(nprint,nind))
          write(10,1003) f,dsqrt(gpeucn2),dsqrt(gieucn2),gpsupn,nind,n,
     *    spgiter,tniter,fcnt,gcnt,cgcnt
      end if

c     Test whether the initial functional value is very small

      if (f.le.fmin) then
          flag= 4

          if (iprint.ge.0) then
              write(*,994)  flag,fmin
              write(10,994) flag,fmin
          end if

          go to 500
      end if

c     Test whether the number of functional evaluations is
c     exhausted (i.e., maxfc = 1)

      if (fcnt.ge.maxfc) then
          flag= 8

          if (iprint.ge.0) then
              write(*,998)  flag,maxfc
              write(10,998) flag,maxfc
          end if

          go to 500
      end if

c     =======================================================
c     Main loop
c     =======================================================

 100  continue

c     =======================================================
c     Test stopping criteria
c     =======================================================

c     Test whether the continuous projected gradient euclidian-norm
c     is small enough to declare convergence

      if (gpeucn2.le.epsgpen2) then
          flag= 0

          if (iprint.ge.0) then
              write(*,990)  flag,epsgpen
              write(10,990) flag,epsgpen
          end if

          go to 500
      end if

c     Test whether the continuous projected gradient infinite-norm
c     is small enough to declare convergence

      if (gpsupn.le.epsgpsn) then
          flag= 1

          if (iprint.ge.0) then
              write(*,991)  flag,epsgpsn
              write(10,991) flag,epsgpsn
          end if

          go to 500
      end if

c     Test whether we performed many iterations without good progress
c     of the functional value

      currprog= fprev - f
      bestprog= dmax1(currprog, bestprog)

      if (currprog.le.epsnfp*bestprog) then

          itnfp= itnfp + 1

          if (itnfp.ge.maxitnfp) then
              flag= 2

              if (iprint.ge.0) then
                  write(*,992)  flag,epsnfp,maxitnfp
                  write(10,992) flag,epsnfp,maxitnfp
              end if

              go to 500
          endif

      else
          itnfp= 0
      endif

c     Test whether we have performed many iterations without good
c     reduction of the euclidian-norm of the projected gradient

      gexp= dlog10(gpeucn2)

      if (gexp.ge.gexpprev) then

          itngp= itngp + 1

          if(itngp.ge.maxitngp) then
              flag= 3

              if (iprint.ge.0) then
                  write(*,993)  flag,maxitngp
                  write(10,993) flag,maxitngp
              end if

              go to 500
          endif

      else
          itngp= 0
      endif

      gexpprev= gexp

c     Test whether the number of iterations is exhausted

      if (iter.ge.maxit) then
          flag= 7

          if (iprint.ge.0) then
              write(*,997)  flag,maxit
              write(10,997) flag,maxit
          end if

          go to 500
      end if

c     Note that the stopping criteria related to small functional
c     values ( f <= fmin ) and number of functional evaluations
c     are detected inside the line searches and do not need to
c     be tested here

c     =======================================================
c     The stopping criteria were not satisfied, a new
c     iteration will be made
c     =======================================================

      iter= iter + 1

c     =======================================================
c     Will we print information on this iteration?
c     Detailed or not?
c     =======================================================

      if (iprint.gt.0.and.mod(iter,iprint).eq.0) then
          outite= .true.
          if (iprint2.eq.1) then
              outdet= .true.
          else
	      outdet= .false.
          end if
      else
          outite= .false.
          outdet= .false.
      end if

c     =======================================================
c     Save current values, f, x and g
c     =======================================================

      fprev= f

      do i= 1, n
          s(i)= x(i)
          y(i)= g(i)
      end do

c     =======================================================
c     Compute new iterate
c     =======================================================

c     We abandon the current face if the norm of the internal gradient
c     (here, internal components of the continuous projected gradient)
c     is smaller than (1-eta) times the norm of the continuous projected
c     gradient. Using eta=0.9 is a rather conservative strategy in the
c     sense that internal iterations are preferred over SPG iterations.
c     Replace eta=0.9 by other tolerance in (0,1) if you find it convenient.

      if (gieucn2.le.ometa2*gpeucn2) then

c         ===================================================
c         Some constraints should be abandoned. Compute
c         the new iterate using an SPG iteration
c         ===================================================

          ittype= 'SPG'
          spgiter= spgiter + 1

c         Compute spectral steplength

          if (iter.eq.1.or.sty.le.0.0d0) then
              lambda= dmax1(1.0d0,xnorm)/dsqrt(gpeucn2)
          else
              lambda= sts/sty
          end if
          lambda= dmin1(lammax,dmax1(lammin,lambda))

c         Perform a line search with safeguarded quadratic
c         interpolation along the direction of the spectral
c         continuous projected gradient

          fcntprev= fcnt
          call spgls(n,x,f,g,l,u,lambda,fmin,maxfc,outdet,fcnt,lsflag,
     *    w(1),w(n+1),gamma,sigma1,sigma2,nint,mininterp,sterel,steabs,
     *    epsrel,epsabs,infty,evalf)

          spgfcnt= spgfcnt + (fcnt-fcntprev)

          if (lsflag.eq.9) then
              flag = 9

              if (iprint.ge.0) then
                  write(*,999)  flag
                  write(10,999) flag
              end if

              go to 500
          end if

c         Compute the gradient of the new iterate

          if (gtype.eq.0) then
              call evalg(n,x,g,inform)
          else if (gtype.eq.1) then
              call evalgdiff(n,x,g,sterel,steabs,evalf,inform)
          end if
          gcnt= gcnt + 1

          if (inform.ne.0) then
              flag = 10

              if (iprint.ge.0) then
                  write(*,1000)  flag
                  write(10,1000) flag
              end if

              go to 500
          end if

      else

c         ===================================================
c         The new iterate will belong to the closure of
c         the actual face
c         ===================================================

          ittype= 'TN '
          tniter= tniter + 1

c         Compute trust-region radius

          if (iter.eq.1) then
              if(udelta0.lt.0.d0) then
                  delta= dmax1(delmin,100.0d0*dmax1(1.0d0,xnorm))
              else
                  delta= udelta0
              end if
          else
              delta= dmax1(delmin,10.0d0*dsqrt(sts))
          end if

c         Shrink the point, its gradient and the bounds

          call shrink(nind,ind,n,x,g,l,u)

c         Compute the descent direction solving the newtonian
c         system by conjugate gradients

c         Set conjugate gradient stopping criteria. Default values are
c         taken if you set ucgeps < 0 and ucgmaxit < 0, respectively.
c         Otherwise, the parameters cgeps and cgmaxit will be the ones
c         set by the user.

          if(ucgmaxit.lt.0) then
              if (nearlyq) then
                  cgmaxit= nind
              else
                  if (cgscre.eq.1) then
                      kappa= dlog10(gpeucn2/gpeucn20)/
     *                       dlog10(epsgpen2/gpeucn20)
                  else ! if (cgscre.eq.2) then
                      kappa= dlog10(gpsupn/gpsupn0)/
     *                       dlog10(epsgpsn/gpsupn0)
                  end if
                  kappa= dmax1(0.0d0,dmin1(1.0d0,kappa))
                  cgmaxit= int(
     *            (1.0d0-kappa)*dmax1(1.0d0,10.0d0*dlog10(dfloat(nind)))
     *            + kappa*dfloat(nind) )
              end if
          else
              cgmaxit= ucgmaxit
          end if

          if (cgscre.eq.1) then
              cgeps= dsqrt(10.0d0**(acgeps*dlog10(gpeucn2)+bcgeps))
          else ! if (cgscre.eq.2) then
              cgeps= 10.0d0**(acgeps*dlog10(gpsupn)+bcgeps)
          end if
          cgeps= dmax1(cgepsf,dmin1(cgepsi,cgeps))

c         Call conjugate gradients

          call cg(nind,ind,n,x,g,delta,l,u,cgeps,epsnqmp,maxitnqmp,
     *    cgmaxit,nearlyq,gtype,htvtype,trtype,outdet,ncomp,d,cgiter,
     *    rbdtype,rbdind,cgflag,w(1),w(n+1),w(2*n+1),w(3*n+1),w(4*n+1),
     *    theta,sterel,steabs,epsrel,epsabs,infty,evalf,evalg,evalhd)

	  cgcnt= cgcnt + cgiter

          if (cgflag.eq.10) then
              flag = 10

              if (iprint.ge.0) then
                  write(*,1000)  flag
                  write(10,1000) flag
              end if

              go to 500

          else if (cgflag.eq.11) then
              flag = 11

              if (iprint.ge.0) then
                  write(*,1001)  flag
                  write(10,1001) flag
              end if

              go to 500
          end if

c         Compute maximum step

          if (cgflag.eq.2) then
              amax= 1.0d0
          else
              amax= infty
              do i= 1, nind
                  if (d(i).gt.0.0d0.and.u(i).lt.infty) then
                      amaxx= (u(i)-x(i))/d(i)
                      if (amaxx.lt.amax) then
                          amax= amaxx
                          rbdind= i
                          rbdtype= 2
                      end if
                  else if (d(i).lt.0.0d0.and.l(i).gt.-infty) then
                      amaxx= (l(i)-x(i))/d(i)
                      if (amaxx.lt.amax) then
                          amax= amaxx
                          rbdind= i
                          rbdtype= 1
                      end if
                  end if
               end do
          end if

c         Perform the line search

          tnintprev= tnintcnt
          tnexgprev= tnexgcnt
          tnexbprev= tnexbcnt

          fcntprev= fcnt

          call tnls(nind,ind,n,x,f,g,d,l,u,amax,rbdtype,rbdind,fmin,
     *    maxfc,gtype,outdet,fcnt,gcnt,tnintcnt,tnexgcnt,tnexbcnt,
     *    lsflag,w(1),w(n+1),gamma,beta,sigma1,sigma2,nint,next,
     *    mininterp,sterel,steabs,epsrel,epsabs,infty,evalf,evalg)

          if (lsflag.eq.9) then
              flag = 9

              if (iprint.ge.0) then
                  write(*,999)  flag
                  write(10,999) flag
              end if

              go to 500

          else if (lsflag.eq.10) then
              flag = 10

              if (iprint.ge.0) then
                  write(*,1000)  flag
                  write(10,1000) flag
              end if

              go to 500
          end if

          tnfcnt= tnfcnt + (fcnt-fcntprev)

          if (tnintcnt.gt.tnintprev) then
              tnintfe= tnintfe + (fcnt-fcntprev)
          else if (tnexgcnt.gt.tnexgprev) then
              tnexgfe= tnexgfe + (fcnt-fcntprev)
          else if (tnexbcnt.gt.tnexbprev) then
              tnexbfe= tnexbfe + (fcnt-fcntprev)
          else
              tnstpcnt= tnstpcnt + 1
          end if

c         Expand the point, its gradient and the bounds

          call expand(nind,ind,n,x,g,l,u)

c         If the line search (interpolation) in the Truncated Newton
c         direction stopped due to a very small step (lsflag=6) we
c         will discard this iteration and force a SPG iteration

c         Note that tnls subroutine was coded in such a way that in
c         case of lsflag=6 termination the subroutine discards all
c         what was made and returns with the same point it started

          if (lsflag.eq.6) then

              if (outdet) then
                  write(*,*)
                  write(*,*)
     *            '     The previous NT iteration was discarded due to',
     *            '     a termination for very small step in the line ',
     *            '     search. A SPG iteration will be forced now.   '

                  write(10,*)
                  write(10,*)
     *            '     The previous NT iteration was discarded due to',
     *            '     a termination for very small step in the line ',
     *            '     search. A SPG iteration will be forced now.   '
              end if

              ittype= 'SPG'
              spgiter= spgiter + 1

c             Compute spectral steplength

              if (iter.eq.1.or.sty.le.0.0d0) then
                  lambda= dmax1(1.0d0,xnorm)/dsqrt(gpeucn2)
              else
                  lambda= sts/sty
              end if
              lambda= dmin1(lammax,dmax1(lammin,lambda))

c             Perform a line search with safeguarded quadratic
c             interpolation along the direction of the spectral
c             continuous projected gradient

              fcntprev= fcnt

              call spgls(n,x,f,g,l,u,lambda,fmin,maxfc,outdet,fcnt,
     *        lsflag,w(1),w(n+1),gamma,sigma1,sigma2,nint,mininterp,
     *        sterel,steabs,epsrel,epsabs,infty,evalf)

              spgfcnt= spgfcnt + (fcnt-fcntprev)

              if (lsflag.eq.9) then
                  flag = 9

                  if (iprint.ge.0) then
                      write(*,999)  flag
                      write(10,999) flag
                  end if

                  go to 500
              end if

c             Compute the gradient in the new iterate

              if (gtype.eq.0) then
                  call evalg(n,x,g,inform)
              else if (gtype.eq.1) then
                  call evalgdiff(n,x,g,sterel,steabs,evalf,inform)
              end if
              gcnt= gcnt + 1

              if (inform.ne.0) then
                  flag = 10

                  if (iprint.ge.0) then
                      write(*,1000)  flag
                      write(10,1000) flag
                  end if

                  go to 500
              end if

          end if

      end if

c     =======================================================
c     Prepare for the next iteration
c     =======================================================

c     This adjustment/projection is "por lo que las putas pudiera"

      do i= 1, n
          if (x(i).le.l(i)+dmax1(epsrel*dabs(l(i)),epsabs)) then
              x(i)= l(i)
          else if (x(i).ge.u(i)-dmax1(epsrel*dabs(u(i)),epsabs)) then
              x(i)= u(i)
          end if
      end do

c     Compute x euclidian-norm

      xnorm= 0.0d0
      do i= 1, n
          xnorm= xnorm + x(i)**2
      end do
      xnorm= dsqrt(xnorm)

c     Compute s = x_{k+1} - x_k, y = g_{k+1} - g_k, <s,s> and <s,y>

      sts= 0.0d0
      sty= 0.0d0
      do i= 1, n
          s(i)= x(i)-s(i)
          y(i)= g(i)-y(i)
          sts= sts + s(i)*s(i)
          sty= sty + s(i)*y(i)
      end do

c     Compute continuous project gradient infinite- and euclidian-
c     norm, internal gradient euclidian-norm, and store in nind the
c     number of free variables and in array p its identifiers.

      nind= 0
      gpsupn= 0.0d0
      gpeucn2= 0.0d0
      gieucn2= 0.0d0
      do i= 1, n
          gpi= dmin1(u(i),dmax1(l(i),x(i)-g(i)))-x(i)
          gpsupn= dmax1(gpsupn, dabs(gpi))
          gpeucn2= gpeucn2 + gpi**2
          if (x(i).gt.l(i).and.x(i).lt.u(i)) then
              gieucn2= gieucn2 + gpi**2
              nind= nind + 1
              ind(nind)= i
          end if
      end do

c     Print information of this iteration

      if (outite) then
          if (outdet) then
		write(*,983) iter,ittype
	  	write(*,985) nprint,(x(i),i=1,nprint)
          	write(*,986) nprint,(g(i),i=1,nprint)
          	write(*,987) nprint,
     *    	(dmin1(u(i),dmax1(l(i),x(i)-g(i)))-x(i),i=1,nprint)
          	write(*,988) min0(nprint,nind),nind,
     *    	(ind(i),i=1,min0(nprint,nind))
	        write(*,1003) f,dsqrt(gpeucn2),dsqrt(gieucn2),gpsupn,
     *    	nind,n,spgiter,tniter,fcnt,gcnt,cgcnt
	  else
		write(*,1002)iter,f,dsqrt(gieucn2),dsqrt(gpeucn2),gpsupn
          endif

          if (outdet) then
		write(10,983) iter,ittype
          	write(10,985) nprint,(x(i),i=1,nprint)
          	write(10,986) nprint,(g(i),i=1,nprint)
          	write(10,987) nprint,
     *    	(dmin1(u(i),dmax1(l(i),x(i)-g(i)))-x(i),i=1,nprint)
          	write(10,988) min0(nprint,nind),nind,
     *    	(ind(i),i=1,min0(nprint,nind))
	        write(10,1003) f,dsqrt(gpeucn2),dsqrt(gieucn2),gpsupn,
     *    	nind,n,spgiter,tniter,fcnt,gcnt,cgcnt
	  else
		write(10,1002)iter,f,dsqrt(gieucn2),dsqrt(gpeucn2),
     *		gpsupn
	  endif
      end if

c     =======================================================
c     Test some stopping criteria that may occur inside the
c     line searches
c     =======================================================

      if (lsflag.eq.4) then

          flag= 4

          if (iprint.ge.0) then
              write(*,994)  flag,fmin
              write(10,994) flag,fmin
          end if

          go to 500

      else if (lsflag.eq.6) then

          flag= 6

          if (iprint.ge.0) then
              write(*,996)  flag,mininterp,epsrel,epsabs
              write(10,996) flag,mininterp,epsrel,epsabs
          end if

          go to 500

      else if (lsflag.eq.8) then

          flag= 8

          if (iprint.ge.0) then
              write(*,998)  flag,maxfc
              write(10,998) flag,maxfc
          end if

          go to 500

      end if

c     =======================================================
c     Iterate
c     =======================================================

c      if (evals(n,x,f,inform)) then
c          flag = 0
c          go to 500
c      end if
c
      go to 100

c     =======================================================
c     End of main loop
c     =======================================================

c     =======================================================
c     Report output status and return
c     =======================================================

 500  continue

c     Print final information

      if (iprint.ge.0) then

          write(*,982) iter
          write(*,985) nprint,(x(i),i=1,nprint)
          write(*,986) nprint,(g(i),i=1,nprint)
          write(*,987) nprint,
     *    (dmin1(u(i),dmax1(l(i),x(i)-g(i)))-x(i),i=1,nprint)
          write(*,988) min0(nprint,nind),nind,
     *    (ind(i),i=1,min0(nprint,nind))
          write(*,1003) f,dsqrt(gpeucn2),dsqrt(gieucn2),gpsupn,nind,n,
     *    spgiter,tniter,fcnt,gcnt,cgcnt

          write(10,982) iter
          write(10,985) nprint,(x(i),i=1,nprint)
          write(10,986) nprint,(g(i),i=1,nprint)
          write(10,987) nprint,
     *    (dmin1(u(i),dmax1(l(i),x(i)-g(i)))-x(i),i=1,nprint)
          write(10,988) min0(nprint,nind),nind,
     *    (ind(i),i=1,min0(nprint,nind))
          write(10,1003) f,dsqrt(gpeucn2),dsqrt(gieucn2),gpsupn,nind,n,
     *    spgiter,tniter,fcnt,gcnt,cgcnt

      end if

      return

c     Non-executable statements

 977  format(/1X, 'Entry to GENCAN. Number of variables: ',I7)
 978  format(/1X,'Lower bounds (first ',I6, ' components): ',
     */,6(1X,1PD11.4))
 979  format(/1X,'Upper bounds (first ',I6, ' components): ',
     */,6(1X,1PD11.4))
 980  format(/1X,'Initial point (first ',I6, ' components): ',
     */,6(1X,1PD11.4))
 981  format(/1X,'GENCAN iteration: ',I6, ' (Initial point)')
 982  format(/1X,'GENCAN iteration: ',I6, ' (Final point)')
 983  format(/,1X,'GENCAN iteration: ',I6,
     *' (This point was obtained using a ',A3,' iteration)')
 985  format(1X,'Current point (first ',I6, ' components): ',
     */,6(1X,1PD11.4))
 986  format(1X,'Current gradient (first ',I6, ' components): ',
     */,6(1X,1PD11.4))
 987  format(1X,'Current continuous projected gradient (first ',I6,
     *' components): ',/,6(1X,1PD11.4))
 988  format(1X,'Current free variables (first ',I6,
     *', the number of free variables is ',I6,'): ',/,10(1X,I6))
 990  format(/1X,'Flag of GENCAN= ',I2,
     *' (convergence with Euclidian-norm of the projected gradient',
     */,1X,'smaller than ',1PD11.4,')')
 991  format(/1X,'Flag of GENCAN= ',I2,
     *' (convergence with sup-norm of the projected gradient smaller',
     */,1X,'than ',1PD11.4,')')
 992  format(/1X,'Flag of GENCAN= ',I2,
     *' (The algorithm stopped by lack of enough progress. This means',
     */,1X,'that  f(x_k) - f(x_{k+1}) .le. ',1PD11.4,
     *' * max [ f(x_j)-f(x_{j+1}, j < k ]',/,1X,'during ',I7,
     *' consecutive iterations')
 993  format(/1X,'Flag of GENCAN= ',I2,
     *' (The algorithm stopped because the order of the',
     */,1X,'Euclidian-norm of the continuous projected gradient did',
     *' not change during ',/,1X,I7,' consecutive iterations.',
     *' Probably, an exagerately small norm of the',/,1X,'continuous',
     *' projected gradient is required for declaring convergence')
 994  format(/1X,'Flag of GENCAN= ',I2,
     *' (The algorithm stopped because the functional value is',
     */,1X,'smaller than ',1PD11.4)
 996  format(/1X,'Flag of GENCAN= ',I2,
     *' (Too small step in a line search. After having made at least ',
     */,1X,I7,' interpolations, the steplength becames small. Small',
     *' means that we were',/,1X,'at point x with direction d and took',
     *' a step  alpha such that',/,1X,'alpha * |d_i| .lt. max [',
     *1PD11.4,' * |x_i|,',1PD11.4,' ] for all i')
 997  format(/1X,'Flag of GENCAN= ',I2,
     *' (It was exceeded the maximum allowed number of iterations',
     */,1X,'(maxit=',I7,')')
 998  format(/1X,'Flag of GENCAN= ',I2,
     *' (It was exceeded the maximum allowed number of functional',
     */,1X,'evaluations (maxfc=',I7,')')
 999  format(/1X,'Flag of GENCAN= ',I2,
     *' (Error in evalf subroutine)')
 1000 format(/1X,'Flag of GENCAN= ',I2,
     *' (Error in evalg subroutine)')
 1001 format(/1X,'Flag of GENCAN= ',I2,
     *' (Error in evalhd subroutine)')
 1002 format(/I5,1X,'f= ',1PD11.4,2X,'|ipg|2= ',1PD11.4,2X,'|pg|2= ',
     *1PD11.4,2X,'|pg|sup= ',1PD11.4)
 1003 format(1X,'Functional value: ', 1PD11.4,
     */,1X,'Euclidian norm of the continuous projected gradient: ',
     *1PD11.4,
     */,1X,'Euclidian norm of the internal projection of gp: ',1PD11.4,
     */,1X,'Sup-norm of the continuous projected gradient: ',1PD11.4,
     */,1X,'Free variables at this point: ',I7,
     *' (over a total of ',I7,')',
     */,1X,'SPG iterations: ',I7,
     */,1X,'TN iterations: ',I7,
     */,1X,'Functional evaluations: ',I7,
     */,1X,'Gradient evaluations: ',I7,
     */,1X,'Conjugate gradient iterations: ',I7)

      end


c     ******************************************************
c     ******************************************************
      subroutine spgls(n,x,f,g,l,u,lambda,fmin,maxfc,output,fcnt,flag,
     *xtrial,d,gamma,sigma1,sigma2,nint,mininterp,sterel,steabs,epsrel,
     *epsabs,infty,evalf)

      logical output
      integer n,maxfc,fcnt,flag,mininterp
      double precision x(n),f,g(n),l(n),u(n),lambda,fmin,xtrial(n),d(n),
     *gamma,sigma1,sigma2,nint,sterel,steabs,epsrel,epsabs,infty
      external evalf
c     Safeguarded quadratic interpolation, used in SPG.
c
c     On Entry
c
c     n    integer
c          the order of the x
c
c     x    double precision x(n)
c          current point
c
c     f    double precision
c          function value at the current point
c
c     g    double precision g(n)
c          gradient vector at the current point
c
c     l    double precision l(n)
c          lower bounds
c
c     u    double precision u(n)
c          upper bounds
c
c     lambda double precision
c          spectral steplength
c
c     fmin double precision
c          functional value for the stopping criteria f <= fmin
c
c     maxfc integer
c          maximum number of funtion evaluations
c
c     output logical
c          TRUE: print some information at each iteration,
c          FALSE: no print.
c
c     xtrial, d double precision xtrial(n), d(n)
c          working vectors
c
c     gamma double precision
c          constant for the Armijo crtierion
c          f(x + alpha d) <= f(x) + gamma * alpha * <\nabla f(x),d>
c
c          RECOMMENDED: gamma = 10^{-4}
c
c     sigma1, sigma2 double precision
c          constant for the safeguarded interpolation
c          if alpha_new \notin [sigma1, sigma*alpha] then we take
c          alpha_new = alpha / nint
c
c          RECOMMENDED: sigma1 = 0.1 and sigma2 = 0.9
c
c     nint double precision
c          constant for the interpolation. See the description of
c          sigma1 and sigma2 above. Sometimes we take as a new trial
c          step the previous one divided by nint
c
c          RECOMMENDED: nint = 2.0
c
c     mininterp integer
c          constant for testing if, after having made at least mininterp
c          interpolations, the steplength is soo small. In that case
c          failure of the line search is declared (may be the direction
c          is not a descent direction due to an error in the gradient
c          calculations)
c
c          RECOMMENDED: mininterp = 4
c
c     sterel, steabs double precision
c          this constants mean a ``relative small number'' and ``an
c          absolute small number'' for the increments in finite
c          difference approximations of derivatives
c
c          RECOMMENDED: epsrel = 10^{-7}, epsabs = 10^{-10}
c
c     epsrel, epsabs, infty  double precision
c          this constants mean a ``relative small number'', ``an
c          absolute small number'', and ``infinite or a very big
c          number''. Basically, a quantity A is considered negligeble
c          with respect to another quantity B if
c          |A| < max ( epsrel * |B|, epsabs )
c
c          RECOMMENDED: epsrel = 10^{-10}, epsabs = 10^{-20} and
c          infty = 10^{+20}
c
c     On Return
c
c     x    double precision
c          final estimation of the solution
c
c     f    double precision
c          functional value at the final estimation
c
c     fcnt integer
c          number of function evaluations used in the line search
c
c     flag integer
c          This output parameter tells what happened in this
c          subroutine, according to the following conventions:
c
c          0= convergence with an Armijo-like criterion
c             (f(xnew) <= f(x) + 1.0d-4 * alpha * <g,d>);
c
c          4= the algorithm stopped because the functional value
c             is very small (f <= fmin);
c
c          6= too small step in the line search. After having made at
c             least mininterp interpolations, the steplength becames
c             small. ``small steplength'' means that we are at point
c             x with direction d and step alpha, and, for all i,
c
c             |alpha * d(i)| .le. max ( epsrel * |x(i)|, epsabs ).
c
c             In that case failure of the line search is declared
c             (maybe the direction is not a descent direction
c             due to an error in the gradient calculations). Use
c             mininterp > maxfc for inhibit this criterion;
c
c          8= it was achieved the maximum allowed number of
c             function evaluations (maxfc);
c
c          9= error in evalf subroutine.

c     We use the Armijo parameter gamma=1.0d-4. You can replace it by
c     some other number in (0,1) if you find it convenient.

      logical samep
      integer i,interp,inform
      double precision ftrial,gtd,alpha,atemp

c     Initialization

      interp= 0

c     Compute first trial point, spectral projected gradient
c     direction, and directional derivative <g,d>.

      alpha= 1.0d0

      gtd= 0.0d0
      do i= 1, n
          xtrial(i)= dmin1(u(i),dmax1(l(i),x(i)-lambda*g(i)))
          d(i)= xtrial(i)-x(i)
          gtd= gtd + g(i)*d(i)
      end do

      call evalf(n,xtrial,ftrial,inform)
      fcnt= fcnt + 1

      if (inform.ne.0) then

          flag = 9

          if (output) then
              write(*,1000) flag
              write(10,1000) flag
          end if

          go to 500

      end if

c     Print initial information

      if (output) then
          write(*,980) lambda
          write(*,999) alpha,ftrial,fcnt

          write(10,980) lambda
          write(10,999) alpha, ftrial, fcnt
      end if

c     Main loop

 100  continue

c     Test Armijo stopping criterion

      if (ftrial.le.f+gamma*alpha*gtd) then

          f= ftrial

          do i= 1, n
              x(i)= xtrial(i)
          end do

          flag= 0

          if (output) then
              write(*,990) flag
              write(10,990) flag
          end if

          go to 500

      end if

c     Test whether f is very small

      if (ftrial.le.fmin) then

          f= ftrial

          do i= 1, n
              x(i)= xtrial(i)
          end do

          flag= 4

          if (output) then
              write(*,994) flag
              write(10,994) flag
          end if

          go to 500

      end if

c     Test whether the number of functional evaluations is exhausted

      if (fcnt.ge.maxfc) then

          if (ftrial.lt.f) then

              f= ftrial

              do i= 1, n
                  x(i)= xtrial(i)
              end do

          end if

          flag= 8

          if (output) then
              write(*,998) flag
              write(10,998) flag
          end if

          go to 500

      end if

c     Compute new step (safeguarded quadratic interpolation)

      interp= interp + 1

      if (alpha.lt.sigma1) then
          alpha= alpha/nint

      else
          atemp= (-gtd*alpha**2)/(2.0d0*(ftrial-f-alpha*gtd))

          if (atemp.lt.sigma1 .or. atemp.gt.sigma2*alpha) then
              alpha= alpha/nint

          else
              alpha= atemp
          end if
      end if

c     Compute new trial point

      do i= 1, n
          xtrial(i)= x(i) + alpha*d(i)
      end do

      call evalf(n,xtrial,ftrial,inform)
      fcnt= fcnt + 1

      if (inform.ne.0) then

          flag = 9

          if (output) then
              write(*,1000) flag
              write(10,1000) flag
          end if

          go to 500

      end if

c     Print information of this iteration

      if (output) then
          write(*,999)  alpha,ftrial,fcnt
          write(10,999) alpha,ftrial,fcnt
      end if

c     Test whether at least mininterp interpolations were made and
c     two consecutive iterates are close enough

      samep= .true.
      do i= 1, n
         if (dabs(alpha*d(i)).gt.dmax1(epsrel*dabs(x(i)),epsabs)) then
             samep= .false.
         end if
      end do

      if (interp.gt.mininterp.and.samep) then

          if (ftrial.lt.f) then

              f= ftrial

              do i= 1, n
                  x(i)= xtrial(i)
              end do

          end if

          flag= 6

          if (output) then
              write(*,996)  flag
              write(10,996) flag
          end if

          go to 500

      end if

c     Iterate

      go to 100

c     Return

 500  continue

      return

c     Non-executable statements

 980  format(/,6x,'SPG (spectral steplength ',1PD11.4,')',
     */,/,6x,'SPG Line search')
 999  format(6x,'Alpha= ',1PD11.4,' F= ',1PD11.4,' FE= ',I5)
 990  format(6x,'Flag of SPG Line search= ',I2,
     *' (Convergence with an Armijo-like criterion)')
 994  format(6x,'Flag of SPG Line search= ',I2,
     *' (Small functional value, smaller than parameter fmin)')
 996  format(6x,'Flag of SPG Line search= ',I2,
     *' (Too small step in the interpolation process)')
 998  format(6x,'Flag of SPG Line search= ',I2,
     *' (Too many functional evaluations)')
 1000 format(6x,'Flag of SPG Line search= ',I2,
     *' (Error in evalf subroutine)')

      end


c     ******************************************************
c     ******************************************************
      subroutine cg(nind,ind,n,x,g,delta,l,u,eps,epsnqmp,maxitnqmp,
     *maxit,nearlyq,gtype,htvtype,trtype,output,ncomp,s,iter,rbdtype,
     *rbdind,flag,w,y,r,d,sprev,theta,sterel,steabs,epsrel,epsabs,infty,
     *evalf,evalg,evalhd)

      logical nearlyq,output
      integer nind,ind(nind),n,maxitnqmp,maxit,gtype,htvtype,trtype,
     *ncomp,iter,rbdtype,rbdind,flag
      double precision x(n),g(n),delta,l(n),u(n),eps,epsnqmp,s(n),w(n),
     *y(n),r(n),d(n),sprev(n),theta,sterel,steabs,epsrel,epsabs,infty
      external evalf,evalg,evalhd
c     This subrotuine implements the conjugate-gradient method for
c     minimizing the quadratic approximation q(s) of f(x) at x, where
c
c     q(s) = 1/2 s^T H s + g^T s,
c
c        H = \nabla^2 f(x),
c
c        g = \nabla f(x),
c
c     subject to ||s||_2 <= delta and l <= x + s <= u.
c
c     The method returns an approximation s to the solution such
c     that ||H s + g||_2 <= eps * ||g||_2; or converges to the
c     boundary of ||s||_2 <= delta and l <= x + s <= u; or finds
c     a point s and a direction d such that q(s + alpha d) = q(s)
c     for any alpha, i.e., d^T H d = g^T d = 0.
c
c     On Entry
c
c     nind integer
c          number of free variables (this is thee dimension in
c          which this subroutine will work)
c
c     ind  integer ind(n)
c          array which contains, in the first nind positions, the
c          identifiers of the free variables
c
c     n    integer
c          dimension of the full space
c
c     x    double precision x(n)
c          point at which f function is being approximated by the
c          quadratic model
c
c          The first nind positions of x contains the free variables
c          x_ind(1), x_ind(2), ..., x_ind(nind).
c
c     g    double precision g(n)
c          linear coeficient of the quadratic function
c
c          This is \nabla f(x) and it also contains in the first nind
c          positions the components g_ind(1), g_ind(2), ..., g_ind(nind).
c
c          IMPORTANT: the linear algebra of this subroutine lies in
c          a space of dimension nind. The value of the full dimension n,
c          the non-free variables (which are at the end of array x) and
c          its gradient components (which are at the and of array g)
c          are, at this moment, being used to approximate the hessian
c          times vector products by incremental quotients.
c
c     delta double precision
c          trust region radius (||s||_2 <= delta)
c
c     l    double precision l(n)
c          lower bounds on x + s. It components are ordered in the
c          same way as x and g.
c
c     u    double precision u(n)
c          upper bounds on x + s. It components are ordered in the
c          same way as x, g and l.
c
c     eps  double precision
c          tolerance for the stopping criterion
c          ||H s + g||_2 < eps * ||g||_2
c
c     epsnqmp double precision
c          see below
c
c     maxitnqmp integer
c          This and the previous one parameter are used for a stopping
c          criterion of the conjugate gradient subalgorithm. If the
c          progress in the quadratic model is less or equal than a
c          fraction of the best progress ( epsnqmp * bestprog ) during
c          maxitnqmp consecutive iterations then CG is stopped by not
c          enough progress of the quadratic model.
c
c          RECOMMENDED: epsnqmp = 1.0d-4, maxitnqmp = 5
c
c     maxit integer
c          maximum number of iterations allowed
c
c     nearlyq logical
c          if function f is (nearly) quadratic, use the option
c          nerlyq = TRUE. Otherwise, keep the default option.
c
c          if, in an iteration of CG we find a direction d such
c          that d^T H d <= 0 then we take the following decision:
c
c          (i) if nearlyq = TRUE then take direction d and try to
c          go to the boundary chosing the best point among the two
c          point at the boundary and the current point.
c
c          (ii) if nearlyq = FALSE then we stop at the current point.
c
c          RECOMMENDED: nearlyq = FALSE
c
c     gtype integer
c          type of gradient calculation
c          gtype = 0 means user suplied evalg subroutine,
c          gtype = 1 means central diference approximation.
c
c          RECOMMENDED: gtype = 0
c
c          (provided you have the evalg subroutine)
c
c     htvtype integer
c          type of gradient calculation
c          htvtype = 0 means user suplied evalhd subroutine,
c          htvtype = 1 means incremental quotients approximation.
c
c          RECOMMENDED: htvtype = 1
c
c          (you take some risk using this option but, a menos que
c          voce tenha uma boa evalhd subroutine, incremental
c          quotients is a very cheap option)
c
c     trtype integer
c          type of trust-region radius
c          trtype = 0 means 2-norm trust-region
c          trtype = 1 means infinite-norm trust-region
c
c          RECOMMENDED: trtype = 0
c
c     output logical
c          TRUE: print some information at each iteration,
c          FALSE: no print.
c
c     w,y,r,d,sprev double precision w(n),y(n),r(n),d(n),sprev(n)
c          working vectors
c
c     theta double precision
c          constant for the angle condition, i.e., at iteration k
c          we need a direction d_k such that
c          <g_k,d_k> <= -theta ||g||_2 ||d_k||_2,
c          where g_k is \nabla f(x_k)
c
c          RECOMMENDED: theta = 10^{-6}
c
c     sterel, steabs double precision
c          this constants mean a ``relative small number'' and ``an
c          absolute small number'' for the increments in finite
c          difference approximations of derivatives
c
c          RECOMMENDED: epsrel = 10^{-7}, epsabs = 10^{-10}
c
c     epsrel, epsabs, infty  double precision
c          this constants mean a ``relative small number'', ``an
c          absolute small number'', and ``infinite or a very big
c          number''. Basically, a quantity A is considered negligeble
c          with respect to another quantity B if
c          |A| < max ( epsrel * |B|, epsabs )
c
c          RECOMMENDED: epsrel = 10^{-10}, epsabs = 10^{-20} and
c          infty = 10^{+20}
c
c     On Return
c
c     s    double precision s(n)
c          final estimation of the solution
c
c     iter integer
c          number of conjugate-gradient iterations performed
c
c     flag integer
c          termination parameter:
c
c          0= convergence with ||H s + g||_2 <= eps * ||g||_2;
c
c          1= convergence to the boundary of ||s||_2 <= delta;
c
c          2= convergence to the boundary of l - x <= s <= u - x;
c
c          3= stopping with s= s_k  such that
c             <g,s_k> <= -theta ||g||_2 ||s_k||_2 and
c             <g,s_{k+1}> > -theta ||g||_2 ||s_{k+1}||_2;
c
c          4= not enough progress of the quadratic model during
c             maxitnqmp iterations, i.e., during maxitnqmp iterations
c             |q-qprev| .le. max ( epsrel * |q|, epsabs );
c
c          6= very similar consecutive iterates,
c             for two consecutive iterates x and y, for all i
c             |x(i)-y(i)| .le. max ( epsrel * |x(i)|, epsabs );
c
c          7= stopping with d such that d^T H d = 0 and g^T d = 0;
c
c          8= too many iterations;
c
c         11= error in evalhd subroutine.

      character*5 rbdtypea
      logical goth,samep
      integer i,itnqmp,rbdposatype,rbdnegatype,rbdposaind,rbdnegaind,
     *inform
      double precision rnorm2,rnorm2prev,beta,alpha,amax,amax1,amax2,
     *dtw,dnorm2,dts,aa,bb,cc,dd,gts,dtr,gnorm2,snorm2,q,snorm2prev,
     *qprev,amax1n,amax2n,amaxn,amax2x,amax2nx,qamax,qamaxn,norm2s,
     *bestprog,currprog,eps2

c     =======================================================
c     Initialization
c     =======================================================

      goth= .false.

      eps2 = eps**2
      gnorm2= norm2s(nind,g)

      iter= 0

      itnqmp= 0
      qprev= infty
      bestprog= 0.0d0

      do i = 1, nind
          s(i)= 0.0d0
          r(i)= g(i)
      end do

      q= 0.0d0

      gts= 0.0d0
      snorm2= 0.0d0
      rnorm2= gnorm2

c     =======================================================
c     Print initial information
c     =======================================================

      if (output) then
          write(*,980) maxit,eps
          if (trtype.eq.0) then
              write(*,981) delta
          else if (trtype.eq.1) then
              write(*,982) delta
          else
              write(*,983)
          end if
          write(*,984) iter,rnorm2,dsqrt(snorm2),q

          write(10,980) maxit,eps
          if (trtype.eq.0) then
              write(10,981) delta
          else if (trtype.eq.1) then
              write(10,982) delta
          else
              write(10,983)
          end if
          write(10,984) iter,rnorm2,dsqrt(snorm2),q

      end if

c     =======================================================
c     Main loop
c     =======================================================

 100  continue

c     =======================================================
c     Test stopping criteria
c     =======================================================

c     if ||r||_2 = ||H s + g||_2 <= eps * ||g||_2 then stop

      if (rnorm2.le.eps2*gnorm2.or.
     *(rnorm2.le.1.0d-17.and.iter.ne.0)) then

          flag= 0

          if (output) then
              write(*,990)  flag
              write(10,990) flag
          end if

          go to 500

      end if

c     if the maximum number of iterations was achieved then stop

      if (iter.ge.maxit) then

          flag= 8

          if (output) then
              write(*,998)  flag
              write(10,998) flag
          end if

          go to 500

      end if

c     =======================================================
c     Compute direction
c     =======================================================

      if (iter.eq.0) then

          dnorm2= rnorm2
          dtr= -rnorm2

	  if (dtr.gt.0.0d0) then
c     Force d to be a descent direction of q(s), i.e.,
c     <\nabla q(s), d> = <H s + g, d> = <r, d> \le 0.
	          do i= 1, nind
        	      d(i)= r(i)
	          end do
        	  dtr= -dtr

	  else
	          do i= 1, nind
        	      d(i)= -r(i)
	          end do
	  end if

      else

          beta= rnorm2/rnorm2prev
          dnorm2= rnorm2 - 2.0d0*beta*(dtr+alpha*dtw) + beta**2*dnorm2
          dtr= -rnorm2 + beta*(dtr+alpha*dtw)

	  if (dtr.gt.0.0d0) then

		do i= 1, nind
        		d(i)= r(i) - beta*d(i)
		end do
        	dtr= -dtr
          else
		do i= 1, nind
			d(i)= -r(i) + beta*d(i)
		end do
          end if
      end if

c     Force d to be a descent direction of q(s), i.e.,
c     <\nabla q(s), d> = <H s + g, d> = <r, d> \le 0.

c      if (dtr.gt.0.0d0) then

c          do i= 1, nind
c              d(i)= -d(i)
c          end do

c          dtr= -dtr

c      end if

c     =======================================================
c     Compute d^T H d
c     =======================================================

c     w= A d

      call calchd(nind,ind,x,d,g,n,x,gtype,htvtype,w,y,sterel,steabs,
     *goth,evalf,evalg,evalhd,inform)

      if (inform.ne.0) then
          flag = 11

          if (output) then
              write(*,1011) flag
              write(10,1011) flag
          end if

          go to 500
      end if

c     Compute d^T w and ||w||^2
c
c	and
c     =======================================================
c     Compute maximum step
c     =======================================================

c     amax1 > 0 and amax1n < 0 are the values of alpha such
c     that ||s + alpha * d||_2 or ||s + alpha * d||_\infty = delta

      dtw= 0.0d0
      dts= 0.0d0
      do i= 1, nind
          dtw= dtw + d(i)*w(i)
          dts= dts + d(i)*s(i)
      end do



c      dts= 0.0d0
c      do i= 1, nind
c          dts= dts + d(i)*s(i)
c      end do

c     2-norm trust-region radius

      if (trtype.eq.0) then

          aa= dnorm2
          bb= 2.0d0*dts
          cc= snorm2-delta**2
          dd= dsqrt(bb**2-4.0d0*aa*cc)

          amax1= (-bb+dd)/(2.0d0*aa)
          amax1n= (-bb-dd)/(2.0d0*aa)

c     infinite-norm trust-region radius

      else if (trtype.eq.1) then

          amax1= infty
          amax1n= -infty

          do i= 1, nind
              if (d(i).gt.0.0d0) then
                  amax1= dmin1(amax1, (delta-s(i))/d(i))
                  amax1n= dmax1(amax1n, (-delta-s(i))/d(i))
              else if (d(i).lt.0.0d0) then
                  amax1= dmin1(amax1, (-delta-s(i))/d(i))
                  amax1n= dmax1(amax1n, (delta-s(i))/d(i))
              end if
          end do

      end if

c     amax2 > 0 and amax2n < 0 are the maximum and the minimum
c     values of alpha such that l - x <= s + alpha * d <= u - x,
c     respectively

      amax2= infty
      amax2n= -infty

      do i= 1, nind
          if (d(i).gt.0.0d0) then
              if (u(i).lt.infty) then
                  amax2x= (u(i)-x(i)-s(i))/d(i)
                  if (amax2x.lt.amax2) then
                      amax2= amax2x
                      rbdposaind= i
                      rbdposatype= 2
                  end if
              end if
              if (l(i).gt.-infty) then
                  amax2nx= (l(i)-x(i)-s(i))/d(i)
                  if (amax2nx.gt.amax2n) then
                      amax2n= amax2nx
                      rbdnegaind= i
                      rbdnegatype= 1
                  end if
              end if
          else if (d(i).lt.0.0d0) then
              if (l(i).gt.-infty) then
                  amax2x= (l(i)-x(i)-s(i))/d(i)
                  if (amax2x.lt.amax2) then
                      amax2= amax2x
                      rbdposaind= i
                      rbdposatype= 1
                  end if
              end if
              if (u(i).lt.infty) then
                  amax2nx= (u(i)-x(i)-s(i))/d(i)
                  if (amax2nx.gt.amax2n) then
                      amax2n= amax2nx
                      rbdnegaind= i
                      rbdnegatype= 2
                  end if
              end if
          end if
      end do

c     Compute amax as the minimum among amax1 and amax2, and
c     amaxn as the minimum among amax1n and amax2n. Moreover
c     change amaxn by -amaxn to have amax and amaxn as maximum
c     steps along d direction (and not -d in the case of amaxn)

      amax=   dmin1(amax1,  amax2)
      amaxn=  dmax1(amax1n, amax2n)

c     =======================================================
c     Compute the step (and the quadratic functional value at
c     the new point)
c     =======================================================

      qprev= q

c     If d^T H d > 0 then take the conjugate gradients step

      if (dtw.gt.0.0d0) then

          alpha= dmin1(amax, rnorm2/dtw)

          q= q + 0.5d0*alpha**2*dtw + alpha*dtr

c     If d^T H d <= 0 and function f is nearly quadratic then
c     take the point with the minimum functional value (q) among
c     the actual one and the ones which are at the boundary, i.e.,
c     the best one between q(s), q(s + amax*d) and q(s + amaxn*d).

      else

          qamax= q + 0.5d0*amax**2*dtw + amax*dtr

c         If we are at iteration zero then take the maximum positive
c         step in the minus gradient direction

          if (iter.eq.0) then

              alpha= amax
              q= qamax

c         If we are not in the first iteration then if function f is
c         nearly quadratic and q(s + amax * d) or q(s + amaxn * d) is
c         smaller than q(s), go to the best point in the boundary

          else if (nearlyq.and.(qamax.lt.q.or.qamaxn.lt.q)) then

              qamaxn= q + 0.5d0*amaxn**2*dtw + amaxn*dtr

              if (qamax.lt.qamaxn) then
                  alpha= amax
                  q= qamax
              else
                  alpha= amaxn
                  q= qamaxn
              end if

c         Else, stop at the current point

          else

              flag= 7

              if (output) then
                  write(*,997)  flag
                  write(10,997) flag
              end if

              go to 500

          end if

      end if

c     =======================================================
c     Compute new s
c     =======================================================
c     =======================================================
c     Compute the residual r = H s + g
c     =======================================================
      snorm2prev= snorm2
      snorm2= snorm2 + alpha**2*dnorm2 + 2.0d0*alpha*dts
      rnorm2prev= rnorm2

      do i= 1, nind
          sprev(i)= s(i)
          s(i)= s(i) + alpha*d(i)
          r(i)= r(i) + alpha*w(i)
      end do
      rnorm2= norm2s(nind,r)


c     =======================================================
c     Increment number of iterations
c     =======================================================

      iter= iter + 1

c     =======================================================
c     Print information of this iteration
c     =======================================================

      if (output) then
          write(*,984)  iter,dsqrt(rnorm2),dsqrt(snorm2),q
          write(10,984) iter,dsqrt(rnorm2),dsqrt(snorm2),q
      end if

c     =======================================================
c     Test other stopping criteria
c     =======================================================

c     Test angle condition

      gts= 0.0d0
      do i= 1, nind
          gts= gts + g(i)*s(i)
      end do

      if (gts.gt.0.0d0 .or. gts**2.lt.theta**2*gnorm2*snorm2) then

          do i= 1, nind
              s(i)= sprev(i)
          end do

          snorm2= snorm2prev

          q= qprev

          flag= 3

          if (output) then
              write(*,993)  flag
              write(10,993) flag
          end if

          go to 500

      end if

c     If we are in the boundary of the box also stop

      if (alpha.eq.amax2.or.alpha.eq.amax2n) then

          if (alpha.eq.amax2) then
              rbdind= rbdposaind
              rbdtype= rbdposatype
          else ! if (alpha.eq.amax2n) then
              rbdind= rbdnegaind
              rbdtype= rbdnegatype
          end if

          if (rbdtype.eq.1) then
              rbdtypea= 'lower'
          else ! if (rbdtype.eq.2) then
              rbdtypea= 'upper'
          end if

          flag= 2

          if (output) then
              write(*,992)  flag,ind(rbdind),rbdtypea
              write(10,992) flag,ind(rbdind),rbdtypea
          end if

          go to 500

      end if

c     If we are in the boundary of the trust region then stop

      if (alpha.eq.amax1.or.alpha.eq.amax1n) then

          flag= 1

          if (output) then
              write(*,991)  flag
              write(10,991) flag
          end if

          go to 500

      end if

c     If two consecutive iterates are much close then stop

      samep= .true.
      do i= 1, nind
         if (dabs(alpha*d(i)).gt.dmax1(epsrel*dabs(s(i)),epsabs)) then
              samep= .false.
          end if
      end do

      if (samep) then

          flag= 6

          if (output) then
              write(*,996)  flag
              write(10,996) flag
          end if

          go to 500

      end if

c     Test whether we performed many iterations without good progress
c     of the quadratic model

c     if (dabs(q-qprev).le.dmax1(epsrel*dabs(qprev),epsabs)) then

c         itnqmp= itnqmp + 1

c         if (itnqmp.ge.maxitnqmp) then

c             flag= 4

c             if (output) then
c                 write(*,994)  flag,itnqmp
c                 write(10,994) flag,itnqmp
c             end if

c             go to 500

c         endif

c     else
c         itnqmp= 0
c     endif

c     Test whether we performed many iterations without good progress
c     of the quadratic model

      currprog= qprev - q
      bestprog= dmax1(currprog, bestprog)

      if (currprog.le.epsnqmp*bestprog) then

          itnqmp= itnqmp + 1

          if (itnqmp.ge.maxitnqmp) then
              flag= 4

              if (output) then
                  write(*,994)  flag,itnqmp,epsnqmp,bestprog
                  write(10,994) flag,itnqmp,epsnqmp,bestprog
              end if

              go to 500
          endif

      else
          itnqmp= 0
      endif

c     =======================================================
c     Iterate
c     =======================================================

      go to 100

c     =======================================================
c     End of main loop
c     =======================================================

c     =======================================================
c     Return
c     =======================================================

 500  continue

c     Print final information

      if (output) then
          write(*,985) min0(nind,ncomp),(s(i),i=1,min0(nind,ncomp))
          write(10,985) min0(nind,ncomp),(s(i),i=1,min0(nind,ncomp))
      end if

      return

c     Non-executable statements

 980  format(/,6x,'Conjugate gradients (maxit= ',I7,' acc= ',1PD11.4,
     *')')
 981  format(6x,'Using Euclidian trust region (delta= ',1PD11.4,
     *')')
 982  format(6x,'Using sup-norm trust region (delta= ',1PD11.4,')')
 983  format(6x,'Unknown trust-region type')
 984  format(6x,'CG iter= ',I5,' rnorm: ',1PD11.4,' snorm= ',1PD11.4,
     *' q= ',1PD11.4)
 985  format(/,6x,'Truncated Newton direction (first ',I6,
     *' components): ',/,1(6x,6(1PD11.4,1x)))
 990  format(6x,'Flag of CG= ',I2,' (Convergence with small residual)')
 991  format(6x,'Flag of CG= ',I2,
     *' (Convergence to the trust region boundary)')
 992  format(6x,'Flag of CG= ',I2,
     *' (Convergence to the boundary of the box constraints,',/,6x,
     *'taking step >= 1, variable ',I6,' will reaches its ',A5,
     *' bound)')
 993  format(6x,'Flag of CG= ',I2,
     *' (The next CG iterate will not satisfy the angle condition)')
 994  format(6x,'Flag of CG= ',I2,
     *' (Not enough progress in the quadratic model. This means',/,6x,
     *'that the progress of the last ',I7,' iterations was smaller ',
     *'than ',/,6x,1PD11.4,' times the best progress (',1PD11.4,')')
 996  format(6x,'Flag of CG= ',I2,
     *' (Very near consecutive iterates)')
 997  format(6x,'Flag of CG= ',I2,
     *' (d such that d^T H d = 0 and g^T d = 0 was found)')
 998  format(6x,'Flag of CG= ',I2,' (Too many GC iterations)')
 1011 format(6x,'Flag of CG= ',I2,' (Error in evalhd subroutine)')

      end


c     ******************************************************
c     ******************************************************
      subroutine tnls(nind,ind,n,x,f,g,d,l,u,amax,rbdtype,rbdind,fmin,
     *maxfc,gtype,output,fcnt,gcnt,intcnt,exgcnt,exbcnt,flag,xplus,
     *xtemp,gamma,beta,sigma1,sigma2,nint,next,mininterp,sterel,steabs,
     *epsrel,epsabs,infty,evalf,evalg)

      logical output
      integer nind,ind(nind),n,rbdtype,rbdind,maxfc,gtype,fcnt,gcnt,
     *intcnt,exgcnt,exbcnt,flag,mininterp
      double precision x(n),f,g(n),d(n),l(n),u(n),amax,fmin,xplus(n),
     *xtemp(n),gamma,beta,sigma1,sigma2,nint,next,sterel,steabs,epsrel,
     *epsabs,infty
     
      external evalf,evalg

c     This subrotuine implements the line search described in a working
c     paper by E. G. Birgin and J. M. Martinez.
c
c     On Entry
c
c     nind integer
c          number of free variables (this is thee dimension in
c          which this subroutine will work)
c
c     ind  integer ind(n)
c          array which contains, in the first nind positions, the
c          identifiers of the free variables
c
c     n    integer
c          dimension of the full space
c
c     x    double precision x(n)
c          actual point
c
c          The first nind positions of x contains the free variables
c          x_ind(1), x_ind(2), ..., x_ind(nind).
c
c     f    double precision
c          functional value at x
c
c     g    double precision g(n)
c          gradient vector at x
c
c          It also contains in the first nind positions the components
c          g_ind(1), g_ind(2), ..., g_ind(nind).
c
c          IMPORTANT: the linear algebra of this subroutine lies in
c          a space of dimension nind. The value of the full dimension n,
c          the non-free variables (which are at the end of array x) and
c          its gradient components (which are at the and of array g)
c          are also used and actualized any time the gradient is being
c          evaluated.
c
c     d    double precision d(nind)
c          descent direction
c
c     l    double precision l(nind)
c          lower bounds on x. It components are ordered in the
c          same way as x and g.
c
c     u    double precision u(nind)
c          upper bounds on x. It components are ordered in the
c          same way as x, g and l.
c
c     fmin double precision
c          functional value for the stopping criteria f <= fmin
c
c     maxfc integer
c          maximum number of funtion evaluations
c
c     gtype integer
c          type of gradient calculation
c          gtype = 0 means user suplied evalg subroutine,
c          gtype = 1 means central diference approximation.
c
c          RECOMMENDED: gtype = 0
c
c          (provided you have the evalg subroutine)
c
c     output logical
c          TRUE: print some information at each iteration,
c          FALSE: no print.
c
c     xplus, xtemp double precision xplus(nind),xtemp(nind)
c          working vectors
c
c     gamma double precision
c          constant for the Armijo crtierion
c          f(x + alpha d) <= f(x) + gamma * alpha * <\nabla f(x),d>
c
c          RECOMMENDED: gamma = 10^{-4}
c
c     beta double precision
c          constant for the beta condition
c          <d_k, g(x_k + d_k)>  <  beta * <d_k,g_k>
c          if (x_k + d_k) satisfies the Armijo condition but does not
c          satisfy the beta condition then the point is accepted, but
c          if it satisfied the Armijo condition and also satisfies the
c          beta condition then we know that there is the possibility
c          for a succesful extrapolation
c
c          RECOMMENDED: beta = 0.5
c
c     sigma1, sigma2 double precision
c          constant for the safeguarded interpolation
c          if alpha_new \notin [sigma1, sigma*alpha] then we take
c          alpha_new = alpha / nint
c
c          RECOMMENDED: sigma1 = 0.1 and sigma2 = 0.9
c
c     nint double precision
c          constant for the interpolation. See the description of
c          sigma1 and sigma2 above. Sometimes we take as a new trial
c          step the previous one divided by nint
c
c          RECOMMENDED: nint = 2.0
c
c     next double precision
c          constant for the extrapolation
c          when extrapolating we try alpha_new = alpha * next
c
c          RECOMMENDED: next = 2.0
c
c     mininterp integer
c          constant for testing if, after having made at least mininterp
c          interpolations, the steplength is soo small. In that case
c          failure of the line search is declared (may be the direction
c          is not a descent direction due to an error in the gradient
c          calculations)
c
c          RECOMMENDED: mininterp = 4
c
c     sterel, steabs double precision
c          this constants mean a ``relative small number'' and ``an
c          absolute small number'' for the increments in finite
c          difference approximations of derivatives
c
c          RECOMMENDED: epsrel = 10^{-7}, epsabs = 10^{-10}
c
c     epsrel, epsabs, infty  double precision
c          this constants mean a ``relative small number'', ``an
c          absolute small number'', and ``infinite or a very big
c          number''. Basically, a quantity A is considered negligeble
c          with respect to another quantity B if
c          |A| < max ( epsrel * |B|, epsabs )
c
c          RECOMMENDED: epsrel = 10^{-10}, epsabs = 10^{-20} and
c          infty = 10^{+20}
c
c     On Return
c
c     x    double precision x(n)
c          new actual point
c
c     f    double precision
c          functional value at x
c
c     g    double precision g(n)
c          gradient vector at x
c
c     fcnt integer
c          number of funtional evaluations used in this line search
c
c     gcnt integer
c          number of gradient evaluations used in this line search
c
c     intcnt integer
c          number of interpolations
c
c     exgcnt integer
c          number of good extrapolations
c
c     exbcnt integer
c          number of bad extrapolations
c
c     flag integer
c          This output parameter tells what happened in this
c          subroutine, according to the following conventions:
c
c          0= convergence with an Armijo-like criterion
c             (f(xnew) <= f(x) + 1.0d-4 * alpha * <g,d>);
c
c          4= the algorithm stopped because the functional value
c             is very small (f <= fmin);
c
c          6= soo small step in the line search. After having made at
c             least mininterp interpolations, the steplength becames
c             small. ``small steplength'' means that we are at point
c             x with direction d and step alpha, and, for all i,
c
c             |alpha * d(i)| .le. max ( epsrel * |x(i)|, epsabs ).
c
c             In that case failure of the line search is declared
c             (may be the direction is not a descent direction
c             due to an error in the gradient calculations). Use
c             mininterp > maxfc for inhibit this criterion;
c
c          8= it was achieved the maximum allowed number of
c             function evaluations (maxfc);
c
c          9= error in evalf subroutine;
c
c         10= error in evalg subroutine.

c     Armijo parameter and beta parameter. You can modify them if
c     necessary

      logical samep
      integer i,interp,inform
      double precision fplus,atemp,ftemp,gtd,gptd,alpha,fbext

c     =======================================================
c     Compute directional derivative
c     =======================================================

      gtd= 0.0d0
      do i= 1, nind
          gtd= gtd + g(i)*d(i)
      end do

c     =======================================================
c     Compute first trial
c     =======================================================

      alpha= dmin1(1.0d0, amax)

      do i= 1, nind
          xplus(i)= x(i) + alpha*d(i)
      end do

      if (alpha.eq.amax) then
          if (rbdtype.eq.1) then
              xplus(rbdind)= l(rbdind)
          else ! if (rbdtype.eq.2) then
              xplus(rbdind)= u(rbdind)
          end if
      end if

      call calcf(nind,ind,xplus,n,x,fplus,evalf,inform)
      fcnt= fcnt + 1

      if (inform.ne.0) then

          flag = 9

          if (output) then
              write(*,1000) flag
              write(10,1000) flag
          end if

          go to 500

      end if

c     Print initial information

      if (output) then
          write(*,980) amax
          write(*,999) alpha,fplus,fcnt

          write(10,980) amax
          write(10,999) alpha,fplus,fcnt
      end if

c     =======================================================
c     Test Armijo and beta-condition and decide for accepting
c     the trial point, interpolate or extrapolate.
c     =======================================================

      if (amax.gt.1.0d0) then

c         x + d belongs to the interior of the feasible set (amax > 1)

          if (output) then
              write(*,*)  '     x+d belongs to int of the feasible set'
              write(10,*) '     x+d belongs to int of the feasible set'
          end if

c         Verify Armijo

          if (fplus.le.f+gamma*alpha*gtd) then

c             Armijo condition holds
              if (output) then
                  write(*,*)  '     Armijo condition holds'
                  write(10,*) '     Armijo condition holds'
              end if

              call calcg(nind,ind,xplus,n,x,gtype,g,sterel,steabs,
     *        evalf,evalg,inform)

              
	      gcnt= gcnt + 1

              if (inform.ne.0) then

                  flag = 10

                  if (output) then
                      write(*,1001) flag
                      write(10,1001) flag
                  end if

                  go to 500

              end if

              gptd= 0.0d0
              do i= 1, nind
                  gptd= gptd + g(i)*d(i)
              end do

c             Verify directional derivative (beta condition)

              if (gptd.ge.beta*gtd) then

c                 Step = 1 was ok, finish the line search
                  if (output) then
                      write(*,*)  '     The beta condition is also true'
                      write(*,*)  '     Line search is over'
                      write(10,*) '     The beta condition is also true'
                      write(10,*) '     Line search is over'
                  end if

                  f= fplus

                  do i= 1, nind
                      x(i)= xplus(i)
                  end do

                  flag= 0

                  if (output) then
                      write(*,990)  flag
                      write(10,990) flag
                  end if

                  go to 500

              else

c                 Extrapolate
                  if (output) then
                      write(*,*) '     The beta-condition does not hold'
                      write(*,*) '     We will extrapolate'
                      write(10,*)'     The beta-condition does not hold'
                      write(10,*)'     We will extrapolate'
                  end if

c                 f before extrapolation
                  fbext= fplus

                  go to 100

              end if

          else

c             Interpolate
              if (output) then
                  write(*,*)  '     Armijo does not hold'
                  write(*,*)  '     We will interpolate'
                  write(10,*) '     Armijo does not hold'
                  write(10,*) '     We will interpolate'
              end if

              go to 200

          end if

      else

c         x + d does not belong to the feasible set (amax <= 1)
          if (output) then
              write(*,*)  '     x+d does not belong to box-interior'
              write(10,*) '     x+d does not belong to box-interior'
          end if

          if (fplus.lt.f) then

c             Extrapolate
              if (output) then
                  write(*,*)  '     f(x+d) < f(x)'
                  write(*,*)  '     We will extrapolate'
                  write(10,*) '     f(x+d) < f(x)'
                  write(10,*) '     We will extrapolate'
              end if

c             f before extrapolation
              fbext= fplus

              go to 100

          else

c             Interpolate
              if (output) then
                  write(*,*)  '     f(x+d) >= f(x)'
                  write(*,*)  '     We will interpolate'
                  write(10,*) '     f(x+d) >= f(x)'
                  write(10,*) '     We will interpolate'
              end if

              go to 200

          end if

      end if


c     =======================================================
c     Extrapolation
c     =======================================================
 100  continue

c     Test f going to -inf

 120  if (fplus.le.fmin) then

c         Finish the extrapolation with the current point

          f= fplus

          do i= 1, nind
              x(i)= xplus(i)
          end do

          call calcg(nind,ind,x,n,x,gtype,g,sterel,steabs,evalf,
     *	  evalg,inform)
          gcnt= gcnt + 1

          if (inform.ne.0) then

              flag = 10

              if (output) then
                  write(*,1001) flag
                  write(10,1001) flag
              end if

              go to 500

          end if

          if (f.lt.fbext) then
              exgcnt= exgcnt + 1
          else
              exbcnt= exbcnt + 1
          end if

          flag= 4

          if (output) then
              write(*,994) flag
              write(10,994) flag
          end if

          go to 500

      end if

c     Test maximum number of functional evaluations

      if (fcnt.ge.maxfc) then

c         Finish the extrapolation with the current point

          f= fplus

          do i= 1, nind
              x(i)= xplus(i)
          end do

          call calcg(nind,ind,x,n,x,gtype,g,sterel,steabs,evalf,
     *	  evalg,inform)
          gcnt= gcnt + 1

          if (inform.ne.0) then

              flag = 10

              if (output) then
                  write(*,1001) flag
                  write(10,1001) flag
              end if

              go to 500

          end if

          if (f.lt.fbext) then
              exgcnt= exgcnt + 1
          else
              exbcnt= exbcnt + 1
          end if

          flag= 8

          if (output) then
              write(*,998) flag
              write(10,998) flag
          end if

          go to 500

      end if

c     Chose new step

      if (alpha.lt.amax.and.next*alpha.gt.amax) then
          atemp= amax
      else
          atemp= next*alpha
      end if

c     Compute new trial point

      do i= 1, nind
          xtemp(i)= x(i) + atemp*d(i)
      end do

      if (atemp.eq.amax) then
          if (rbdtype.eq.1) then
              xtemp(rbdind)= l(rbdind)
          else ! if (rbdtype.eq.2) then
              xtemp(rbdind)= u(rbdind)
          end if
      end if

c     Project

      if (atemp.gt.amax) then
          do i= 1, nind
              xtemp(i)= dmax1(l(i),dmin1(xtemp(i), u(i)))
          end do
      end if

c     Test if this is not the same point as the previous one.
c     This test is performed only when alpha >= amax.

      if(alpha.ge.amax) then

          samep= .true.
          do i= 1, nind
              if (dabs(xtemp(i)-xplus(i)).gt.
     *        dmax1(epsrel*dabs(xplus(i)),epsabs)) then
                  samep= .false.
              end if
          end do

          if (samep) then

c             Finish the extrapolation with the current point

              f= fplus

              do i= 1, nind
                  x(i)= xplus(i)
              end do

              call calcg(nind,ind,x,n,x,gtype,g,sterel,steabs,
     *        evalf,evalg,inform)
              gcnt= gcnt + 1

              if (inform.ne.0) then

                  flag = 10

                  if (output) then
                      write(*,1001) flag
                      write(10,1001) flag
                  end if

                  go to 500

              end if

              if (f.lt.fbext) then
                  exgcnt= exgcnt + 1
              else
                  exbcnt= exbcnt + 1
              end if

              flag= 0

              if (output) then
                  write(*,990) flag
                  write(10,990) flag
              end if

              go to 500

          end if

      end if

c     Evaluate function

      call calcf(nind,ind,xtemp,n,x,ftemp,evalf,inform)
      fcnt= fcnt + 1

      if (inform.ne.0) then

          flag = 9

          if (output) then
              write(*,1000) flag
              write(10,1000) flag
          end if

          go to 500

      end if

c     Print information of this iteration

      if (output) then
          write(*,999)  atemp,ftemp,fcnt
          write(10,999) atemp,ftemp,fcnt
      end if

c     If the functional value decreases then set the current
c     point and continue the extrapolation

      if (ftemp.lt.fplus) then

          alpha= atemp

          fplus= ftemp

          do i= 1, nind
              xplus(i)= xtemp(i)
          end do

          go to 120

c     If the functional value does not decrease then discard the
c     last trial and finish the extrapolation with the previous point

      else

          f= fplus

          do i= 1, nind
              x(i)= xplus(i)
          end do

          call calcg(nind,ind,x,n,x,gtype,g,sterel,steabs,evalf,
     *	  evalg,inform)
          gcnt= gcnt + 1

          if (inform.ne.0) then

              flag = 10

              if (output) then
                  write(*,1001) flag
                  write(10,1001) flag
              end if

              go to 500

          end if

          if (f.lt.fbext) then
              exgcnt= exgcnt + 1
          else
              exbcnt= exbcnt + 1
          end if

          flag= 0

          if (output) then
              write(*,990) flag
              write(10,990) flag
          end if

          go to 500

      end if
c     =======================================================
c     End of extrapolation
c     =======================================================

c     =======================================================
c     Interpolation
c     =======================================================
 200  continue
      intcnt= intcnt + 1

c     Initialization

      interp= 0

c     Test f going to -inf

 210  if (fplus.le.fmin) then

c         Finish the interpolation with the current point

          f= fplus

          do i= 1, nind
              x(i)= xplus(i)
          end do

          call calcg(nind,ind,x,n,x,gtype,g,sterel,steabs,evalf,
     *	  evalg,inform)
          gcnt= gcnt + 1

          if (inform.ne.0) then

              flag = 10

              if (output) then
                  write(*,1001) flag
                  write(10,1001) flag
              end if

              go to 500

          end if

          flag= 4

          if (output) then
              write(*,994) flag
              write(10,994) flag
          end if

          go to 500

      end if

c     Test maximum number of functional evaluations

      if (fcnt.ge.maxfc) then

c         As this is an abrupt termination then the current point of
c         the interpolation may be worst than the intial one

c         If the current point is better than the initial one then
c         finish the interpolation with the current point else
c         discard all we did inside this line search and finish with
c         the initial point

          if (fplus.lt.f) then

              f= fplus

              do i= 1, nind
                  x(i)= xplus(i)
              end do

              call calcg(nind,ind,x,n,x,gtype,g,sterel,steabs,
     *        evalf,evalg,inform)
              gcnt= gcnt + 1

              if (inform.ne.0) then

                  flag = 10

                  if (output) then
                      write(*,1001) flag
                      write(10,1001) flag
                  end if

                  go to 500

              end if

          end if

          flag= 8

          if (output) then
              write(*,998) flag
              write(10,998) flag
          end if

          go to 500

      end if

c     Compute new step

      interp= interp + 1

      if (alpha.lt.sigma1) then
          alpha= alpha/nint

      else
          atemp= (-gtd*alpha**2)/(2.0d0*(fplus-f-alpha*gtd))

          if (atemp.lt.sigma1 .or. atemp.gt.sigma2*alpha) then
              alpha= alpha/nint

          else
              alpha= atemp
          end if
      end if

c     Compute new trial point

      do i= 1, nind
          xplus(i)= x(i) + alpha*d(i)
      end do

      call calcf(nind,ind,xplus,n,x,fplus,evalf,inform)
      fcnt= fcnt + 1

      if (inform.ne.0) then

          flag = 9

          if (output) then
              write(*,1000) flag
              write(10,1000) flag
          end if

          go to 500

      end if

c     Print information of this iteration

      if (output) then
          write(*,999)  alpha,fplus,fcnt
          write(10,999) alpha,fplus,fcnt
      end if

c     Test Armijo condition

      if (fplus.le.f+gamma*alpha*gtd) then

c         Finish the line search

          f= fplus

          do i= 1, nind
              x(i)= xplus(i)
          end do

          call calcg(nind,ind,x,n,x,gtype,g,sterel,steabs,evalf,
     *	  evalg,inform)
          gcnt= gcnt + 1

          if (inform.ne.0) then

              flag = 10

              if (output) then
                  write(*,1001) flag
                  write(10,1001) flag
              end if

              go to 500

          end if

          flag= 0

          if (output) then
              write(*,990) flag
              write(10,990) flag
          end if

          go to 500

      end if

c     Test whether at least mininterp interpolations were made and
c     two consecutive iterates are much close

      samep= .true.
      do i= 1, nind
         if (dabs(alpha*d(i)).gt.dmax1(epsrel*dabs(x(i)),epsabs)) then
             samep= .false.
         end if
      end do

      if (interp.gt.mininterp.and.samep) then

c         As this is an abrupt termination then the current point of
c         the interpolation may be worst than the intial one

c         If the current point is better than the initial one then
c         finish the interpolation with the current point else
c         discard all we did inside this line search and finish with
c         the initial point

c         if (fplus.lt.f) then

c             f= fplus

c             do i= 1, nind
c                 x(i)= xplus(i)
c             end do

c             call calcg(nind,ind,x,n,x,gtype,g,sterel,steabs,evalg,inform)
c             gcnt= gcnt + 1

c             if (inform.ne.0) then

c                 flag = 10

c                 if (output) then
c                     write(*,1001) flag
c                     write(10,1001) flag
c                 end if

c                 go to 500

c             end if

c         end if

c         The previous lines were commented because, as it is been
c         used, this subroutine must return with the intial point
c         in case of finding a very small interpolation step

          flag= 6

          if (output) then
              write(*,996)  flag
              write(10,996) flag
          end if

          go to 500

      end if

c     Else, iterate

      go to 210
c     =======================================================
c     End of interpolation
c     =======================================================

 500  continue

c     =======================================================
c     Return
c     =======================================================

      return

c     Non-executable statements

 980  format(/,6x,'TN Line search (alphamax= ',1PD11.4,')')
 999  format(6x,'Alpha= ',1PD11.4,' F= ',1PD11.4,' FE= ',I5)
 990  format(6x,'Flag of TN Line search= ',I2,
     *' (Convergence with an Armijo-like criterion)')
 994  format(6x,'Flag of TN Line search= ',I2,
     *' (Small functional value, smaller than parameter fmin)')
 996  format(6x,'Flag of TN Line search= ',I2,
     *' (Too small step in the interpolation process)')
 998  format(6x,'Flag of TN Line search= ',I2,
     *' (Too many functional evaluations)')
 1000 format(6x,'Flag of TN Line search= ',I2,
     *' (Error in evalf subroutine)')
 1001 format(6x,'Flag of TN Line search= ',I2,
     *' (Error in evalg subroutine)')

      end


c     ******************************************************
c     ******************************************************
      subroutine shrink(nind,ind,n,x,g,l,u)

      integer n, nind, ind(nind)
      double precision x(n), g(n), l(n), u(n)

c     Shrink all vectors x, g, l and u from the full dimension
c     space (dimension n) to the reduced space (dimension nind).

      integer i, indi
      double precision temp

c     Shrink x, g, l and u for the reduced space

      do i= 1, nind
           indi= ind(i)
           if (i.ne.indi) then
               temp= x(indi)
               x(indi)= x(i)
               x(i)= temp

               temp= g(indi)
               g(indi)= g(i)
               g(i)= temp

               temp= l(indi)
               l(indi)= l(i)
               l(i)= temp

               temp= u(indi)
               u(indi)= u(i)
               u(i)= temp
          end if
      end do

      return

      end


c     ******************************************************
c     ******************************************************
      subroutine expand(nind,ind,n,x,g,l,u)

      integer n, nind, ind(nind)

      double precision x(n), g(n), l(n), u(n)

c     Expands vectors x, g, l and u from the reduced space
c     (dimension nind) to the full space (dimension n).

      integer i, indi
      double precision temp

c     Expand x, g, l and u to the full space

      do i= nind, 1, -1
          indi= ind(i)
          if (i.ne.indi) then
              temp= x(indi)
              x(indi)= x(i)
              x(i)= temp

              temp= g(indi)
              g(indi)= g(i)
              g(i)= temp

              temp= l(indi)
              l(indi)= l(i)
              l(i)= temp

              temp= u(indi)
              u(indi)= u(i)
              u(i)= temp
          end if
      end do

      return

      end


c     ******************************************************
c     ******************************************************
      subroutine calcf(nind,ind,x,n,xc,f,evalf,inform)

      integer nind,ind(nind),n,inform
      double precision x(n),xc(n),f
      external evalf
c     This subroutines computes the objective function. It is
c     called from the reduced space (dimension nind), expands
c     the point x where the function will be evaluated and call
c     the subroutine evalf (provided by the user) to compute
c     the objective function. Finally, returns vector x to the
c     reduced space (shrinking).
c
c     About subroutines named calc[something]. The subroutines
c     whos names start with ``calc'' work in (are called from)
c     the reduced space. Their task is (i) expand the arguments
c     to the full space, (ii) call the corresponding ``eval''
c     subroutine (which works in the full space), and (iii)
c     shrink the parameters again and also shrink an eventualy
c     output of the ``eval'' subroutines. Subroutines of this
c     type are: calcf, calcg, calchd and calchddiff (the last
c     one called from calchd) and the corresponding subroutines
c     in the full space are evalf, evalg and evalhd.

      integer i,indi
      double precision temp

c     Complete x

      do i= nind+1, n
          x(i)= xc(i)
      end do

c     Expand x to the full space

      do i= nind, 1, -1
          indi= ind(i)
          if (i.ne.indi) then
              temp= x(indi)
              x(indi)= x(i)
              x(i)= temp
          end if
      end do

c     Compute f

      call evalf(n,x,f,inform)

c     Shrink x to the reduced space

      do i= 1, nind
          indi= ind(i)
          if (i.ne.indi) then
              temp= x(indi)
              x(indi)= x(i)
              x(i)= temp
          end if
      end do

      return

      end


c     ******************************************************
c     ******************************************************
      subroutine calcg(nind,ind,x,n,xc,gtype,g,sterel,steabs,evalf,
     *evalg,inform)

      integer nind,ind(nind),n,gtype,inform
      double precision x(n),xc(n),g(n),sterel,steabs
      external evalf,evalg

c     This subroutine computes the gradient vector g(x). The way
c     it is computed depends on parameter gtype:
c
c     gtype = 0: a user defined function, called evalg, is used,
c     gtype = 1: central finite differences are used.
c
c     It is called from the reduced space (dimension nind), expands
c     the point x where the gradient will be evaluated and call
c     the subroutine evalg (provided by the user) to compute
c     the gradient vector. Finally, shrinks vectors x and g to the
c     reduced space.
c
c     About subroutines named calc[something]. The subroutines
c     whos names start with ``calc'' work in (are called from)
c     the reduced space. Their task is (i) expand the arguments
c     to the full space, (ii) call the corresponding ``eval''
c     subroutine (which works in the full space), and (iii)
c     shrink the parameters again and also shrink an eventualy
c     output of the ``eval'' subroutines. Subroutines of this
c     type are: calcf, calcg, calchd and calchddiff (the last
c     one called from calchd) and the corresponding subroutines
c     in the full space are evalf, evalg and evalhd.

      integer i,indi
      double precision temp

c     Complete x

      do i= nind+1, n
          x(i)= xc(i)
      end do

c     Expand x to the full space

      do i= nind, 1, -1
          indi= ind(i)
          if (i.ne.indi) then
              temp= x(indi)
              x(indi)= x(i)
              x(i)= temp
          end if
      end do

c     Compute gradient vector

c     True gradient

      if (gtype.eq.0) then
          call evalg(n,x,g,inform)

c     Central finite diferences approximation

      else if (gtype.eq.1) then
          call evalgdiff(n,x,g,sterel,steabs,evalf,inform)

      end if

c     shrink x and g to the reduced space

      do i= 1, nind
          indi= ind(i)
          if (i.ne.indi) then
              temp= x(indi)
              x(indi)= x(i)
              x(i)= temp

              temp= g(indi)
              g(indi)= g(i)
              g(i)= temp
          end if
      end do

      return

      end


c ****************************************************
c ****************************************************
      subroutine evalgdiff(n,x,g,sterel,steabs,evalf,inform)

      integer n,inform
      double precision x(n),g(n),sterel,steabs
      external evalf

c     Computes the gradient vector by central finite differences.
c     This subroutine, which works in the full space, is prepared
c     to replace the subroutine evalg (to evaluate the gradient
c     vector) in the case of the lastest have not being provided
c     by the user.

      integer j
      double precision tmp,step,fplus,fminus

      do j= 1, n
          tmp= x(j)
          step= dmax1(steabs, sterel*dabs(tmp))

          x(j)= tmp + step
          call evalf(n,x,fplus,inform)

          x(j)= tmp - step
          call evalf(n,x,fminus,inform)

          g(j)= (fplus-fminus) / (2.0d0*step)
          x(j)= tmp
      end do

      return

      end


c     ******************************************************
c     ******************************************************
      subroutine calchd(nind,ind,x,d,g,n,xc,gtype,htvtype,hd,xtemp,
     *sterel,steabs,goth,evalf,evalg,evalhd,inform)

      logical goth
      integer nind,ind(nind),n,gtype,htvtype,inform
      double precision x(n),d(n),g(n),xc(n),hd(n),xtemp(n),sterel,steabs
      external evalf,evalg,evalhd

c     This subroutine computes the product Hessian times vector d.
c     The way it is computed depends on parameter htvtype:
c
c     mvptype = 0: a user subroutine, called evalhd, for computing
c     the hessian times vector d product is called,
c
c     mvptype = 1: a incremental quotients aproximation is used.
c
c     If a user subroutine will be used then this subroutine (which
c     is called from the reduced space) expands vectors x and d,
c     calls the user supplied subroutine to compute the hessian times
c     vector d product, and shrinks vectors x, d and hd.
c
c     About subroutines named calc[something]. The subroutines
c     whos names start with ``calc'' work in (are called from)
c     the reduced space. Their task is (i) expand the arguments
c     to the full space, (ii) call the corresponding ``eval''
c     subroutine (which works in the full space), and (iii)
c     shrink the parameters again and also shrink an eventualy
c     output of the ``eval'' subroutines. Subroutines of this
c     type are: calcf, calcg, calchd and calchddiff (the last
c     one called from calchd) and the corresponding subroutines
c     in the full space are evalf, evalg and evalhd.

      integer i,indi
      double precision temp

c     =======================================================
c     User defined subroutine to compute the Hessian times
c     vector d product (it works in the full dimension space)
c     =======================================================

      if (htvtype.eq.0) then

c         Complete d with zeroes

          do i= nind+1, n
              d(i)= 0.0d0
          end do

c         Complete x

          do i= nind+1, n
              x(i)= xc(i)
          end do

c         Expand x, d and g to the full space

          do i= nind, 1, -1
              indi= ind(i)
              if (i.ne.indi) then
                  temp= x(indi)
                  x(indi)= x(i)
                  x(i)= temp

                  temp= d(indi)
                  d(indi)= d(i)
                  d(i)= temp

                  temp= g(indi)
                  g(indi)= g(i)
                  g(i)= temp
              end if
          end do

c         Call the user defined subroutine

          call evalhd(nind,ind,n,x,d,hd,inform)

c         Shrink x, d, g and hd to the reduced space

          do i= 1, nind
              indi= ind(i)
              if (i.ne.indi) then
                  temp= x(indi)
                  x(indi)= x(i)
                  x(i)= temp

                  temp= d(indi)
                  d(indi)= d(i)
                  d(i)= temp

                  temp= g(indi)
                  g(indi)= g(i)
                  g(i)= temp

                  temp= hd(indi)
                  hd(indi)= hd(i)
                  hd(i)= temp
              end if
          end do


c     =======================================================
c     Incremental quotients approximation
c     (it works in the reduced space)
c     =======================================================

      else if (htvtype.eq.1) then
          call calchddiff(nind,ind,x,d,g,n,xc,gtype,hd,xtemp,sterel,
     *    steabs,evalf,evalg,inform)

      end if

      return

      end


c ****************************************************
c ****************************************************
      subroutine calchddiff(nind,ind,x,d,g,n,xc,gtype,hd,xtemp,sterel,
     *steabs,evalf,evalg,inform)

      integer nind,ind(n),n,gtype,inform
      double precision x(n),d(n),g(n),xc(n),hd(n),xtemp(n),sterel,steabs
      external evalf,evalg

c     This subroutine computes the Hessian times vector d product
c     by means of a ``directional finite difference''. The idea is
c     that, at the current point x, the product H d is the limit of
c
c     [ Gradient(x + t d) - Gradient(x) ] / t
c
c     In this implementation we use
c
c     t = max(steabs, sterel ||x||_\infty) / ||d||_\infty
c
c     provided that d not equal 0, of course.
c
c     So, we evaluate the Gradient at the auxiliary point x + t d
c     and use the quotient above to approximate H d.
c
c     About subroutines named calc[something]. The subroutines
c     whos names start with ``calc'' work in (are called from)
c     the reduced space. Their task is (i) expand the arguments
c     to the full space, (ii) call the corresponding ``eval''
c     subroutine (which works in the full space), and (iii)
c     shrink the parameters again and also shrink an eventualy
c     output of the ``eval'' subroutines. Subroutines of this
c     type are: calcf, calcg, calchd and calchddiff (the last
c     one called from calchd) and the corresponding subroutines
c     in the full space are evalf, evalg and evalhd.
c
c     On Entry
c
c     n     integer
c           order of the x
c
c     x     double precision x(n)
c           point for which Hessian(x) times d will be approximated
c
c     d     double precision d(n)
c           vector for which the Hessian times vetor product will
c           be approximated
c
c     g     double precision g(n)
c           gradient at x
c
c     xtemp double precision xtemp(n)
c           working vector
c
c     sterel, steabs double precision
c           this constants mean a ``relative small number'' and
c           ``an absolute small number''
c
c     On Return
c
c     hd    double precision hd(n)
c           approximation of H d

      integer i
      double precision xinfn,dinfn,step

c     Compute incremental quotients step

      xinfn= 0.0d0
      dinfn= 0.0d0
      do i= 1, nind
          xinfn= dmax1(xinfn, dabs(x(i)))
          dinfn= dmax1(dinfn, dabs(d(i)))
      end do

      step= dmax1(sterel*xinfn,steabs) / dinfn

c     Set the point in which the gradient will be
c     evaluated: xtemp = x + step * d

      do i= 1, nind
          xtemp(i)= x(i) + step*d(i)
      end do

c     Evaluate the gradient at (x + step * d)

      call calcg(nind,ind,xtemp,n,xc,gtype,hd,sterel,steabs,evalf,
     *evalg,inform)

c     Compute incremental quotients

      do i= 1, nind
          hd(i)= (hd(i)-g(i)) / step
      end do

      return

      end


c ****************************************************
c ****************************************************
      double precision function norm2s(n,x)

c     Slightly modified version of the BLAS dnrm2 function

      integer n
      double precision x(n)

c     integer i

c     double precision absxi,norm2s,scale,ssq
      double precision hsldnrm2

      norm2s= hsldnrm2(n,x,1) ** 2
      return

c     if (n.lt.1) then
c         norm2s= 0.0d0
c     else if (n.eq.1) then
c         norm2s= dabs(x(1))
c     else
c         scale= 0.0d0
c         ssq= 1.0d0
c         do i= 1, n
c             if (x(i).ne.0.0d0) then
c                 absxi= dabs(x(i))
c                 if (scale.lt.absxi) then
c                     ssq= 1.0d0 + ssq*(scale/absxi)**2
c                     scale= absxi
c                 else
c                     ssq= ssq + (absxi/scale)**2
c                 end if
c             end if
c         end do
c         norm2s= (ssq * scale) * scale
c     end if

c     return

      end

      DOUBLE PRECISION FUNCTION HSLDNRM2(N,DX,INCX)
      DOUBLE PRECISION ZERO,ONE
      PARAMETER (ZERO=0.0D0,ONE=1.0D0)
      DOUBLE PRECISION CUTLO,CUTHI
      PARAMETER (CUTLO=8.232D-11,CUTHI=1.304D19)
      INTEGER INCX,N
      DOUBLE PRECISION DX(*)
      DOUBLE PRECISION HITEST,SUM,XMAX
      INTEGER I,J,NEXT,NN
      INTRINSIC DABS,DSQRT,FLOAT
      IF (N.GT.0) GO TO 10
      HSLDNRM2 = ZERO
      GO TO 300
   10 ASSIGN 30 TO NEXT
      SUM = ZERO
      NN = N*INCX
      I = 1
   20 GO TO NEXT
   30 IF (DABS(DX(I)).GT.CUTLO) GO TO 85
      ASSIGN 50 TO NEXT
      XMAX = ZERO
   50 IF (DX(I).EQ.ZERO) GO TO 200
      IF (DABS(DX(I)).GT.CUTLO) GO TO 85
      ASSIGN 70 TO NEXT
      GO TO 105
  100 I = J
      ASSIGN 110 TO NEXT
      SUM = (SUM/DX(I))/DX(I)
  105 XMAX = DABS(DX(I))
      GO TO 115
   70 IF (DABS(DX(I)).GT.CUTLO) GO TO 75
  110 IF (DABS(DX(I)).LE.XMAX) GO TO 115
      SUM = ONE + SUM* (XMAX/DX(I))**2
      XMAX = DABS(DX(I))
      GO TO 200
  115 SUM = SUM + (DX(I)/XMAX)**2
      GO TO 200
   75 SUM = (SUM*XMAX)*XMAX
   85 HITEST = CUTHI/DFLOAT(N)
      DO 95 J = I,NN,INCX
        IF (DABS(DX(J)).GE.HITEST) GO TO 100
   95 SUM = SUM + DX(J)**2
      HSLDNRM2 = DSQRT(SUM)
      GO TO 300
  200 CONTINUE
      I = I + INCX
      IF (I.LE.NN) GO TO 20
      HSLDNRM2 = XMAX*DSQRT(SUM)
  300 CONTINUE
      RETURN
      END

c     DOUBLE PRECISION FUNCTION MI2DNRM2 ( N, DX, INCX)
c     INTEGER          N, INCX, NEXT
c     DOUBLE PRECISION DX( * ), CUTLO, CUTHI, HITEST, SUM,
c    *                 XMAX, ZERO, ONE
c     INTRINSIC        ABS, SQRT
c     INTEGER          I, J, NN
c     PARAMETER ( ZERO = 0.0D+0, ONE = 1.0D+0 )
C
C     EUCLIDEAN NORM OF THE N-VECTOR STORED IN DX() WITH STORAGE
C     INCREMENT INCX .
C     IF    N .LE. 0 RETURN WITH RESULT = 0.
C     IF N .GE. 1 THEN INCX MUST BE .GE. 1
C
C           C.L.LAWSON, 1978 JAN 08
C
C     FOUR PHASE METHOD     USING TWO BUILT-IN CONSTANTS THAT ARE
C     HOPEFULLY APPLICABLE TO ALL MACHINES.
C         CUTLO = MAXIMUM OF  DSQRT(U/EPS)  OVER ALL KNOWN MACHINES.
C         CUTHI = MINIMUM OF  DSQRT(V)      OVER ALL KNOWN MACHINES.
C     WHERE
C         EPS = SMALLEST NO. SUCH THAT EPS + 1. .GT. 1.
C         U   = SMALLEST POSITIVE NO.   (UNDERFLOW LIMIT)
C         V   = LARGEST  NO.            (OVERFLOW  LIMIT)
C
C     BRIEF OUTLINE OF ALGORITHM..
C
C     PHASE 1    SCANS ZERO COMPONENTS.
C     MOVE TO PHASE 2 WHEN A COMPONENT IS NONZERO AND .LE. CUTLO
C     MOVE TO PHASE 3 WHEN A COMPONENT IS .GT. CUTLO
C     MOVE TO PHASE 4 WHEN A COMPONENT IS .GE. CUTHI/M
C     WHERE M = N FOR X() REAL AND M = 2*N FOR COMPLEX.
C
C     VALUES FOR CUTLO AND CUTHI..
C     FROM THE ENVIRONMENTAL PARAMETERS LISTED IN THE IMSL CONVERTER
C     DOCUMENT THE LIMITING VALUES ARE AS FOLLOWS..
C     CUTLO, S.P.   U/EPS = 2**(-102) FOR  HONEYWELL.  CLOSE SECONDS ARE
C                   UNIVAC AND DEC AT 2**(-103)
C                   THUS CUTLO = 2**(-51) = 4.44089E-16
C     CUTHI, S.P.   V = 2**127 FOR UNIVAC, HONEYWELL, AND DEC.
C                   THUS CUTHI = 2**(63.5) = 1.30438E19
C     CUTLO, D.P.   U/EPS = 2**(-67) FOR HONEYWELL AND DEC.
C                   THUS CUTLO = 2**(-33.5) = 8.23181D-11
C     CUTHI, D.P.   SAME AS S.P.  CUTHI = 1.30438D19
c     DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
C
c     IF ( N .LE. 0) THEN
c        MI2DNRM2  = ZERO
c     ELSE
c        NEXT = 1
c        SUM  = ZERO
c        NN   = N * INCX
C
C  BEGIN MAIN LOOP
c
c        I = 1
c  20    CONTINUE
c        GO TO ( 30, 50, 70, 110 ), NEXT
c  30    CONTINUE
c        IF( ABS( DX( I ) ) .GT. CUTLO ) GO TO 85
c        NEXT = 2
c        XMAX = ZERO
C
C  PHASE 1.  SUM IS ZERO
C
c  50    CONTINUE
c        IF ( DX( I ) .EQ. ZERO ) GO TO 200
c        IF ( ABS( DX( I ) ) .GT. CUTLO ) GO TO 85
C
C  PREPARE FOR PHASE 2.
C
c        NEXT = 3
c        GO TO 105
C
C  PREPARE FOR PHASE 4.
C
c 100    CONTINUE
c        I    = J
c        NEXT = 4
c        SUM  = ( SUM / DX( I ) ) / DX( I )
c 105    CONTINUE
c        XMAX = ABS( DX( I ) )
c        SUM  = SUM + ( DX( I ) / XMAX ) ** 2
c        GO TO 200
C
C  PHASE 2.  SUM IS SMALL. SCALE TO AVOID DESTRUCTIVE UNDERFLOW.
C
c  70    CONTINUE
c        IF ( ABS( DX( I ) ) .GT. CUTLO ) THEN
C
C  PREPARE FOR PHASE 3.
C
c           SUM = ( SUM * XMAX) * XMAX
c           GO TO 85
c        END IF
C
C  COMMON CODE FOR PHASES 2 AND 4.
C  IN PHASE 4 SUM IS LARGE.  SCALE TO AVOID OVERFLOW.
C
c 110    CONTINUE
c        IF ( ABS( DX( I ) ) .GT. XMAX ) THEN
c           SUM  = ONE + SUM * ( XMAX / DX( I ) ) ** 2
c           XMAX = ABS( DX( I ) )
c        ELSE
c           SUM = SUM + ( DX( I ) / XMAX ) ** 2
c        END IF
c 200    CONTINUE
c        I = I + INCX
c        IF ( I .LE. NN ) GO TO 20
C
C  END OF MAIN LOOP.
C
C  COMPUTE SQUARE ROOT AND ADJUST FOR SCALING.
C
c        MI2DNRM2 = XMAX * SQRT(SUM)
c        GO TO 300
C
C  FOR REAL OR D.P. SET HITEST = CUTHI/N
C
c  85    CONTINUE
c        HITEST = CUTHI/FLOAT( N )
C
C  PHASE 3. SUM IS MID-RANGE.  NO SCALING.
C
c        DO 95 J = I, NN, INCX
c           IF( ABS( DX( J ) ) .GE. HITEST ) GO TO 100
c           SUM = SUM + DX( J ) ** 2
c  95    CONTINUE
c        MI2DNRM2 = SQRT( SUM )
c     END IF
c 300 CONTINUE
c     RETURN
c     END

c     Modifications introduced from March 1st to March 21th of 2002
c     in ocassion of the ISPG development:
c
c     1) Comments of some new parameters introduzed in the previous
c     modification
c
c     2) As it was, in the first iteration of GENCAN (when kappa
c     takes value equal 1) and for one-dimensional faces, cgmaxit
c     (the maximum number of Conjugate Gradient iterations to compute
c     the internal to the face truncated-Newton direction) was being 0.
c     As it is obviously wrong, we add a max between what was being
c     computed and one to allow at least one CG iteration.
c
c     3) Parameter inform in subroutines evalf, evalg and evalhd
c     supplied by the user was added
c
c     Modifications introduced from May 31th to November 2nd of 2001
c     in ocassion of the ALGENCAN development:
c
c     Fixed bugs:
c
c     1) The first spectral steplength was not been projected in the
c     [lammin,lammax] interval.
c
c     2) The conjugate gradients accuracy (cgeps) which is linearly
c     dependent of the euclidian norm of the projected gradient, was
c     also not been projected in the interval [cgepsi,cgepsf].
c
c     3) Conjugate gradients said that it was being used an euclidian
c     norm trust region when it has really being used an infinite norm
c     trust region and viceversa.
c
c     4) Sometimes, the analytic gradient has been used although the
c     user choose the finite differences option.
c
c     Modifications:
c
c     1) To avoid roundoff errors, an explicit detection of at least one
c     variable reaching its bound when a maximum step is being made was
c     added.
c
c     2) The way in which two points were considered very similar in, for
c     example, the interpolations and the extrapolations (which was
c     dependent of the infinity norm of the points) showed to be very
c     scale dependent. A new version which test the difference coordinate
c     to coordinate was done. In this was the calculus of the current
c     point x and the descent direction sup-norm is not done any
c     more.
c
c     3) The same constants epsrel and epsabs were used as small
c     relative and absolute values for, for example, detecting similar
c     points and for finite diferences. Now,
c     epsrel and epsabs are used for detecting similar points
c     (and the recommended values are 10^{-10} and 10^{-20}, respectively)
c     and new constants sterel ans steabs were introduced for finite
c     differences (and the recommended values are 10^{-7} and 10^{-10},
c     respectively).
c
c     4) Two new stopping criteria for CG were added: (i) we stop if
c     two consecutive iterates are too  close; and (ii) we also
c     stop if there is no enough quadratic model progress during
c     maxitnqmp iterations.
c
c     5) The linear relation between the conjugate gradient accuracy
c     and the norm of the projected gradient can be computed using
c     the euclidian- and the sup-norm of the projected gradient (only
c     euclidian-norm version was present in the previous version. The
c     linear relation is such that the CG accuracy is cgepsi when the
c     projected gradient norm value is equal to the value corresponding
c     to the initial guess and the CG accuracy is cgepsf when the
c     projected gradient norm value is cgrelf).
c
c     6) Inside Conjugate Gradients, the euclidian-norm is been
c     computed using an algorithm developed by C.L.LAWSON, 1978 JAN 08.
c     Numerical experiments showed that the performance of GENCAN depends
c     basically on the conjugate gradients performance and stopping
c     criteria and that the conjugate gradients depends on the way the
c     euclidian-norm is been computed. These things deserve further
c     research.
c
c     7) In the Augmented Lagrangean algorithm ALGENCAN, which uses
c     GENCAN to solve the bounded constrained subproblems, the maximum
c     number of Conjugate Gradients iterations (cgmaxit), which in
c     this version is linearly dependent of the projected gradient norm,
c     was set to 2 * (# of free variables). As CG is not using restarts
c     we do not know very well what this means. On the other hand,
c     the accuracy (given by cgeps) continues being more strict when
c     we are near to the solution and less strict when we ar far from
c     the solution.
c
c     8) Many things in the output were changed.

c -------------------------------------------------------

c -- 
c Ernesto G. Birgin
c Department of Computer Science IME-USP
c http://www.ime.usp.br/~egbirgin

	subroutine milonga (n, m, x, f, g, a, ifree, ele, u,
     *   gaux, aux, d, otro, ap, gamma, beta, ktot, nftot, ngtot,
     *   nintot, nstot, nptot, nbtot, netot, nctot,
     *   eps, maxtang, maxcg, tol, costol, distol, iopt, iophes, iopfac, 
     *   iflag, ambda, rhoinic, rhofac, rho, h, aj,
     *   konout, maxout, ipmil, ipt, ier, qcib, alin, ata, nlin,
     *   evalf, evalg, hessi, hrest, jacobh)

c   Subroutine Milonga:
c
c   This subroutine solves the problem
c                 Minimize f(x)
c      subject to   h(x) = 0
c                   l \leq x \leq u
c
c   where f: R^n ---> R  and  h:R^n ---> R^m   are smooth.
c   
c   The subroutine has been written (beginning september 2002) by 
c   J. M. Martinez with didactical purposes. It uses an augmented
c   Lagrangian approach, which means that, at each outer iteration,
c   the problem
c               Minimize f(x) + h(x)^T y + (rho/2) ||h(x)||^2
c                 subject to l \leq x \leq u
c   
c   and the Lagrange multipliers (y) and the penalty parameter (rho) 
c   are updated before the next outer iteration. 
c   For solving the subproblem above, the subroutine Tango is used.
c   Tango solves minimization problems with box-constraints using 
c   the approach of
c
c   E. G. Birgin and J. M. Mart\'{\i}nez. Large-scale active-set
c   box-constrained optimization method with spectral projected gradients. 
c   {\it Computational Optimization and Applications} 23, pp. 101-125 (2002).
c
c   However, for minimization within the faces of the box, a
c   different algorithm from the one described in this reference is used.
c
c   Calling sequence:
c 
c        call milonga (n, m, x, f, g, a, ifree, ele, u,
c     *   gaux, aux, d, otro, ap, gamma, beta, ktot, nftot, ngtot,
c     *   nintot, nstot, nptot, nbtot, netot, nctot,
c     *   eps, maxtang, maxcg, tol, costol, distol, iopt, iophes, iopfac, 
c     *   iflag, ambda, rhoinic, rhofac, rho, h, aj,
c     *   konout, maxout, ipmil, ipt, ier, qcib, alin, ata, nlin)
c
c   All real parameters are in double precision.
c
c   Parameters:
c   n: number of variables
c   m: number of constraints in h(x)=0.
c   x: (n real positions) Initial point - Final point.
c   f: final value of f(x).
c   g: auxiliar (n real positions)
c   a: auxiliar (n^2 real positions)
c   ifree: auxiliar (n integer positions)
c   ele: lower bounds (n real positions)
c   u: upper bounds (n real positions)
c   gaux: auxiliar (n real positions)
c   aux: auxiliar (n real positions)
c   d: auxiliar (n real positions)
c   otro: auxiliar (n real positions)
c   ap: auxiliar (n real positions)
c  gamma: parameter for Armijo-like searches. Recommended: 1.e-4
c  beta: parameter of Armijo-like searches. Recommended: 0.5
c  ktot: total number of inner (Tango) iterations.
c  nftot: functional evaluations in Tango.
c  ngtot: gradient evaluations in Tango.
c  nintot: number of internal iterations in Tango (iterations where
c          the point remains in the same closed face). 
c  nstot:  number of spg iterations in Tango (iterations where a 
c          closed face is abandoned). 
c  nptot:  number of pure alfa-beta iterations in Tango ( internal iterations
c          where both Armijo (alfa) condition and  beta condition
c          were satisfied with step = 1.
c  nbtot:  number of internal iterations in Tango where backtracking was
c          necessary. 
c  netot:  number of internal 
c          iterations in Tango where extrapolation was tried.
c  nctot:  number of internal iterations in Tango where it was detected
c          that the (approx) Hessian is not positive definite.
c  eps:  small positive parameter for declaring convergence (success).
c        Milonga converges when both the sup-norm of the constraints 
c        and the continuous projected gradient is less than or equal to
c        eps. Tango runs are declared convergent when the supnorm of 
c        the projected gradient is less than or equal to eps.
c  maxtang: maximum number of iterations allowed at each call of Tango.
c  maxcg: maximum number of iterations allowed at each call of the
c         conjugate-gradient method, when this is used. If maxcg=-1, 
c         the maximum number of cg-iterations is automatically set to
c         be the number of free variables.
c  tol: parameter between 0 and 1 used to decide to leave a closed face
c       (using spg) or staying in the face. The face is abandoned when
c       the quotient ginor/gpnor is smaller than tol, where gpnor here
c       is the euclidian norm of the projected gradient and and ginor
c       is the euclidian norm of its projection on the current face.
c  costol: tolerance for cosine. If the cosine of the angle between the
c  search direction and the negative gradient is less than costol, then
c  the search direction is replaced by the negative gradient.
c  distol: when the relative difference between the current point and
c          the backtracked point is smaller than distol, the algorithm
c          Tango returns. This may be because you are using a very 
c          strict criterion (eps) for the projected gradient.
c  iopt: parameter to decide what to do when the Hessian is not positive
c        definite. iopt=1 modifies the diagonal to make it diagonally
c        dominant.   iopt=2 uses conjugate gradients.
c  iophes: Parameter that indicates what type of Hessian is being used.
c        iophes=1 indicates Discrete Hessian
c        iophes=2 indicates that the user provides a subroutine for
c                 computing the analytic Hessian at an arbitrary given
c                 point. In this case, the Hessian of the augmented
c                 Lagrangian used is 
c                 Hessian of the function + rho * A^T A
c                 where A is the Jacobian of the constraints.
c                 This is known as the Gauss-Newton approach in
c   N. Kreji\'c, J. M. Mart\'{\i}nez, M. P. Mello and E. A. Pilotta.
c   Validation of an augmented Lagrangian algorithm with a Gauss-Newton
c   Hessian approximation using a set of hard-spheres problems. 
c   {\it Computational Optimization and
c   Applications}~16,~pp.~247-263~(2000).

c                 See comment of subroutine hessi.
c        iophes=3 indicates "quadratic programming problem"  where you
c        supply the (constant) Hessian and the matrix of constraints 
c        (when m > 0).
c  iopfac: If iopfac=1, an initial Tango iteration is performed with
c        only the sum of squares of constraints as objective function.
c        This option merely changes the initial point to a more feasible
c        one.
c  iflag: output parameter that says what happened in the last iteration
c        of Tango. If iflag=0, Tango returned with the eps-convergence
c        diagnostic. If iflag=1 the maximum allowed Tango-iterations was
c        exhausted. If iflag=2, Tango returned because the relative 
c        difference between a current point and the backtracked point
c        was smaller than distol. 
c  ambda: (m real positions) On input, initial approximation to the
c        Lagrange multipliers. On output, final estimates of the 
c        Lagrange multipliers. 
c  rhoinic: initial value for the penalty parameter.
c  rhofac: factor for which the penalty parameter is multiplied after
c          each outer iteration, if necessary. By mystical reasons one
c          usually sets rhofac = 10.
c  rho: final value of the penalty parameter used.
c  h: (m real positions) On output, values of the constraints h(x).
c  aj: (m * n  real positions) Auxiliar array, used to stored the
c      Jacobian of the constraints. Please, when m=0, declare in the
c      main program dimension aj(1) (or any other natural number 
c      greater than 1, instead of 1) in order to avoid compiling errors.
c  konout: effective number of outer (milonga) iterations performed.
c  maxout: maximum number of outer iterations allowed. Many times, when
c      this number is exceeded the reason is that the problem is 
c      infeasible.
c  ipmil: parameter that commands printing of milonga. Milonga prints
c      in the screen and in the file milonga.out. If ipmil < 0, nothing
c      is printed. If ipmil=0 only initial and final information is 
c      printed. If ipmil > 0 information of milonga is printed every 
c      ipmil outer iterations. If m=0 the value of ipmil is irrelevant
c      and all printings are commanded by ipt.
c  ipt: parameter that commands printing of Tango. Tango prints
c      in the screen and in the file milonga.out. If ipt < 0, nothing
c      is printed. If ipt=0 only initial and final information is 
c      printed. If ipt > 0 information of milonga is printed every 
c      ipt Tango-iterations.
c  ier: output parameter that says what happened. If ier=0 convergence
c       occurred in the sense that both the supnorm of the constraints
c       and the supnorm of the projected gradient are smaller than or
c       equal to eps. If ier=1 the number of outer iterations was 
c       exhausted.
c  qcib: Assume that your problem is of the form 
c        Minimize x^T Q x + c^T x   subject to   A x = b.
c        You can deal with this problem as an ordinary problem with 
c        ordinary objective function and constraints. But Milonga
c        allows you to take advantage with (part of) the structure
c        of the problem. If you want to take such advantage, set 
c        iophes = 3 (see comment of iophes above) and provide the 
c        matrix Q in the array qcib. So, qcib must be a symmetric
c        matrix that must be declared in the main program as having
c        a number of rows that also must be informed to Milonga as 
c        being equal to nlin. That is, the parameter nlin must be 
c        the exact number of rows declared for qcib in the main program.
c        Of course, qcib must have at least n columns.
c  alin: In the case that described in the comment of qcib you must
c        also provide the matrix A. This matrix must be given in the
c        array alin. However, unlike the storage of qcib, alin must be
c        stored as a single vector in the main program. The vector 
c        must store the elementes of A, in columnwise form. Of course,
c        alin must have at least m*n entries.
c  ata:  Again in the case described in the comment of qcib, Milonga
c        needs an auxiliary matrix called ata. You must declare this 
c        matrix as having exactly nlin rows and at least n columns. 
c  nlin: on entry, this must be the exact number of rows declared for
c        qcib and ata in the main program.
c
c        The user must also provide four subroutines that give,
c        respectively, the objective function value, its gradient,
c        the constraints and the Jacobian of the constraints.
c        Let us now describe how these subroutines must be.
c
c  Subroutine that computes the objective function value:
c  Must have the form:
c
c  Subroutine evalf (n, x, f)
c  implicit double precision (a-h,o-z)
c  dimension x(n)
c  .....
c  return
c  end
c
c  where n is the number of variables, x is the point where f(x) must
c  be computed and f (the output) is the functional value. The user
c  must code the subroutine. However, in the case "iophes=3"  the user
c  can take advantage of the situation merely coding
c
c  Subroutine evalf (n, x, f)
c  implicit double precision (a-h,o-z)
c  dimension x(n)
c  dimension aux(134)   (say)
c  ..............
c  nlin = 58        (say)
c	call funquad (n, qcib, x, ccib, f, aux, nlin)
c	return
c  end
c
c  In fact, funquad is an internal routine of Milonga. Observe that the
c  information qcib and ccib must be passed through common. I'm
c  sorry. This will be improved in the future. 
c
c  Subroutine that computes the gradient of the objective function:
c  Must have the form:
c
c  Subroutine evalg (n, x, g)
c  implicit double precision (a-h, o-z)
c  dimension x(n), g(n)
c ...............
c  return
c  end
c
c  In this subroutine, n is the number of variables, x is the point where
c  the gradient must be computed and g is the computed gradient. 
c
c  As in the case of evalf, in the case "iophes=3"  the user
c  can take advantage of the situation merely coding
c
c  Subroutine evalg (n, x, g)
c  implicit double precision (a-h,o-z)
c  dimension x(n)
c  ..............
c  nlin = 58        (say)
c  call graquad (n, x, qcib, ccib, g, nlin)
c  return
c  end
c
c  In fact, graquad is an internal routine of Milonga. Observe that the
c  information qcib and ccib must be passed through common. I'm
c  sorry. This will be improved in the future. 
c
c  Subroutine that computes the constraints h(x):
c  Must have the form:
c  Subroutine hrest (m, n, x, h)
c  implicit double precision (a-h,o-z)
c  dimension x(n), h(m)
c  .....
c  return
c  end
c
c  where n is the number of variables, m is the number of constraints
c  x is the point where the constraints must be computed and h
c  is the vector of constraints. No provision is taken, up to now, to
c  take advantage of linear constraints here.
c
c  Subroutine that computes the Jacobian of the constraints:
c  Must have the form:
c 	subroutine jacobh (m, n, x, aj)
c	implicit double precision (a-h, o-z)
c	dimension x(n), aj(m, n)
c  
c  where n is the number of variables, m is the number of constraints
c  x is the point where the constraints must be computed and the matrix
c  aj must be computed in order to store the derivatives of the constraints.
c  aj(i, j) must be the derivative of the i-th constraint with respect
c  to the j-th variable. No provision is taken, up to now, to
c  take advantage of linear constraints here.
c
c  Subroutine that computes the Hessian of the objective function:
c  The user must code this subroutine only if iophes=2. 
c  Must have the form:
c         subroutine hessi (n, x, hess)
c         implicit double precision (a-h,o-z)
c         dimension x(n), hess(n, n)	
c         ---------
c         return
c         end
c  In fact, observe that this subroutine, exactly in the way described
c  above, is part of this package. You must fill the dashed lines if 
c  you provide the Hessian. 
c



	implicit double precision (a-h,o-z)
	external funtan,gratan,sumsq,grasum
	external evalf,evalg,hrest,hessi, jacobh

	dimension a(n, n)
	dimension ifree(n)
	dimension ele(n), u(n)
	dimension x(n), g(n)
	dimension gaux(n), aux(n)
	dimension d(n)
	dimension otro(n)
	dimension ap(n)
	dimension ambda(m)
	dimension h(m)
	dimension aj(m, n)
	dimension qcib(nlin, *)
	dimension alin(*)
	dimension ata(nlin, *)

	n10 = min0(n, 10)
	m10 = min0(m, 10)

	if(m.gt.0) then

        	if(rhoinic.eq.0) then
	        write(*, *)' Error. Initial penalty parameter null.'
	        stop
	        endif

	rho = rhoinic
	
	   if(iophes.eq.3) then
	   do i = 1, n
	   do j = 1, n
	   ata(i, j) = 0.d0
	   do k = 1, m
	   ata(i, j) = ata(i, j) + alin((i-1)*m+k) * alin((j-1)*m+k)
	   end do
	   end do
	   end do
	   end if
	endif

c  Checking box
	do i = 1, n
	x(i) = dmax1(ele(i), dmin1(x(i), u(i)))
	end do

	if(m.eq.0) then
 	call tango (funtan, gratan, n, x, f, g, a, ifree, ele, u,
     *   gaux, aux, d, otro, ap, gamma, beta, kon, nef, neg, nint,
     *   nspg, npur, nback, nextr, ncor, nfsmal, 
     *   eps, maxtang, maxcg, tol, costol, distol, iopt, iophes, 
     *   iflag, gpnor, m, ambda, rho, h, aj, ipt, qcib, ata, nlin,
     *   evalf, evalg, hessi, hrest, jacobh)
	return
	endif
	
c  Find a better initial point

	if(iopfac.eq.1) then
 	call tango (sumsq, grasum, n, x, f, g, a, ifree, ele, u,
     *   gaux, aux, d, otro, ap, gamma, beta, kon, nef, neg, nint,
     *   nspg, npur, nback, nextr, ncor, nfsmal, 
     *   eps, maxtang, maxcg, tol, costol, distol, iopt, iophes, 
     *   iflag, gpnor, m, ambda, rho, h, aj, ipt, qcib, ata, nlin,
     *   evalf, evalg, hessi, hrest, jacobh)
	endif

	ktot = 0
	nftot = 0
	ngtot = 0
	nintot = 0
	nstot = 0
	nptot = 0
	nbtot = 0
	netot = 0
	nctot = 0
	nfstot = 0

	konout = 0

c  Initial evaluation of constraints



	call hrest(m, n, x, h)


c   Compute sup norm of constraints
	hnor = 0.d0
	do i = 1, m
	hnor = dmax1(hnor, dabs(h(i)))
	end do


	call jacobh (m, n, x, aj)


	call evalg(n, x, g)


	do j = 1, n
	do i = 1, m
	g(j) = g(j) + aj(i, j) * ambda(i)
	end do
	end do


	gpnor = 0.d0
	do i = 1, n
	z = x(i) - g(i)
	z = dmax1(ele(i), dmin1(u(i), z))
	z = dabs(z - x(i))
	gpnor = dmax1(z, gpnor)
	end do



1	continue

	call evalf (n, x, f)

	if(ipmil.ge.0) then
	write(10, *)
	write(10, *)' Milonga (Outer) iteration:', konout
	write(10, *)' Current point:'
	write(10, *)(x(i), i = 1, n10)
	write(10, *)' Objective function:', f
	write(10, *)' Sup norm of the constraints:', hnor
	write(10, *)' Multipliers:'	
	write(10, *) (ambda(i),i=1,m10)
	write(10, *)' Sup norm of projected gradient of Lagrangian:',
     *                gpnor
	


	write(*, *)
	write(*, *)' Milonga (Outer) iteration:', konout
	write(*, *)' Current point:'
	write(*, *)(x(i), i = 1, n10)
	write(*, *)' Objective function:', f
	write(*, *)' Sup norm of the constraints:', hnor
	write(*, *)' Multipliers:'	
	write(*, *) (ambda(i),i=1,m10)
	write(*, *)' Sup norm of projected gradient of Lagrangian:',
     *                gpnor
	endif

	if(dmax1(hnor, gpnor).le.eps) then
	ier = 0
	if(ipmil.ge.0) then
	write(10, *)
	write(10, *)' Solution found. f(x)=',f
	write(*, *)
	write(*, *)' Solution found. f(x)=',f
	write(10, *)' Number of inner (Tango) iterations:', ktot
	write(10, *)' Function evaluations in Tango:', nftot
	write(10, *)' Gradient evaluations in Tango:', ngtot
	write(10, *)' Number of internal iterations:', nintot
	write(10, *)' Number of spg iterations:', nstot
	write(10, *)' Current points where nfree < m:', nfstot
	write(10, *)' Number of pure alfa-beta iterations:', nptot
	write(10, *)' Number of internals with backtracking:',nbtot
	write(10, *)' Number of extrapolations tried:', netot
	write(10, *)' Number of nonsemiposdef Hessians:', nctot

	write(*, *)' Number of inner (Tango) iterations:', ktot
	write(*, *)' Function evaluations in Tango:', nftot
	write(*, *)' Gradient evaluations in Tango:', ngtot
	write(*, *)' Number of internal iterations:', nintot
	write(*, *)' Number of spg iterations:', nstot
	write(*, *)' Current points where nfree < m:', nfstot
	write(*, *)' Number of pure alfa-beta iterations:', nptot
	write(*, *)' Number of internals with backtracking:',nbtot
	write(*, *)' Number of extrapolations tried:', netot
	write(*, *)' Number of non semiposdef Hessians:', nctot
	endif

	return
	endif
	
	if(konout.ge.maxout) then
	ier = 1
	if(ipmil.ge.0) then
	write(10, *)
	write(10, *)' Exceeded allowed outer iterations'
	write(*, *)
	write(*, *)' Exceeded allowed outer iterations'
	write(10, *)' Number of inner (Tango) iterations:', ktot
	write(10, *)' Function evaluations in Tango:', nftot
	write(10, *)' Gradient evaluations in Tango:', ngtot
	write(10, *)' Number of internal iterations:', nintot
	write(10, *)' Current points where to nfree < m:', nstot
	write(10, *)' Spg iterations due to nfree small:', nfstot
	write(10, *)' Number of pure alfa-beta iterations:', nptot
	write(10, *)' Number of internals with backtracking:',nbtot
	write(10, *)' Number of extrapolations tried:', netot
	write(10, *)' Number of nonsemiposdef Hessians:', nctot
	
	write(*, *)' Number of inner (Tango) iterations:', ktot
	write(*, *)' Function evaluations in Tango:', nftot
	write(*, *)' Gradient evaluations in Tango:', ngtot
	write(*, *)' Number of internal iterations:', nintot
	write(*, *)' Number of spg iterations:', nstot
	write(*, *)' Current points where to nfree < m:', nfstot
	write(*, *)' Number of pure alfa-beta iterations:', nptot
	write(*, *)' Number of internals with backtracking:',nbtot
	write(*, *)' Number of extrapolations tried:', netot
	write(*, *)' Number of non semiposdef Hessians:', nctot
	endif

	return
	endif

	if(ipmil.ge.0) then
	write(10, *)' Penalty parameter for the next iteration:',rho
	write(*, *)' Penalty parameter for the next iteration:',rho
	endif

	hnoran = hnor


 	call tango (funtan, gratan, n, x, f, g, a, ifree, ele, u,
     *   gaux, aux, d, otro, ap, gamma, beta, kon, nef, neg, nint,
     *   nspg, npur, nback, nextr, ncor, nfsmal, 
     *   eps, maxtang, maxcg, tol, costol, distol, iopt, iophes, 
     *   iflag, gpnor, m, ambda, rho, h, aj, ipt, qcib, ata, nlin,
     *   evalf, evalg, hessi, hrest, jacobh)


	ktot = ktot + kon
	nftot = nftot + nef
	ngtot = ngtot + neg
	nintot = nintot + nint
	nstot = nstot + nspg
	nptot = nptot + npur
	nbtot = nbtot + nback
	netot = netot + nextr
	nctot = nctot + ncor
	nfstot = nfstot + nfsmal


	call hrest (m, n, x, h)

	hnor = 0.d0
	do i = 1, m
	hnor = dmax1(hnor, dabs(h(i)))
	end do
	

	if(gpnor.le.eps) then
	if(ipmil.ge.0) then
	write(10, *)' Tango ran with success'
	write(*, *)' Tango ran with success'
	endif
	do i = 1, m
	ambda(i) = ambda(i) + rho * h(i)
	end do
	endif

	if(hnor.gt.hnoran/10.d0) then
	rho = rhofac * rho
	endif
	
	konout = konout + 1
	go to 1
	
	end

	

	subroutine tango (funtan, gratan, n, x, f, g, a, ifree, ele, u,
     *   gaux, aux, d, otro, ap, gamma, beta, kon, nef, neg, nint,
     *   nspg, npur, nback, nextr, ncor, nfsmal, 
     *   eps, max, maxcg, tol, costol, distol, iopt, iophes, 
     *   iflag, gpnor, m, ambda, rho, h, aj, ipt, qcib, ata, nlin,
     *   evalf, evalg, hessi, hrest, jacobh)

	implicit double precision (a-h,o-z)
	external funtan, gratan, evalf, evalg, hessi, hrest, jacobh
	dimension a(n, n)
	dimension ifree(n)
	dimension ele(n), u(n)
	dimension x(n), g(n)
	dimension gaux(n), aux(n)
	dimension d(n)
	dimension otro(n)
	dimension ap(n)
	dimension ambda(m)
	dimension h(m)
	dimension aj(m, n)
	dimension ata(nlin, *), qcib(nlin, *)
c
c  Tango is a subroutine for box-constrained minimization written
c  by J. M. Martinez with didactical purposes in the context of 
c  the course Metodos Computacionais de Otimizacao at the 
c  University of Campinas
c  The purpose is to minimize f(x) subject to bounds on the variables
c  The subroutine uses the active set strategy and line searches 
c  described in
c  E. G. Birgin and J. M. Martinez (2002) ``Large-scale active set
c  box-constrained optimization method with spectral projected 
c  gradients'',  Computational Optimization and Applications 23, 
c  pp. 101-125 (2002).
c  However, the search directions are different from the ones defined
c  in that paper, which is devoted to large-scale problems.
c  In Tango the search directions are Newton directions inside the
c  faces and are corrected in different ways when the Hessians are not
c  positive definite.
c  Parameters:
c  n: number of variables
c  x: initial point - final point
c  f: final value of the objective function
c  g: final gradient
c  a: auxiliar array of n**2 positions for internal storage of the Hessian
c  ifree: auxiliar integer array of n positions (for free variables)
c  ele, u: lower and upper bounds
c  gaux, aux, d, otro, ap: auxiliar double precision arrays n positions
c  beta: parameter for line search. Default: 0.5
c  kon: number of iterations
c  nef: number of function evaluations
c  neg: number of gradient evaluations
c  nint: number of iterations within the faces
c  nspg: number of iterations that leave the current face (spg iterations)
c  npur: number of iterations where the line search stopped at the first
c        trial (alfa-beta iterations)
c  nback: number of iterations where backtracking was necessary
c  nextr: number of iterations where extrapolation was tried
c  ncor: number of iterations where the Hessian was not positive definite
c  eps: small number for convergence (projected gradient small)
c  max: maximum number of iterations allowed
c  tol: parameter to decide leaving faces. Default: 0.1
c  costol: tolerance for cosine. If the cosine of the angle between the
c  search direction and the negative gradient is less than costol, then
c  the search direction is replaced by the negative gradient.
c  iopt: parameter to decide what to do when the Hessian is not positive
c        definite. iopt=1 modifies the diagonal to make it diagonally
c        dominant.   iopt=2 uses conjugate gradients.
c  iflag: output parameter that says what happened.
c  

c	write(10, *)' In tango'
c	write(10, *)' Half-Hessian of the quadratic:'
c	do i = 1, n
c	write(10, *) (qcib(i, j), j=1,n)
c	end do
	

c  
c  Initialization
	tol2 = tol * tol
c  itipo is the type of iterate. 0 means initial point
	itipo = 0
	kon = 0
	nint = 0
	nspg = 0
	npur = 0
	nback = 0
	nextr = 0
	ncor = 0
	nfsmal = 0

c  Initial evaluation of function and gradient
	call funtan(m, n, x, ambda, rho, h, f,evalf,hrest)
	call gratan (m, n, x, ambda, rho, h, aj, g, evalg,hrest,jacobh)
	nef = 1
	neg = 1



c  Here begins the loop
c  Compute free variables
1	nfree = 0
c  Project initial point on the box

	do i = 1, n
	x(i) = dmin1(u(i), dmax1(ele(i), x(i)))
	if(x(i).gt.ele(i).and.x(i).lt.u(i)) then
	nfree = nfree + 1
	ifree(nfree) = i
	end if
	end do

c  Compute norms of projected gradient and internal gradient
	gpnor = 0.d0
	ginor2 = 0.d0
	gpnor2 = 0.d0

	do i = 1, n
	z = x(i) - g(i)
	z = dmin1(u(i), dmax1(ele(i), z))
	z = z - x(i)
	z2 = z * z
	gpnor = dmax1(gpnor, dabs(z))
	gpnor2 = gpnor2 + z2
	if(x(i).gt.ele(i).and.x(i).lt.u(i)) then
	ginor2 = ginor2 + z2
	endif
	end do

c  Printing
	if(ipt.gt.0.and.mod(kon,ipt).eq.0) then
	
	write(10, *)
	write(10, *)' Tango Iteration ', kon
	if(itipo.ne.0) then
	if(itipo.eq.1) then
	write(10, *)' Point obtained in the same closed face'
	else
	write(10, *)' Point obtained by SPG iteration'
	endif
	endif
	write(10, *)' Point:'
	write(10, *) (x(i),i=1,n)
	write(10, *)' f(x) =', f
	write(10, *)' Gradient:'
	write(10, *) (g(i),i=1,n)
	write(10, *)' Sup norm of projected gradient:', gpnor
	write(10, *)' Number of free variables:', nfree
	if(nfree.gt.0) then
	write(10, *)' Free variables:', (ifree(i),i=1,nfree)
	endif
	write(10, *)' Function evaluations:', nef,
     *   ' Gradient evaluations:', neg
	write(10, *)' Number of internal iterations:', nint
	write(10, *)' Number of spg iterations:', nspg
	write(10, *)' Current points where to nfree < m:', nfsmal
	write(10, *)' Number of pure alfa-beta iterations:', npur
	write(10, *)' Number of internals with backtracking:',nback
	write(10, *)' Number of extrapolations tried:', nextr
	write(10, *)' Number of nonsemiposdef Hessians:', ncor
	
	write(10, *)
	write(*, *)
	write(*, *)' Tango Iteration ', kon
	if(itipo.ne.0) then
	if(itipo.eq.1) then
	write(*, *)' Point obtained in the same closed face'
	else
	write(*, *)' Point obtained by SPG iteration'
	endif
	endif
	write(*, *)' Point:'
	write(*, *) (x(i),i=1,n)
	write(*, *)' f(x) =', f
	write(*, *)' Gradient:'
	write(*, *) (g(i),i=1,n)
	write(*, *)' Sup norm of projected gradient:', gpnor
	write(*, *)' Number of free variables:', nfree
	if(nfree.gt.0) then
	write(*, *)' Free variables:', (ifree(i),i=1,nfree)
	endif
	write(*, *)' Function evaluations:', nef,
     *   ' Gradient evaluations:', neg
	write(*, *)' Number of internal iterations:', nint
	write(*, *)' Number of spg iterations:', nspg
	write(*, *)' Current points where to nfree < m:', nfsmal
	write(*, *)' Number of pure alfa-beta iterations:', npur
	write(*, *)' Number of internals with backtracking:',nback
	write(*, *)' Number of extrapolations tried:', nextr
	write(*, *)' Number of non semiposdef Hessians:', ncor
	write(*, *)
	endif




c   Stopping criteria
	itipo = 1
	if(gpnor.le.eps) then
	iflag = 0
	if(ipt.ge.0) then
	write(10, *) ' Convergence: small sup norm of proj. gradient'
	write(*, *) ' Convergence: small sup norm of proj. gradient'
	endif
	return
	endif

	if(kon.gt.max) then
	iflag = 1
	if(ipt.ge.0) then
	write(10, *)' Maximum number of iterations exhausted'
	write(*, *)' Maximum number of iterations exhausted'
	endif
	return
	endif


c   Abandon the face if the number of free variables is smaller than
c   the number of constraints
	
	if(m.gt.nfree) nfsmal = nfsmal + 1

c   Decision about giving up the current face or not
c   If the norm of internal gradient is large in comparison to the 
c   projected gradient we keep the same face
c


	if(ginor2.le.tol2*gpnor2) then 
c   Abandon the face using an spg iteration
c   itipo = 2 means that the following point leaves the current face

	itipo = 2
c   call the subroutine that abandons the face (spg)
	call giveup (funtan, gratan, 
     *      n, x, f, g, ele, u, nef, neg, gamma, 
     *      aux, gaux, d, m, ambda, rho, h, aj, evalf,evalg,hrest,
     *      jacobh)
	kon = kon + 1
	nspg = nspg + 1
	go to 1
	endif



c Check if we have at least one free variable
	if(nfree.lt.1) then
	write(*, *)' There are no free variables. Something wrong.'
        write(*, *)' Probably, the gradient was evaluated at a'
        write(*, *)' Forbidden point, given not-a-number as result.'
	stop
	endif

c Check if x is in the box
	do i = 1, n
	if(x(i).gt.u(i).or.x(i).lt.ele(i)) then
	write(*, *) ' x out of bounds'
	stop
	endif
	end do



c Check free variables
	do i = 1, nfree
	ii = ifree(i)
	if(x(ii).ge.u(ii).or.x(ii).le.ele(ii)) then
	write(*, *)' The free variable', ii, ' is not free'
	stop
	endif
	end do
	nint = nint + 1

	   if(iophes.eq.2) then
	   call hessi (n, x, a)

c	write(10, *)' Hessian:'
c	do i = 1, n
c	write(10, *) (a(i, j), j=1,n)
c	end do
	
        	do i = 1, nfree
	        do j = 1, nfree
	        ii = ifree(i)
	        jj = ifree(j)
	        qcib(i, j) = a(ii, jj)
	        end do
	        end do

c	write (10, *)' Free variables:'
c	write(10, *) (ifree(i), i=1,nfree)

c	write(10, *)' Reduced Hessian:'
c	do i = 1, nfree
c	write(10, *) (qcib(i, j), j=1,nfree)
c	end do


	   if(m.gt.0) then
	   call jacobh(m, n, x, aj)


c	write(10, *)' Point where I compute Jacobian:'
c	write(10, *) (x(i), i=1,n)
c	write(10, *) ' Jacobian:'
c	do i = 1, m
c	write(10, *) (aj(i, j), j=1,n)
c	end do

	   do i = 1, n
	   do j = 1, n
	   ata(i, j) = 0.d0
	   do k = 1, m
	   ata(i, j) = ata(i, j) + aj(k, i) * aj(k, j)
	   end do
	   end do
	   end do


c	write(10, *)' Reduced Hessian (qcib) de nuevo:'
c	do i = 1, nfree
c	write(10, *) (qcib(i, j), j=1,nfree)
c	end do
c	write(10, *) ' J^T J (ata):'
c	do i = 1, n
c	write(10, *) (ata(i, j), j=1,n)
c	end do
c	write(10, *)' rho =', rho

        	do i = 1, nfree
	        do j = 1, nfree
	        ii = ifree(i)
	        jj = ifree(j)
	        
c	        write(10, *)' i = ', i, ' j =', j
c		write(10, *)' ii = ', ii,' jj = ', jj
c		write(10, *)' qcib(i, j)=', qcib(i, j)
c		write(10, *)' rho = ', rho
c		write(10, *)' ata(ii, jj) =', ata(ii, jj)
		
	        qcib(i, j) = qcib(i, j) + rho * ata(ii, jj)

c		write(10, *)' qcib(i,j)+rho*ata(ii,jj)=',qcib(i,j)
c		write(10, *)' qcib(2, 1) =', qcib(2, 1)

	        end do
	        end do

c	write(10, *) ' Hessian gaussnewton (nuevo qcib):'
c	do i = 1, nfree
c	write(10, *) (qcib(i, j), j=1,nfree)
c	end do



	   end if
c  This endif corresponds to if(m.gt.0)

	do i = 1, nfree
	do j = 1, nfree
	a(i, j) = qcib(i, j) 
	end do
	end do


c	write(10, *) ' Hessian gaussnewton:'
c
c	do i = 1, nfree
c	write(10, *) (a(i, j), j=1,nfree)
c	end do
c
c	stop


	   endif
c  This endif corresponds to if(iophes.eq.2n)		


	if(iophes.eq.3) then
	if(m.gt.0) then
	do i = 1, nfree
	do j = 1, nfree
	ii = ifree(i)
	jj = ifree(j)
	a(i, j) = 2.d0 * qcib(ii, jj) + rho * ata(ii, jj)
	end do
	end do
	else
	do i = 1, nfree
	do j = 1, nfree
	ii = ifree(i)
	jj = ifree(j)
	a(i, j) = 2.d0 * qcib(ii, jj) 
	end do
	end do
	endif


c	write(10, *)' Half-Hessian of the quadratic:'
c	do i = 1, n
c	write(10, *) (qcib(i, j), j=1,n)
c	end do
c
c	write(10, *)' quadratic hessian of the augmented lag.:'
c	do i = 1, nfree
c	write(10, *)(a(i, j), j=1,nfree)
c	end do



	endif


	if(iophes.eq.1) then
c Compute the discrete Hessian


c	write(10, *)' Point where I compute discrete Hessian:'
c	write(10, *) (x(i), i = 1, n)
c	write(10, *)' Lagrange multipliers:'
c	write(10, *) (ambda(i), i=1,m)
c	write(10, *)' gradient in basic point:'
c	write(10, *) (g(i),i=1,n)

	do j = 1, nfree
	jj = ifree(j)
	hh = dmax1(1.d-10, dabs(x(jj))*1.d-7)
	if(x(jj).lt.0.d0) hh = - hh
	save = x(jj)
	x(jj) = x(jj) + hh


       call gratan (m, n, x, ambda, rho, h, aj, gaux, evalg,hrest,
     *	jacobh)

c	write(10, *)' j =', j
c	write(10, *)' x =', (x(i),i=1,n)
c	write(10, *)' lambda:', (ambda(i),i=1,m)
c	write(10, *)' Jacobian:'
c	do i =1, m
c	write(10, *) (aj(i,jjj),jjj=1,n)
c	end do
c	write(10, *)' h increment:', hh
c	write(10, *)' Auxiliar gradient:'
c	write(10, *)(gaux(i), i=1,n)

	do i = 1, nfree
	a(i, j) = (gaux(ifree(i)) - g(ifree(i)))/hh
	end do


	x(jj) = save
	end do



c	write(10, *)' Hessian before simetrization:'
c	do i = 1, nfree
c	write(10, *) (a(i, j), j=1,nfree)
c	end do
c	write(10, *)

c  Simetrization
	if(nfree.ne.1) then
	do i = 2, nfree
	do j = 1, i-1
	a(i, j) = (a(i, j) + a(j, i))/2.d0
	a(j, i) = a(i, j)
	end do
	end do
	endif



c	write(10, *)' Hessian after simetrization:'
c	do i = 1, nfree
c	write(10, *) (a(i, j), j=1,nfree)
c	end do
c	write(10, *)

c	write(10, *)' discrete hessian:'
c	do i = 1, nfree
c	write(10, *)(a(i, j), j=1,nfree)
c	end do



	endif
c   This endif corresponds to if(iophes.eq.1) (Discrete Hessian option)

c
c  iopt=1 is the option that corrects the diagonal of the Hessian if
c  the Hessian is not positive definite
c
	if(iopt.eq.1) then
	icore = 0
c  Test a null Hessian
	anor = 0.d0
	do i = 1, nfree
	do j = 1, i
	anor = dmax1(anor, dabs(a(i, j)))
	end do
	end do



c  Detect null diagonal elements
	corret = 0.d0
	diamin = 1.d0
	do i = 1, nfree
	if(a(i,i).lt.diamin) diamin = a(i,i)
	end do
	if(diamin.le.0.d0) then
	corret = -diamin + 1.d-8 * anor
	do i = 1, n
	a(i, i) = a(i, i) + corret
	end do



c	write(10, *)' Maximum element of Hessian:', anor
c	write(10, *)' Diagonal corrected by ', corret
	icore = 1
	endif
	
		


c  Null Hessian replaced by Identity
	if(anor.eq.0.d0) then
	icore = 1
	anor = 1.d0
	do i = 1, nfree
	a(i, i) = 1.d0
	end do
	endif


c  Factorization of the Hessian
	call chole(nfree, a, ier, aux, n)



	if(ier.gt.0) then
    	icore = 1
c  Modify the Hessian because it is not positive definite
          if(nfree.gt.1) then
	  defic = 0.d0
	  do i = 1, nfree
	  acum = 0.d0
	  do j = 1, nfree
	  if(i.ne.j) acum = acum + dabs(a(i, j))
	  end do
	  defic = dmax1(defic, dmax1(0.d0, acum - a(i, i)))
	  end do

c  Correct the diagonal of the Hessian to make it positive definite

         correc = defic + 1.d-8 * anor
	  do i = 1, nfree
	  a(i, i) = a(i, i) + correc
	  end do
	 corret = corret + correc 

         else
	  a(1, 1) = 1.d0
	  corret = 1.d0
	  endif

c	write(10, *)' Corrected Hessian:'
c	do i = 1, nfree
c	write(10, *) (a(i, j), j=1,nfree)
c	end do
c	write(10, *)

c	write(10, *)' Total diagonal correction:', corret


c  Re-factorize
	call chole(nfree, a, ier, aux, n)
	if(ier.ne.0) then
	write(*, *)' Something wrong. Modified Hessian not pos.def.'
	stop
	endif

	endif

c Solve the Newtonian system


	do i = 1, nfree
	ii = ifree(i)
	gaux(i) = -g(ii)
	end do

	
	
	call sicho (nfree, a, d, gaux, aux, n)


	if(icore.eq.1) ncor = ncor + 1

	endif
c  This endif corresponds to    - if (iopt.eq.1) -
c  End of the option iopt=1 . The output of this option is the
c  ``newtonian'' direction d

c  When iopt=2 and we detect a nonpositive definite Hessian, we
c  try conjugate gradients.
c
	if(iopt.eq.2) then
	do i = 1, nfree
	ii = ifree(i)
	gaux(i) = - g(ii)
	end do
	call chole (nfree, a, iercho, aux, n)
	if(iercho.ne.0) then
	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
	write(10, *)' The Hessian is not pos.def. Try CG'
	endif
	endif
	if(iercho.eq.0) then
	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
	write(10, *)' The Hessian is pos. def. '
	endif
	call sicho (nfree, a, d, gaux, aux, n)
	else
c  The Hessian is not positive definite. 
	ncor = ncor + 1
	
	if(maxcg.eq.-1) maxcg = nfree

c	write(10, *) ' Termino independiente en cg :'
c	write(10, *) (gaux(i), i=1,nfree)

	call milalonga_cg (nfree, a, gaux, d, otro, aux, ap, n, iercg,
     *     koncg, maxcg)
c   The conjugate gradient subroutine finished with a direction d that
c   minimizes the quadratic in the Krylov subspace and a direction aux
c   where the quadratic has nonpositive curvature (when iercg=1)
c
	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
	write(10, *)' Output of CG. iercg =', iercg,' cg-iterations:',
     *    koncg
	write(10, *)' Quadratic minimizer in Krylov subspace:'
	write(10, *) (d(i), i = 1, nfree)
	endif
	if(iercg.eq.1) then
	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
	write(10, *)' CG finished finding a nonpositive curvature'
	endif
	pesca = 0.d0
	do i = 1, nfree
	ii = ifree(i)
	pesca = pesca + d(i) * g(ii)
	end do
c  This scalar product must be nonpositive, in theory.

	if(pesca.lt.0.d0) then
c	write(10, *)' Krylov direction is a descent direction'
c	write(10, *)' directional derivative:', pesca

c  The Krylov direction d is a descent direction. 

	delta  = 0.d0
	do i = 1, nfree
	delta = dmax1(delta, dabs(d(i)))
	delta = dmax1(delta, dabs(x(ifree(i))))
	end do

	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
	write(10, *)' Nonpositive curvature direction:'
	write(10, *) (aux(i), i=1,nfree)
	endif

	p1 = 0.d0
	do i = 1, nfree
	p1 = p1 + otro(i)*aux(i)
	end do


	if(p1.lt.0.d0) then
	do i = 1, nfree
	aux(i) = -aux(i)
	end do
	endif

	
	if(p1.ne.0.d0) then
	amor = 0.d0
	do i = 1, nfree
	amor = dmax1(amor, dabs(aux(i)))
	end do
	if(amor.gt.delta) then
	amor = delta/amor
	do i = 1, nfree
	aux(i) = aux(i) * amor
	end do
	endif

	do i = 1, nfree
	aux(i) = d(i) + aux(i)
	end do
	p1 = 0.d0
	do i = 1, nfree
	ii = ifree(i)
	p1 = p1 + aux(i) * g(ii)
	end do

	if(p1.ge.0.d0) then
	z = pesca / (pesca - p1)
	z = z/2.d0
	do i = 1, nfree
	d(i) = d(i) + z * (aux(i) - d(i))
	end do
	else
	do i = 1, nfree
	d(i) = aux(i)
	end do
	endif

	endif
c   This endif corresponds to - if(p1.ne.0.d0) - 





	else
c  This else corresponds to - if(pesca.lt.0.d0) -

c	write(10, *)' Krylov direction is not a descent direction'
c	write(10, *)' directional derivative:', pesca
c	write(10, *)' Taken d = -g'

	do i = 1, nfree
	ii = ifree(i)
	d(i) = - g(ii)
	end do

	endif
c  This endif corresponds to - if(pesca.lt.0.d0) - else

	endif
c  This endif corresponds to - if(iercg.eq.1) - ( after  call cg )

	endif
c  This endif corresponds to - if(iercho.eq.0  -  else  -


	endif
c  This endif corresponds to    - if(iopt.eq.2) -

c  d is the Newton direction (only free variables)

	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
	write(10, *)' Newton direction:'
	
	write(10, *) (d(i), i=1,nfree)
	endif


	dnor = 0.d0
	do i = 1, nfree
	dnor = dmax1(dnor, dabs(d(i)))
	end do

c	write(10, *)' Sup norm of Newton direction:', dnor

	if(dnor.eq.0.d0) then
	write(*, *)' Something wrong. Newton direction null'
	stop
	endif


	do i = 1, n
	aux(i) = x(i)
	otro(i) = x(i)
	end do


	dmin = dnor
	do i = 1, nfree
	if(d(i).ne.0.d0) then
	dmin = dmin1(dmin, dabs(d(i)))
	endif
	end do


c  Check whether the point is interior or not
	inter = 1
	do i = 1, nfree
	ii = ifree(i)
	z = x(ii) + d(i)
	if(z.ge.u(ii).or.z.le.ele(ii)) inter = 0
	end do


c  Compute alfamax
	alfamax = 0.d0
	do i = 1, nfree
	ii = ifree(i)
	alfamax = dmax1(alfamax, (u(ii)-x(ii))/dmin)
	alfamax = dmax1(alfamax, (x(ii)-ele(ii))/dmin)
	end do
	

	do i = 1, nfree
	ii = ifree(i)
	if(d(i).ne.0.d0) then
	  if(d(i).gt.0.d0) then
	  alfamax = dmin1(alfamax, (u(ii)-x(ii))/d(i))
	  else
	  alfamax = dmin1(alfamax, (ele(ii)-x(ii))/d(i))
	  endif
	endif
	end do

	if(inter.eq.0) alfamax = dmin1(alfamax, 1.d0)

	alfa = dmin1(alfamax, 1.d0)


	if(alfamax.gt.1.d0) then

c	write(10, *)' The newtonian trial point is interior'

c  The newtonian trial point is interior

c  Checking interiority

	do i = 1, nfree
	ii = ifree(i)
	if(x(ii) + d(i).ge.u(ii).or.x(ii) + d(i).le. ele(ii)) then
	write(*, *)' Be careful. Possible rounding error in alfamax',
     *    alfamax
	stop
	endif
	end do





	pesca = 0.d0
	dnor2 = 0.d0
	gnor2 = 0.d0
	do i = 1, nfree
	ii = ifree(i)
	pesca = pesca + d(i) * g(ii)
	dnor2 = dnor2 + d(i)**2
	gnor2 = gnor2 + g(ii)**2
	end do


	if(pesca.ge.0.d0) then
	write(*, *)' Something wrong. Not a descent direction'
	stop
	endif


	cose = pesca/(dsqrt(gnor2)*dsqrt(dnor2))
	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
	write(10, *)' Cosine of angle newton-gradient:', cose
	endif

	if(cose.gt.-costol) then
	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
	write(10, *)' Search direction replaced by -gradient:'
	endif

c  Replace the scalar product for Armijo
	pesca = 0.d0
	do i = 1, nfree
	ii = ifree(i)
	d(i) = -g(ii)
	pesca = pesca - d(i)*d(i)
	end do
	dnor2 = gnor2
	endif

	dnorn = dsqrt(dnor2/dfloat(nfree))
c	write(10, *)' Norma de la direccion de busqueda:',dnorn

	xnorn = 0.d0
	do i = 1, nfree
	xnorn = xnorn + x(ifree(i))**2
	end do
	xnorn = dsqrt(xnorn/dfloat(nfree))


	do i = 1, nfree
	ii = ifree(i)
	aux(ii) = x(ii) + d(i)
	end do

	
	call funtan (m, n, aux, ambda, rho, h, fn,evalf,hrest)
	nef = nef + 1

c  Test Armijo
c  If Armijo does not hold, do backtracking (goto4)
	if(fn.gt.f + gamma * pesca) go to 4

c  Test beta-condition
	
	call gratan (m, n, aux, ambda, rho, h, aj, gaux,evalg,hrest,
     *  jacobh)
	neg = neg + 1
	pesnew = 0.d0
	do i = 1, nfree
	pesnew = pesnew + d(i) * gaux(ifree(i))
	end do

c  If the beta-condition does not hold, do extrapolation (goto3)
	if(pesnew.le.beta*pesca) go to 3
	do i = 1, nfree
	x(ifree(i)) = aux(ifree(i))
	end do
	f = fn
	do i = 1, n
	g(i) = gaux(i)
	end do
	kon = kon + 1
	npur = npur + 1
	go to 1
	

	endif
c  (This endif corresponds to      if(alfamax.gt.1) )

c  The point x + d is not interior


c	write(10, *)' The newtonian trial point is not interior'
c       write(10, *)' alfamax =', alfamax,' alfa =', alfa

	do i = 1, nfree
	ii = ifree(i)
	aux(ii) = x(ii) + alfamax * d(i)
	aux(ii) =
     *   dmin1(u(ii), dmax1(aux(ii), ele(ii)))
	end do


c	if(mod(kon,ipt).eq.0) 
c     *    write(10, *)' breakpoint aux:', (aux(i),i=1,n)

	call funtan (m, n, aux, ambda, rho, h, fn,evalf,hrest)

c	if(mod(kon,ipt).eq.0) 
c     *      write(10, *)' f(breakpoint)=', fn
c	nef = nef + 1

c   If the functional value at the boundary did not improve, do
c   backtracking (goto4)
c   Otherwise, do extrapolation (3)

c	write(10, *)' The trial point is not interior'

	dnor2 = 0.d0
	do i = 1, nfree
	dnor2 = dnorn + d(i)*d(i)
	end do
	dnorn = dsqrt (dnor2/dfloat(nfree))

c	write(10, *)' Norm of the direction:', dnorn
c	write(10, *)' dnorn antes de un goto 4'
c	write(10, *)' d ='
c	write(10, *) (d(i), i=1,nfree)
c	write(10, *)' dnorn =', dnorn
c	write(10, *)' pesca previously computed =', pesca

	pesca = 0.d0
	do i = 1, nfree
	pesca = pesca + g(ifree(i))*d(i)
	end do

c	write(10, *)' Verificando, pesca = ', pesca
c	write(10, *)' Current point:'
c	write(10, *) (x(i), i=1,n)
c	
c	write(10, *)' Verificando pesca de nuevo:'
c	pesca = 0.d0
c	do i = 1, n
c	pesca = pesca + g(i) * d(i)
c	end do
c	write(10, *)' Derivada direccional:', pesca
c
c	call funtan(m, n, x, ambda, rho, h, f)
c	call gratan (m, n, x, ambda, rho, h, aj, g)
c	write(10, *)' f(current point):', f
c	write(10, *)' Gradiente de current point:'
c	write(10, *) (g(i), i=1,n)
c
c	write(10, *)' Verificando pesca otra vez:'
c	pesca = 0.d0
c	do i = 1, n
c	pesca = pesca + g(i) * d(i)
c	end do
c	write(10, *)' Derivada direccional:', pesca
c
c	alftri = 1.d0
c	do itri = 1, 20
c	
c	write(10, *)
c	write(10, *)' itri = ', itri,'  alftri =', alftri
c	do i = 1, nfree
c	ii = ifree(i)
c	aux(ii) = x(ii) + alftri * d(i)
c	end do
c	write(10, *)' Trial calculado como en back:'
c	write(10, *) (aux(i), i=1,n)
c
c	do i = 1, n
c	aux(i) = x(i) + alftri * d(i)
c	end do
c
c	write(10, *)' Trial calculado en el verificador:'
c	write(10, *) (aux(i),i=1,n)
c
c	call funtan(m, n, aux, ambda, rho, h, ftrial)
c
c	write(10, *)' f =' , f, ' ftrial =', ftrial
c
c
c
c
c
c	alftri = alftri/10.d0
c	if(itri.eq.19) alftri = 7.1487099959547d-6
c	end do




c	if(fn.gt.f) write(10, *)' f(boundary)=', fn,' f(curr)=',f

	if(fn.gt.f) go to 4

c   Extrapolation
3	fbest = fn


	
	do i = 1, nfree
	ii = ifree(i)
	otro(ii) = aux(ii)
	end do



	if(alfa.lt.alfamax.and.2.d0*alfa.gt.alfamax) then

	alfa = alfamax
	else


	alfa = 2.d0 * alfa
	endif


	do i = 1, nfree
	ii = ifree(i)
	aux(ii) = x(ii) + alfa * d(i)
	aux(ii) = dmin1(u(ii), dmax1(ele(ii), aux(ii)))
	end do


	call funtan (m, n, aux, ambda, rho, h, fn,evalf,hrest)
	nef = nef + 1


c   If extrapolation is being successful, continue:
c	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
c
c	write(10, *)' fbest=',fbest,' fn=', fn,' alfa=', alfa
c	endif


	if(fn.lt.fbest) go to 3
c
c   Extrapolation is not successful anymore:


c	if(ipt.ge.0.and.mod(kon,ipt).eq.0) then
c	write(10, *)' Extrapolation not successful anymore'
c	endif


	do i = 1, nfree
	ii = ifree(i)
	x(ii) = otro(ii)
	end do


	f = fbest
	call gratan (m, n, x, ambda, rho, h, aj, g,evalg,hrest,jacobh)
	neg = neg + 1
	kon = kon + 1
	nextr = nextr + 1
	go to 1

c  Backtracking
4	alfnew = - pesca*alfa*alfa/(2.d0*(fn-f-pesca*alfa))


c          write(10, *)' alfa =', alfa,'  alfa new:', alfnew

	if(alfnew.gt.alfa/2.d0.or.alfnew.lt.0.1d0) alfnew = alfa/2.d0
	alfa = alfnew

c        write(10, *)' alfa new:', alfnew


	if(alfa*dnorn.le.distol*xnorn) then
	iflag = 2
	if(mod(kon,ipt).eq.0) then
	write(10, *)' Tango stopped by the relative diff. criterion'
	write(10, *)' alpha=', alfa,' dnorn=', dnorn
	write(10, *)' alpha*dnor=',alfa*dnorn,' xnorn=', xnorn
	endif
	return
	endif

	do i = 1, nfree
	ii = ifree(i)
	aux(ii) = x(ii) + alfa * d(i)
	end do
c	write(10, *)' Trial point:', (aux(i), i=1,n)

	call funtan (m, n, aux, ambda, rho, h, fn,evalf,hrest)

c	write(10, *)' f(x)=', f,'  f(trial point) =', fn
c	write(10, *)' pesca =', pesca,' alfa =', alfa
c	write(10, *)' Predicted reduction:', -pesca*alfa
c	write(10, *)' Actual reduction:', f - fn

	nef = nef + 1
c   Test Armijo
	   if(fn.gt.f + gamma*pesca*alfa) go to 4



c            Armijo holds
	   f = fn
	   do i = 1, nfree
	   ii = ifree(i)
	   x(ii) = aux(ii)
	   end do
	   call gratan (m, n, x, ambda, rho, h, aj, g,evalg,hrest,
     *     jacobh)
	   neg = neg + 1
	   kon = kon + 1
	   nback = nback + 1
	   go to 1
	end


	subroutine milalonga_cg (n, a, b, x, r, p, ap, nlin, ier, k, max)
	implicit double precision (a-h, o-z)
	dimension a(nlin, n), b(n), x(n), r(n), p(n), ap(n)
	ier = 0
	do i = 1, n
	x(i) = 0.d0
	r(i) = b(i)
	end do
	r2 = 0.d0

c  Here is the loop
	do k = 1, max
	r2a = r2
	r2 = 0.d0
	rnor = 0.d0
	do i = 1, n
	rnor = dmax1(rnor, dabs(r(i)))
	r2 = r2 + r(i)**2
	end do
	if(rnor.le.1.d-8) return
	beta = 0.d0
	if(k.gt.1) beta = r2/r2a
	if(k.eq.1) then
	do i = 1, n
	p(i) = r(i)
	end do
	else
	do i = 1, n
	p(i) = r(i) + beta * p(i)
	end do
	end if
	do i = 1, n
	ap(i) = 0.d0
	do j = 1, n
	ap(i) = ap(i) + a(i, j) * p(j)
	end do
	end do
	pap = 0.d0
	do i = 1, n
	pap = pap + p(i) * ap(i)
	end do
	if(pap.le.0.d0) then
	ier = 1
	return
	else
	alfa = r2/pap
	do i = 1, n
	x(i) = x(i) + alfa * p(i)
	r(i) = r(i) - alfa * ap(i)
	end do
	endif
	end do
	return
c  End of the loop
	end




	subroutine giveup(funtan, gratan, 
     *      n, x, f, g, ele, u, nef, neg, gamma, 
     *      aux, gaux, d, m, ambda, rho, h, aj,evalf,evalg,hrest,
     *      jacobh)
	implicit double precision (a-h,o-z)
	external evalf, evalg,hrest,jacobh
	dimension x(n), g(n), ele(n), u(n), aux(n), gaux(n), d(n)
	dimension ambda(m), h(m), aj(m, n)
	xnor = 0.d0
	do i = 1, n
	xnor = dmax1(xnor, dabs(x(i)))
	end do
	hh = dmax1(1.d-10, 1.d-5 * xnor)
	do i = 1, n
	aux(i) = x(i) - hh * g(i)
	aux(i) = dmax1(ele(i), dmin1(u(i), aux(i)))
	end do
        call gratan (m, n, aux, ambda, rho, h, aj, gaux,evalg,hrest,
     *  jacobh)
	neg = neg + 1
	ss = 0.d0
	sy = 0.d0
	do i = 1, n
	z = aux(i) - x(i)
	ss = ss + z * z
	sy = sy + z * (gaux(i) - g(i))
	end do
	if(sy.ne.0.d0) then
	step = dmax1(1.d-4, dmin1(1.d4, ss/sy))
	else
	step = 1.d4
	endif

	do i = 1, n
	aux(i) = dmin1(u(i), dmax1(ele(i), x(i)-step*g(i)))
	d(i) = aux(i) - x(i)
	end do
	alfa = 1.d0
	pesca = 0.d0
	do i = 1, n
	pesca = pesca + g(i) * d(i)
	end do

1	call funtan (m, n, aux, ambda, rho, h, fn,evalf,hrest)
	nef = nef + 1
	if(fn .gt. f + alfa * gamma * pesca) then
c  Armijo did not hold 
	alfnew = - pesca*alfa*alfa/(2.d0*(fn-f-pesca*alfa))
	if(alfnew.gt.alfa/2.d0.or.alfnew.lt.0.1d0) alfnew = alfa/2.d0
	alfa = alfnew
	do i = 1, n
	aux(i) = dmin1(u(i), dmax1(ele(i), x(i) + alfa*d(i)))
	end do
	go to 1
	else
c  Armijo holds. Return.
	do i = 1, n
	x(i) = aux(i)
	end do
	call gratan (m, n, x, ambda, rho, h, aj, g, evalg,hrest,jacobh)
	neg = neg + 1
	f = fn
	return
	endif
	end



	subroutine chole (n, a, ier, diag, nlin)
	implicit double precision (a-h,o-z)
	dimension a(nlin, n), diag(n)	
	ier = 0
c Save the diagonal of the matrix
	do i = 1, n
	diag(i) = a(i, i)
	end do
c Test nonnegativity of diagonal
	do i = 1, n
	if(diag(i).le.0) then
	ier = 1
	return
	endif
	end do

	a(1,1) = dsqrt(a(1, 1))
	if(n.eq.1)return

	do 1 i = 2, n
	do 2 j = 1 ,i-1
	z = 0.d0
	if(j.gt.1)then
	do 3 k=1,j-1
3	z = z + a(i,k) * a(j,k)
	endif
	a(i,j) = (a(i,j) - z)/a(j,j)
2	continue
	z = 0.d0
	do 4 j=1,i-1
4	z = z + a(i,j)**2
	temp = a(i, i) - z

c   Test positive definiteness
	if(temp.le.0.d0) then
	ier = i
c   Restore the diagonal
	do ii = 1, n
	a(ii, ii) = diag(ii)
	end do
c   Restore lower triangular part
	do ii = 2, n
	do j = 1, ii-1
	a(ii, j) = a(j, ii)
	end do
	end do	
	return
	endif

	a(i,i) = dsqrt(temp)
1	continue
	return
	end


	subroutine sicho (n, a, x, b, aux, nlin)
	implicit double precision (a-h,o-z)
	dimension a(nlin, n),x(n),b(n),aux(n)
	aux(1) = b(1)/a(1,1)
	if(n.gt.1)then
	do 1 i=2,n
	z = 0.d0
	do 2 j=1,i-1
2	z = z + a(i,j)*aux(j)
	aux(i) = (b(i) - z) / a(i,i)
1	continue
	endif
	x(n) = aux(n)/a(n,n)
	if(n.eq.1)return
	do 3 i=n-1,1,-1
	z = 0.d0
	do 4 j=i+1,n
4	z = z + a(j,i)*x(j)
	x(i) = (aux(i) - z)/a(i,i)
3	continue
	return
	end



	subroutine funtan (m, n, x, ambda, rho, h, f,evalf,hrest)
	implicit double precision (a-h, o-z)
	dimension x(n), ambda(m), h(m)
        external evalf,hrest
        
	call evalf (n, x, f)

c	write(10, *) ' f inside funtan:', f
c	write(10, *) ' m =', m
c	write(10, *) ' rho inside funtan:', rho

	
	if(m.eq.0) return
	rho2 = rho/2.d0


	call hrest (m, n, x, h)

c	write(10, *)' h inside funtan:'
c	write(10, *) (h(i),i=1,m)

	do i = 1, m
	f = f + (ambda(i) + rho2 * h(i)) * h(i)
	end do
	
	return
	end


	subroutine sumsq (m, n, x, ambda, rho, h, f,evalf,hrest)
	implicit double precision (a-h, o-z)
	dimension x(n), ambda(m), h(m)
        external evalf,hrest

	call hrest (m, n, x, h)

	f = 0.d0
	do i = 1, m
	f = f + h(i)* h(i)
	end do
	f = f/2.d0
	
	return
	end




	subroutine gratan (m, n, x, ambda, rho, h, aj, g, evalg,hrest,
     *  jacobh)
	implicit double precision (a-h, o-z)
	dimension x(n), ambda(m), h(m), aj(m, n), g(n)
	external evalg,hrest,jacobh
	
	call evalg(n, x, g)

c	write(10, *)' Dentro de gratan, lambda='
c	write(10, *)(ambda(i),i=1,m)

	if(m.eq.0) return

	
	call hrest (m, n, x, h)
	call jacobh (m, n, x, aj)

	do j = 1, n

	do i = 1, m
	g(j) = g(j) + ambda(i) * aj(i, j)
	end do

	z = 0.d0
	do i = 1, m
	z = z + aj(i, j) * h(i)
	end do

	g(j) = g(j) + rho * z
	end do
	return
	end



	subroutine grasum (m, n, x, ambda, rho, h, aj, g, evalg,hrest,
     *  jacobh)
	implicit double precision (a-h, o-z)
	dimension x(n), ambda(m), h(m), aj(m, n), g(n)
        external evalg,hrest,jacobh
	
	call hrest (m, n, x, h)
	call jacobh (m, n, x, aj)

	do j = 1, n
	g(j) = 0.d0
	do i = 1, m
	g(j) = g(j) + aj(i, j) * h(i)
	end do
	end do

	return
	end



	subroutine funquad (n, q, x, c, f, v, nlin)
	implicit double precision (a-h,o-z)
	dimension q(nlin, n), x(n), c(n), v(n)
	do i = 1, n
	v(i) =0.d0
	do j = 1, n
	v(i) = v(i) + q(i, j) * x(j)
	end do
	end do
	f = 0.d0
	do i = 1, n
	f = f + c(i)*x(i)
	end do
	do i = 1, n
	f = f + v(i)*x(i)
	end do
	return
	end


	subroutine graquad(n, x, q, c, g, nlin)
	implicit double precision (a-h, o-z)
	dimension x(n), q(nlin, n), c(n), g(n)
	do i = 1, n
	g(i) =0.d0
	do j = 1, n
	g(i) = g(i) + q(i, j) * x(j)
	end do
	end do
	do i = 1, n
	g(i) = 2.d0 * g(i) + c(i)
	end do
	return
	end	






		

c*********************************************************************
c*                       SUBROUTINE BOX9903                          *
c*********************************************************************
c      Written: March 1999
c
c      Modifications:
c      January 16, 2002: add missing declaration in subroutine grad
c      April 14, 1999: parameter ftol was added .
c      May 7, 2001: forbidden L(i) = U(i)
c
c      Developed by the Optimization Group at the State University of
c                            Campinas 
c
c                     Date: March 1999      (99/03)
C
C          This subroutine solves the problem
C
C                      Minimize f(x)
c                      s. t. h(x) = 0
c                            A x  = b                          (1)
C                           l <= x <= u                        
c
c       where 
c
c                     f: \R^n ---> \R
c
c                     h: \R^n ----> \R^{nonlc}
c
c                     A \in \R^{m x n}
c
c       and f and h are differentiable functions. That is to say, the 
c       smooth nonlinear programming problem with m linear equality 
c       constraints, nonlc nonlinear equality constraints, 
c       and bounds on the variables. 
c
c          This code was written with the aim of dealing with large-scale
c       problems, for this reason it does not impose storing or factorization
c       of matrices of any kind. 
c          The outer algorithm for solving (1) is the Augmented Lagrangian
c       method. Namely, at each outer-iteration the following 
c       box-constrained problem is solved       
c
c                            
c                          Minimize   L(x) 
c                                                          (2)
c                      subject to  l <= x <= u
c          
c
c                             where L(x) =
c
c                         f(x) +  mu^T h(x) + 
c
c              + (1/2) Sum_{i=1}^{nonlc} ra(i) [h(x)]_i^2 +
c          
c             +  lambda^T (A x - b) + (ro/2) ||A x - b||_2^2
c
c      L(x) is called ``the Augmented Lagrangian'' associated to (1).
c
c

c
c         Therefore, mu is the vector of Lagrange multipliers associated
c      to nonlinear equality constraints, lambda is the vector of Lagrange
c      multipliers associated to linear constraints, ra is a vector of
c      penalty parameters associated to nonlinear equality constraints,
c      and ro is  a single  penalty parameter associated to linear constraints.
c
c         A description of the method used in box9903 can be found in
c
c       N. Krejic, J. M. Martinez, M. P. Mello and E. A. Pilotta
c       [1999]: "Validation of an Augmented Lagrangian algorithm with a
c       Gauss-Newton Hessian approximation using a set of hard-spheres
c       problems", to appear in 
c       Computational Optimization and Applications.
c
c
c
c         For solving (2) at each outer iteration it is used the subroutine
c      BOX, enclosed within this piece of software. BOX solves (2) using
c      the method described in:
c
C       A. Friedlander, J. M. Martinez and S. A. Santos [1994]: "A new
C       trust-region strategy for box-constrained minimization", 
C       Applied Mathematics and Optimization  30 (1994) 235-266.
c
c
c          At each outer iteration BOX will be called trying to find 
c       a minimizer of (2) up to the precision eps (or epsd).
c
c
c          The main work performed by box9903 consists in calling BOX 
c       and modifying the penalty parameters ro (associated to the 
c       linear constraints) and ra (associated to the nonlinear
c       equality constraints). Moreover, the Lagrange multipliers mu 
c       (associated to the nonlinear equality constraints), and lambda 
c       (associated to the linear constraints) are also updated in box9903
c       at each outer iteration. 
c
c*******************************************************************
c*                                                                 *
c*                                                                 *
c*                      PARAMETERS OF BOX9903                      *
c*                                                                 *
c*                                                                 *
c*******************************************************************
c
c       n: number of variables.
c   
c       m: number of linear constraints.
c
c       nonlc: number of nonlinear equality constraints.
c
c       roinic: (input) if linear constraints are present (m > 0) you must 
c       set roinic equal to the initial value that you wish for 
c       the penalty parameter associated to the linear constraints.
c
c       rainic: (input) is a vector of nonlc positions. If nonlc = 0
c       you must dimension rainic with only one position.  If nonlinear 
c       equality constraints are present (nonlc > 0) you
c       must set rainic equal to the initial values that you wish for 
c       the penalty parameters associated to nonlinear constraints.
c
c       ra: (auxiliar) is a vector of nonlc positions. If nonlc = 0
c       you must dimension ra with only one position. If nonlinear 
c       equality constraints are present (nonlc > 0) ra is used by 
c       this subroutine to store the penalty parameters associated to
c       each nonlinear equality constraint. 
c
c       facro: (input) if linear constraints are present (m > 0) you must
c       set facro >= 1 equal to the factor by which you want to multiply
c       penalty parameter ro after each outer iteration.
c       
c       facra: (input) if nonlinear equality constraints are present 
c       (nonlc > 0) you must set facra >= 1 equal to the factor by which 
c       you want to multiply the penalty parameters ra(i) after
c       each outer iteration.
c
c       indivi: (input) if you set indivi = 1, penalty parameters
c       associated to each nonlinear equality constraint 
c       will be increased separately. 
c       If indivi = 0, penalty parameters associated to
c       nonlinear equality constraints will be increased 
c       together, so that the process will work as if it existed only 
c       one penalty parameter associated to nonlinear equality constraints.
c
c       epslin: (input) if linear constraints are present you must
c       set epslin equal to the level of feasibility that you want associated
c       to these constraints. In other words, a point x will be considered
c       ``feasible'' with respect to linear constraints when
c
c                       ||A x - b||_\infty <= epslin
c
c       epsnon: (input) if nonlinear equality constraints 
c       are present you must set epsnon equal to the level of feasibility 
c       that you want associated to these constraints.
c       In other words, a point x will be considered
c       ``feasible'' with respect to nonlinear equality constraints when
c
c                          || h(x) ||_\infty <= epsnon
c
c       ratfea: (input) If the feasibility at the new outer iteration
c       is better than ratfea*(the feasibility at the previous iteration)
c       the penalty parameter will not be increased. ratfea must be greater
c       than or equal to zero. 
c
c       epsinic: (input) This is the convergence criterion that will be
c       used by Box at the first outer iteration. 
c
c	epsdiv: (input) If epsinic > epsfin, the convergence criterion
c       used by Box at successive outer iterations is the previous one
c       over epsdiv. For example, if Box used eps = 10^{-2} at the outer
c       iteration kon, it will use eps/epsdiv at the following one.
c       However if the new eps is less than epsfin, it is replaced by
c       epsfin. epsdiv must be greater than 1.
c
c       epsfin: (input) This is the convergence criterion that will
c       be used by Box at the final outer iteration. 
c       If you set epsinic = epsfin
c       the same convergence criterion will be used at all the iterations.
c
c
c       maxout: (input) maximum number of outer iterations (calls to BOX).
c
c       iprint: (input) parameter by means of which you can say what
c               you want to be printed automatically by box9903, both
c               in the screen and in a file (unity 10). If iprint < 0,
c               nothing will be printed. If iprint = 0, only information
c               at the initial point and at the final point will be 
c               printed. In all the other cases, information will also
c               be printed every iprint outer iterations. 
c
c       konout: (output) effective number of outer iterations performed.
c       konint: (output) total number of inner iterations (iterations of BOX)
c       nefint: (output) total number of evaluations of f(x)
c       itqint: (output) total number of quacan iterations
c       mvpint: (output) total number of matrix-vector products performed 
c               in quacan
c
c       hresan: (input) auxiliar double precision vector of at least 
c               nonlc positions (1 position if nonlc = 0)
c
c       ierla: output parameter that indicates what happened in the 
c        execution of box9903. If ierla = 0, a feasible point, according
c        to the prescribed tolerances epslin and epsnon, has been found.
c        If there are no constraints in the problem ierla will be necessarily
c        equal to 0. The final diagnostic concerning the execution of
c        box9903 must be complemented looking at the BOX output parameter
c        istop. In fact, if istop = 0 and ierla = 0 you can guarantee
c        that a point that satisfies first-order optimality
c        conditions of (1) has been found. Other situations are doubtful.
c        If ierla = 1, the allowed number of outer iterations (calls to
c        BOX) has been exhausted without achieving feasibility. 
c   
c      ilag: (input) can take the values 0 and 1. If ilag = 0 the estimates
c        of the  Lagrange  multipliers at each iteration are zero. In
c        other words, in this case one is using a pure  penalty method.
c        If ilag = 1 first order Lagrange multipliers are estimated 
c        at each outer iteration.
c
c      iguess: (input) can take the values 0 and 1. If iguess = 1
c        this means that you have a procedure to guess a good approxima-
c        tion to the solution of the quadratic problem that must be 
c        solved at each iteration of BOX. In this case, you must write
c        the way to calculate your guess in the subroutine guess. More
c        about this parameter and subroutine guess in the comments of
c        the subroutine BOX.
c
c      x: double precision vector with n positions. On input, initial
c         approximation to the solution. On output, best solution obtained.
c
c      l, u : on input, double precision vectors that define the
c             bounds of Problem (1).
c
c      hres: double precision auxiliar vector with at least nonlc positions.
c            On output it contains the values of h(x) mentioned in (1).
c      
c      res: double precision auxiliar vector with m positions.
c           On exit, when m is not 0, residual vector A x - b.
c
c      grad:  double precision auxiliar vector with n positions.
c           On exit, g is the gradient of L (the augmented Lagrangian)
c           at the final point.
c
c      fx:  on output, functional value f(x).
c
C
C     iprbox : control for printing in subroutine BOX. If iprbox< 0 nothing 
c       is printed in BOX. If iprbox = 0, only a
C       final summary is printed. If iprbox > 0, information every iprbox
C       iterations is printed. 
C
c
c
C     mu: auxiliar double precision input vector with nonlc components,
c     (1 component if nonlc = 0)
c     that contributes to define the objective function. It stores the
c     Lagrange multipliers associated to nonlinear equality constraints.
c
c     lambda: auxiliar double precision input vector with m components
c     (1 component if m = 0)
c     that contributes to define the Augmented Lagrangian. It stores the
c     Lagrange multipliers associated to linear equality constraints.
c
c
c---------------------------------------------------------------------------
c
c             SUBROUTINES phi AND MAPRO, THAT DEFINE Phi(x),     
c
c
c              ITS GRADIENT, AND ITS HESSIAN APPROXIMATION
c
c
C---------------------------------------------------------------------------
c
C       The user must provide a subroutine named phi for computing
C       the function value 
c
c                             Phi(x) =
c
c                
c                     =  f(x) +  mu^T h(x) + 
c
c              + (1/2) Sum_{i=1}^{nonlc} ra(i) h_i(x)^2 +
c          
c       the gradient of Phi(x) and the information relative to the 
c       Hessian approximation of Phi(x).
c
C       The calling sequence of phi is
C
C  call phi (n, nonlc, x, mu, ra, flagra, fx, grad, hres, hess, inhess, modo )
C
C       where n is the number of variables, nonlc is the number of
c       components of h, 
c       x is the point where the  function is calculated within phi, 
c       mu and ra are the other input parameters necessary
c       for computing Phi(x).
c       As output, phi must produce flagra (Phi(x)), fx (f(x)), 
C       grad, the gradient of the function Phi computed at x, hres 
c       (the nonlinear vector of residuals  h(x)).
c       Finally, hess and inhess inhess are arrays that can contain 
c       the information relative to the Hessian approximation. 
C       You can choose the name for the subroutine phi. For this
C       reason, phi is a parameter of box9903. In the calling
C       program, the name actually used must be declared EXTERNAL. 
C       If modo = 1, phi must compute ONLY the function 
c       values flagra and fx and the
c       vector of nonlinear residuals hres,
c       which, of course, are by-products of the computation of the 
c       function value flagra.
C       If modo = 2, phi must compute ONLY the gradient at
c       the point x and the information relative to the Hessian.
c       Now, you can take
c       advantage of the common calculations to function and gradient-
c       Hessian learning that a call to phi with modo=2 is always
c       preceeded, in BOX, by a call to phi with modo=1 at the same
c       point. So, you can prepare information inside phi in such a way
c       that calculations for modo=2 are already done, and you do not
c       need to begin from scratch. In particular, for computing the
c       gradient, you will need the nonlinear residuals hres.
c       So, you can use it freely.
C       You can choose the data structure for the Hessian
c       information provided that it fits in the arrays inhess and 
c       hess. This information must be compatible with the coding of
c       user supplied subroutine mapro, commented below.
c       In previous versions of BOX it was assumed that the communication
c       of Hessian information between phi and mapro was coded through
c       COMMON statements. We think that passage through parameters is
c       less prone to errors, so we decided to introduce the new 
c       parameters hess and inhess in 1995. However, if you
c       find easier to make the communication by COMMON, you can do it
c       disregarding the existence of hess and inhess. However, do not
c       forget to dimension hess and inhess.
c
c       Helping your memory:
c
c   The gradient of the objective function Phi(x) considered here is
c
c  \nabla f(x) +  Sum_{i=1}^{nonlc} [mu(i) + ra(i) h_i(x)] \nabla h_i(x) 
c
c
c   The Hessian is
c
c  \nabla^2 f(x) + Sum_{i=1}^{nonlc} ra(i) \nabla h_i(x) \nabla h_i(x)^T +
c
c     + Sum_{i=1}^{nonlc} [mu(i) + ra(i) h_i(x)] \nabla^2 h_i(x)
C
c
C       You must also provide the subroutine mapro. As in the case
C       of phi , you can choose the name of this subroutine, which, for
C       this reason, must be declared EXTERNAL in the calling program.
C       mapro is called only from quacan. As a result, it is also
C       a parameter of quacan, and it is declared EXTERNAL in BOX 
C       subroutine. The calling sequence of mapro is
C
C               call mapro (n, nind, ind, u, v, hess, inhess )
C       
C       where n (the number of variables) and u (a double precision vector
C       of n positions) are the main inputs, and v, a double precision
c       vector of n positions is the output. v must be the product H * u,
c       where H is the current Hessian approximation of the function Phi(x).
c       That is, H is the last  computed Hessian approximation of Phi(x)
c       within the subroutine phi. 
c       Therefore, mapro must be coded in such a way that the structure 
c       given for this matrix within phi is compatible with formulae for
c       the product.
c       Moreover, if nind < n (both are input parameters), the integer vector
c       ind, with nind positions, contains the indices where the input
c       u is different from zero. So, you can take advantage of this 
c       information to write the matrix-vector product, but if you do
c       not know how to do it, simply ignore nind and ind and write the
c       matrix vector product as if u were a dense vector. The algorithm
c       will be the same, but taking advantage of nind and ind makes it
c       faster. 
c       Many times, you will find the task of coding the information
c       relative to the Hessian very cumbersome. You can use a 
c       ``directional finite difference'' version of mapro instead of
c       products with true Hessians. The idea is that, at the current
c       point x, the product H u is the limit of 
c 
c               [Gradient(x + t u) - Gradient(x) ] / t
c
c       Using this directional derivative idea, you can code mapro 
c       passing, within hess, the current point x and the current 
c       gradient g to mapro. Then, you use, say, 
c
c       t = max ( 1.d-20, 1.d-8 ||x||_\infty ) / || d ||_\infty
c
c       provided that d \neq 0, of course.
c
c      So, in this case you evaluate the Gradient 
c      at the auxiliary point x + t u and 
c      finally, you use the quotient above to approximate H u. There
c      are some risks using this device, but you can try.
c
C--------------------------------------------------------------------------
c                       PARAMETERS  hess AND inhess
C--------------------------------------------------------------------------
C
C      From the point of view of box9903, hess and inhess are two auxiliar
c      arrays. hess is double precision and inhess is integer. They can
c      be used in the subroutines phi and mapro to transmit Hessian information
c      between them (from phi to mapro) as explained above. The
c      number of positions reserved to hess and inhess must be sufficient
c      for the information that you want to transmit.
c
c----------------------------------------------------------------------------
c
c                         SUBROUTINE GUESS
c
c----------------------------------------------------------------------------
C
C     At each iteration of BOX, bound-constrained quadratic problems of
c     the form
c
c          Minimize grad(x^k) d + (1/2) d^T B_k d
c          subject to lint <= d <= uint
c
c     are solved by the subroutine Quacan. Here, B_k is an approximation
c     of the Hessian of the objective function used in BOX (the whole
c     augmented Lagrangian). Sometimes, experienced users know how to
c     compute good approximations to the solution of this subproblem,
c     independently of Quacan. In this case, the user sets the input 
c     parameter iguess equal to 1. In fact, in that case, Quacan is going
c     to take the approximation ``computed by the user'' as initial appro-
c     ximation for its own job. When you set iguess = 1, you must code
c     your way to compute the initial approximation to the solution of
c     the bound-constrained quadratic subproblem in the subroutine guess.
c     (In fact, since the name of the subroutine is a parameter, you can
c     give other name to the subroutine, as is the case with Phi and Mapro.
c     Consequently, you must also declare external the name of this subroutine
c     in your main code.)
c     The calling sequence of guess must be:
c
c     call guess(n, x, grad, ro, ra, lambda, mu, lint, uint, d)
c
c     where you must consider that n is the number of variables, x is
c     current point in the procedure commanded by BOX, grad is the gra-
c     dient of the objective function (Augmented Lagrangian) at x, lint
c     is the vector of lower bounds for d, uint is the vector of upper
c     bounds of d, ro is the penalty parameter associated to linear 
c     constraints, ra is the vector of penalty parameters associated
c     to nonlinear equality constraints, lambda is the vector
c     of multipliers associated to linear constraints, mu is the
c     vector of multipliers associated to nonlinear equality constraints,
c     Finally, d (the output) is the approximate solution to 
c     the bound-constrained quadratic subproblem computed by guess.
c     All real parameters in guess must be double precision. Probably,
c     for computing your approximation you could need additional information
c     on the current point. In this case, use common statements to make
c     the communication between Phi and Guess. Probably, all the relevant
c     information necessary for Guess has already been computed in Phi,
c     with modo=2. 
c     Even if you are setting iguess=0, you must include a subroutine
c     called guess in your main stack but, in this case, it will not be
c     called by BOX, so, it can consist only of the statements return
c     and end in order of not to disturb the compilation. It is enough,
c     in the case ``iguess=0'', that you include the statements
c                             subroutine guess
c                             return
c                             end
c
c
c-------------------------------------------------------------------------
c
c     PARAMETERS THAT DEFINE THE LINEAR AUGMENTED LAGRANGIAN TERM
C
c                            
C           lambda^T (A x - b) + (ro/2) || A x - b ||^2 
c
c
c
c     m, lambda, ro, ispar, nelem, inda, a, b are the input
c        parameters that define the augmented Lagrangian term.
c
c      m : number of rows of the matrix A. Set m=0 if there is no 
c          Lagrangian term at all
c
c
c      lambda : vector of m double precision positions given in the 
c          definition of the objective function L.
c
c      ro : real*8 number given in the definition of L
c
c      ispar : input integer parameter that can take the value 0 or 1
c              If ispar = 0, this means that the m x n matrix A is stored
c              in the array a columnwise, that is a(1,1), a(2,1), a(3,1),
c              ... a(m,1), a(1,2), a(2,2),...,a(m,2)...
c              You can use ispar=0 when there is not advantage on taking
c              into account sparsity of A. In other words, when you judge
c              that A is dense.
c              If ispar=1, this means that you give only the nonzero elements
c              of A, in the way explained below.
c
c      nelem : this input parameter is used only when ispar = 1. It
c              is the number of ``nonzero'' elements that you are reporting
c              for the matrix A.
c
c      inda : this input parameter is used only when ispar = 1. In
c             this case, it is an integer nelem x 2 array where you
c             must store, in any order, the pairs (i , j) such that the
c             corresponding element a_{ij} of the matrix A is different
c             from zero. 
c
c      a    :  If ispar=0, this array contains the entries of the matrix
c              A, stored columnwise (see ispar above). If ispar =1, this
c              array contains the nonzero elements of A in such a way
c              that a(k) = a_{ij} when the row k of inda is (i, j).
c
c      b    :  real*8 vector of m positions, mentioned in the definition
c              of L(x) above.
c
c ----------------------------------------------------------------------------
c             A SET OF PARAMETERS USED ONLY IN THE SUBROUTINE BOX
c ----------------------------------------------------------------------------

C
C     accuracy : accuracy demanded for quacan at its first call
c       within a box-iteration. The user must give this parameter belonging
C       to (0,1). We recommend to set accuracy = 0.1. If the
c       objective function f is quadratic we recommend accuracy=1.d-8
c       so that most the work will be executed by quacan. A small 
c       accuracy is also desirable if the problem is badly scaled.
c	Moreover, if the number of variables is small we prefer accuracy
c       very small since in this case the quadratic solver is not very
c       costly.
c
C     acumenor : accuracy demanded for quacan at subsequent calls
c       (not the first) 
c       within a box-iteration. The user must give this parameter belonging
C       to (0,1). We recommend to set acumenor=0.5. 
c	If the number of variables is small we prefer acumenor
c       very small since in this case the quadratic solver is not very
c       costly.
c
c     relarm, absarm: two input parameters that define when the trial
c       point is accepted. Namely, if Pred < 0 is the value of the approxi-
c       mating quadratic at its approximate minimizer and x+ is the corres-
c       ponding trial point, x+ is accepted as new point when
c
c              L(x+) \leq  L(x) +  max ( relarm * Pred,  -absarm)
c
c       We recommend relarm = 0.1, absarm = 1.d-6
c
c        
c
C     epsd : input parameter representing a tolerance for the trust
C       region radius used in BOX. See usage in the description of 
c       (istop = 4) below.
C       When BOX is unable to produce a decrease even with a trust
C       region of size epsd, this possibly  means that we are very close  
C       to a solution, which was not detected by the convergence criterion
C       based on the projected gradient because, perhaps, that stopping
c       parameter  was given  excessively small. 
c       Roughly speaking, BOX  returns because of the
C       (istop = 4) criterion, when the quadratic model restricted
C       to a ball of radius epsd is unable to produce a decrease of the
C       function. This is typical when a local minimizer occurs, but we
C       must be careful. We recommend to set epsd = 1.d-8. However, warning!
c       this is a dimensional parameter, you must take into account
c       the scaling (unit measures) of your problem. Roughly speaking,
c       epsd shoud be a NEGLIGIBLE DISTANCE in the x-space.
C
C     nafmax : Maximum allowed number of function evaluations at each
c       call of BOX. See  description of (istop = 2) below.
C
C     itmax : Maximum allowed number of iterations at each call of BOX.
C       See description of (istop = 3) below.
C
C     par : This parameter is used to define the size of the new trust
C       region radius and must be given by the user belonging to (1,10).
C       We recommend to set par = 4. See usage in the description of
C       deltamin below.
c
C     delta0 : This input parameter is the initial trust region radius at
C       the beginning of iteration zero. Warning! Delta0 is dimensional.
c       It should represent the radius of a ball centered on the initial
c       point where you reasonably expect to be the solution.
C
C     deltamin : This input parameter allows the subroutine to define
C       the trust region radius. In fact, at the beginning of an 
C       iteration, the trust region radius is defined by BOX to be 
c       not less than deltamin. Due to this choice, the
C       trust region radius can inherit more or less information from the 
C       previous iteration, according to the size of deltamin. deltamin can 
C       be a fraction of the diameter of the problem (1), provided that 
C       there are no artificial bounds. We recommend deltamin=delta0/100.
C
C     istop : This output parameter tells what happened in the last call
C       subroutine BOX (that is to say, the last outer iteration),
c       according to the following conventions:
C       istop = 0   ->  Convergence : 
C                       ||projected gradient||_\infty \leq eps.
C       istop = 1   ->  Convergence : 
C                       L(x) \leq ftol
C       istop = 2   ->  It is achieved the maximum allowed number of
C                       function evaluations (nafmax).
C       istop = 3   ->  It is achieved the maximum allowed number of
C                       iterations (Itmax).
C       istop = 4   ->  Strangled point, i.e. trust region radius less
C                       than epsd.
c
C       istop = 5   ->  Data error. A lower bound is greater than an
C                       upper bound.
c
c       istop = 6   ->  Some input parameter is out of its prescribed
c                       bounds
c
C       istop = 7   ->  The progress (L(x_k) - L(x_{k-1})) in the last 
C                       iteration is less than bont * (the maximum
C                       progress obtained in previous iterations)
c                       during kbont consecutive iterations.
c
C       istop = 8   ->  The order of the norm of the continuous 
c                       projected gradient did not change 
c                       during kauts consecutive
c                       iterations. Probably, we are asking for an 
c                       exagerately small norm of continuous projected
c                       gradient for declaring convergence.
c
C     bont, kbont : This parameters play the same role as dont and kdont do
c     for quacan. We also suggest to set bont = 0.01 together with kbont = 5.
C
c    kauts : If the order of the norm of the current 
c              continuous projected gradient did not change during 
c              kauts consecutive iterations the execution
c              stops with istop = 8. Recommended: kaustky = 10. In any
c              case kauts must be greater than or equal to 1. 
c
c     You must also set the following input quacan parameters:
c
c     dont : Positive number, less than 1, used for the second convergence
c       criterion by quacan, according to the description above. See
c       also the comments of the subroutine quacan.
c
c    eta: On input, number belonging to (0, 1) .
c        If eta is close to 1, faces are fully exploited before abandoning
c        them. If eta is close to 0, abandoning faces is frequent. We
c        recommend eta = 0.9.
c
c    factor: On input, real number greater than 1 (we recommend factor=5)
c           intended to improve the current trial guess through extrapo-
c           lation procedures. It is used in the subroutine Double. See
c           its comments.
c   mitqu: maximum number of iterations allowed on each call to quacan.
c   maxmv: maximum number of matrix-vector products allowed on each call
c          to quacan.
c    ipqua: printing parameter of quacan. If ipqua < 0, nothing is printed.
c                             If ipqua = 0, only a final summary is printed
c                             of each call of quacan.
c                             Otherwise, information on quacan
c                             iterations are  printed every
c                             ipqua iterations.
c
c
c     lint, uint, s, gq, gc, xn, gn, d: auxiliar double
c                    precision vector with n positions.
c     bd: auxiliar vector that must be dimensioned with n+1 positions
c       when m = 0 an with at least 2n+m real*8 positions when m > 0
c
c     ingc, infree: integer auxiliar vectors of n positions.
c
c ----------------------------------------------------------------------------
c             END OF ``A SET OF PARAMETERS USED ONLY IN THE SUBROUTINE BOX''
c ----------------------------------------------------------------------------

c
c      For consults relative to the use of this subroutine please contact:
c
c                      J. M. Martinez
c                     IMECC - UNICAMP
c                        C.P. 6065
c                    13081-970 Campinas SP
c                          Brazil
c                E-mail: martinez@ime.unicamp.br
c                   

	subroutine box9903 (n, m, nonlc, roinic, ra, rainic, indivi,
     *  facro, facra, ilag, iguess, epslin, epsnon, ratfea,
     *  maxout, konout, konint, nefint, itqint, mvpint, ierla, iprint, 
     *  x, l , u, fx, hres, hresan, res, grad,
     *  accuracy, acumenor, relarm, absarm, epsinic, epsdiv, epsfin,
     *  epsd, ftol, nafmax, itmax, par, delta0, deltamin, istop,
     *  bont, kbont, kauts, dont, kdont, eta, factor, 
     *  mitqu, maxmv, phi, mapro, guess, hess, inhess, iprbox,
     *  ipqua, lint, uint, s, gq, gc, bd, xn, gn, d, ingc, infree,
     *  mu, lambda,  ispar, nelem, inda, a, b)

	implicit double precision(a-h,o-z)
	external phi, mapro, guess
	double precision l(n), lint(n), lambda(*), mu(*)
	dimension x(n), u(n), grad(n), hess(*),  uint(n)
        dimension s(n), gq(n), gc(n), bd(*), xn(n), gn(n)
	dimension d(n), ingc(n), infree(n), inda(*)
	dimension a(*), b(*)
	dimension res(*), hres(*)
	dimension inhess(*)
	dimension rainic(*), ra(*)
	dimension hresan(*)


	do i = 1, n
	if(l(i).ge.u(i)) then
	istop = 6
	write(*, *)' Lower bound',i,' not smaller than upper bound'
	write(10, *)' Lower bound',i,' not smaller than upper bound'
	return
	endif
	if(x(i).lt.l(i)) x(i) = l(i)
	if(x(i).gt.u(i)) x(i) = u(i)
	end do
	

c
	if(iprint.ge.0)then
	n10 = min0(n, 10)
	m10 = min0(m, 10)
	nlc10 = min0(nonlc, 10)
	endif
c
c       We set the initial vectors of multipliers equal to zero
c
c       We set the initial penalty parameters equal to the ones 
c       indicated by the user
c
	if(nonlc.gt.0)then
	do  i = 1, nonlc
	ra(i) = rainic(i)
	mu(i) = 0.d0
	end do
	endif

	if(m.gt.0) then
	do  i =1,m
	lambda(i) = 0.d0
	end do
	ro = roinic
	endif

c
c       konout is the counter of outer iterations
c
        konout = 0
c
c
c      Initialization of counters of inner iterations, function evaluations,
c      quacan-iterations and matrix-vector products
c
	konint = 0
	nefint = 0
	itqint = 0
	mvpint = 0
c
c      Evaluations at the initial point
c

        call phi (n, nonlc, x, mu, ra, flagra,
     *           fx, grad, hres, hess, inhess, 1 )


	if(m.gt.0) call pena(n, x, flagra, grad, res, 
     *   m, ilag, lambda, ro, ispar, nelem, inda, a, b, bd, 1)


	if(nonlc.gt.0) then
	hnor = 0.d0
	do i = 1, nonlc
	hnor = dmax1(hnor, dabs(hres(i)))
	hresan(i) = dabs(hres(i))
	end do	
	hnoran = hnor
	endif

	if(m.gt.0) then
	anor = 0.d0
	do i = 1, m
	anor = dmax1(anor, dabs(res(i)))
	end do
	anoran = anor
	endif


	if(iprint.ge.0) then 
	write(10,*)
	write(*,*)
	write(10,*)'                           OUTPUT OF BOX9903'
	write(10,*)
c
	write(*,*)'                            OUTPUT OF BOX9903'
	write(*,*)
	write(*,*)

	call imprimir (n10, m10, nlc10, nonlc, 
     *     konout, x, istop, konint, nefint, eps, 
     *     itqint, mvpint, anor, hnor, 
     *     ra, ro, mu, lambda, flagra, fx)

	endif
c

c
c   At the first call to box, we set eps = epsinic
c
	eps = epsinic


10	call box (n, x, l , u, iguess, flagra, fx, hres, res,
     *  grad, accuracy, acumenor, relarm, absarm, eps, epsd, ftol,
     *  nafmax, itmax, kont, naf, iqua, mvp, par, 
     *  delta0, deltamin, istop, bont, kbont, kauts,
     *  dont, kdont, eta, factor, 
     *  mitqu, maxmv, phi, mapro, guess, hess, inhess, iprbox, ipqua, 
     *  lint, uint, s, gq, gc, bd, xn, gn, d, ingc, infree,
     *  nonlc, mu, ra, 
     *  m, lambda, ro, ispar, nelem, inda, a, b)





c
c     Increment counters of outer iterations, 
c     inner (BOX)-iterations, evaluations, quacan-iterations
c     and matrix-vector products
c
	konout = konout + 1
	konint = konint + kont
	nefint = nefint + naf
	itqint = itqint + iqua
	mvpint = mvpint + mvp
c


	hnor=0.d0
	if(nonlc.gt.0)then
	do  i=1,nonlc
	hnor=dmax1(hnor, dabs(hres(i)))
	end do
	endif


	anor=0.d0
	if(m.gt.0)then
	do  i =1,m
	anor = dmax1(anor, dabs(res(i)))
	end do
	endif


c   If ilag = 1, update the Lagrange multiplier estimators
c
	if(ilag.eq.1)then

	if(nonlc.gt.0)then

	do  i=1,nonlc
	mu(i)=mu(i) + ra(i) * hres(i)
	end do

	endif
c
c
	if(m.gt.0)then

	do  i=1,m
	lambda(i) = lambda(i) + ro * res(i)
	end do

	endif

	endif

c   Printing session

	if(iprint.gt.0. and. mod(konout, iprint).eq.0)then
	call imprimir (n10, m10, nlc10, nonlc, 
     *     konout, x, istop, konint, nefint, eps, 
     *     itqint, mvpint, anor, hnor, 
     *     ra, ro, mu, lambda, flagra, fx)
	endif


c    Terminate if feasibility was achieved
	if(eps.le.epsfin) then
	if((hnor.le.epsnon.or.nonlc.le.0).and.
     *   (anor.le.epslin.or.m.eq.0))then
	ierla = 0
	if(iprint.lt.0)return
	write(10,*)
	write(10,*)' Feasibility was achieved.'
	write(*,*)
	write(*,*)' Feasibility was achieved.'
	if(iprint.gt.0. and. mod(konout, iprint).eq.0)return
	call imprimir (n10, m10, nlc10, nonlc, 
     *     konout, x, istop, konint, nefint, eps, 
     *     itqint, mvpint, anor, hnor, 
     *     ra, ro, mu, lambda, flagra, fx)
	return
	endif
	endif

c     Terminate if number of allowed outer iterations is exhausted
	if(konout.ge.maxout) then 
	ierla = 1 
	if(iprint.lt.0)return
	write(10,*)
	write(10,*)' Maximum number  of outer  iterations achieved.'
	write(*,*)
	write(*,*)' Maximum number of outer iterations achieved.'
	if(iprint.gt.0. and. mod(konout, iprint).eq.0)return
	call imprimir (n10, m10, nlc10, nonlc, 
     *     konout, x, istop, konint, nefint, eps, 
     *     itqint, mvpint, anor, hnor, 
     *     ra, ro, mu, lambda, flagra, fx)
	return
	endif
c
c     Updating penalty parameters corresponding to
c     the nonlinear equality constraints
c
	if(nonlc.gt.0)then
         if(indivi.eq.1)then

	do  i = 1, nonlc
c   Update, separately, penalty parameters corresponding to nonlinear
c   constraints
c   Increase the penalty parameter
c   only if feasibility was not greatly improved
          if(dabs(hres(i)) .gt. ratfea * hresan(i)) then
            ra(i) = facra * ra(i)
            endif

c   Save the vector of constraints at the present iteration, to be used
c   in the following one
	   hresan(i) = dabs(hres(i))
	end do

	else

c   Case indivi .ne. 1. All the nonlinear penalty parameters are 
c   updated together

	if(hnor.gt. ratfea * hnoran) then
c   At subsequent iterations update the penalty parameter if feasibility
c   was not greatly improved
	do  i=1,nonlc
	ra(i) = facra * ra(i)
	end do
	endif
c   Save the norm of the vector of constraints to be used at subsequent
c   iterations
	hnoran = hnor	
	endif 
	endif

	if(m.gt.0)then
c   Update the penalty parameter ro if we are at the first iteration or
c   if linear feasibility was not greatly improved
	if(anor .gt. ratfea * anoran) then
	ro = facro * ro
	endif
c   Save the norm of the vector of linear constraints, to be used at
c   subsequent iterations
	anoran = anor
	endif
c
c   Compute the convergence parameter that will be used by Box at
c   the next outer iteration, as an interpolation between epsinic and
c   epsfin
c
	eps = dmax1(eps/epsdiv, epsfin)
	
c   Perform a new outer iteration
	goto 10

	end




	subroutine imprimir(n10, m10, nlc10, nonlc, 
     *    konout, x, istop, konint, nefint, eps, 
     *    itqint, mvpint, anor, hnor, 
     *    ra, ro, mu, lambda, flagra, fx)

c    Printing subroutine of box9903

	implicit double precision (a-h, o-z)
	dimension x(*)	
	double precision lambda(*), mu(*), ra(*)

	write(10,*)
	write(10,*) ' Outer Augmented Lagrangian iteration :', konout
	write(10,*) ' (First 10) components of the current point:'
	write(10,*) (x(i), i=1, n10)

	write(*,*)
	write(*,*) ' Outer Augmented Lagrangian iteration :', konout
	write(*,*) ' (First 10) components of the current point:'
	write(*,*) (x(i), i=1, n10)


	if(m10.gt.0)then
	if(konout.ne.0) then
	write(10,*) ' (First 10) components of lambda:'
	write(10,*) (lambda(i), i=1, m10)
	write(10,*) ' Penalty parameter used for linear constraints:',
     *     ro
	write(*,*) ' (First 10) components of lambda:'
	write(*,*) (lambda(i), i=1, m10)
	write(*,*) ' Penalty parameter used for linear constraints:',
     *     ro
	endif
	endif

	if(nlc10.gt.0)then
	if(konout.ne.0) then

	write(10,*) ' (First 10) nonlinear equality multipliers:'
	write(10,*) (mu(i), i=1, nlc10)
	write(10,*) ' Penalty parameters used for nonlinear equality', 
     *  ' constraints (first 10):'
	write(10,*) (ra(i), i=1, nlc10)


	write(*,*) ' (First 10) nonlinear equality multipliers:'
	write(*,*) (mu(i), i=1, nlc10)
	write(*,*) ' Penalty parameters used for nonlinear equality', 
     *  ' constraints (first 10):'
	write(*,*) (ra(i), i=1, nlc10)

	ramax = 0.d0
	ramin = ra(1)
	do  i = 1, nonlc
	ramin = dmin1(ramin, ra(i))
	ramax = dmax1(ramax, ra(i))
	end do

	write(10,*)' Maximum nonlinear equality penalty parameter',
     *   ' used:',ramax
	write(10,*)' Minimum nonlinear equality penalty parameter',
     *    ' used:',ramin


	write(*,*)' Maximum nonlinear equality penalty parameter',
     *   ' used:',ramax
	write(*,*)' Minimum nonlinear equality penalty parameter',
     *    ' used:',ramin

	endif
	endif



	if(konout.ne.0) then
	write(10,*)' Diagnostic of BOX at this iteration:', istop
	write(10,*)' Convergence epsilon used in Box:', eps
	write(10,*)' Total number of BOX-iterations:', konint
	write(10,*)' Total number of function evaluations:', nefint
	write(10,*)' Total number of quacan-iterations:', itqint
	write(10,*)' Total number of matrix-vector products:', mvpint


	write(*,*)' Diagnostic of BOX at this iteration:', istop
	write(*,*)' Convergence epsilon used in Box:', eps
	write(*,*)' Total number of BOX-iterations:', konint
	write(*,*)' Total number of function evaluations:', nefint
	write(*,*)' Total number of quacan-iterations:', itqint
	write(*,*)' Total number of matrix-vector products:', mvpint

	endif


	if(m10.gt.0) then
	write(*,*)' Sup norm of A x - b:', anor
	write(10,*)' Sup norm of A x - b:', anor
	endif
	if(nlc10.gt.0) then
	write(*,*)' Maximum violation of nonlinear equality ',
     *  ' constraints :', hnor
	write(10,*)' Maximum violation of nonlinear equality ',
     *  ' constraints :', hnor
	endif

	write(10,*)' Value of the objective function:', fx
	write(10,*)' Value of the augmented Lagrangian function:',flagra

	write(*,*)' Value of the objective function:', fx
	write(*,*)' Value of the augmented Lagrangian function:',flagra



	return
	end




	
C--------------------------------------------------------------------
C                                               February 1997
C

	subroutine box (n, x, l , u, iguess, flagra, fx, hres,
     *  res, grad, accuracy, acumenor, relarm, absarm, 
     *  eps, epsd, ftol, nafmax, itmax, kont, naf, iquatot, mvptot,
     *  par, delta0, deltamin, istop, bont, kbont, kauts,
     *  dont, kdont, eta, factor, mitqu, maxmv, phi, mapro, guess, hess, 
     *  inhess, ipr, ipqua, lint, uint, s, gq, gc, bd, xn, gn, d, ingc,
     *  infree, nonlc, mu, ra, m, lambda, ro, ispar,
     *  nelem, inda, a, b)

C
C       This subroutine solves the problem
C
C                           Minimize L(x)
C                          s.t. l <= x <= u                        (1)
c
c                            where L(x) =
c
c                         f(x) +  mu^T h(x) + 
c
c              + (1/2) Sum_{i=1}^{nonlc} ra(i) [h(x)]_i^2 +
c          
c
c             +  lambda^T (A x - b) + (ro/2) ||A x - b||_2^2
c
c
c       f:\R^n \to \R, h:\R^n \to \R^{nonlc}, 
c       are differentiable, A is an m x n matrix, b \in \R^m,
c       mu \in \R^{nonlc}, ra \in \R^nonlc}, 
c       lambda \in \R^m and ro is a real number.
c
c
c       (That is, L(x) has the form of an augmented Lagrangian of f, for
c       nonlinear constraints of the form h(x) = 0, and 
c       linear constraints of the form A x = b, where A is a matrix of
c       m rows and n columns.) 
C
C       We assume that  l and u are finite n-dimensional bounds.
C
C       The method used to solve (1) is described in
C
C       A. Friedlander, J. M. Martinez and S. A. Santos [1994]: "A new
C       trust-region strategy for box-constrained minimization", 
C       Applied Mathematics and Optimization  30 (1994) 235-266.
c       This algorithm has been modified several times after 1992. 
c
C       The main features of the method are the following:
C
C       a) At each iteration k, the following quadratic approximation
C       of L(x) is considered:
C
C   q(x) = L(x^k) + grad(x^k)^T (x - x^k) + (1/2)(x - x^k)^T B_k (x - x^k)
C       
C       where grad(x) is the gradient of L at x, and B_k is an L-Hessian 
C       approximation (not necessarily positive semidefinite). A sequence
C       of subproblems of the form
C
C                      Minimize q(x) s.t. box_k                        (2)
C
C       is solved  approximately until the solution of (2) satisfies a  
C       decrease condition. Then this solution is chosen as x^{k+1}.
C       The size of box_k depends on the natural bounds of the
C       problem , as well as on a trust-region size. The trust region
C       size is decreased each time the sufficient decrease condition 
C       is not satisfied.
C
C       b) The approximate solution of (2) uses the subroutine quacan,
C       which is a bound constrained not necessarily positive 
c       semidefinite quadratic solver.
C       Given an initial approximation, quacan guarantees
C       to produce an approximation to the solution of (2) where the 
C       two-norm of the projected gradient of q , is as small as 
C       desired. In fact, the degree of accuracy desirable in the solution
C       of (2) is one of the main parameters of BOX, and the
C       best choice is currently under discussion. The stopping criterion
C       in (2) is
C
C       ||Projected gradient of the quadratic||_2
c             <= accuracy * ||Projected gradient of L at x^k||_2      (3)
C       
C       where accuracy < 1 represents the degree of accuracy required. 
c	At the first call of quacan at each iteration the precision used
c       is accuracy. At the subsequent calls of quacan within a box-iteration
c       we used the precision acumenor instead of accuracy. The idea
c       is that accuracy should be less than or equal to accumenor, since
c       a great precision in quacan is only justified at the first call,
c       when we have the chance to take (nearly) full-Newton steps.
c       
c       In april 1992 it was suggested by numerical
c       experiments that acc = 0.1 was a good choice. In november 1995
c       it was observed that, for badly scaled problems, values of acc
c       close to 0 are better. The reason is that Newton's method is invariant
c       to scaling and the criterion (3) makes the iteration close to
c       the Newton iteration when acc is close to 0.
c       The parameter acumenor, as different from accuracy, was introduced
c       in September 1996. We suggest accuracy = 1.e-3, acumenor=0.1.
c       However, this depends on the cost of quacan calls. If the number
c       of variables is small, calls to quacan are cheap. In this
c       case we recommend accuracy = acumenor = 1.e-8.
c       In some experiments in september  1996 the best accuracy was 0.1
c       associated to acumenor = 0.5.
C       In november 1995, we incorporated a second stopping criterion
c       for quacan. Namely, quacan stops also when the progress obtained
c       within the current iteration is less than dont*(the best progress
c       obtained by quacan iterations before the current one) during
c       kdont consecutive quacan iterations. Of course
c       this stopping criterion may be inhibited setting dont = 0. We
c       recommend, preliminary, to set dont = 0.01 and kdont = 5. Perhaps
c       kdont should also be dependent on n, to give a chance to the con-
c       vergence of the conjugate gradient method, that is within quacan.
C       In the description of the parameters of the subroutine we shall
C       have the opportunity of describing further characteristics of
C       the method.
C
C
C       REMARK!
C                For running this code in a PC, you will perhaps need
C       to set the card $large  at the beginning of the main program.
C       The aim of such a command is to expand 
C       memory.
C
C
C     Parameters:
c
C     iguess: Sometimes, due to the characteristics of your problem,
c       you can compute a guess of the solution of the quadratic 
c       subproblem that must be solved by Quacan, at each iteration 
c       of BOX. If this is the case, set iguess = 1, otherwise, set
c       iguess = 0. If you set iguess = 1 you need to write the sub-
c       routine guess, that computes your especial approximation to
c       the solution of the quadratic subproblem. See the comments on
c       the subroutine guess.
C
C     ipr : Control for printing in BOX. If ipr< 0 nothing is printed
c       in BOX. If ipr=0, only a
C       final summary is printed. If ipr > 0, information every ipr 
C       iterations is printed. 
C
C     n  : Dimension of problem
C
C     x : On entry, initial approximation to the solution of (1), provided
C       by the user. Remember that l <= x <= u. If these bounds do
c       not hold for your x, BOX projects your initial x on the box.
c         On exit, x is the final approximation
C       to the solution of (1), obtained by BOX.
C
C
C     l , u : On entry, these two double precision vectors are
C       the bounds of problem (1). That is, they are the l and the u of (1)
C       respectively.
C
C     flagra :  On exit, value of the objective function  L(x).
c
c     fx: On exit, value of f(x).
c
C     grad :  On exit, g is the gradient of L at the final point.
c
c     nonlc: number of components of h. (nonlc means ``nonlinear constraints'')
c
C     mu: input vector with nonlc components, that contributes to 
c     define the objective function.
c
c
c     ro: real*8 parameter
c            that contribute to define the objective function. 
c
c     ra: on input, double precision vector with at least nonlc positions
c         that contributes to the definition of the objective
c         function. If nonlc=0, you must dimension ra with 1 position.
c
c
c     mu, lambda: real*8 nonlc- and m- vectors (respectively)
c          that contribute to define the objective function.
c
c
c
c     res: On exit, when m is not 0, residual vector A x - b.
c
c     hres: On exit, when nonlc is not 0, nonlinear residual h(x).
c
c---------------------------------------------------------------------------
c
c             SUBROUTINES phi AND MAPRO, THAT DEFINE Phi(x),     
c
c
c              ITS GRADIENT, AND ITS HESSIAN APPROXIMATION
C
C       The user must provide a subroutine named phi for computing
C       the function value 
c
c                             Phi(x) =
c
c                
c                     =  f(x) +  mu^T h(x) + 
c
c              + (1/2) Sum_{i=1}^{nonlc} ra(i) h_i(x)^2  ,
c          
c
c       the gradient of Phi(x) and the information relative to the 
c       Hessian approximation of Phi(x).
c
C       The calling sequence of phi is
C
C     call phi (n, nonlc,  x, mu,  ra,  flagra,
c           fx, grad, hres, hess, inhess, modo )
C
C       where n is the number of variables, nonlc is the number of
c       components of h, 
c       x is the point where the  function is calculated within phi, 
c       mu, ra  are the other input parameters necessary
c       for computing Phi(x).
c       As output, phi must produce flagra (Phi(x)), fx (f(x)), 
C       grad, the gradient of the function Phi computed at x, hres 
c       (the nonlinear vector of residuals  h(x)), 
c       Finally, hess and inhess 
c       inhess are arrays that can contain the information relative
c       to the Hessian approximation. 
C       You can choose the name for the subroutine phi. For this
C       reason, phi is a parameter of BOX. In the calling
C       program, the name actually used must be declared EXTERNAL. 
C       If modo = 1, phi must compute ONLY the function 
c       values flagra and fx and the
c       vectors of nonlinear residuals hres and gres,
c       which, of course, are by-products of the computation of the 
c       function value flagra.
C       If modo = 2, phi must compute ONLY the gradient at
c       the point x and the information relative to the Hessian.
c       Now, you can take
c       advantage of the common calculations to function and gradient-
c       Hessian observing that a call to phi with modo=2 is always
c       preceeded, in BOX, by a call to phi with modo=1 at the same
c       point. So, you can prepare information inside phi in such a way
c       that calculations for modo=2 are already done, and you do not
c       need to begin from scratch. In particular, for computing the
c       gradient, you will need the nonlinear residuals hres and gres.
c       So, you can use it freely.
C       You can choose the data structure for the Hessian
c       information provided that it fits in the arrays inhess and 
c       hess. This information must be compatible with the coding of
c       user supplied subroutine mapro, commented below.
c       In previous versions of BOX it was assumed that the communication
c       of Hessian information between phi and mapro was coded through
c       COMMON statements. We think that passage through parameters is
c       less prone to errors, so we decided to introduce the new 
c       parameters hess and inhess in 1995. However, if you
c       find easier to make the communication by COMMON, you can do it
c       disregarding the existence of Hess and Inhess. However, do not
c       forget to dimension them.
c
c       Helping your memory:
c
c   The gradient of the objective function Phi(x) considered here is
c
c  \nabla f(x) +  Sum_{i=1}^{nonlc} (mu(i) + ra(i) h_i(x) \nabla h_i(x) 
c
c
c   The Hessian is
c
c  \nabla^2 f(x) + Sum_{i=1}^{nonlc} ra(i) \nabla h_i(x) \nabla h_i(x)^T +
c
c     + Sum_{i=1}^{nonlc} [mu(i) + ra(i) h_i(x)] \nabla^2 h_i(x)
C
c
C       You must also provide the subroutine mapro. As in the case
C       of phi , you can choose the name of this subroutine, which, for
C       this reason, must be declared EXTERNAL in the calling program.
C       mapro is called only from quacan. As a result, it is also
C       a parameter of quacan, and it is declared EXTERNAL in BOX 
C       subroutine. The calling sequence of mapro is
C
C               call mapro (n, nind, ind, u, v, hess, inhess )
C       
C       where n (the number of variables) and u (a double precision vector
C       of n positions) are the main inputs, and v, a double precision
c       vector of n positions is the output. v must be the product H * u,
c       where
C       H is the current Hessian approximation of the function Phi(x).
c       That is, H is the last  computed Hessian approximation of Phi(x)
c       within the subroutine phi. 
c       Therefore, mapro
C       must be coded in such a way that the structure given for this
C       matrix within phi is compatible with formulae for the product.
c       Moreover, if nind < n (both input parameters), the integer vector
c       ind, with nind positions, contains the indices where the input
c       u is different from zero. So, you can take advantage of this 
c       information to write the matrix-vector product, but if you do
c       not know how to do it, simply ignore nind and ind and write the
c       matrix vector product as if u were a dense vector. The algorithm
c       will be the same, but taking advantage of nind and ind makes it
c       faster. 
c       Many times, you will find the task of coding the information
c       relative to the Hessian very cumbersome. You can use a 
c       ``directional finite difference'' version of mapro instead of
c       products with true Hessians. The idea is that, at the current
c       point x, the product H u is the limit of 
c 
c               [Gradient(x + t u) - Gradient(x) ] / t
c
c       Using this directional derivative idea, you can code mapro 
c       passing, within hess, the current point x and the current 
c       gradient g to mapro. Then, you use, say, 
c
c       t = max ( 1.d-20, 1.d-8 ||x||_\infty ) / || d ||_\infty
c
c       provided that d \neq 0, of course.
c
c      So, in this case you evaluate the Gradient 
c      at the auxiliary point x + t u and 
c      finally, you use the quotient above to approximate H u. There
c      are some risks using this device, but you can try.
c
C--------------------------------------------------------------------------
c
c                         SUBROUTINE GUESS
C
C     At each iteration of BOX, bound-constrained quadratic problems of
c     the form
c
c          Minimize grad(x^k) d + (1/2) d^T B_k d
c          subject to lint <= d <= uint
c
c     are solved by the subroutine Quacan. Here, B_k is an approximation
c     of the Hessian of the objective function used in BOX (the whole
c     augmented Lagrangian). Sometimes, experienced users know how to
c     compute good approximations to the solution of this subproblem,
c     independently of Quacan. In this case, the user sets the input 
c     parameter iguess equal to 1. In fact, in that case, Quacan is going
c     to take the approximation ``computed by the user'' as initial appro-
c     ximation for its own job. When you set iguess = 1, you must code
c     your way to compute the initial approximation to the solution of
c     the bound-constrained quadratic subproblem in the subroutine guess.
c     (In fact, since the name of the subroutine is a parameter, you can
c     give other name to the subroutine, as is the case with Phi and Mapro.
c     Consequently, you must also declare external the name of this subroutine
c     in your main code.)
c     The calling sequence of guess must be:
c
c     call guess(n, x, grad, ro, ra, lambda, mu, lint, uint, d)
c
c     where you must consider that n is the number of variables, x is
c     current point in the procedure commanded by BOX, grad is the gra-
c     dient of the objective function (Augmented Lagrangian) at x, lint
c     is the vector of lower bounds for d, uint is the vector of upper
c     bounds of d, ro is the penalty parameter associated to linear 
c     constraints, ra is the vector of penalty parameters associated
c     to nonlinear equality constraints, 
c     lambda is the vector of multipliers associated to linear constraints,
c     mu is the  vector of multipliers associated to nonlinear equality 
c     constraints,
c     Finally, d (the output) is the approximate solution to 
c     the bound-constrained quadratic subproblem computed by guess.
c     All real parameters in guess must be double precision. Probably,
c     for computing your approximation you could need additional information
c     on the current point. In this case, use common statements to make
c     the communication between Phi and Guess. Probably, all the relevant
c     information necessary for Guess has already been computed in Phi,
c     with modo=2. 
c     Even if you are setting iguess=0, you must include a subroutine
c     called guess in your main stack but, in this case, it will not be
c     called by BOX, so, it can consist only of the statements return
c     and end in order of not to disturb the compilation. It is enough,
c     in the case ``iguess=0'', that you include the statements
c                             subroutine guess
c                             return
c                             end
c
c
c-------------------------------------------------------------------------
c
c         PARAMETERS THAT DEFINE THE LINEAR AUGMENTED LAGRANGIAN TERM
C
c                            
C                lambda^T (A x - b) + (ro/2) || A x - b ||^2 
c
c
c
c     m, lambda, ro, ispar, nelem, inda, a, b are the input
c        parameters that define the augmented Lagrangian term.
c
c      m : number of rows of the matrix A. Set m=0 if there is no 
c          Lagrangian term at all
c
c
c      lambda : vector of m double precision positions given in the defini-
c          tion of the objective function L.
c
c 
c      ro : real*8 number given in the definition of L
c
c      ispar : input integer parameter that can take the value 0 or 1
c              If ispar = 0, this means that the m x n matrix A is stored
c              in the array a columnwise, that is a(1,1), a(2,1), a(3,1),
c              ... a(m,1), a(1,2), a(2,2),...,a(m,2)...
c              You can use ispar=0 when there is not advantage on taking
c              into account sparsity of A. In other words, when you judge
c              that A is dense
c              If ispar=1, this means that you give only the nonzero elements
c              of A, in the way explained below.
c
c      nelem : this input parameter is used only when ispar = 1. It
c              is the number of ``nonzero'' elements that you are reporting
c              for the matrix A.
c
c      inda : this input parameter is used only when ispar = 1. In
c             this case, it is an integer nelem x 2 array where you
c             must store, in any order, the pairs (i , j) such that the
c             corresponding element a_{ij} of the matrix A is different
c             from zero. 
c
c      a    :  If ispar=0, this array contains the entries of the matrix
c              A, stored columnwise (see ispar above). If ispar =1, this
c              array contains the nonzero elements of A in such a way
c              that a(k) = a_{ij} when the row k of inda is (i, j).
c
c      b    :  real*8 vector of m positions, mentioned in the definition
c              of L(x) above.
c
C-------------------------------------------------------------------------
C
C     accuracy : accuracy demanded for quacan at its first call
c       within a box-iteration. The user must give this parameter belonging
C       to (0,1). We recommend to set Accuracy = 0.001. If the
c       objective function f is quadratic we recommend accuracy=1.d-8
c       so that most the work will be executed by quacan. A small 
c       accuracy is also desirable if the problem is badly scaled.
c	Moreover, if the number of variables is small we prefer accuracy
c       very small since in this case the quadratic solver is not very
c       costly.
c
C     acumenor : accuracy demanded for quacan at subsequent calls
c       (not the first) 
c       within a box-iteration. The user must give this parameter belonging
C       to (0,1). We recommend to set acumenor=0.1. 
c	If the number of variables is small we prefer acumenor
c       very small since in this case the quadratic solver is not very
c       costly.
c
c     relarm, absarm: two input parameters that define when the trial
c       point is accepted. Namely, if Pred < 0 is the value of the approxi-
c       mating quadratic at its approximate minimizer and x+ is the corres-
c       ponding trial point, x+ is accepted as new point when
c
c              L(x+) \leq  L(x) +  max ( relarm * Pred,  -absarm)
c
c       We recommend relarm = 0.1, absarm = 1.d-6
c
c        
C     eps : Input parameter given by the user for deciding convergence. 
c       Convergence is declared if the euclidean norm of the 
c       ``continuous projected gradient'' is less than or equal to eps.
c       The continuous projected gradient at x is defined as the
c       difference between the projection on the box of x - grad(x) and
c       x       ( Proj [ x - grad(x)] - x )
c
C     epsd : Input parameter given by the user which gives tolerance for trust
C       region radius. See usage in the description of (istop = 4) below.
C       When the method is unable to produce a decrease even with a trust
C       region of size epsd, this possibly  means that we are very close  
C       to a solution, which was not detected by the convergence criterion
C       based on the projected gradient because, perhaps, epsg was given
C       excessively small. Roughly speaking, BOX  returns because of the
C       (istop = 4) criterion, when the quadratic model restricted
C       to a ball of radius epsd is unable to produce a decrease of the
C       function. This is typical when a local minimizer occurs, but we
C       must be careful. We recommend to set epsd = 1.d-8. However, warning!
c       this is a dimensional parameter, you must take into account
c       the scaling (unit measures) of your problem. Roughly speaking,
c       epsd shoud be a NEGLIGIBLE DISTANCE in the x-space.
C
C     ftol : Input parameter given by the user which gives tolerance for
C       objective function L. 
c       See usage in the description of (istop = 1) below.
C
C
C     nafmax : Maximum allowed number of function evaluations. See 
C       description of (istop = 2) below.
C
C     itmax : Maximum allowed number of iterations. See description of
C       (istop = 3) below.
C
c
C     kont : Number of iterations performed by BOX.
C
C     naf : Number of function evaluations performed in BOX.
c
c     iquatot: Total number of iterations performed by the subroutine
c              quacan
c     
c     mvptot: Total number of matrix-vector products done within the 
c             subroutine quacan
c
C     par : This parameter is used to define the size of the new trust
C       region radius and must be given by the user belonging to (1,10).
C       We recommend to set par = 4. See usage in the description of
C       deltamin below.
c
C     delta0 : This input parameter is the initial trust region radius at
C       the beginning of iteration zero. Warning! Delta0 is dimensional.
c       It should represent the radius of a ball centered on the initial
c       point where you reasonably expect to be the solution.
C
C     deltamin : This input parameter allows the subroutine to define
C       the trust region radius. In fact, at the beginning of an 
C       iteration, the trust region radius is defined by BOX to be 
c       not less than deltamin. Due to this choice, the
C       trust region radius can inherit more or less information from the 
C       previous iteration, according to the size of deltamin. deltamin can 
C       be a fraction of the diameter of the problem (1), provided that 
C       there are no artificial bounds. We recommend deltamin=delta0/100.
C
C     istop : This output parameter tells what happened in this 
C       subroutine, according to the following conventions:
C       istop = 0   ->  Convergence : 
C                       ||projected gradient||_\infty \leq eps.
C       istop = 1   ->  Convergence : 
C                       L(x) \leq ftol
C       istop = 2   ->  It is achieved the maximum allowed number of
C                       function evaluations (nafmax).
C       istop = 3   ->  It is achieved the maximum allowed number of
C                       iterations (Itmax).
C       istop = 4   ->  Strangled point, i.e. trust region radius less
C                       than epsd.
c
C       istop = 5   ->  Data error. A lower bound is greater than an
C                       upper bound.
c
c       istop = 6   ->  Some input parameter is out of its prescribed
c                       bounds
c
C       istop = 7   ->  The progress (L(x_k) - L(x_{k-1})) in the last 
C                       iteration is less than bont * (the maximum
C                       progress obtained in previous iterations)
c                       during kbont consecutive iterations.
c
C       istop = 8   ->  The order of the norm of the continuous 
c                       projected gradient did not change 
c                       during kauts consecutive
c                       iterations. Probably, we are asking for an 
c                       exagerately small norm of continuous projected
c                       gradient for declaring convergence.
c
C     bont, kbont : This parameters play the same role as dont and kdont do
c     for quacan. We also suggest to set bont = 0.01 whenever BOX is used in a
C       iteratively way (e.g. in an Augmented Lagrangian or SQP
c       context), together with kbont = 5 .
C       Otherwise, we recommend to inhibit this parameter, using 
C       bont = 0.0.
C
c    kauts : If the order of the norm of the current 
c              continuous projected gradient did not change during 
c              kauts consecutive iterations the execution
c              stops with istop = 8. Recommended: kaustky = 10. In any
c              case kauts must be greater than or equal to 1. 
c
c     You must also set the following input quacan parameters:
c
c     dont : Positive number, less than 1, used for the second convergence
c       criterion by quacan, according to the description above. See
c       also the comments of the subroutine quacan.
c
c    eta: On input, number belonging to (0, 1) .
c        If eta is close to 1, faces are fully exploited before abandoning
c        them. If eta is close to 0, abandoning faces is frequent. We
c        recommend eta=0.1.
c
c    factor: On input, real number greater than 1 (we recommend factor=5)
c           intended to improve the current trial guess through extrapo-
c           lation procedures. It is used in the subroutine Double. See
c           its comments.
c   mitqu: maximum number of iterations allowed on each call to quacan.
c   maxmv: maximum number of matrix-vector products allowed on each call
c          to quacan.
c    ipqua: printing parameter of quacan. If ipqua < 0, nothing is printed.
c                             If ipqua = 0, only a final summary is printed
c                             of each call of quacan.
c                             Otherwise, information on quacan
c                             iterations are  printed every
c                             ipqua iterations.
c
c
c     lint, uint, s, gq, gc, xn, gn, d: auxiliar double
c                    precision vector with n positions.
c     bd: auxiliar vector that must be dimensioned with n+1 positions
c       when m = 0 an with at least 2n+m real*8 positions when m > 0
c
c     ingc, infree: integer auxiliar vectors of n positions
c

	implicit double precision (a-h, o-z)
	double precision l(n), lint(n), lambda(*), mu(*)
C
	dimension x(n), u(n), grad(n), hess(*), inhess(*)
	dimension uint(n), s(n)
	dimension gq(n), gc(n), bd(*), xn(n), gn(n)
	dimension d(n), ingc(n), infree(n)
	dimension a(*), b(*), inda(nelem,2)
	dimension res(*), hres(*), ra(*)

C
	external phi, mapro

c       open (unit = 10,file = 'box.sai')

c    We set the quacan parameter ichan equal to 1. In this way, at each
c    quacan call, quacan will test if the initial approximation given
c    is better than the null initial approximation. If it is not, the
c    initial approximation (increment) given to quacan will be automatically
c    replaced by the null vector.
	ichan = 1
c    nrepl is a counter of the number of times that the quadratic model
c    was replaced by the easy-quadratic model due to insufficient decrease of
c    the quadratic model.
c    The easy-quadratic model of the function is defined here as 
c    qeasy(d) = g^T d + ||d||^2 / 2, therefore, its solution is the 
c    projection of -g on the trust-region box
c
	reg = 0
	nkauts = 0
	nrepl = 0
	if(ipr.ge.0)then
	write(10,*)
	write(10,*)'                         OUTPUT OF BOX'
	write(10,*)
	n10=amin0(n,10)
	endif
c
c    Check whether input parameters are correct
c
	if(n.le.0.or.accuracy.lt.0.d0.or.acumenor.lt.0.d0
     *  .or.eps.lt.0.d0.or.epsd.lt.0.d0.
     *  or.nafmax.lt.0.or.itmax.lt.0.or.par.lt.1.d0.or.delta0.le.0.d0.
     *  or.deltamin.lt.0.d0.or.bont.lt.0.d0.or.kbont.le.0.or.dont.lt.
     *  0.d0.or.kdont.le.0.or.eta.le.0.d0.or.eta.gt.1.d0.or.factor.lt.
     *  1.d0.or.mitqu.lt.0.or.maxmv.lt.0.or.
     *  (m.gt.0.and.ispar.lt.0).or.(m.gt.0.and.ispar.gt.1)
     *  .or.(m.gt.0.and.(ispar.eq.1.and.nelem.le.0)).or.m.lt.0.or.
     *   nonlc.lt.0.or.kauts.lt.1)
     *  then
	ier=6
	if(ipr.ge.0)then
	write(*,*)' Some input parameter of BOX is incorrectly posed'
	write(10,*)' Some input parameter of BOX is incorrectly posed'
	endif
	return
	endif
c
	do 1 i=1,n
	   if(l(i).lt.u(i)) goto1
	   istop=6
	   if(ipr.ge.0)then
	   write(10,*)' Lower bound',i,' not smaller than'
	   write(10,*)' upper bound', i
	   endif
	   return
1       continue
c
c     Project the initial point on the feasible box, if necessary
	do 2 i=1,n
	   if(x(i).lt.l(i)) x(i)=l(i)
	   if(x(i).gt.u(i)) x(i)=u(i)
2       continue
c
c    If lambda = 0, ila is set to 0. If not, ila is set to 1.
	ila=0
	if(m.gt.0)then
	do 17 i=1,m
	if(lambda(i).eq.0.d0)goto17
	ila=1
	goto18
17      continue
	endif
C
18      kont=0
	mvptot=0
	irep = 0
	iquatot=0
	nopro=0
	progress = 0.d0

C     Calculates value of objective function, the gradient, and 
c     the Hessian information at initial point
C
        call phi (n, nonlc, x, mu, ra, flagra,
     *           fx, grad, hres, hess, inhess, 1 )
	
	if(m.gt.0) call pena(n, x, flagra, grad, res, 
     *   m, ila, lambda, ro, ispar, nelem, inda, a, b, bd, 1)
	naf = 1 
C
c     Here begins the loop
c
C
C     Test convergence 
C

3        call phi (n, nonlc, x, mu, ra, flagra,
     *           fx, grad, hres, hess, inhess, 2 )


	if(m.gt.0) call pena(n, x, flagra, grad, res, 
     *   m, ila, lambda, ro, ispar, nelem, inda, a, b, bd, 2)
	
	

	If (flagra .le. ftol) then
	   istop = 1
	   if(ipr.ge.0)then
	   write(*,*)
	   write(10,*)
	   write(*,*) ' Convergence of BOX by small function value'
	   write(10,*)' Convergence of BOX by small function value'
	   write(10,*)' Warning: Do Not consider the values printed'
	   write(10,*)' below for the norms of projected gradients'
	   write(*,*)' Warning: Do Not consider the values printed'
	   write(*,*)' below for the norms of projected gradients'
	   call printibox(kont,n10,x,grad,flagra,gpnor,gpcont,
     *     naf,iquatot,mvptot,delta,  pred, ared, nrepl, irep)
	   endif
	   return
	endif
c
c     Compute the 2-norm  and the sup-norm of the projected gradient
	gpnor2=0.d0
	gpcont=0.d0
	do 4 i=1,n
	if((x(i).gt.l(i).and.x(i).lt.u(i)) .or.
     *     (x(i).eq.l(i).and.grad(i).lt.0.d0) .or.
     *     (x(i).eq.u(i).and.grad(i).gt.0.d0)) then
	z=x(i)-grad(i)
	if(z.gt.u(i)) z=u(i)
	if(z.lt.l(i)) z=l(i)
	gpnor2 = gpnor2 + grad(i)**2
	gpcont = gpcont + (z-x(i))**2
	endif
4       continue
	gpnor=dsqrt(gpnor2)
	gpcont = dsqrt(gpcont)
c
c      Test whether the continuous projected gradient is small enough
c      to declare convergence
c
	if(gpcont.le.eps) then
	istop=0
	   if(ipr.ge.0)then
	   write(*,*)
	   write(10,*)
	   write(*,*) ' Convergence of BOX by small projected gradient'
	   write(10,*)' Convergence of BOX by small projected gradient'
	   call printibox(kont, n10, x, grad, flagra, gpnor, gpcont,
     *     naf, iquatot, mvptot, delta, pred, ared, nrepl, irep)
	   endif
	   return
	endif
c
c     Test whether the number of iterations is exhausted
c
	if(kont.ge.itmax) then
	istop=3
	   if(ipr.ge.0)then
	   write(*,*)
	   write(10,*)
	   write(*,*) ' Maximum number of BOX iterations exhausted'
	   write(10,*)' Maximum number of BOX iterations exhausted'
	   call printibox(kont,n10,x,grad,flagra,gpnor,gpcont,
     *     naf,iquatot,mvptot,delta, pred, ared, nrepl, irep)
	   endif
	   return
	endif
c
c     Test whether the number of functional evaluations is exhausted
c
	if(naf.ge.nafmax) then
	istop=2
	   if(ipr.ge.0)then
	   write(*,*)
	   write(10,*)
	   write(*,*) naf,' evaluations performed, exceeding maximum'
	   write(10,*)naf,' evaluations performed, exceeding maximum'
	   call printibox(kont,n10,x,grad,flagra,gpnor,gpcont,
     *     naf,iquatot,mvptot,delta, pred, ared, nrepl, irep)
	   endif
	   return
	endif
c
c       Test whether we performed many iterations without good progress
c
	if(kont.ne.0) then
	   prog=fant-flagra
	   progress=dmax1(prog,progress)
	   if(prog.le.bont*progress)then
	   nopro=nopro+1
		if(nopro.ge.kbont) then
		istop=7
		if(ipr.ge.0)then
		write(*,*)
		write(10,*)
		write(*,*) ' BOX finished by lack of progress'
		write(10,*) ' BOX finished by lack of progress'
		call printibox(kont,n10,x,grad,flagra,gpnor,gpcont,
     *             naf,iquatot,mvptot,delta, pred, ared, nrepl, irep)
		endif
		return
		endif
	   else
	   nopro=0
	   endif
	endif
	fant=flagra
c
c    Test whether we have performed kauts iterations without good reduction
c    of the 2-norm of the projected gradient
c
	if(kont.ne.0)then
           logp = dlog10(gpcont)
	   
	   if(logp.ge.logpant) then
	   nkauts = nkauts + 1
	   else
	   nkauts = 0
	   endif
	      if(nkauts.ge.kauts) then
	      istop = 8
		if(ipr.ge.0)then
		write(*,*)
		write(10,*)
		write(*,*) ' BOX finished by no enough improvement'
		write(*,*) ' of the continuous projected gradient'
		write(10,*) ' BOX finished by no enough improvement'
		write(10,*) ' of the continuous projected gradient'
		call printibox(kont,n10,x,grad,flagra,gpnor,gpcont,
     *             naf,iquatot,mvptot,delta, pred, ared, nrepl, irep)
		endif
              return
	      endif
            logpant = logp
	    else
	    logpant = dlog10(gpcont)
	    endif
c
c    A new iteration begins here
	if(ipr.gt.0.and.(kont.eq.0.or.mod(kont,ipr).eq.0))then
	call printibox(kont,n10,x,grad,flagra,gpnor,gpcont,
     *    naf,iquatot,mvptot,delta, pred, ared, nrepl, irep)
	endif

c    Set the convergence criterion for quacan at the first call within
c    the current iteration
	epsq=accuracy*gpnor


c    Update delta
	if(kont.eq.0)then
	delta=delta0
	else
c
c    If the actual reduction of the merit function  was 
c    greater than half the predicted reduction we multiply
c    the trust region radius by the expansion parameter par
c
	if(ared.ge.0.5d0*pred) delta = par * delta
	delta=dmin1(1.d30, dmax1(delta, deltamin))
	endif


c    Compute the bounds for quacan, lint and uint
	line=0

	do 14 i=1,n
	lint(i)= dmax1(-delta, l(i)-x(i))
14      uint(i)= dmin1(delta, u(i)-x(i))

12      if(line.eq.1)then
c
c    There was at least one Armijo failure at this iteration
c    (line=1). We update the bounds for quacan
c    and  we use as
c    initial point for quacan a fraction of the previous solution
c
	do 15 i=1,n
	lint(i)=dmax1(-delta, lint(i))
15      uint(i)=dmin1(delta, uint(i))
c
c
	do 13 i=1,n
13      s(i)=s(i)*delta/snor0

c    Set the convergence criterion for quacan at not-the-first calls within
c    the current iteration
	epsq=acumenor*gpnor


	else

c
c     The initial point for quacan at its first call within a particular
c     iteration is the null increment. However, if iguess=1 we call 
c     the user-provided subroutine guess to compute the inital approxima-
c     tion to the solution of the bound-constrained quadratic subproblem.
c
	if(iguess.eq.1) then
	call guess(n, x, grad, ro, ra, lambda, mu, lint, uint, s)
	do 26 i=1,n
	if(s(i).lt.lint(i)) s(i) = lint(i)
	if(s(i).gt.uint(i)) s(i) = uint(i)
26	continue
	else
	do 19 i=1,n
19      s(i)=0.d0
	endif

	endif


c
c    Solve, approximately, the quadratic subproblem
c

	call quacan (mapro, grad, n, s, fq, gq, lint, uint, eta, factor,
     *    kon, mvp, ipqua, mitqu, maxmv, dont, kdont, epsq, ier, 
     *    gc, bd, xn, gn, d, ingc, infree, hess, inhess,
     *    m, ro, reg, ispar, nelem, inda, a, ichan, irep0)
	
c
	iquatot=iquatot+kon
	mvptot=mvptot+mvp
	irep = irep + irep0
c
c    Now we test whether the quadratic model produced enough decrease,
c    that is, we test whether fq is small enough.
c    For this purpose, we consider the ``easy-quadratic model'', and we 
c    compute d, the minimizer of the easy-quadratic model in the trust region
c    box. If the quadratic model did not produce a decrease at least
c    equal to some fraction of the decrease produced by the easy-quadratic
c    model, the solution of the quadratic model is replaced by the
c    one of the easy-quadratic model
c
	flimo = 0.d0
	dtd = 0.d0
	do 24 i = 1, n
	d(i)=-grad(i)
	if(d(i).lt.lint(i)) d(i) = lint(i)
	if(d(i).gt.uint(i)) d(i) = uint(i)
	dtd = dtd + d(i)**2
24	flimo = flimo + d(i) * grad(i)
	flimo = flimo + dtd/2.d0
	if(fq .gt. 1.d-6 * flimo) then
	nrepl = nrepl + 1
	do 25 i=1,n
25	s(i)=d(i)
	fq = flimo
	endif

c
c    The vector s contains our trial increment. Now we test whether it
c    can be accepted.
c    xn will contain the trial point
c
	do 9 i=1,n
	xn(i)=x(i)+s(i)
c
c   These are safeguards to ensure that the trial point do not
c   escape from the box by rounding errors, which should be 
c   catastrophic. 
c   The quantity 1.d-14 is meant to be something a litter bit larger
c   than the machine precision. You must change it if the machine
c   precision changes. Here it is assumed to be 1.d-16
c
	if(xn(i).gt.u(i) - 1.d-14 * dabs(u(i)))xn(i)=u(i)
	if(xn(i).lt.l(i) + 1.d-14 * dabs(l(i)))xn(i)=l(i)
9       continue
c
c    Compute the functional value at the trial point
	call phi (n, nonlc,  xn, mu,  ra, fn, fxn, gn, hres, 
     *   hess, inhess, 1)
	if(m.gt.0) call pena (n, xn, fn, gn, res, 
     *   m, ila, lambda, ro, ispar, nelem, inda, a, b, bd, 1)
	naf = naf + 1
	if(ipr.eq.1)then
	write(10, *)' Trust region radius:', delta
	write(*, *)' Trust region radius:', delta
	write(10,*)' Predicted reduction:', -fq
	write(10,*)' Actual reduction:', flagra - fn
	write(*,*)' Predicted reduction:', -fq
	write(10,*)' Reason for termination of quacan, ier =',ier
	write(*,*)' Reason for termination of quacan, ier =',ier
	write(10,*)' Number of iterations at last call to quacan:',kon
	write(*,*)' Number of iterations at last call to quacan:',kon
	write(*,*)' Actual reduction:', flagra - fn
	write(10,*)' Objective function value at trial point:',fn
	write(*,*)' Objective function value at trial point:',fn
	endif
c
c    Test if the trial point can be accepted
c
	desce = dmax1 (relarm * fq, - absarm)
	if ( fn. le . flagra + desce ) then
c
c    The trial point is accepted and is going to be the new iterate
c
	do 10 i=1,n
10      x(i)=xn(i)
	pred = -fq
	ared = flagra - fn
	flagra=fn
	fx=fxn
	kont=kont+1
	goto3
c
	endif
c
c   The trial point was not good enough. Reduce delta
c
c
c   First, verify if delta is very small (strangled point)
c
	if(delta.le.epsd)then
	istop=4
	if(ipr.ge.0)then
	write(*,*)
	write(10,*)
	write(*,*)' BOX stops by excessively small trust region'
	write(*,*)' (strangled point)'  
	write(10,*)' BOX stops by excessively small trust region'
	write(10,*)' (strangled point)' 
	call printibox(kont,n10,x,grad,flagra,gpnor,gpcont,
     *       naf,iquatot,mvptot,delta, pred, ared, nrepl, irep)
	endif
	return
	endif

c    Updating delta after a failure of the sufficient descent 
c    condition
c
	snor0=0.d0
	do 11 i=1,n
11      snor0= dmax1(snor0, dabs(s(i)))
c
c    contrac is a contraction factor for the trust region radius.
c    If fn was less than flagra - 0.1 fq
c    contrac is set to be equal to 2. (Therefore, the trust-region 
c    radius is not excessively reduced.)
c    If fn was greater than flagra - 0.1 fq we set contrac equal to 10.
c    That is, is fn was much larger than flagra we reduce the trust-region
c    radius rather drastically. 
c
	if(fn.le.flagra - 0.1d0 * fq) then
	contrac = 2.d0
	else
	contrac = 10.d0
	endif

	delta = snor0 / contrac
	line=1
	goto12
c
	end


	subroutine printibox(kon,n10,x,grad,f,gpnor,gpcont,
     *   naf,iquatot,mvp,del, pred, ared, nrepl, irep)
	implicit double precision(a-h,o-z)
	dimension x(n10), grad(n10)
	write(10,*)
	write(10,*)' BOX iteration ', kon
	write(10,*)' First (at most 10) components of current point:'
	write(10,*)(x(i), i=1,n10)
	write(10,*)' First (at most 10) components of the gradient:'
	write(10,*)(grad(i), i=1,n10)
	write(10,*)' Objective function value:',f




	write(*,*)
	write(*,*)' BOX iteration ', kon
	write(*,*)' First (at most 10) components of current point:'
	write(*,*)(x(i), i=1,n10)
	write(*,*)' First (at most 10) components of the gradient:'
	write(*,*)(grad(i), i=1,n10)
	write(*,*)' Objective function value:',f



	if(kon.gt.0) then
	write(10,*)' Predicted reduction:', pred
	write(10,*)' Actual reduction:', ared

	write(*,*)' Predicted reduction:', pred
	write(*,*)' Actual reduction:', ared

	endif

	write(10,*)' 2-Norm of the continuous projected gradient :',
     *               gpcont
	write(10,*)' 2-Norm of the (non-continuous) projected gradient:'
     *             , gpnor
	write(10,*)' Functional evaluations:', naf
	write(10,*)' Total number of quacan iterations:', iquatot
	write(10,*)' Number of matrix-vector products:', mvp
	write(10,*)' Number of times in which the solution of the'
	write(10,*)' quadratic model was replaced by the solution of'
	write(10,*)' the easy-quadratic model:', nrepl
	write(10,*)' Number of times in which the guessed increment'
	write(10,*)' or, perhaps, the backtracked increment'
	write(10,*)' was worse than the null increment in terms of the'
	write(10,*)' quadratic model:', irep


	write(*,*)' 2-Norm of the continuous projected gradient :',
     *               gpcont
	write(*,*)' 2-Norm of the (non-continuous) projected gradient:'
     *             , gpnor
	write(*,*)' Functional evaluations:', naf
	write(*,*)' Total number of quacan iterations:', iquatot
	write(*,*)' Number of matrix-vector products:', mvp
	write(*,*)' Number of times in which the solution of the'
	write(*,*)' quadratic model was replaced by the solution of'
	write(*,*)' the easy-quadratic model:', nrepl
	write(*,*)' Number of times in which the guessed increment'
	write(*,*)' or, perhaps, the backtracked increment'
	write(*,*)' was worse than the null increment in terms of the'
	write(*,*)' quadratic model:', irep

	if(kon.ne.0)then
	write(10,*)' The current point was obtained within a trust'
	write(10,*)' region of radius', del

	write(*,*)' The current point was obtained within a trust'
	write(*,*)' region of radius', del


	endif
	write(10,*)
	write(*,*)

	return
	end
	



C
C----------------------------------------------------------------------
	subroutine quacan (mapro, b, n, x, f, g, l, u, eta, factor,
     *    kon, mvp, ipri, maxit, maxef, dont, kdont, eps, ier, 
     *    gc, bd, xn, gn, d, ingc, infree, hess, inhess,
     *    mrowsa, ro, reg, ispar, nelem, inda, amat, ichan, irep0)


c    
c    Initiated in November 1995 
c
c    This subroutine aims to minimize a quadratic function
c
c        f(x) = (1/2) x^T ( B + ro A^T A + reg I ) x + b^T x 
c 
c    (f:\R^n \to \R) on the box given by l \leq x \leq u. 
c    It is especially suited for n large. 
c    The matrix A has mrowsa rows and n columns and can be stored dense
c    or sparse according to the parameter ispar. 
c    Quacan replaces a previous version, avoiding
c    the cumbersome driving of indices that characterizes active set
c    strategies. 
c    The main purpose was to develop an ``easy code'', easy to manipu-
c    late and modify for testing different ideas.
c    The method implemented in Quacan is described in the report BFGMR
c    (paper by Bielschowky, Friedlander, Gomes, Martinez and Raydan).
c    It is based on a mild active set strategy that uses conjugate 
c    gradients inside the faces, projected searches and chopped
c    gradients to leave the faces. The criterion to leave a face is
c    
c                       ||g_c|| \geq eta  ||g_p||                 (1)
c
c   where g_c is the chopped gradient, g_p is the projected gradient,
c   defined as in BFGMR and || . || is the euclidian norm.
c
c   Parameters:
c   Mapro: subroutine that must be declared external in the calling 
c   routine or program. The calling sequence of mapro is
c                   call mapro(n, nind, ind, u, v)
c     This subroutine must be coded by the user, taking into account that
c     n is the number of variables of the problem and that v must be 
c     the product B u. Moreover, you must assume, when you code mapro,
c     that only nind components of u are nonnull and that ind is the set
c     of indices of those components. In other words, you must write
c     mapro in such a way that v is the vector whose i-th  entry  is 
c                     \Sum_{j=1}^{nind} B_{i ind(j)} u_ind(j)
c     However, observe that you must assume that, in u, the whole vector
c     is present, with its n components, even the zeroes. So, if you
c     decide to code mapro without taking into account the presence 
c     of ind and nind, you can do it. A final advertence concerning
c     your coding of mapro. You must test, in the code, if nind = n.
c     In this case, do not use ind, because it is a void vector and,
c     of course, has no utility. In other words, if nind=n you must 
c     not assume that ind is the vector (1, 2, ..., n). It is not. A
c     final observation: probably, if nind is close to n, it is not
c     worthwhile to use ind, due to the cost of accessing the correct
c     indices. If you want, you can test, within your mapro, if 
c     (say) nind > n/2, and, in this case use a straightforward scalar
c     product for the components of v.
c
c----------------------------------------------------------------------
c         INPUT PARAMETERS THAT DEFINE RO AND THE MATRIX A
c
c               mrowsa, ro, ispar, nelem, inda, amat
c
c
c      mrowsa : number of rows of the matrix A. Set mrowsa = 0 if there is no 
c          Lagrangian term at all
c
c      ro : real*8 number given in the definition of the problem
c
c      ispar : input integer parameter that can take the value 0 or 1
c              If ispar = 0, this means that the m x n matrix A is stored
c              in the array a columnwise, that is a(1,1), a(2,1), a(3,1),
c              ... a(m,1), a(1,2), a(2,2),...,a(m,2)...
c              You can use ispar=0 when there is not advantage on taking
c              into account sparsity of A. In other words, when you judge
c              that A is dense
c              If ispar=1, this means that you give only the nonzero elements
c              of A, in the way explained below.
c
c      nelem : this input parameter is used only when ispar = 1. It
c              is the number of ``nonzero'' elements that you are reporting
c              for the matrix A. Set nelem = 1 if ispar is not 1.
c
c      inda : this input parameter is used only when ispar = 1. In
c             this case, it is an integer nelem x 2 array where you
c             must store, in any order, the pairs (i , j) such that the
c             corresponding element a_{ij} of the matrix A is different
c             from zero. 
c
c      amat :  If ispar=0, this array contains the entries of the matrix
c              A, stored columnwise (see ispar above). If ispar =1, this
c              array contains the nonzero elements of A in such a way
c              that a(k) = a_{ij} when the row k de inda is (i, j).
c
c
c      ichan : Input integer parameter. If you set ichan = 1, quacan
c              tests if the initial approximation is better than the
c              null initial approximation. If it is not, quacan changes
c              the given initial approximation by the vector 0. In 
c              other words, if the quadratic value at the given initial
c              approximation is greater than 0, the initial approxima-
c              tion is replaced by the null vector. If you set ichan 
c              different from 1, the initial approximation given is
c              not changed, no matter its functional value.
c
c      irep0:  Output parameter that can take the values 0 or 1. If 
c              irep0 = 1, this means that, being ichan=1, the initial
c              point of quacan was really changed to the null initial
c              point.
c    
c-------------------------------------------------------------------------
c             PARAMETER RELATED TO THE REGULARIZATION TERM
C
C   reg: real*8 regularization parameter.
c
c
c-------------------------------------------------------------------------
c
c   n: number of variables.
c   x (dimension n): on entry, initial approximation, feasible 
c     to the box, on exit, best point obtained.
c   f: on exit, value of f(x).
c   g: when convergence ocurs, this vector (dimension n) contains the
c      final values of the gradient at x.
c   eta: On input, number belonging to (0, 1) according to (1) above.
c        If eta is close to 1, faces are fully exploited before abandoning
c        them. If eta is close to 0, abandoning faces is frequent.
c   factor: On input, real number greater than 1 (we recommend factor=5)
c           intended to improve the current trial guess through extrapo-
c           lation procedures. It is used in the subroutine Double. See
c           its comments.
c   eps: Small positive number for declaring convergence when  the eucli-
c        dian norm of the projected gradient is less than
c        or equal to eps.
c   maxit: maximum number of iterations allowed.
c   maxef: maximum number of matrix-vector products allowed.
c   kon: on exit, number of iterations performed.
c   mvp: on exit, matrix-vector products (calls to mapro)
c   dont: ``lack of enough progress'' measure. The algorithm stops by
c        ``lack of enough progress'' when 
c          f(x_k) - f(x_{k+1}) \leq  dont * max \{f(x_j)-f(x_{j+1}, j<k\}
c          during kdont consecutive iterations.
c   kdont: see the meaning of dont, above.
c   ier: output message.
c        If ier=0, convergence was declared.
c        If ier=1, the maximum number of iterations was exhausted.
c        If ier=2, the maximum number of matrix-vector products was exhausted.
c        If ier=3, the method stopped by ``lack of enough progress''.
c        If ier=4, the initial point was not within the box.
c        If ier=5, there are input parameters that are not within their
c                  limits. Check eps, eta, etc.
c        If ier=6, some component of u is less than or equal to the 
c                  corresponding component of l.
c   ipri: printing parameter. If ipri < 0, nothing is printed.
c                             If ipri = 0, only a final summary is printed
c                             Otherwise, information is printed every
c                             ipri iterations.
c   gc, xn, gn, d : auxiliar double precision real vectors of n positions.
c   bd: auxiliar double precision real vector of n+1 positions. (Warning:
c   I think that the previous comment is wrong. See dimensioning of bd
c   in BOX). 
c   ingc, infree : auxiliar integer vectors of n positions.
c
c   hess, inhess : double precision and integer array, respectively,
c   that must be dimensioned in the main problem with the number of
c   positions sufficient to pass to mapro the necessary information
c   to perform matrix-vector products, essentially when quacan is
c   used as a subroutine of BOX. If quacan is used independently, as
c   in the example below, you can ignore them. 
c

 

	implicit double precision (a-h, o-z)
	external mapro
	dimension amat(*), inda(nelem,2)
	double precision l(n)
	dimension x(n), g(n), u(n), b(n)
	dimension gc(n), bd(*), xn(n), d(n), gn(n)
	dimension ingc(n), infree(n)
	dimension hess(*), inhess(*)
c
	irep0 = 0
	if(ipri.ge.0)then
	write(10,*)
	write(*,*)
	write(*,*)'                          OUTPUT OF QUACAN:'
	write(*,*)
	write(10,*)'                         OUTPUT OF QUACAN:'
	write(10,*)
	endif
c
c   Test if all the input parameters are within their limits
c
	if(eps.lt.0.d0.or.eta.le.0.d0.or.eta.gt.1.d0.or.dont.lt.0.d0
     *    .or.n.le.0.or.maxit.lt.0.or.maxef.lt.0.or.kdont.le.0
     *    .or.factor.lt.1.d0)then
	ier=5
	    if(ipri.ge.0)then
	    write(*,*)' Input parameters out of their prescribed bounds'
	    write(10,*)' Input parameters out of prescribed bounds'
	    endif
	return
	endif
c   Check if l < u
c
	do 8 i=1,n
	if(u(i).le.l(i))then
	ier=6
	if(ipri.ge.0)then
	write(*,*)' Component',i,' of l is >= than component',i,' of u'
	write(10,*)' Component',i,' of l is >= than component',i,' of u'
	endif
	return
	endif
8       continue
c
c   Test if the initial point is within to the box
	do 1 i = 1, n
	if(x(i).lt.l(i).or.x(i).gt.u(i))then
	ier=4
	if(ipri.lt.0) return
	write(*,*)
	write(*,*)' The initial point is not feasible'
	write(*,*)
	write(10,*)
	write(10,*)' The initial point is not feasible'
	write(10,*)
	return
	endif
1       continue
c
	indica=0
c  indica=1 means that the iteration that begins now is of conjugate
c  gradient type. indica=0 means that it is of chopped gradient type
c  or internal gradient type.
	kon=0
	mvp=0
	if(ipri.ge.0) n10=min0(n,10)
	noprog=0
c
c   Progress is the maximum progress obtained up to now
	progress=0.d0
c
c       Evaluate the gradient at the initial point
	call grad (n, mapro, b, x, g, mvp, hess, inhess,
     *   mrowsa, ro, reg, ispar, nelem, inda, amat, 
     *   bd(n+1), bd(n+mrowsa+1))       
c       Evaluate the objective function at the initial point
	call fuqu(n, x, g, b, f)
c
	if(ichan.eq.1) then 
c   Test if the initial point given is better than the null vector
c   If it is not, it will be changed.
	if(f. gt. 0.d0) then 
c   Replace the given initial point by the null vector 
	irep0 = 1
        do 23  i = 1, n  
23      x(i) = 0.d0
c
c       Evaluate the gradient at the initial point
	call grad (n, mapro, b, x, g, mvp, hess, inhess,
     *   mrowsa, ro, reg, ispar, nelem, inda, amat, 
     *   bd(n+1), bd(n+mrowsa+1))       
c       Evaluate the objective function at the initial point
	call fuqu(n, x, g, b, f)
c
	endif
	endif
c
c       Here begins the iteration loop
c
c       nfree is the number of components of the internal gradient
c       (number of free variables)
c       infree is the vector of indices of components of the internal
c       gradient (free variables).
c       ncgc is the number of components of the chopped gradient
c       ingc is the vector of indices of the components of the chopped
c       gradient.
c
10      nfree=0
	ncgc=0
	do 3 i=1,n
	if(x(i).gt.l(i).and.x(i).lt.u(i))then
	nfree=nfree+1
	infree(nfree)=i
	endif
	if(x(i).eq.l(i).and.g(i).lt.0.d0)then
	ncgc=ncgc+1
	ingc(ncgc)=i
	endif
	if(x(i).eq.u(i).and.g(i).gt.0.d0)then
	ncgc=ncgc+1
	ingc(ncgc)=i
	endif
3       continue
c
c
c       Compute the squared 2-norm of the internal gradient
c       However, if indica=1, this is not necessary since it has
c       been already computed at the end of the previous iteration
	if(indica.eq.0)then
	ginor2=0.d0
	    if(nfree.gt.0)then
	    do 4 i=1,nfree
	    j=infree(i)
4           ginor2=ginor2+g(j)**2
	    endif
	endif
c       Compute the 2-norm of the chopped gradient
	gcnor2=0.d0
	if(ncgc.gt.0)then
	do 22 i=1,ncgc
	j=ingc(i)
22      gcnor2=gcnor2+g(j)**2
	endif
c       Compute the 2-norm of the projected gradient
	gcnor=dsqrt(gcnor2)
	gpnor2=ginor2+gcnor2
	gpnor=dsqrt(gpnor2)
c
c       Test convergence criterion
c
	if(gpnor.le.eps)then
	ier=0
	if(ipri.ge.0)then
	write(*,*)
	write(10,*)
	write(*,*)' Convergence detected at iteration ', kon
	write(10,*)' Convergence detected at iteration ', kon
	call printi(kon,n,n10,x,g,f,gpnor,gcnor,nfree,ncgc,mvp,ichop,
     *  internal, iconju)
	write(10,*)' Use Quacan and you will be happy for ever!!'
	write(*,*)' Use Quacan and you will be happy for ever!!'
c
	write(*,*)
	write(10,*)
	endif
	return
	endif
c
c       Test maximum number of iterations
c
	if(kon.ge.maxit)then
	ier=1
	if(ipri.ge.0)then
	write(*,*)
	write(10,*)
	write(*,*)' Maximum number of iterations ', kon,' reached'
	write(10,*)' Maximum number of iterations ', kon,' reached'
	call printi(kon,n,n10,x,g,f,gpnor,gcnor,nfree,ncgc,mvp,
     *  ichop,internal, iconju)
	endif
	return
	endif
c
c       Test maximum number of matrix-vector products
c

	if(mvp.ge.maxef)then
	ier=2
	if(ipri.ge.0)then
	write(*,*)
	write(10,*)
	write(*,*)' Maximum number of matrix-vector products ',
     *   maxef,' reached'
	write(10,*)' Maximum number of matrix-vector products ',
     *   maxef,' reached'
	call printi(kon,n,n10,x,g,f,gpnor,gcnor,nfree,ncgc,mvp,
     *  ichop,internal, iconju)

	endif
	return
	endif
	if(kon.ne.0)then
	prog=dmax1(0.d0, fant-f)
	progress=dmax1(prog, progress)
	if(prog.le.dont*progress)then
	 noprog=noprog+1
	  if(noprog.ge.kdont)then
	  ier=3
	   if(ipri.ge.0)then
	   write(*,*)
	   write(10,*)
	   write(*,*)' Quacan stops because of lack of progress'
	   write(10,*)' Quacan stops because of lack of progress'
	   call printi(kon,n,n10,x,g,f,gpnor,gcnor,nfree,ncgc,mvp,
     *     ichop,internal, iconju)
	   endif
	  return
	  endif
	else
	  noprog=0
	endif
	endif
	fant=f
c
c       Printing session
c
	if(ipri.gt.0)then
	if(mod(kon,ipri).eq.0.or.kon.eq.0)then
	call printi(kon,n,n10,x,g,f,gpnor,gcnor,nfree,ncgc,mvp,
     *  ichop,internal, iconju)

	endif
	endif   
c
c
c       A new iteration is going to be performed
	kon=kon+1
c
c       Test if the current face must be leaved or not
c
	if(gcnor.ge.eta*gpnor)then
c   ichop, internal and iconju are to indicate the printer which
c   type of iteration has been performed
	if(ipri.ge.0)then
	ichop=1
	internal=0
	iconju=0
	endif

c
c       The current face must be abandoned
c
c       Use the chopped gradient to leave it
c
c
c       gc is the (negative) chopped gradient vector
c
	do 5 i=1,n
5       gc(i)=0.d0
	do 6 i=1,ncgc
	j=ingc(i)
	gc(j)= -g(j)
6       continue
c
c       Compute the minimum breakpoint alfabreak along the chopped
c       gradient direction. (Observe that all the components of gc
c       that appear dividing are different from zero.)
c
	j=ingc(1)
	if(x(j).eq.l(j)) then
	alfabreak =  (u(j) - l(j))/gc(j)
	jbreak=j
	else
	alfabreak = (l(j) - u(j))/gc(j)
	jbreak=j
	endif
	if(ncgc.gt.1)then
	do 9 i = 2, ncgc
	j=ingc(i)
	if(x(j).eq.l(j)) then
	alfa = (u(j) - l(j))/gc(j)
	if(alfa.lt.alfabreak)then
	alfabreak=alfa
	jbreak=j
	endif
	else
	alfa = (l(j) - u(j))/gc(j)
	if(alfa.lt.alfabreak)then
	alfabreak=alfa
	jbreak=j
	endif
	endif
9       continue
	endif   
c
c
c
c       Compute the product of the Hessian times the chopped gradient

	call mapro(n, ncgc, ingc, gc, bd, hess, inhess)
	if(mrowsa.gt.0)call roata(n, ncgc, ingc, gc, bd, 
     *     mrowsa, ro, reg, ispar, nelem, inda, amat, bd(n+1), 
     *     bd(n+mrowsa+1))
	mvp=mvp+1
c
c       Compute the denominator for the linesearch
c
	den=0.d0
	do 7 i=1,ncgc
c    In the following line an overflow appeared on 28/12/95, running gedan
7       den=den + gc(ingc(i)) * bd(ingc(i))
c  
c     If den .le. 0, the next iteration will be the minimum breakpoint
c     along the chopped gradient direction, or, perhaps, something
c     better (after the double-stepping procedure)
c               
	if(den.le.0.d0) then
	call double (n, b, x, f, g, gc, ingc, ncgc, l, u, mapro, factor,
     *     alfabreak, jbreak, xn, gn, bd, mvp, hess, inhess, 
     *      mrowsa, ro, reg, ispar, nelem, inda, amat)
c     
c       The new iteration has been computed and stored in x
c       The new gradient is stored in g
c       The new objective function value is at f
c       The iteration stops here
c       The next iteration will not be conjugate
	indica=0
	goto10
	endif


c       Compute the numerator of the linesearch coefficient
c
	alfa= gcnor2/den
	if(alfa.ge.alfabreak) then              
	call double (n, b, x, f, g, gc, ingc, ncgc, l, u, mapro, factor,
     *     alfabreak, jbreak, xn, gn, bd, mvp, hess, inhess, 
     *      mrowsa, ro, reg, ispar, nelem, inda, amat)

c     
c       The new iteration has been computed and stored in x
c       The new gradient is stored in g
c       The new objective function value is at f
c       The iteration stops here
c       The next iteration will not be conjugate (indica=0)
	indica=0
	goto10
	endif
c
c    If the minimizer along the direction of the chopped gradient is
c    before the minimum breakpoint, we adopt this minimizer as new
c    iterate
c
	do 12 i=1,ncgc
	j=ingc(i)
12      x(j)=x(j)+alfa*gc(j)
c
c    Compute the gradient at the new point x
	do 13 i=1,n
13      g(i)=g(i)+alfa*bd(i)
c
c    Compute the new objective function value
	call fuqu(n, x, g, b, f)
c    The iteration stops here
c
c    The next iteration will not be conjugate (indica=0)
	indica=0
	goto10
c    Here finishes the ``if'' that begins with ``if(gcnor.ge.eta*gpnor)''
c
	else
c    Now, we consider the case where the face must not be abandoned
c    that is, gcnor < eta*gpnor
c    In this case, we perform conjugate gradient iterations
c    However, we need an indicator for telling us if the iteration
c    must be ``conjugate gradient'' or merely gradient. A conjugate
c    gradient iteration will take place only if the indicator 
c    indica is equal to 1. Otherwise, this will be a gradient iteration
c    along the (negative) internal gradient. Observe that we set indica=0 at 
c    the steps of the algorithm that corresponds to chopped gradient
c    iterations.
c    Put the search direction on vector d
	if(indica.eq.0)then
c    Gradient search direction
	do 15 i=1,n
15      d(i)=0.d0
	do 14 j=1,nfree
	i=infree(j)
14      d(i)=-g(i)
	endif
	if(indica.eq.1)then
c    Conjugate search direction
	do 19 j=1,nfree
	i=infree(j)
19      d(i)= -g(i) + beta*d(i)
	endif
c
c   Compute the minimum breakpoint along d
	alfabreak=-1.d0
	do 16 i=1,nfree
	j=infree(i)
	if(d(j).eq.0.d0)goto16
	alfa = (u(j)-x(j))/d(j)
	if(alfa.gt.0.d0)then
	if(alfabreak.eq.-1.d0.or.alfa.lt.alfabreak)then
	alfabreak=alfa
	jbreak=j
	goto16
	endif
	else
	alfa = (l(j)-x(j))/d(j)
	if(alfa.le.0.d0)goto16
	if(alfabreak.eq.-1.d0.or.alfa.lt.alfabreak)then
	alfabreak=alfa
	jbreak=j
	endif
	endif
16      continue
c
c   Compute the denominator of the linesearch
	
	call mapro(n, nfree, infree, d, bd, hess, inhess)
	if(mrowsa.gt.0)call roata(n, nfree, infree, d, bd, 
     *     mrowsa, ro, reg, ispar, nelem, inda, amat, bd(n+1), 
     *     bd(n+mrowsa+1))
	mvp=mvp+1
	den=0.d0
	do 17 i=1,nfree
	j=infree(i)
17      den=den+bd(j)*d(j)
c
c   If the denominator of the linesearch is .le. 0, go to the breakpoint
c
	if(den.le.0.d0)then
	call double (n, b, x, f, g, d, infree, nfree,
     *     l, u, mapro, factor, alfabreak, jbreak, xn, gn, bd, mvp,
     *     hess, inhess, 
     *     mrowsa, ro, reg, ispar, nelem, inda, amat )
c     
c       The new iteration has been computed and stored in x
c       The new gradient is stored in g
c       The new objective function value is at f
c       The iteration stops here
	indica=0
c   ichop, internal and iconju are to indicate the printer which
c   type of iteration has been performed
	if(ipri.ge.0)then
	ichop=0
	internal=1
	iconju=0
	endif
	goto10
	endif
c       Compute the linesearch coefficient
	alfa= ginor2/den
	if(alfa.ge.alfabreak) then      
	call double (n, b, x, f, g, d, infree, nfree, l, u, 
     *     mapro, factor, alfabreak, jbreak, xn, gn, bd, mvp,
     *     hess, inhess, mrowsa, ro, reg, ispar, nelem, inda, amat)
c     
c       The new iteration has been computed and stored in x
c       The new gradient is stored in g
c       The new objective function value is at f
c       The iteration stops here
c   ichop, internal and iconju are to indicate the printer which
c   type of iteration has been performed
	if(ipri.ge.0)then
	ichop=0
	if(indica.eq.0)then
	internal=1
	iconju=0
	else
	iconju=1
	internal=0
	endif
	endif
c    The next iteration will not be conjugate (indica=0)
	indica=0
	goto10
	else

c
c    The new iterate is in the same face. The next iteration will
c    be conjugate
	do 18 i=1,nfree
	j=infree(i)
18      x(j)=x(j)+alfa*d(j)
	do 20 i=1,n
20      g(i)=g(i)+alfa*bd(i)
	gant2=ginor2
	ginor2=0.d0
	do 21 j=1,nfree
	i=infree(j)
21      ginor2=ginor2+g(i)**2
	beta=ginor2/gant2
	call fuqu(n, x, g, b, f)
	if(ipri.ge.0)then
	ichop=0
	if(indica.eq.0)then
	internal=1
	iconju=0
	else
	iconju=1
	internal=0
	endif
	endif
	indica=1
	goto10
	endif
	endif
	end

c  End of subroutine Quacan




	subroutine grad (n, mapro, b, x, g, mvp, hess, inhess,
     *     mrowsa, ro, reg, ispar, nelem, inda, amat, u, v)     
	implicit double precision (a-h, o-z)
	dimension x(n), b(n), g(n), nada(1)
	dimension hess(*), inhess(*)
	dimension inda(nelem,2), amat(*)
c   The following line was missing until January 16, 2002
	dimension u(*), v(*)
c       This subroutine is   called by quacan to compute the gradient
c       of the quadratic f at the point x. 
c       So, the output vector g is
c                  g = (B + ro A^T A + reg I) x + b
c       The product B x is computed using the user subroutine mapro,
c       which is described in the comments of Quacan. 
c       mvp increments in 1 the number of matrix-vector products.
c
c
	call mapro (n, n, nada, x, g, hess, inhess)
c
c
c
c       Add to B x the term        ro A^T A x
c
	if(mrowsa.ne.0)then
	call roata (n, n, nada, x, g, 
     *     mrowsa, ro, reg, ispar, nelem, inda, amat, u, v)
	endif
	mvp=mvp+1
	do 1 i=1,n
1       g(i)=g(i)+b(i)
	return
	end

c   End of subroutine grad




	subroutine printi(kon,n,n10,x,g,f,gpnor,gcnor,nfree,ncgc,mvp,
     *  ichop,internal, iconju)
	implicit double precision(a-h,o-z)
	dimension x(n10), g(n10)
	write(10,*)
	write(10,*)' Quacan-iteration ', kon
	write(*,*)' Quacan-iteration ', kon
	if(kon.gt.0)then
	if(ichop.eq.1)then
	write(10,*)' This point comes from a chopped gradient search'
	write(*,*)' This point comes from a chopped gradient search'
	endif
	if(internal.eq.1)then
	write(10,*)' This point comes from an internal gradient search'
	write(*,*)' This point comes from an internal gradient search'
	endif
	if(iconju.eq.1)then
	write(10,*)' This point comes from a conj. gradient search'
	write(*,*)' This point comes from a conj. gradient search'
	endif
	endif
	write(10,*)' First (at most 10) components of current point:'
	write(10,*)(x(i), i=1,n10)
	write(10,*)' First (at most 10) components of the gradient:'
	write(10,*)(g(i), i=1,n10)
	write(10,*)' Value of the quadratic objective function:',f
	write(10,*)' 2-Norm of the projected gradient:', gpnor
	write(10,*)' 2-Norm of the chopped gradient:', gcnor
	write(10,*)' Number of free variables:', nfree
	nbound=n-nfree
	write(10,*)' Number of variables on their bounds:',nbound
	write(10,*)' Number of components of chopped gradient:',ncgc
	write(10,*)' Number of matrix-vector products:', mvp
	write(10,*)
	write(*,*)
	write(*,*)' First (at most 10) components of current point:'
	write(*,*)(x(i), i=1,n10)
	write(*,*)' Value of the quadratic objective function:',f
	write(*,*)' Norm of the projected gradient:', gpnor
	write(*,*)' Norm of the chopped gradient:', gcnor
	write(*,*)' Number of free variables:', nfree
	write(*,*)' Number of variables on their bounds:',nbound
	write(*,*)' Number of components of chopped gradient:',ncgc
	write(*,*)' Number of matrix-vector products:', mvp
	write(*,*)
	return
	end

	subroutine fuqu(n, x, g, b, f)
	implicit double precision (a-h,o-z)
	dimension x(n), g(n), b(n)
c   This subroutine evaluates 
c            f(x) = (1/2) x^T B x + b^T x
c   using    g(x) = B x + b
c
c   We use the formula
c
c  f(x) = (1/2) x^T [B x + b] + b^T x / 2 = (1/2) x^T g(x) + b^T x / 2  
c           = x^T (g(x) + b)/2
c
	f=0.d0
	do 7 i=1,n
7       f=f+ x(i) * (g(i) + b(i))
	f=f/2.d0
	return
	end





	subroutine double (n, b, x, f, g, d, infree, nfree, l, u, 
     *     mapro, factor, alfabreak, jbreak, xn, gn, bd, mvp, 
     *     hess, inhess, mrowsa, ro, reg, ispar, nelem, inda, amat)
	implicit double precision (a-h, o-z)
	double precision l(n)
	external mapro
	dimension x(n), d(n), u(n), g(n), b(n)
	dimension infree(n)
	dimension xn(n), gn(n), bd(*)
	dimension hess(*), inhess(*)
	dimension inda(nelem,2), amat(*)
c
c       Compute the trial point corresponding to the minimum break
c       We use jbreak to put variables that, by rounding errors,
c       are free, on the corresponding bounds. For example, the va-
c       riable alfabreak certainly must be on a bound, but the variables
c       that, perhaps, have a distance to a bound that is less than or
c       equal to the distance of x(jbreak) to its bound, will be also
c       put on the corresponding bound.
c
c
c       Moreover, in dic 4 1995 we decided to put a variable on its bound
c       if the difference between this bound and the variable is less
c       than 1.d-14 (relative error). This modification is present in
c       the version box9512, but not in box9511d. We assume a machine
c       precision around 1.d-16 If the machine precision changes, you
c       must change 1.d-14 consequently.

	do 7 i=1,n
7       xn(i)=x(i)
	do 1 i=1,nfree
	j=infree(i)
	xn(j)=x(j) + alfabreak*d(j)
1       continue
	tole = dmin1(u(jbreak)-xn(jbreak), xn(jbreak)-l(jbreak))
	tole = dmax1(0.d0, tole)
	tole = 1.5d0*tole


c    The following two lines should not be necessary
c    if we neglected rounding errors. See comment above.
	do 10 i=1,nfree
	j=infree(i)
	tolo=dmax1(tole, 1.d-14 * dabs(u(j)))
	if(xn(j).ge.u(j)-tolo) xn(j)=u(j)
	tolo=dmax1(tole, 1.d-14 * dabs(l(j)))
	if(xn(j).le.l(j)+tolo) xn(j)=l(j)
10      continue        
c
c       Compute the gradient at this xn
c
	do 2 i=1,n
2       gn(i)=g(i)+alfabreak*bd(i)
c
c       Compute the functional value at this xn
c
	call fuqu(n, xn, gn, b, fn)

c
c       Copy xn in x, since this new point is necessarily better than
c       the old one
c
	do 3 i=1,nfree
	j=infree(i)
3       x(j)=xn(j)
	alfa=alfabreak
	do 4 i=1,n
4       g(i)=gn(i)
	f=fn
c
c       Initiate de double-step procedure, with the aim of obtaining
c       a point even better
c
9       alfa=factor*alfa
	do 8 i=1,nfree
	j=infree(i)
	xn(j)=x(j)+alfa*d(j)
	if(xn(j).gt.u(j))xn(j)=u(j)
	if(xn(j).lt.l(j))xn(j)=l(j)
8       continue
	call grad(n, mapro, b, xn, gn, mvp, hess, inhess,
     *    mrowsa, ro, reg, ispar, nelem, inda, amat, 
     *    bd(n+1), bd(n+mrowsa+1))      
	call fuqu(n, xn, gn, b, fn)

c       If the doubling step did not improve, return
	if(fn.ge.f)return
	f=fn
	do 5 i=1,nfree
	j=infree(i)
5       x(j)=xn(j)
	do 6 i=1,n
6       g(i)=gn(i)
	goto9
	end


	subroutine roata (n, nfree, infree, d, bd, 
     *     m, ro, reg, ispar, nelem, inda, a, u, v)
	implicit double precision (a-h, o-z)
c
c    This subroutine adds the term ro A^T A d + reg I d to the vector bd
c    See the comments on the use of mapro, and the comments of the
c    calling subroutines for more details on storage of A, etc
c
	dimension d(n), bd(*), inda(nelem,2), a(*), u(*), v(*)
	dimension infree(*)


	if(ispar.eq.0.and.nfree.eq.n)then
c
c    Compute  u  =  A d
c
	do 1 i=1,m
	u(i)=0.d0
	do 1 j=1,n
	k=(j-1)*m+i
c
c    a(k) is   [A]_ij
c
1       u(i)=u(i)+a(k)*d(j)
c
c    Compute A^T u, pre-multiply by ro and add to bd
c
6       do 2 j=1,n
	z=0.d0
	do 3 i=1,m
	k=(j-1)*m+i
c
c    a(k) is   [A]_ij
c

3       z=z+a(k)*u(i)
2       bd(j)=bd(j) + ro*z


	if(reg.ne.0.d0) then
	do 14 i=1,n
14      bd(i)=bd(i)+reg*d(i)
	endif
	return
	endif

	if(ispar.eq.0.and.nfree.lt.n)then
c
c    Compute  u  =  A d
c
	do 5 i=1,m
	u(i)=0.d0
	do 5 k=1,nfree
	j=infree(k)  
	kk=(j-1)*m+i
c
c    a(kk) is   [A]_ij
c
5       u(i)=u(i)+ a(kk)*d(j)
c
c    Compute A^T u, pre-multiply by ro and add to bd
c
	do 7 j=1,n
	z=0.d0
	do 8 i=1,m
	k=(j-1)*m+i
c
c    a(k) is   [A]_ij
c

8       z=z+a(k)*u(i)
7       bd(j)=bd(j) + ro*z


	if(reg.ne.0.d0) then
	do 15 i=1,n
15      bd(i)=bd(i)+reg*d(i)
	endif
	return
	endif
c

	if(ispar.eq.1)then
c
c    Compute  u  =  A d
c
	do 13 i=1,m
13      u(i)=0.d0
	do 9 k=1,nelem
	i=inda(k,1)
	j=inda(k,2)
c
c    a(k) is   [A]_ij
c
9       u(i)=u(i)+a(k)*d(j)
c
c    Compute A^T u, pre-multiply by ro and add to bd
c
	do 10 i=1,n
10      v(i)=0.d0
	do 11 k=1,nelem
	i=inda(k,1)
	j=inda(k,2)
c
c    a(k) is   [A]_ij
c

11      v(j)=v(j) + a(k)*u(i)
	do 12 j=1,n
12      bd(j)=bd(j)+ro*v(j)
	if(reg.ne.0.d0) then
	do 16 i=1,n
16      bd(i)=bd(i)+reg*d(i)
	endif
	return
	endif
c
c       if(ispar.eq.1.and.nfree.lt.n) then ????
c       I do not know how to take advantage of sparsity both in A and
c       d for obtaining the product A d
c
	end


	subroutine pena (n, x, f, g, res, 
     *   m, ila, lambda, ro, ispar, nelem, inda, a, b, aux, modo)
	implicit double precision (a-h,o-z)
	double precision lambda(*)
	dimension x(n), g(n), inda(nelem, 2), a(*), b(*), res(*)
	dimension aux(*)
c
c   This subroutine adds to f the term 
c
c  lambda^T (A x - b) +  (ro/2) || A x - b ||^2 
c
c   if modo = 1  and adds to g the term
c
c      A^T [ lambda + ro (A x - b) ] 
c
c   if modo = 2 .
c
c   We store A x - b in the vector res and we use the fact that, in 
c   BOX a call of pena with modo=2 is always immediately 
c   preceeded by a call with
c   modo=1 so that we can use the values of res computed in modo=1 
c   for the computations for modo=2 .
c
c   See the comments of BOX for the storage of A
c
c
c   Compute the residual vector res
c
	if(modo.eq.1)then
		if(m.gt.0)then
	if(ispar.eq.0)then
	do 1 i=1,m
	res(i) = - b(i)
	do 1 j=1,n
	k=(j-1)*m+i
c
c    a(k)  is  [A]_ij
c
1       res(i)=res(i)+a(k)*x(j)
	else
	do 2 i = 1, m
2       res(i) = - b(i)

	do 3 k = 1, nelem
	i = inda (k, 1)
	j = inda (k, 2)
c
c    a(k)  is  [A]_ij
c
3       res(i) = res(i) + a(k) * x(j)


	endif

	pes=0.d0
	if(ila.eq.1)then
	do 4 i=1,m
4       pes=pes+lambda(i)*res(i)
	endif
	z=0.d0
	do 5 i=1,m
5       z=z+res(i)**2
	f = f + pes + ro * z / 2.d0
		       endif
	return
	else
c  
c    Now, modo = 2
c
	if(m.ne.0)then
	do 7 i=1,m
7       aux(n+i) = lambda(i) + ro*res(i)
c
	do 6 j=1,n
6       aux(j)=0.d0
	if(ispar.eq.0)then
	do 10 j=1,n
	do 10 i=1,m
	k=(j-1)*m+i
10      aux(j)=aux(j)+ a(k)*aux(n+i)
	else
	do 8 k=1,nelem
	i=inda(k,1)
	j=inda(k,2)
8       aux(j)=aux(j)+a(k)*aux(n+i)
	endif
	do 9 j=1,n
9       g(j)=g(j)+aux(j)
	endif
	return
	endif

	end







c
C----------------------------------------------------------------------
C
      	integer function mult( p, q)
C
	Integer p, q, p0, p1, q0, q1
C
	p1 = p/10000
	p0 = mod(p,10000)
	q1 = q/10000
	q0 = mod(q,10000)
	mult = mod( mod( p0*q1+p1*q0,10000)*10000+p0*q0,100000000)
	return
	end
C
C----------------------------------------------------------------------
C
	real*8 function rnd(sem)
C
	integer sem, mult
C
	sem = mod( mult( sem, 3141581) + 1, 100000000)
	rnd = sem/100000000.0d0
	return
	end
C
C----------------------------------------------------------------------

c     this file contains the lbfgs algorithm and supporting routines
c     ****************
c     lbfgs subroutine
c     ****************
c     vanuxem gregory (2003): modified outputting information and iflag
c			      returned
c
      subroutine lbfgs(n,m,x,f,g,diagco,diag,iprint,maxit,eps,xtol,
     *grtol,w,iflag)
c
      integer n,m,iprint(2),iflag, maxit
      double precision x(n),g(n),diag(n),w(n*(2*m+1)+2*m)
      double precision f,eps,xtol,grtol
      logical diagco
c
c        limited memory bfgs method for large scale optimization
c                          jorge nocedal
c                        *** july 1990 ***
c
c 
c     this subroutine solves the unconstrained minimization problem
c 
c                      min f(x),    x= (x1,x2,...,xn),
c
c      using the limited memory bfgs method. the routine is especially
c      effective on problems involving a large number of variables. in
c      a typical iteration of this method an approximation hk to the
c      inverse of the hessian is obtained by applying m bfgs updates to
c      a diagonal matrix hk0, using information from the previous m steps.
c      the user specifies the number m, which determines the amount of
c      storage required by the routine. the user may also provide the
c      diagonal matrices hk0 if not satisfied with the default choice.
c      the algorithm is described in "on the limited memory bfgs method
c      for large scale optimization", by d. liu and j. nocedal,
c      mathematical programming b 45 (1989) 503-528.
c 
c      the user is required to calculate the function value f and its
c      gradient g. in order to allow the user complete control over
c      these computations, reverse  communication is used. the routine
c      must be called repeatedly under the control of the parameter
c      iflag. 
c
c      the steplength is determined at each iteration by means of the
c      line search routine mcvsrch, which is a slight modification of
c      the routine csrch written by more' and thuente.
c 
c      the calling statement is 
c 
c          call lbfgs(n,m,x,f,g,diagco,diag,iprint,eps,xtol,w,iflag)
c 
c      where
c 
c     n       is an integer variable that must be set by the user to the
c             number of variables. it is not altered by the routine.
c             restriction: n>0.
c 
c     m       is an integer variable that must be set by the user to
c             the number of corrections used in the bfgs update. it
c             is not altered by the routine. values of m less than 3 are
c             not recommended; large values of m will result in excessive
c             computing time. 3<= m <=7 is recommended. restriction: m>0.
c 
c     x       is a double precision array of length n. on initial entry
c             it must be set by the user to the values of the initial
c             estimate of the solution vector. on exit with iflag=0, it
c             contains the values of the variables at the best point
c             found (usually a solution).
c 
c     f       is a double precision variable. before initial entry and on
c             a re-entry with iflag=1, it must be set by the user to
c             contain the value of the function f at the point x.
c 
c     g       is a double precision array of length n. before initial
c             entry and on a re-entry with iflag=1, it must be set by
c             the user to contain the components of the gradient g at
c             the point x.
c 
c     diagco  is a logical variable that must be set to .true. if the
c             user  wishes to provide the diagonal matrix hk0 at each
c             iteration. otherwise it should be set to .false., in which
c             case  lbfgs will use a default value described below. if
c             diagco is set to .true. the routine will return at each
c             iteration of the algorithm with iflag=2, and the diagonal
c              matrix hk0  must be provided in the array diag.
c 
c 
c     diag    is a double precision array of length n. if diagco=.true.,
c             then on initial entry or on re-entry with iflag=2, diag
c             it must be set by the user to contain the values of the 
c             diagonal matrix hk0.  restriction: all elements of diag
c             must be positive.
c 
c     iprint  is an integer array of length two which must be set by the
c             user.
c 
c             iprint(1) specifies the frequency of the output:
c                iprint(1) < 0 : no output is generated,
c                iprint(1) = 0 : output only at first and last iteration,
c                iprint(1) > 0 : output every iprint(1) iterations.
c 
c             iprint(2) specifies the type of output generated:
c                iprint(2) = 0 : iteration count, number of function 
c                                evaluations, function value, norm of the
c                                gradient, and steplength,
c                iprint(2) = 1 : same as iprint(2)=0, plus vector of
c                                variables and  gradient vector at the
c                                initial point,
c                iprint(2) = 2 : same as iprint(2)=1, plus vector of
c                                variables,
c                iprint(2) = 3 : same as iprint(2)=2, plus gradient vector.
c 
c 
c     eps     is a positive double precision variable that must be set by
c             the user, and determines the accuracy with which the solution
c             is to be found. the subroutine terminates when
c
c                         ||g|| < eps max(1,||x||),
c
c             where ||.|| denotes the euclidean norm.
c 
c     xtol    is a  positive double precision variable that must be set by
c             the user to an estimate of the machine precision (e.g.
c             10**(-16) on a sun station 3/60). the line search routine will
c             terminate if the relative width of the interval of uncertainty
c             is less than xtol.
c 
c     w       is a double precision array of length n(2m+1)+2m used as
c             workspace for lbfgs. this array must not be altered by the
c             user.
c 
c     iflag   is an integer variable that must be set to 0 on initial entry
c             to the subroutine. a return with iflag < 0 or iflag > 2 indicates 
c	      an error, and iflag=0 indicates that the routine has terminated
c	      without detecting errors. on a return with iflag=1, the user must
c             evaluate the function f and gradient g. on a return with
c             iflag=2, the user must provide the diagonal matrix hk0.
c 
c             The following values of iflag, detecting an error,
c             are possible:
c 
c              iflag=-1  the i-th diagonal element of the diagonal inverse
c                        hessian approximation, given in diag, is not
c                        positive.
c           
c              iflag=-2  improper input parameters for lbfgs (n or m are
c                        not positive).
c
c             if  iflag > 2 the line search routine mcsrch failed:
c
c                       iflag = 3  more than 20 function evaluations were
c                                 required at the present iteration.
c
c                       iflag = 4  the step is too small.
c
c                       iflag = 5  the step is too large.
c
c                       iflag = 6  rounding errors prevent further progress. 
c                                 there may not be a step which satisfies
c                                 the sufficient decrease and curvature
c                                 conditions. tolerances may be too small.
c
c                       iflag = 7  relative width of the interval of
c                                 uncertainty is at most xtol.
c
c                       iflag = 8  improper input parameters.
c 
c 
c
c
c    on the driver:
c
c    the program that calls lbfgs must contain the declaration:
c
c                       external lb2
c
c    lb2 is a block data that defines the default values of several
c    parameters described in the common section. 
c
c 
c 
c    common:
c 
c     the subroutine contains one common area, which the user may wish to
c    reference:
c 
         common /lb3/mp,lp,gtol,stpmin,stpmax
c 
c    mp  is an integer variable with default value 6. it is used as the
c        unit number for the printing of the monitoring information
c        controlled by iprint.
c 
c    lp  is an integer variable with default value 6. it is used as the
c        unit number for the printing of error messages. this printing
c        may be suppressed by setting lp to a non-positive value.
c 
c    gtol is a double precision variable with default value 0.9, which
c        controls the accuracy of the line search routine mcsrch. if the
c        function and gradient evaluations are inexpensive with respect
c        to the cost of the iteration (which is sometimes the case when
c        solving very large problems) it may be advantageous to set gtol
c        to a small value. a typical small value is 0.1.  restriction:
c        gtol should be greater than 1.d-04.
c 
c    stpmin and stpmax are non-negative double precision variables which
c        specify lower and uper bounds for the step in the line search.
c        their default values are 1.d-20 and 1.d+20, respectively. these
c        values need not be modified unless the exponents are too large
c        for the machine being used, or unless the problem is extremely
c        badly scaled (in which case the exponents should be increased).
c 
c
c  machine dependencies
c
c        the only variables that are machine-dependent are xtol,
c        stpmin and stpmax.
c 
c
c  general information
c 
c    other routines called directly:  daxpy, ddot, lb1, mcsrch
c 
c    input/output  :  no input; diagnostic messages on unit mp and
c                     error messages on unit lp.
c 
c 
c     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      double precision gtol,one,zero,gnorm,ddot,stp1,ftol,stpmin,
     .                 stpmax,stp,ys,yy,sq,yr,beta,xnorm
      integer mp,lp,iter,nfun,point,ispt,iypt,maxfev,info,
     .        bound,npt,cp,i,nfev,inmc,iycn,iscn,request
      logical finish
c
      save
      data one,zero/1.0d+0,0.0d+0/
c
c     initialize
c     ----------
c
      if (grtol .gt. 1.d-04) gtol = grtol 
      request = 0
      if(iflag.eq.0) go to 10
      go to (172,100) iflag
  10  iter= 0
      if(n.le.0.or.m.le.0) go to 196
      if(gtol.le.1.d-04) then
        if(lp.gt.0 .and. iprint(1).ge.0) write(lp,245)
        gtol=9.d-01
      endif
      nfun= 1
      point= 0
      finish= .false.
      if(diagco) then
         do 30 i=1,n
 30      if (diag(i).le.zero) go to 195
      else
         do 40 i=1,n
 40      diag(i)= 1.0d0
      endif
c
c     the work vector w is divided as follows:
c     ---------------------------------------
c     the first n locations are used to store the gradient and
c         other temporary information.
c     locations (n+1)...(n+m) store the scalars rho.
c     locations (n+m+1)...(n+2m) store the numbers alpha used
c         in the formula that computes h*g.
c     locations (n+2m+1)...(n+2m+nm) store the last m search
c         steps.
c     locations (n+2m+nm+1)...(n+2m+2nm) store the last m
c         gradient differences.
c
c     the search steps and gradient differences are stored in a
c     circular order controlled by the parameter point.
c
      ispt= n+2*m
      iypt= ispt+n*m     
      do 50 i=1,n
 50   w(ispt+i)= -g(i)*diag(i)
      gnorm= dsqrt(ddot(n,g,1,g,1))
      stp1= one/gnorm
c
c     parameters for line search routine
c     
      ftol= 1.0d-4
      maxfev= 20
c
      if(iprint(1).ge.0) call lb1(iprint,iter,nfun,
     *                     gnorm,n,m,x,f,g,stp,finish,request)
c
c    --------------------
c     main iteration loop
c    --------------------
c
 80   iter= iter+1
      info=0
      bound=iter-1
      if(iter.eq.1) go to 165
      if (iter .gt. m)bound=m
c
         ys= ddot(n,w(iypt+npt+1),1,w(ispt+npt+1),1)
      if(.not.diagco) then
         yy= ddot(n,w(iypt+npt+1),1,w(iypt+npt+1),1)
         do 90 i=1,n
   90    diag(i)= ys/yy
      else
         iflag=2
         return
      endif
 100  continue
      if(diagco) then
        do 110 i=1,n
 110    if (diag(i).le.zero) go to 195
      endif
c
c     compute -h*g using the formula given in: nocedal, j. 1980,
c     "updating quasi-newton matrices with limited storage",
c     mathematics of computation, vol.24, no.151, pp. 773-782.
c     ---------------------------------------------------------
c
      cp= point
      if (point.eq.0) cp=m
      w(n+cp)= one/ys
      do 112 i=1,n
 112  w(i)= -g(i)
      cp= point
      do 125 i= 1,bound
         cp=cp-1
         if (cp.eq. -1)cp=m-1
         sq= ddot(n,w(ispt+cp*n+1),1,w,1)
         inmc=n+m+cp+1
         iycn=iypt+cp*n
         w(inmc)= w(n+cp+1)*sq
         call daxpy(n,-w(inmc),w(iycn+1),1,w,1)
 125  continue
c
      do 130 i=1,n
 130  w(i)=diag(i)*w(i)
c
      do 145 i=1,bound
         yr= ddot(n,w(iypt+cp*n+1),1,w,1)
         beta= w(n+cp+1)*yr
         inmc=n+m+cp+1
         beta= w(inmc)-beta
         iscn=ispt+cp*n
         call daxpy(n,beta,w(iscn+1),1,w,1)
         cp=cp+1
         if (cp.eq.m)cp=0
 145  continue
c
c     store the new search direction
c     ------------------------------
c
       do 160 i=1,n
 160   w(ispt+point*n+i)= w(i)
c
c     obtain the one-dimensional minimizer of the function 
c     by using the line search routine mcsrch
c     ----------------------------------------------------
 165  nfev=0
      stp=one
      if (iter.eq.1) stp=stp1
      do 170 i=1,n
 170  w(i)=g(i)
 172  continue
      call mcsrch(n,x,f,g,w(ispt+point*n+1),stp,ftol,
     *            xtol,maxfev,info,nfev,diag)
      if (info .eq. -1) then
        iflag=1
        return
      endif
      nfun= nfun + nfev
      if (info .ne. 1) then 
      	finish=.true.
      	request=2
        go to 180
      endif

c
c     compute the new step and gradient change 
c     -----------------------------------------
c
      npt=point*n
      do 175 i=1,n
      w(ispt+npt+i)= stp*w(ispt+npt+i)
 175  w(iypt+npt+i)= g(i)-w(i)
      point=point+1
      if (point.eq.m)point=0
c
c     termination test
c     ----------------
c
 180  gnorm= dsqrt(ddot(n,g,1,g,1))
      xnorm= dsqrt(ddot(n,x,1,x,1))
      xnorm= dmax1(1.0d0,xnorm)
      if (gnorm/xnorm .le. eps) finish=.true.
      if (iter .eq. maxit) then
      	finish=.true.
      	if (request .ne. 2) request=1
      endif
c
      if(iprint(1).ge.0) call lb1(iprint,iter,nfun,
     *               gnorm,n,m,x,f,g,stp,finish,request)
      if (finish) then
 	 maxit = iter
         if (request .gt. 0) then
	 	if (request .eq. 1) then
		 	iflag=3
	 	else 
	 		iflag = info
		 	if (info .eq. 0) iflag = 8
		 	if (info .eq. 2) iflag = 7
	 		go to 190
	 	endif
	 else
	 	iflag=0
 	 endif
         return
      endif
      go to 80
c
c     ------------------------------------------------------------
c     end of main iteration loop. error exits.
c     ------------------------------------------------------------
c
 190  if(lp.gt.0) then
	if (info .eq. 0) write (lp,200) 
	if (info .eq. 2 .and. iprint(1).ge.0) write (lp,202) xtol
	if (info .eq. 3 .and. iprint(1).ge.0) write (lp,203)
	if (info .eq. 4 .and. iprint(1).ge.0) write (lp,204) stpmin
	if (info .eq. 5 .and. iprint(1).ge.0) write (lp,205) stpmax
	if (info .eq. 6 .and. iprint(1).ge.0) write (lp,206)
      endif
      return
 195  iflag=-2
      if(lp.gt.0) write(lp,235) i
      return
 196  iflag= -3
      if(lp.gt.0) write(lp,240)

 200  format(/' Improper imput parameter for line search.')
 202  format(/' Relative width of the interval of uncertainty',/,
     .       ' is at most: ', d10.3)
 203  format (/,
     +' Line search cannot locate an adequate point after 20 function',/
     +,' and gradient evaluations.',/,
     +' Possible causes: 1 error in function or gradient evaluation;',/,
     +'                  2 rounding error dominate computation.')
 204  format(/' The step is at the lower bound:', d10.3)
 205  format(/' The step is at the upper bound:', d10.3)
 206  format (/,
     .' Rounding errors prevent further progress.',/
     .,'  There may not be a step which satisfies the',/,
     .' sufficient decrease and curvature conditions.',/,
     .' Tolerances may be too small.')
 235  format(/' iflag= -2',/' the',i5,'-th diagonal element of the',/
     .       ' inverse hessian approximation is not positive')
 240  format(/' iflag= -3',/' improper input parameters (n or m',
     .       ' are not positive)')
 245  format(/'  gtol is less than or equal to 1.d-04',
     .       / ' it has been reset to 9.d-01')
      return
      end
c
c     last line of subroutine lbfgs
c
c
      subroutine lb1(iprint,iter,nfun,
     *                     gnorm,n,m,x,f,g,stp,finish,request)
c
c     -------------------------------------------------------------
c     this routine prints monitoring information. the frequency and
c     amount of output are controlled by iprint.
c     -------------------------------------------------------------
c
      integer iprint(2),iter,nfun,lp,mp,n,m,request
      double precision x(n),g(n),f,gnorm,stp,gtol,stpmin,stpmax
      logical finish
      common /lb3/mp,lp,gtol,stpmin,stpmax
c
      if (iter.eq.0)then
           write(mp,10)
           write(mp,20) n,m
           write(mp,30)f,gnorm
                 if (iprint(2).ge.1)then
                     write(mp,40)
                     write(mp,50) (x(i),i=1,n)
                     write(mp,60)
                     write(mp,50) (g(i),i=1,n)
                  endif
           write(mp,10)
           write(mp,70)
      else
          if ((iprint(1).eq.0).and.(iter.ne.1.and..not.finish))return
              if (iprint(1).ne.0)then
                   if(mod(iter-1,iprint(1)).eq.0.or.finish)then
                         if(iprint(2).gt.1.and.iter.gt.1) write(mp,70)
                         write(mp,80)iter,nfun,f,gnorm,stp
                   else
                         return
                   endif
              else
                   if( iprint(2).gt.1.and.finish) write(mp,70)
                   write(mp,80)iter,nfun,f,gnorm,stp
              endif
              if (iprint(2).eq.2.or.iprint(2).eq.3)then
                    if (finish)then
                        write(mp,90)
                    else
                        write(mp,40)
                    endif
                      write(mp,50)(x(i),i=1,n)
                  if (iprint(2).eq.3)then
                      write(mp,60)
                      write(mp,50)(g(i),i=1,n)
                  endif
              endif
            if (finish) then
	    	if (request .gt. 0)then
		    if(request .eq. 1 ) write(mp,110)
		    if(request .eq. 2 ) write(mp,120)
		else
		    write(mp,100)
		endif
	    endif
      endif
c
 10   format('*************************************************')
 20   format('  n=',i5,'   number of corrections=',i2,
     .       /,  '       initial values')
 30   format(' f= ',1pd10.3,'   gnorm= ',1pd10.3)
 40   format(' vector x= ')
 50   format(6(2x,1pd10.3))
 60   format(' gradient vector g= ')
 70   format(/'   i   nfn',4x,'func',8x,'gnorm',7x,'steplength'/)
 80   format(2(i4,1x),3x,3(1pd10.3,2x))
 90   format(' final point x= ')
 100  format(/' The minimization terminated without detecting errors.',
     .       /' iflag = 0')
 110  format(/' The minimization reach the maximum number of',
     .      ' iteration.')
 120  format(/' Line search failed. Lowest point returned.')

      return
      end
c     ******
c
c
c   ----------------------------------------------------------
c     data 
c   ----------------------------------------------------------
c
      block data lb2
      integer lp,mp
      double precision gtol,stpmin,stpmax
      common /lb3/mp,lp,gtol,stpmin,stpmax
      data mp,lp,gtol,stpmin,stpmax/6,6,9.0d-01,1.0d-20,1.0d+20/
      end
c
c
c   ----------------------------------------------------------
c
c greg : removed daxpy,ddot
c
c    ------------------------------------------------------------------
c
c     **************************
c     line search routine mcsrch
c     **************************
c
      subroutine mcsrch(n,x,f,g,s,stp,ftol,xtol,maxfev,info,nfev,wa)
      integer n,maxfev,info,nfev
      double precision f,stp,ftol,gtol,xtol,stpmin,stpmax
      double precision x(n),g(n),s(n),wa(n)
      common /lb3/mp,lp,gtol,stpmin,stpmax
      save
c
c                     subroutine mcsrch
c                
c     a slight modification of the subroutine csrch of more' and thuente.
c     the changes are to allow reverse communication, and do not affect
c     the performance of the routine. 
c
c     the purpose of mcsrch is to find a step which satisfies
c     a sufficient decrease condition and a curvature condition.
c
c     at each stage the subroutine updates an interval of
c     uncertainty with endpoints stx and sty. the interval of
c     uncertainty is initially chosen so that it contains a
c     minimizer of the modified function
c
c          f(x+stp*s) - f(x) - ftol*stp*(gradf(x)'s).
c
c     if a step is obtained for which the modified function
c     has a nonpositive function value and nonnegative derivative,
c     then the interval of uncertainty is chosen so that it
c     contains a minimizer of f(x+stp*s).
c
c     the algorithm is designed to find a step which satisfies
c     the sufficient decrease condition
c
c           f(x+stp*s) .le. f(x) + ftol*stp*(gradf(x)'s),
c
c     and the curvature condition
c
c           abs(gradf(x+stp*s)'s)) .le. gtol*abs(gradf(x)'s).
c
c     if ftol is less than gtol and if, for example, the function
c     is bounded below, then there is always a step which satisfies
c     both conditions. if no step can be found which satisfies both
c     conditions, then the algorithm usually stops when rounding
c     errors prevent further progress. in this case stp only
c     satisfies the sufficient decrease condition.
c
c     the subroutine statement is
c
c        subroutine mcsrch(n,x,f,g,s,stp,ftol,xtol, maxfev,info,nfev,wa)
c     where
c
c       n is a positive integer input variable set to the number
c         of variables.
c
c       x is an array of length n. on input it must contain the
c         base point for the line search. on output it contains
c         x + stp*s.
c
c       f is a variable. on input it must contain the value of f
c         at x. on output it contains the value of f at x + stp*s.
c
c       g is an array of length n. on input it must contain the
c         gradient of f at x. on output it contains the gradient
c         of f at x + stp*s.
c
c       s is an input array of length n which specifies the
c         search direction.
c
c       stp is a nonnegative variable. on input stp contains an
c         initial estimate of a satisfactory step. on output
c         stp contains the final estimate.
c
c       ftol and gtol are nonnegative input variables. (in this reverse
c         communication implementation gtol is defined in a common
c         statement.) termination occurs when the sufficient decrease
c         condition and the directional derivative condition are
c         satisfied.
c
c       xtol is a nonnegative input variable. termination occurs
c         when the relative width of the interval of uncertainty
c         is at most xtol.
c
c       stpmin and stpmax are nonnegative input variables which
c         specify lower and upper bounds for the step. (in this reverse
c         communication implementatin they are defined in a common
c         statement).
c
c       maxfev is a positive integer input variable. termination
c         occurs when the number of calls to fcn is at least
c         maxfev by the end of an iteration.
c
c       info is an integer output variable set as follows:
c
c         info = 0  improper input parameters.
c
c         info =-1  a return is made to compute the function and gradient.
c
c         info = 1  the sufficient decrease condition and the
c                   directional derivative condition hold.
c
c         info = 2  relative width of the interval of uncertainty
c                   is at most xtol.
c
c         info = 3  number of calls to fcn has reached maxfev.
c
c         info = 4  the step is at the lower bound stpmin.
c
c         info = 5  the step is at the upper bound stpmax.
c
c         info = 6  rounding errors prevent further progress.
c                   there may not be a step which satisfies the
c                   sufficient decrease and curvature conditions.
c                   tolerances may be too small.
c
c       nfev is an integer output variable set to the number of
c         calls to fcn.
c
c       wa is a work array of length n.
c
c     subprograms called
c
c       mcstep
c
c       fortran-supplied...abs,max,min
c
c     argonne national laboratory. minpack project. june 1983
c     jorge j. more', david j. thuente
c
c     **********
      integer infoc,j
      logical brackt,stage1
      double precision dg,dgm,dginit,dgtest,dgx,dgxm,dgy,dgym,
     *       finit,ftest1,fm,fx,fxm,fy,fym,p5,p66,stx,sty,
     *       stmin,stmax,width,width1,xtrapf,zero
      data p5,p66,xtrapf,zero /0.5d0,0.66d0,4.0d0,0.0d0/
      if(info.eq.-1) go to 45
      infoc = 1
c
c     check the input parameters for errors.
c
      if (n .le. 0 .or. stp .le. zero .or. ftol .lt. zero .or.
     *    gtol .lt. zero .or. xtol .lt. zero .or. stpmin .lt. zero
     *    .or. stpmax .lt. stpmin .or. maxfev .le. 0) return
c
c     compute the initial gradient in the search direction
c     and check that s is a descent direction.
c
      dginit = zero
      do 10 j = 1, n
         dginit = dginit + g(j)*s(j)
   10    continue
      if (dginit .ge. zero) then
         write(lp,15)
   15    format(/'  the search direction is not a descent direction')
         return
         endif
c
c     initialize local variables.
c
      brackt = .false.
      stage1 = .true.
      nfev = 0
      finit = f
      dgtest = ftol*dginit
      width = stpmax - stpmin
      width1 = width/p5
      do 20 j = 1, n
         wa(j) = x(j)
   20    continue
c
c     the variables stx, fx, dgx contain the values of the step,
c     function, and directional derivative at the best step.
c     the variables sty, fy, dgy contain the value of the step,
c     function, and derivative at the other endpoint of
c     the interval of uncertainty.
c     the variables stp, f, dg contain the values of the step,
c     function, and derivative at the current step.
c
      stx = zero
      fx = finit
      dgx = dginit
      sty = zero
      fy = finit
      dgy = dginit
c
c     start of iteration.
c
   30 continue
c
c        set the minimum and maximum steps to correspond
c        to the present interval of uncertainty.
c
         if (brackt) then
            stmin = min(stx,sty)
            stmax = max(stx,sty)
         else
            stmin = stx
            stmax = stp + xtrapf*(stp - stx)
            end if
c
c        force the step to be within the bounds stpmax and stpmin.
c
         stp = max(stp,stpmin)
         stp = min(stp,stpmax)
c
c        if an unusual termination is to occur then let
c        stp be the lowest point obtained so far.
c
         if ((brackt .and. (stp .le. stmin .or. stp .ge. stmax))
     *      .or. nfev .ge. maxfev-1 .or. infoc .eq. 0
     *      .or. (brackt .and. stmax-stmin .le. xtol*stmax)) stp = stx
c
c        evaluate the function and gradient at stp
c        and compute the directional derivative.
c        we return to main program to obtain f and g.
c
         do 40 j = 1, n
            x(j) = wa(j) + stp*s(j)
   40       continue
         info=-1
         return
c
   45    info=0
         nfev = nfev + 1
         dg = zero
         do 50 j = 1, n
            dg = dg + g(j)*s(j)
   50       continue
         ftest1 = finit + stp*dgtest
c
c        test for convergence.
c
         if ((brackt .and. (stp .le. stmin .or. stp .ge. stmax))
     *      .or. infoc .eq. 0) info = 6
         if (stp .eq. stpmax .and.
     *       f .le. ftest1 .and. dg .le. dgtest) info = 5
         if (stp .eq. stpmin .and.
     *       (f .gt. ftest1 .or. dg .ge. dgtest)) info = 4
         if (nfev .ge. maxfev) info = 3
         if (brackt .and. stmax-stmin .le. xtol*stmax) info = 2
         if (f .le. ftest1 .and. abs(dg) .le. gtol*(-dginit)) info = 1
c
c        check for termination.
c
         if (info .ne. 0) return
c
c        in the first stage we seek a step for which the modified
c        function has a nonpositive value and nonnegative derivative.
c
         if (stage1 .and. f .le. ftest1 .and.
     *       dg .ge. min(ftol,gtol)*dginit) stage1 = .false.
c
c        a modified function is used to predict the step only if
c        we have not obtained a step for which the modified
c        function has a nonpositive function value and nonnegative
c        derivative, and if a lower function value has been
c        obtained but the decrease is not sufficient.
c
         if (stage1 .and. f .le. fx .and. f .gt. ftest1) then
c
c           define the modified function and derivative values.
c
            fm = f - stp*dgtest
            fxm = fx - stx*dgtest
            fym = fy - sty*dgtest
            dgm = dg - dgtest
            dgxm = dgx - dgtest
            dgym = dgy - dgtest
c
c           call cstep to update the interval of uncertainty
c           and to compute the new step.
c
            call mcstep(stx,fxm,dgxm,sty,fym,dgym,stp,fm,dgm,
     *                 brackt,stmin,stmax,infoc)
c
c           reset the function and gradient values for f.
c
            fx = fxm + stx*dgtest
            fy = fym + sty*dgtest
            dgx = dgxm + dgtest
            dgy = dgym + dgtest
         else
c
c           call mcstep to update the interval of uncertainty
c           and to compute the new step.
c
            call mcstep(stx,fx,dgx,sty,fy,dgy,stp,f,dg,
     *                 brackt,stmin,stmax,infoc)
            end if
c
c        force a sufficient decrease in the size of the
c        interval of uncertainty.
c
         if (brackt) then
            if (abs(sty-stx) .ge. p66*width1)
     *         stp = stx + p5*(sty - stx)
            width1 = width
            width = abs(sty-stx)
            end if
c
c        end of iteration.
c
         go to 30
c
c     last line of subroutine mcsrch.
c
      end
      subroutine mcstep(stx,fx,dx,sty,fy,dy,stp,fp,dp,brackt,
     *                 stpmin,stpmax,info)
      integer info
      double precision stx,fx,dx,sty,fy,dy,stp,fp,dp,stpmin,stpmax
      logical brackt,bound
c
c     subroutine mcstep
c
c     the purpose of mcstep is to compute a safeguarded step for
c     a linesearch and to update an interval of uncertainty for
c     a minimizer of the function.
c
c     the parameter stx contains the step with the least function
c     value. the parameter stp contains the current step. it is
c     assumed that the derivative at stx is negative in the
c     direction of the step. if brackt is set true then a
c     minimizer has been bracketed in an interval of uncertainty
c     with endpoints stx and sty.
c
c     the subroutine statement is
c
c       subroutine mcstep(stx,fx,dx,sty,fy,dy,stp,fp,dp,brackt,
c                        stpmin,stpmax,info)
c
c     where
c
c       stx, fx, and dx are variables which specify the step,
c         the function, and the derivative at the best step obtained
c         so far. the derivative must be negative in the direction
c         of the step, that is, dx and stp-stx must have opposite
c         signs. on output these parameters are updated appropriately.
c
c       sty, fy, and dy are variables which specify the step,
c         the function, and the derivative at the other endpoint of
c         the interval of uncertainty. on output these parameters are
c         updated appropriately.
c
c       stp, fp, and dp are variables which specify the step,
c         the function, and the derivative at the current step.
c         if brackt is set true then on input stp must be
c         between stx and sty. on output stp is set to the new step.
c
c       brackt is a logical variable which specifies if a minimizer
c         has been bracketed. if the minimizer has not been bracketed
c         then on input brackt must be set false. if the minimizer
c         is bracketed then on output brackt is set true.
c
c       stpmin and stpmax are input variables which specify lower
c         and upper bounds for the step.
c
c       info is an integer output variable set as follows:
c         if info = 1,2,3,4,5, then the step has been computed
c         according to one of the five cases below. otherwise
c         info = 0, and this indicates improper input parameters.
c
c     subprograms called
c
c       fortran-supplied ... abs,max,min,sqrt
c
c     argonne national laboratory. minpack project. june 1983
c     jorge j. more', david j. thuente
c
      double precision gamma,p,q,r,s,sgnd,stpc,stpf,stpq,theta
      info = 0
c
c     check the input parameters for errors.
c
      if ((brackt .and. (stp .le. min(stx,sty) .or.
     *    stp .ge. max(stx,sty))) .or.
     *    dx*(stp-stx) .ge. 0.0 .or. stpmax .lt. stpmin) return
c
c     determine if the derivatives have opposite sign.
c
      sgnd = dp*(dx/abs(dx))
c
c     first case. a higher function value.
c     the minimum is bracketed. if the cubic step is closer
c     to stx than the quadratic step, the cubic step is taken,
c     else the average of the cubic and quadratic steps is taken.
c
      if (fp .gt. fx) then
         info = 1
         bound = .true.
         theta = 3*(fx - fp)/(stp - stx) + dx + dp
         s = max(abs(theta),abs(dx),abs(dp))
         gamma = s*sqrt((theta/s)**2 - (dx/s)*(dp/s))
         if (stp .lt. stx) gamma = -gamma
         p = (gamma - dx) + theta
         q = ((gamma - dx) + gamma) + dp
         r = p/q
         stpc = stx + r*(stp - stx)
         stpq = stx + ((dx/((fx-fp)/(stp-stx)+dx))/2)*(stp - stx)
         if (abs(stpc-stx) .lt. abs(stpq-stx)) then
            stpf = stpc
         else
           stpf = stpc + (stpq - stpc)/2
           end if
         brackt = .true.
c
c     second case. a lower function value and derivatives of
c     opposite sign. the minimum is bracketed. if the cubic
c     step is closer to stx than the quadratic (secant) step,
c     the cubic step is taken, else the quadratic step is taken.
c
      else if (sgnd .lt. 0.0) then
         info = 2
         bound = .false.
         theta = 3*(fx - fp)/(stp - stx) + dx + dp
         s = max(abs(theta),abs(dx),abs(dp))
         gamma = s*sqrt((theta/s)**2 - (dx/s)*(dp/s))
         if (stp .gt. stx) gamma = -gamma
         p = (gamma - dp) + theta
         q = ((gamma - dp) + gamma) + dx
         r = p/q
         stpc = stp + r*(stx - stp)
         stpq = stp + (dp/(dp-dx))*(stx - stp)
         if (abs(stpc-stp) .gt. abs(stpq-stp)) then
            stpf = stpc
         else
            stpf = stpq
            end if
         brackt = .true.
c
c     third case. a lower function value, derivatives of the
c     same sign, and the magnitude of the derivative decreases.
c     the cubic step is only used if the cubic tends to infinity
c     in the direction of the step or if the minimum of the cubic
c     is beyond stp. otherwise the cubic step is defined to be
c     either stpmin or stpmax. the quadratic (secant) step is also
c     computed and if the minimum is bracketed then the the step
c     closest to stx is taken, else the step farthest away is taken.
c
      else if (abs(dp) .lt. abs(dx)) then
         info = 3
         bound = .true.
         theta = 3*(fx - fp)/(stp - stx) + dx + dp
         s = max(abs(theta),abs(dx),abs(dp))
c
c        the case gamma = 0 only arises if the cubic does not tend
c        to infinity in the direction of the step.
c
         gamma = s*sqrt(max(0.0d0,(theta/s)**2 - (dx/s)*(dp/s)))
         if (stp .gt. stx) gamma = -gamma
         p = (gamma - dp) + theta
         q = (gamma + (dx - dp)) + gamma
         r = p/q
         if (r .lt. 0.0 .and. gamma .ne. 0.0) then
            stpc = stp + r*(stx - stp)
         else if (stp .gt. stx) then
            stpc = stpmax
         else
            stpc = stpmin
            end if
         stpq = stp + (dp/(dp-dx))*(stx - stp)
         if (brackt) then
            if (abs(stp-stpc) .lt. abs(stp-stpq)) then
               stpf = stpc
            else
               stpf = stpq
               end if
         else
            if (abs(stp-stpc) .gt. abs(stp-stpq)) then
               stpf = stpc
            else
               stpf = stpq
               end if
            end if
c
c     fourth case. a lower function value, derivatives of the
c     same sign, and the magnitude of the derivative does
c     not decrease. if the minimum is not bracketed, the step
c     is either stpmin or stpmax, else the cubic step is taken.
c
      else
         info = 4
         bound = .false.
         if (brackt) then
            theta = 3*(fp - fy)/(sty - stp) + dy + dp
            s = max(abs(theta),abs(dy),abs(dp))
            gamma = s*sqrt((theta/s)**2 - (dy/s)*(dp/s))
            if (stp .gt. sty) gamma = -gamma
            p = (gamma - dp) + theta
            q = ((gamma - dp) + gamma) + dy
            r = p/q
            stpc = stp + r*(sty - stp)
            stpf = stpc
         else if (stp .gt. stx) then
            stpf = stpmax
         else
            stpf = stpmin
            end if
         end if
c
c     update the interval of uncertainty. this update does not
c     depend on the new step or the case analysis above.
c
      if (fp .gt. fx) then
         sty = stp
         fy = fp
         dy = dp
      else
         if (sgnd .lt. 0.0) then
            sty = stx
            fy = fx
            dy = dx
            end if
         stx = stp
         fx = fp
         dx = dp
         end if
c
c     compute the new step and safeguard it.
c
      stpf = min(stpmax,stpf)
      stpf = max(stpmin,stpf)
      stp = stpf
      if (brackt .and. bound) then
         if (sty .gt. stx) then
            stp = min(stx+0.66*(sty-stx),stp)
         else
            stp = max(stx+0.66*(sty-stx),stp)
            end if
         end if
      return
c
c     last line of subroutine mcstep.
c
      end

      subroutine spg(n,x,m,eps,eps2,maxit,maxfc,output,f,pginfn,pgtwon,
     +               iter,fcnt,gcnt,flag, evalf, evalg, proj)

C     Subroutine SPG implements the Spectral Projected Gradient
C     Method (Version 2: "continuous projected gradient direction") 
C     to find the local minimizers of a given function with convex
C     constraints, described in 
C
C     E. G. Birgin, J. M. Martinez, and M. Raydan, "Nonmonotone 
C     spectral projected gradient methods on convex sets", SIAM 
C     Journal on Optimization 10, pp. 1196-1211, 2000.
C 
C     and
C 
C     E. G. Birgin, J. M. Martinez, and M. Raydan, "SPG: software 
C     for convex-constrained optimization", ACM Transactions on 
C     Mathematical Software, 2001 (to appear).
C
C     The user must supply the external subroutines evalf, evalg 
C     and proj to evaluate the objective function and its gradient 
C     and to project an arbitrary point onto the feasible region.
C
C     This version 17 JAN 2000 by E.G.Birgin, J.M.Martinez and M.Raydan.
C     Reformatted 03 OCT 2000 by Tim Hopkins.
C     Final revision 03 JUL 2001 by E.G.Birgin, J.M.Martinez and M.Raydan.
C
C     On Entry:
C
C     n     integer,
C           size of the problem,
C
C     x     double precision x(n),
C           initial guess,
C
C     m     integer,
C           number of previous function values to be considered 
C           in the nonmonotone line search,
C
C     eps   double precision,
C           stopping criterion: ||projected grad||_inf < eps,
C
C     eps2  double precision,
C           stopping criterion: ||projected grad||_2 < eps2,
C
C     maxit integer,
C           maximum number of iterations,
C
C     maxfc integer,
C           maximum number of function evaluations,
C
C     output logical,
C           true: print some information at each iteration,
C           false: no print.
C
C     On Return:
C
C     x     double precision x(n),
C           approximation to the local minimizer,
C
C     f     double precision,
C           function value at the approximation to the local
C           minimizer,
C
C     pginfn double precision,
C           ||projected grad||_inf at the final iteration,
C
C     pgtwon double precision,
C           ||projected grad||_2^2 at the final iteration,
C
C     iter  integer,
C           number of iterations,
C
C     fcnt  integer,
C           number of function evaluations,
C
C     gcnt  integer,
C           number of gradient evaluations,
C
C     flag  integer,
C           termination parameter:
C           0= convergence with projected gradient infinite-norm,
C           1= convergence with projected gradient 2-norm,
C           2= too many iterations,
C           3= too many function evaluations,
C           4= error in proj subroutine,
C           5= error in evalf subroutine,
C           6= error in evalg subroutine.

C     PARAMETERS
      double precision lmin
      parameter (lmin=1.0d-30)
      double precision lmax
      parameter (lmax=1.0d+30)
      integer nmax
      parameter (nmax=100000)
      integer mmax
      parameter (mmax=100)

C     SCALAR ARGUMENTS
      double precision pginfn,pgtwon,eps,eps2,f
      integer fcnt,flag,gcnt,iter,m,maxfc,maxit,n
      logical output

C     ARRAY ARGUMENTS
      double precision x(n)

C     LOCAL SCALARS
      double precision fbest,fnew,gtd,lambda,sts,sty
      integer i,lsflag,inform

C     LOCAL 
      double precision pg(nmax),g(nmax),gnew(nmax),s(nmax),y(nmax),
     +                 d(nmax),xbest(nmax),xnew(nmax),lastfv(0:mmax-1)

C     EXTERNAL SUBROUTINES
      external ls,evalf,evalg,proj

C     INTRINSIC FUNCTIONS
      intrinsic abs,max,min,mod

C     INITIALIZATION

      iter = 0
      fcnt = 0
      gcnt = 0

      do i = 0,m - 1
          lastfv(i) = -1.0d+99
      end do

C     PROJECT INITIAL GUESS

      call proj(n,x,inform)

      if (inform .ne. 0) then
        ! ERROR IN PROJ SUBROUTINE, STOP
          flag = 4
          go to 200
      end if

C     INITIALIZE BEST SOLUTION

      do i = 1,n
          xbest(i) = x(i)
      end do

C     EVALUATE FUNCTION AND GRADIENT

      call evalf(n,x,f,inform)
      fcnt = fcnt + 1

      if (inform .ne. 0) then
        ! ERROR IN EVALF SUBROUTINE, STOP
          flag = 5
          go to 200
      end if

      call evalg(n,x,g,inform)
      gcnt = gcnt + 1

      if (inform .ne. 0) then
        ! ERROR IN EVALG SUBROUTINE, STOP
          flag = 6
          go to 200
      end if

C     STORE FUNCTION VALUE FOR THE NONMONOTONE LINE SEARCH

      lastfv(0) = f

C     INITIALIZE BEST FUNCTION VALUE

      fbest = f

C     COMPUTE CONTINUOUS PROJECTED GRADIENT (AND ITS NORMS)

      do i = 1,n
          pg(i) = x(i) - g(i)
      end do

      call proj(n,pg,inform)

      if (inform .ne. 0) then
        ! ERROR IN PROJ SUBROUTINE, STOP
          flag = 4
          go to 200
      end if

      pgtwon = 0.0D0
      pginfn = 0.0D0
      do i = 1,n
          pg(i) = pg(i) - x(i)
          pgtwon = pgtwon + pg(i)**2
          pginfn = max(pginfn,abs(pg(i)))
      end do

C     PRINT ITERATION INFORMATION

      if (output) then
          write (*,fmt=9010) iter,f,pginfn
      end if

C     DEFINE INITIAL SPECTRAL STEPLENGTH

      if (pginfn .ne. 0.0d0) then
          lambda =  min(lmax,max(lmin,1.0d0/pginfn))
      end if

C     MAIN LOOP

C     TEST STOPPING CRITERIA

 100  continue

      if (pginfn .le. eps) then
        ! GRADIENT INFINITE-NORM STOPPING CRITERION SATISFIED, STOP
          flag = 0
          go to 200
      end if

      if (pgtwon .le. (eps2*eps2)) then
        ! GRADIENT 2-NORM STOPPING CRITERION SATISFIED, STOP
          flag = 1
          go to 200
      end if

      if (iter .gt. maxit) then
        ! MAXIMUM NUMBER OF ITERATIONS EXCEEDED, STOP
          flag = 2
          go to 200
      end if

      if (fcnt .gt. maxfc) then
        ! MAXIMUM NUMBER OF FUNCTION EVALUATIONS EXCEEDED, STOP
          flag = 3
          go to 200
      end if

C     DO AN ITERATION

      iter = iter + 1

C     COMPUTE THE SPECTRAL PROJECTED GRADIENT DIRECTION
C     AND <G,D>

      do i = 1,n
          d(i) = x(i) - lambda*g(i)
      end do

      call proj(n,d,inform)

      if (inform .ne. 0) then
        ! ERROR IN PROJ SUBROUTINE, STOP
          flag = 4
          go to 200
      end if

      gtd = 0.0d0
      do i = 1,n
          d(i) = d(i) - x(i)
          gtd = gtd + g(i)*d(i)
      end do

C     NONMONOTONE LINE SEARCH

      call ls(n,x,f,d,gtd,m,lastfv,maxfc,fcnt,fnew,xnew,lsflag,evalf)

      if (lsflag .eq. 3) then
        ! THE NUMBER OF FUNCTION EVALUATIONS WAS EXCEEDED 
        ! INSIDE  THE LINE SEARCH, STOP
          flag = 3
          go to 200
      end if

C     SET NEW FUNCTION VALUE AND SAVE IT FOR THE NONMONOTONE
C     LINE SEARCH

      f = fnew
      lastfv(mod(iter,m)) = f

C     COMPARE THE NEW FUNCTION VALUE AGAINST THE BEST FUNCTION 
C     VALUE  AND, IF SMALLER, UPDATE THE BEST FUNCTION 
C     VALUE AND THE CORRESPONDING BEST POINT

      if (f .lt. fbest) then
          fbest = f
          do i = 1,n
              xbest(i) = xnew(i)
          end do
      end if

C     EVALUATE THE GRADIENT AT THE NEW ITERATE

      call evalg(n,xnew,gnew,inform)
      gcnt = gcnt + 1

      if (inform .ne. 0) then
        ! ERROR IN EVALG SUBROUTINE, STOP
          flag = 6
          go to 200
      end if

C     COMPUTE S = XNEW - X, Y = GNEW - G, <S,S>, <S,Y>,
C     THE CONTINUOUS PROJECTED GRADIENT AND ITS NORMS

      sts = 0.0d0
      sty = 0.0d0
      do i = 1,n
          s(i) = xnew(i) - x(i)
          y(i) = gnew(i) - g(i)
          sts = sts + s(i)*s(i)
          sty = sty + s(i)*y(i)
          x(i) = xnew(i)
          g(i) = gnew(i)
          pg(i) = x(i) - g(i)
      end do

      call proj(n,pg,inform)

      if (inform .ne. 0) then
        ! ERROR IN PROJ SUBROUTINE, STOP
          flag = 4
          go to 200
      end if

      pgtwon = 0.0D0
      pginfn = 0.0D0
      do i = 1,n
          pg(i) = pg(i) - x(i)
          pgtwon = pgtwon + pg(i)**2
          pginfn = max(pginfn,abs(pg(i)))
      end do

C     PRINT ITERATION INFORMATION

      if (output) then
          write (*,fmt=9010) iter,f,pginfn
      end if

C     COMPUTE SPECTRAL STEPLENGTH

      if (sty .le. 0.0d0) then
          lambda = lmax

      else
          lambda = min(lmax,max(lmin,sts/sty))
      end if

C     FINISH THE ITERATION

      go to 100

C     STOP

 200  continue

C     SET X AND F WITH THE BEST SOLUTION AND ITS FUNCTION VALUE

      f = fbest
      do i = 1,n
          x(i) = xbest(i)
      end do

 9010 format ('ITER= ',I10,' F= ',1P,D17.10,' PGINFNORM= ',1P,D17.10)

      end


      subroutine ls(n,x,f,d,gtd,m,lastfv,maxfc,fcnt,fnew,xnew,flag,evaf)

C     Subroutine LS implements a nonmonotone line search with
C     safeguarded quadratic interpolation.
C
C     This version 17 JAN 2000 by E.G.Birgin, J.M.Martinez and M.Raydan.
C     Reformatted 03 OCT 2000 by Tim Hopkins.
C     Final revision 03 JUL 2001 by E.G.Birgin, J.M.Martinez and M.Raydan.
C
C     On Entry:
C
C     n     integer,
C           size of the problem,
C
C     x     double precision x(n),
C           initial guess,
C
C     f     double precision,
C           function value at the actual point,
C
C     d     double precision d(n),
C           search direction,
C
C     gtd   double precision,
C           internal product <g,d>, where g is the gradient at x,
C
C     m     integer,
C           number of previous function values to be considered 
C           in the nonmonotone line search,
C
C     lastfv double precision lastfv(m),
C           last m function values,
C
C     maxfc integer,
C           maximum number of function evaluations,
C
C     fcnt  integer,
C           actual number of function evaluations.
C
C     On Return:
C
C     fcnt  integer,
C           actual number of function evaluations,
C
C     fnew  double precision,
C           function value at the new point,
C
C     xnew  double precision xnew(n),
C           new point,
C
C     flag  integer,
C           0= convergence with nonmonotone Armijo-like criterion,
C           3= too many function evaluations,
C           5= error in evalf subroutine.

C     PARAMETERS
      double precision gamma
      parameter (gamma=1.0d-04)

C     SCALAR ARGUMENTS
      double precision f,fnew,gtd
      integer maxfc,fcnt,m,n,flag

C     ARRAY ARGUMENTS
      double precision d(n),lastfv(0:m-1),x(n),xnew(n)

C     LOCAL SCALARS
      double precision alpha,atemp,fmax
      integer i,inform

C     EXTERNAL SUBROUTINES
      external evaf

C     INTRINSIC FUNCTIONS
      intrinsic max

C     INITIALIZATION

C     COMPUTE THE MAXIMUM FUNCTIONAL VALUE OF THE LAST M ITERATIONS

      fmax = lastfv(0)
      do i = 1,m - 1
          fmax = max(fmax,lastfv(i))
      end do

C     COMPUTE FIRST TRIAL

      alpha = 1.0d0

      do i = 1,n
          xnew(i) = x(i) + d(i)
      end do

      call evaf(n,xnew,fnew,inform)
      fcnt = fcnt + 1

      if (inform .ne. 0) then
        ! ERROR IN EVALF SUBROUTINE, STOP
          flag = 5
          go to 200
      end if

C     MAIN LOOP

 100  continue

C     TEST STOPPING CRITERIA

      if (fnew .le. fmax + gamma*alpha*gtd) then
        ! NONMONOTONE ARMIJO-LIKE STOPPING CRITERION SATISFIED, STOP
          flag = 0
          go to 200
      end if

      if (fcnt .ge. maxfc) then
        ! MAXIMUM NUMBER OF FUNCTION EVALUATIONS EXCEEDED, STOP
          flag = 3
          go to 200
      end if 

C     DO AN ITERATION

C     SAFEGUARDED QUADRATIC INTERPOLATION

      if (alpha .le. 0.1d0) then
          alpha = alpha/2.0d0

      else
          atemp = (-gtd*alpha**2) / (2.0d0*(fnew-f-alpha*gtd))
          if (atemp .lt. 0.1d0 .or. atemp .gt. 0.9d0*alpha) then
              atemp = alpha/2.0d0
          end if
          alpha = atemp
      end if

C     COMPUTE TRIAL POINT 

      do i = 1,n
          xnew(i) = x(i) + alpha*d(i)
      end do

C     EVALUATE FUNCTION

      call evaf(n,xnew,fnew,inform)
      fcnt = fcnt + 1

      if (inform .ne. 0) then
        ! ERROR IN EVALF SUBROUTINE, STOP
          flag = 5
          go to 200
      end if

C     ITERATE

      go to 100

C     STOP

 200  continue

      end
